#include "soapH.h"

SOAP_FMAC3 void * SOAP_FMAC4 soap_instantiate(struct soap *soap, int t, const char *type, const char *arrayType, size_t *n)
{
	switch (t)
	{
#ifndef WITH_NOGLOBAL
	case SOAP_TYPE_SOAP_ENV__Detail:
		return (void*)soap_instantiate_SOAP_ENV__Detail(soap, -1, type, arrayType, n);
#endif
	case SOAP_TYPE_std__string:
		return (void*)soap_instantiate_std__string(soap, -1, type, arrayType, n);
	case SOAP_TYPE_vbox__IRemoteDisplayInfo:
		return (void*)soap_instantiate_vbox__IRemoteDisplayInfo(soap, -1, type, arrayType, n);
	case SOAP_TYPE_vbox__IGuestOSType:
		return (void*)soap_instantiate_vbox__IGuestOSType(soap, -1, type, arrayType, n);
	case SOAP_TYPE_vbox__IMediumAttachment:
		return (void*)soap_instantiate_vbox__IMediumAttachment(soap, -1, type, arrayType, n);
	case SOAP_TYPE_vbox__ISharedFolder:
		return (void*)soap_instantiate_vbox__ISharedFolder(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBoxErrorInfo_USCOREgetResultCode:
		return (void*)soap_instantiate__vbox__IVirtualBoxErrorInfo_USCOREgetResultCode(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBoxErrorInfo_USCOREgetResultCodeResponse:
		return (void*)soap_instantiate__vbox__IVirtualBoxErrorInfo_USCOREgetResultCodeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBoxErrorInfo_USCOREgetInterfaceID:
		return (void*)soap_instantiate__vbox__IVirtualBoxErrorInfo_USCOREgetInterfaceID(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBoxErrorInfo_USCOREgetInterfaceIDResponse:
		return (void*)soap_instantiate__vbox__IVirtualBoxErrorInfo_USCOREgetInterfaceIDResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBoxErrorInfo_USCOREgetComponent:
		return (void*)soap_instantiate__vbox__IVirtualBoxErrorInfo_USCOREgetComponent(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBoxErrorInfo_USCOREgetComponentResponse:
		return (void*)soap_instantiate__vbox__IVirtualBoxErrorInfo_USCOREgetComponentResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBoxErrorInfo_USCOREgetText:
		return (void*)soap_instantiate__vbox__IVirtualBoxErrorInfo_USCOREgetText(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBoxErrorInfo_USCOREgetTextResponse:
		return (void*)soap_instantiate__vbox__IVirtualBoxErrorInfo_USCOREgetTextResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBoxErrorInfo_USCOREgetNext:
		return (void*)soap_instantiate__vbox__IVirtualBoxErrorInfo_USCOREgetNext(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBoxErrorInfo_USCOREgetNextResponse:
		return (void*)soap_instantiate__vbox__IVirtualBoxErrorInfo_USCOREgetNextResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetEnabled:
		return (void*)soap_instantiate__vbox__IDHCPServer_USCOREgetEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetEnabledResponse:
		return (void*)soap_instantiate__vbox__IDHCPServer_USCOREgetEnabledResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDHCPServer_USCOREsetEnabled:
		return (void*)soap_instantiate__vbox__IDHCPServer_USCOREsetEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDHCPServer_USCOREsetEnabledResponse:
		return (void*)soap_instantiate__vbox__IDHCPServer_USCOREsetEnabledResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetIPAddress:
		return (void*)soap_instantiate__vbox__IDHCPServer_USCOREgetIPAddress(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetIPAddressResponse:
		return (void*)soap_instantiate__vbox__IDHCPServer_USCOREgetIPAddressResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetNetworkMask:
		return (void*)soap_instantiate__vbox__IDHCPServer_USCOREgetNetworkMask(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetNetworkMaskResponse:
		return (void*)soap_instantiate__vbox__IDHCPServer_USCOREgetNetworkMaskResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetNetworkName:
		return (void*)soap_instantiate__vbox__IDHCPServer_USCOREgetNetworkName(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetNetworkNameResponse:
		return (void*)soap_instantiate__vbox__IDHCPServer_USCOREgetNetworkNameResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetLowerIP:
		return (void*)soap_instantiate__vbox__IDHCPServer_USCOREgetLowerIP(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetLowerIPResponse:
		return (void*)soap_instantiate__vbox__IDHCPServer_USCOREgetLowerIPResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetUpperIP:
		return (void*)soap_instantiate__vbox__IDHCPServer_USCOREgetUpperIP(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetUpperIPResponse:
		return (void*)soap_instantiate__vbox__IDHCPServer_USCOREgetUpperIPResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDHCPServer_USCOREsetConfiguration:
		return (void*)soap_instantiate__vbox__IDHCPServer_USCOREsetConfiguration(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDHCPServer_USCOREsetConfigurationResponse:
		return (void*)soap_instantiate__vbox__IDHCPServer_USCOREsetConfigurationResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDHCPServer_USCOREstart:
		return (void*)soap_instantiate__vbox__IDHCPServer_USCOREstart(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDHCPServer_USCOREstartResponse:
		return (void*)soap_instantiate__vbox__IDHCPServer_USCOREstartResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDHCPServer_USCOREstop:
		return (void*)soap_instantiate__vbox__IDHCPServer_USCOREstop(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDHCPServer_USCOREstopResponse:
		return (void*)soap_instantiate__vbox__IDHCPServer_USCOREstopResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetVersion:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetVersion(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetVersionResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetVersionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetRevision:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetRevision(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetRevisionResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetRevisionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetPackageType:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetPackageType(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetPackageTypeResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetPackageTypeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetHomeFolder:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetHomeFolder(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetHomeFolderResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetHomeFolderResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetSettingsFilePath:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetSettingsFilePath(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetSettingsFilePathResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetSettingsFilePathResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetHost:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetHost(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetHostResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetHostResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetSystemProperties:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetSystemProperties(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetSystemPropertiesResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetSystemPropertiesResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetMachines:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetMachines(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetMachinesResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetMachinesResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetHardDisks:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetHardDisks(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetHardDisksResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetHardDisksResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetDVDImages:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetDVDImages(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetDVDImagesResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetDVDImagesResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetFloppyImages:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetFloppyImages(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetFloppyImagesResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetFloppyImagesResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetProgressOperations:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetProgressOperations(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetProgressOperationsResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetProgressOperationsResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetGuestOSTypes:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetGuestOSTypes(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetGuestOSTypesResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetGuestOSTypesResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetSharedFolders:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetSharedFolders(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetSharedFoldersResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetSharedFoldersResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetPerformanceCollector:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetPerformanceCollector(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetPerformanceCollectorResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetPerformanceCollectorResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetDHCPServers:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetDHCPServers(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetDHCPServersResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetDHCPServersResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateMachine:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREcreateMachine(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateMachineResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREcreateMachineResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateLegacyMachine:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREcreateLegacyMachine(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateLegacyMachineResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREcreateLegacyMachineResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREopenMachine:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREopenMachine(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREopenMachineResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREopenMachineResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREregisterMachine:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREregisterMachine(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREregisterMachineResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREregisterMachineResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetMachine:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetMachine(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetMachineResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetMachineResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREfindMachine:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREfindMachine(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREfindMachineResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREfindMachineResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREunregisterMachine:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREunregisterMachine(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREunregisterMachineResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREunregisterMachineResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateAppliance:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREcreateAppliance(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateApplianceResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREcreateApplianceResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateHardDisk:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREcreateHardDisk(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateHardDiskResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREcreateHardDiskResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREopenHardDisk:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREopenHardDisk(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREopenHardDiskResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREopenHardDiskResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetHardDisk:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetHardDisk(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetHardDiskResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetHardDiskResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREfindHardDisk:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREfindHardDisk(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREfindHardDiskResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREfindHardDiskResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREopenDVDImage:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREopenDVDImage(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREopenDVDImageResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREopenDVDImageResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetDVDImage:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetDVDImage(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetDVDImageResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetDVDImageResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREfindDVDImage:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREfindDVDImage(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREfindDVDImageResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREfindDVDImageResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREopenFloppyImage:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREopenFloppyImage(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREopenFloppyImageResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREopenFloppyImageResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetFloppyImage:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetFloppyImage(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetFloppyImageResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetFloppyImageResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREfindFloppyImage:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREfindFloppyImage(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREfindFloppyImageResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREfindFloppyImageResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetGuestOSType:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetGuestOSType(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetGuestOSTypeResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetGuestOSTypeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateSharedFolder:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREcreateSharedFolder(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateSharedFolderResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREcreateSharedFolderResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREremoveSharedFolder:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREremoveSharedFolder(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREremoveSharedFolderResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREremoveSharedFolderResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetExtraDataKeys:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetExtraDataKeys(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetExtraDataKeysResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetExtraDataKeysResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetExtraData:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetExtraData(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetExtraDataResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREgetExtraDataResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREsetExtraData:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREsetExtraData(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREsetExtraDataResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREsetExtraDataResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREopenSession:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREopenSession(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREopenSessionResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREopenSessionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREopenRemoteSession:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREopenRemoteSession(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREopenRemoteSessionResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREopenRemoteSessionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREopenExistingSession:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREopenExistingSession(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREopenExistingSessionResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREopenExistingSessionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREwaitForPropertyChange:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREwaitForPropertyChange(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREwaitForPropertyChangeResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREwaitForPropertyChangeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateDHCPServer:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREcreateDHCPServer(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateDHCPServerResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREcreateDHCPServerResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREfindDHCPServerByNetworkName:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREfindDHCPServerByNetworkName(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREfindDHCPServerByNetworkNameResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREfindDHCPServerByNetworkNameResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREremoveDHCPServer:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREremoveDHCPServer(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREremoveDHCPServerResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREremoveDHCPServerResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcheckFirmwarePresent:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREcheckFirmwarePresent(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcheckFirmwarePresentResponse:
		return (void*)soap_instantiate__vbox__IVirtualBox_USCOREcheckFirmwarePresentResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREgetPath:
		return (void*)soap_instantiate__vbox__IVFSExplorer_USCOREgetPath(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREgetPathResponse:
		return (void*)soap_instantiate__vbox__IVFSExplorer_USCOREgetPathResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREgetType:
		return (void*)soap_instantiate__vbox__IVFSExplorer_USCOREgetType(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREgetTypeResponse:
		return (void*)soap_instantiate__vbox__IVFSExplorer_USCOREgetTypeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREupdate:
		return (void*)soap_instantiate__vbox__IVFSExplorer_USCOREupdate(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREupdateResponse:
		return (void*)soap_instantiate__vbox__IVFSExplorer_USCOREupdateResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREcd:
		return (void*)soap_instantiate__vbox__IVFSExplorer_USCOREcd(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREcdResponse:
		return (void*)soap_instantiate__vbox__IVFSExplorer_USCOREcdResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREcdUp:
		return (void*)soap_instantiate__vbox__IVFSExplorer_USCOREcdUp(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREcdUpResponse:
		return (void*)soap_instantiate__vbox__IVFSExplorer_USCOREcdUpResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREentryList:
		return (void*)soap_instantiate__vbox__IVFSExplorer_USCOREentryList(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREentryListResponse:
		return (void*)soap_instantiate__vbox__IVFSExplorer_USCOREentryListResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREexists:
		return (void*)soap_instantiate__vbox__IVFSExplorer_USCOREexists(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREexistsResponse:
		return (void*)soap_instantiate__vbox__IVFSExplorer_USCOREexistsResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREremove:
		return (void*)soap_instantiate__vbox__IVFSExplorer_USCOREremove(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREremoveResponse:
		return (void*)soap_instantiate__vbox__IVFSExplorer_USCOREremoveResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IAppliance_USCOREgetPath:
		return (void*)soap_instantiate__vbox__IAppliance_USCOREgetPath(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IAppliance_USCOREgetPathResponse:
		return (void*)soap_instantiate__vbox__IAppliance_USCOREgetPathResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IAppliance_USCOREgetDisks:
		return (void*)soap_instantiate__vbox__IAppliance_USCOREgetDisks(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IAppliance_USCOREgetDisksResponse:
		return (void*)soap_instantiate__vbox__IAppliance_USCOREgetDisksResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IAppliance_USCOREgetVirtualSystemDescriptions:
		return (void*)soap_instantiate__vbox__IAppliance_USCOREgetVirtualSystemDescriptions(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IAppliance_USCOREgetVirtualSystemDescriptionsResponse:
		return (void*)soap_instantiate__vbox__IAppliance_USCOREgetVirtualSystemDescriptionsResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IAppliance_USCOREread:
		return (void*)soap_instantiate__vbox__IAppliance_USCOREread(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IAppliance_USCOREreadResponse:
		return (void*)soap_instantiate__vbox__IAppliance_USCOREreadResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IAppliance_USCOREinterpret:
		return (void*)soap_instantiate__vbox__IAppliance_USCOREinterpret(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IAppliance_USCOREinterpretResponse:
		return (void*)soap_instantiate__vbox__IAppliance_USCOREinterpretResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IAppliance_USCOREimportMachines:
		return (void*)soap_instantiate__vbox__IAppliance_USCOREimportMachines(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IAppliance_USCOREimportMachinesResponse:
		return (void*)soap_instantiate__vbox__IAppliance_USCOREimportMachinesResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IAppliance_USCOREcreateVFSExplorer:
		return (void*)soap_instantiate__vbox__IAppliance_USCOREcreateVFSExplorer(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IAppliance_USCOREcreateVFSExplorerResponse:
		return (void*)soap_instantiate__vbox__IAppliance_USCOREcreateVFSExplorerResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IAppliance_USCOREwrite:
		return (void*)soap_instantiate__vbox__IAppliance_USCOREwrite(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IAppliance_USCOREwriteResponse:
		return (void*)soap_instantiate__vbox__IAppliance_USCOREwriteResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IAppliance_USCOREgetWarnings:
		return (void*)soap_instantiate__vbox__IAppliance_USCOREgetWarnings(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IAppliance_USCOREgetWarningsResponse:
		return (void*)soap_instantiate__vbox__IAppliance_USCOREgetWarningsResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREgetCount:
		return (void*)soap_instantiate__vbox__IVirtualSystemDescription_USCOREgetCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREgetCountResponse:
		return (void*)soap_instantiate__vbox__IVirtualSystemDescription_USCOREgetCountResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREgetDescription:
		return (void*)soap_instantiate__vbox__IVirtualSystemDescription_USCOREgetDescription(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREgetDescriptionResponse:
		return (void*)soap_instantiate__vbox__IVirtualSystemDescription_USCOREgetDescriptionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREgetDescriptionByType:
		return (void*)soap_instantiate__vbox__IVirtualSystemDescription_USCOREgetDescriptionByType(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREgetDescriptionByTypeResponse:
		return (void*)soap_instantiate__vbox__IVirtualSystemDescription_USCOREgetDescriptionByTypeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREgetValuesByType:
		return (void*)soap_instantiate__vbox__IVirtualSystemDescription_USCOREgetValuesByType(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREgetValuesByTypeResponse:
		return (void*)soap_instantiate__vbox__IVirtualSystemDescription_USCOREgetValuesByTypeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREsetFinalValues:
		return (void*)soap_instantiate__vbox__IVirtualSystemDescription_USCOREsetFinalValues(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREsetFinalValuesResponse:
		return (void*)soap_instantiate__vbox__IVirtualSystemDescription_USCOREsetFinalValuesResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREaddDescription:
		return (void*)soap_instantiate__vbox__IVirtualSystemDescription_USCOREaddDescription(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREaddDescriptionResponse:
		return (void*)soap_instantiate__vbox__IVirtualSystemDescription_USCOREaddDescriptionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetLogoFadeIn:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREgetLogoFadeIn(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetLogoFadeInResponse:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREgetLogoFadeInResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetLogoFadeIn:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREsetLogoFadeIn(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetLogoFadeInResponse:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREsetLogoFadeInResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetLogoFadeOut:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREgetLogoFadeOut(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetLogoFadeOutResponse:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREgetLogoFadeOutResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetLogoFadeOut:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREsetLogoFadeOut(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetLogoFadeOutResponse:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREsetLogoFadeOutResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetLogoDisplayTime:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREgetLogoDisplayTime(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetLogoDisplayTimeResponse:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREgetLogoDisplayTimeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetLogoDisplayTime:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREsetLogoDisplayTime(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetLogoDisplayTimeResponse:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREsetLogoDisplayTimeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetLogoImagePath:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREgetLogoImagePath(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetLogoImagePathResponse:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREgetLogoImagePathResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetLogoImagePath:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREsetLogoImagePath(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetLogoImagePathResponse:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREsetLogoImagePathResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetBootMenuMode:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREgetBootMenuMode(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetBootMenuModeResponse:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREgetBootMenuModeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetBootMenuMode:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREsetBootMenuMode(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetBootMenuModeResponse:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREsetBootMenuModeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetACPIEnabled:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREgetACPIEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetACPIEnabledResponse:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREgetACPIEnabledResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetACPIEnabled:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREsetACPIEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetACPIEnabledResponse:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREsetACPIEnabledResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetIOAPICEnabled:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREgetIOAPICEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetIOAPICEnabledResponse:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREgetIOAPICEnabledResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetIOAPICEnabled:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREsetIOAPICEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetIOAPICEnabledResponse:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREsetIOAPICEnabledResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetTimeOffset:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREgetTimeOffset(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetTimeOffsetResponse:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREgetTimeOffsetResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetTimeOffset:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREsetTimeOffset(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetTimeOffsetResponse:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREsetTimeOffsetResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetPXEDebugEnabled:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREgetPXEDebugEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetPXEDebugEnabledResponse:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREgetPXEDebugEnabledResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetPXEDebugEnabled:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREsetPXEDebugEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetPXEDebugEnabledResponse:
		return (void*)soap_instantiate__vbox__IBIOSSettings_USCOREsetPXEDebugEnabledResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetParent:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetParent(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetParentResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetParentResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetAccessible:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetAccessible(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetAccessibleResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetAccessibleResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetAccessError:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetAccessError(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetAccessErrorResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetAccessErrorResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetName:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetName(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetNameResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetNameResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetName:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetName(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetNameResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetNameResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetDescription:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetDescription(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetDescriptionResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetDescriptionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetDescription:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetDescription(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetDescriptionResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetDescriptionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetId:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetId(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetIdResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetIdResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetOSTypeId:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetOSTypeId(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetOSTypeIdResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetOSTypeIdResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetOSTypeId:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetOSTypeId(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetOSTypeIdResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetOSTypeIdResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetHardwareVersion:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetHardwareVersion(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetHardwareVersionResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetHardwareVersionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetHardwareVersion:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetHardwareVersion(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetHardwareVersionResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetHardwareVersionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetHardwareUUID:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetHardwareUUID(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetHardwareUUIDResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetHardwareUUIDResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetHardwareUUID:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetHardwareUUID(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetHardwareUUIDResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetHardwareUUIDResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetCPUCount:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetCPUCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetCPUCountResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetCPUCountResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetCPUCount:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetCPUCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetCPUCountResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetCPUCountResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetMemorySize:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetMemorySize(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetMemorySizeResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetMemorySizeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetMemorySize:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetMemorySize(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetMemorySizeResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetMemorySizeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetMemoryBalloonSize:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetMemoryBalloonSize(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetMemoryBalloonSizeResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetMemoryBalloonSizeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetMemoryBalloonSize:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetMemoryBalloonSize(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetMemoryBalloonSizeResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetMemoryBalloonSizeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetStatisticsUpdateInterval:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetStatisticsUpdateInterval(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetStatisticsUpdateIntervalResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetStatisticsUpdateIntervalResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetStatisticsUpdateInterval:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetStatisticsUpdateInterval(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetStatisticsUpdateIntervalResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetStatisticsUpdateIntervalResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetVRAMSize:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetVRAMSize(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetVRAMSizeResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetVRAMSizeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetVRAMSize:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetVRAMSize(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetVRAMSizeResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetVRAMSizeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetAccelerate3DEnabled:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetAccelerate3DEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetAccelerate3DEnabledResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetAccelerate3DEnabledResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetAccelerate3DEnabled:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetAccelerate3DEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetAccelerate3DEnabledResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetAccelerate3DEnabledResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetAccelerate2DVideoEnabled:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetAccelerate2DVideoEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetAccelerate2DVideoEnabledResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetAccelerate2DVideoEnabledResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetAccelerate2DVideoEnabled:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetAccelerate2DVideoEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetAccelerate2DVideoEnabledResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetAccelerate2DVideoEnabledResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetMonitorCount:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetMonitorCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetMonitorCountResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetMonitorCountResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetMonitorCount:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetMonitorCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetMonitorCountResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetMonitorCountResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetBIOSSettings:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetBIOSSettings(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetBIOSSettingsResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetBIOSSettingsResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetFirmwareType:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetFirmwareType(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetFirmwareTypeResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetFirmwareTypeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetFirmwareType:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetFirmwareType(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetFirmwareTypeResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetFirmwareTypeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetSnapshotFolder:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetSnapshotFolder(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetSnapshotFolderResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetSnapshotFolderResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetSnapshotFolder:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetSnapshotFolder(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetSnapshotFolderResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetSnapshotFolderResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetVRDPServer:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetVRDPServer(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetVRDPServerResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetVRDPServerResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetMediumAttachments:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetMediumAttachments(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetMediumAttachmentsResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetMediumAttachmentsResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetUSBController:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetUSBController(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetUSBControllerResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetUSBControllerResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetAudioAdapter:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetAudioAdapter(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetAudioAdapterResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetAudioAdapterResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetStorageControllers:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetStorageControllers(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetStorageControllersResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetStorageControllersResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetSettingsFilePath:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetSettingsFilePath(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetSettingsFilePathResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetSettingsFilePathResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetSettingsModified:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetSettingsModified(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetSettingsModifiedResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetSettingsModifiedResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetSessionState:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetSessionState(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetSessionStateResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetSessionStateResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetSessionType:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetSessionType(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetSessionTypeResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetSessionTypeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetSessionPid:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetSessionPid(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetSessionPidResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetSessionPidResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetState:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetState(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetStateResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetStateResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetLastStateChange:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetLastStateChange(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetLastStateChangeResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetLastStateChangeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetStateFilePath:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetStateFilePath(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetStateFilePathResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetStateFilePathResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetLogFolder:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetLogFolder(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetLogFolderResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetLogFolderResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetCurrentSnapshot:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetCurrentSnapshot(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetCurrentSnapshotResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetCurrentSnapshotResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetSnapshotCount:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetSnapshotCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetSnapshotCountResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetSnapshotCountResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetCurrentStateModified:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetCurrentStateModified(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetCurrentStateModifiedResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetCurrentStateModifiedResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetSharedFolders:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetSharedFolders(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetSharedFoldersResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetSharedFoldersResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetClipboardMode:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetClipboardMode(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetClipboardModeResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetClipboardModeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetClipboardMode:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetClipboardMode(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetClipboardModeResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetClipboardModeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetGuestPropertyNotificationPatterns:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetGuestPropertyNotificationPatterns(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetGuestPropertyNotificationPatternsResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetGuestPropertyNotificationPatternsResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetGuestPropertyNotificationPatterns:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetGuestPropertyNotificationPatterns(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetGuestPropertyNotificationPatternsResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetGuestPropertyNotificationPatternsResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetTeleporterEnabled:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetTeleporterEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetTeleporterEnabledResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetTeleporterEnabledResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetTeleporterEnabled:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetTeleporterEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetTeleporterEnabledResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetTeleporterEnabledResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetTeleporterPort:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetTeleporterPort(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetTeleporterPortResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetTeleporterPortResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetTeleporterPort:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetTeleporterPort(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetTeleporterPortResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetTeleporterPortResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetTeleporterAddress:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetTeleporterAddress(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetTeleporterAddressResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetTeleporterAddressResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetTeleporterAddress:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetTeleporterAddress(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetTeleporterAddressResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetTeleporterAddressResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetTeleporterPassword:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetTeleporterPassword(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetTeleporterPasswordResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetTeleporterPasswordResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetTeleporterPassword:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetTeleporterPassword(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetTeleporterPasswordResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetTeleporterPasswordResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetBootOrder:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetBootOrder(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetBootOrderResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetBootOrderResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetBootOrder:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetBootOrder(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetBootOrderResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetBootOrderResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREattachDevice:
		return (void*)soap_instantiate__vbox__IMachine_USCOREattachDevice(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREattachDeviceResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREattachDeviceResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREdetachDevice:
		return (void*)soap_instantiate__vbox__IMachine_USCOREdetachDevice(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREdetachDeviceResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREdetachDeviceResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREpassthroughDevice:
		return (void*)soap_instantiate__vbox__IMachine_USCOREpassthroughDevice(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREpassthroughDeviceResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREpassthroughDeviceResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREmountMedium:
		return (void*)soap_instantiate__vbox__IMachine_USCOREmountMedium(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREmountMediumResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREmountMediumResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetMedium:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetMedium(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetMediumResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetMediumResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetMediumAttachmentsOfController:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetMediumAttachmentsOfController(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetMediumAttachmentsOfControllerResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetMediumAttachmentsOfControllerResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetMediumAttachment:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetMediumAttachment(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetMediumAttachmentResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetMediumAttachmentResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetNetworkAdapter:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetNetworkAdapter(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetNetworkAdapterResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetNetworkAdapterResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREaddStorageController:
		return (void*)soap_instantiate__vbox__IMachine_USCOREaddStorageController(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREaddStorageControllerResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREaddStorageControllerResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetStorageControllerByName:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetStorageControllerByName(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetStorageControllerByNameResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetStorageControllerByNameResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetStorageControllerByInstance:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetStorageControllerByInstance(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetStorageControllerByInstanceResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetStorageControllerByInstanceResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREremoveStorageController:
		return (void*)soap_instantiate__vbox__IMachine_USCOREremoveStorageController(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREremoveStorageControllerResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREremoveStorageControllerResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetSerialPort:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetSerialPort(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetSerialPortResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetSerialPortResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetParallelPort:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetParallelPort(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetParallelPortResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetParallelPortResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetExtraDataKeys:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetExtraDataKeys(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetExtraDataKeysResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetExtraDataKeysResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetExtraData:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetExtraData(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetExtraDataResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetExtraDataResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetExtraData:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetExtraData(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetExtraDataResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetExtraDataResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetCpuProperty:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetCpuProperty(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetCpuPropertyResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetCpuPropertyResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetCpuProperty:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetCpuProperty(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetCpuPropertyResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetCpuPropertyResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetCpuIdLeaf:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetCpuIdLeaf(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetCpuIdLeafResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetCpuIdLeafResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetCpuIdLeaf:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetCpuIdLeaf(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetCpuIdLeafResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetCpuIdLeafResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREremoveCpuIdLeaf:
		return (void*)soap_instantiate__vbox__IMachine_USCOREremoveCpuIdLeaf(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREremoveCpuIdLeafResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREremoveCpuIdLeafResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREremoveAllCpuIdLeafs:
		return (void*)soap_instantiate__vbox__IMachine_USCOREremoveAllCpuIdLeafs(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREremoveAllCpuIdLeafsResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREremoveAllCpuIdLeafsResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetHWVirtExProperty:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetHWVirtExProperty(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetHWVirtExPropertyResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetHWVirtExPropertyResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetHWVirtExProperty:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetHWVirtExProperty(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetHWVirtExPropertyResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetHWVirtExPropertyResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsaveSettings:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsaveSettings(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsaveSettingsResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsaveSettingsResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREdiscardSettings:
		return (void*)soap_instantiate__vbox__IMachine_USCOREdiscardSettings(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREdiscardSettingsResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREdiscardSettingsResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREdeleteSettings:
		return (void*)soap_instantiate__vbox__IMachine_USCOREdeleteSettings(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREdeleteSettingsResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREdeleteSettingsResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREexport:
		return (void*)soap_instantiate__vbox__IMachine_USCOREexport(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREexportResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREexportResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetSnapshot:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetSnapshot(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetSnapshotResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetSnapshotResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREfindSnapshot:
		return (void*)soap_instantiate__vbox__IMachine_USCOREfindSnapshot(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREfindSnapshotResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREfindSnapshotResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetCurrentSnapshot:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetCurrentSnapshot(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetCurrentSnapshotResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetCurrentSnapshotResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREcreateSharedFolder:
		return (void*)soap_instantiate__vbox__IMachine_USCOREcreateSharedFolder(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREcreateSharedFolderResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREcreateSharedFolderResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREremoveSharedFolder:
		return (void*)soap_instantiate__vbox__IMachine_USCOREremoveSharedFolder(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREremoveSharedFolderResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREremoveSharedFolderResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREcanShowConsoleWindow:
		return (void*)soap_instantiate__vbox__IMachine_USCOREcanShowConsoleWindow(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREcanShowConsoleWindowResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREcanShowConsoleWindowResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREshowConsoleWindow:
		return (void*)soap_instantiate__vbox__IMachine_USCOREshowConsoleWindow(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREshowConsoleWindowResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREshowConsoleWindowResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetGuestProperty:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetGuestProperty(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetGuestPropertyResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetGuestPropertyResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetGuestPropertyValue:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetGuestPropertyValue(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetGuestPropertyValueResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetGuestPropertyValueResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetGuestPropertyTimestamp:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetGuestPropertyTimestamp(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREgetGuestPropertyTimestampResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREgetGuestPropertyTimestampResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetGuestProperty:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetGuestProperty(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetGuestPropertyResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetGuestPropertyResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetGuestPropertyValue:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetGuestPropertyValue(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREsetGuestPropertyValueResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREsetGuestPropertyValueResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREenumerateGuestProperties:
		return (void*)soap_instantiate__vbox__IMachine_USCOREenumerateGuestProperties(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREenumerateGuestPropertiesResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREenumerateGuestPropertiesResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREquerySavedThumbnailSize:
		return (void*)soap_instantiate__vbox__IMachine_USCOREquerySavedThumbnailSize(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREquerySavedThumbnailSizeResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREquerySavedThumbnailSizeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREreadSavedThumbnailToArray:
		return (void*)soap_instantiate__vbox__IMachine_USCOREreadSavedThumbnailToArray(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREreadSavedThumbnailToArrayResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREreadSavedThumbnailToArrayResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREquerySavedScreenshotPNGSize:
		return (void*)soap_instantiate__vbox__IMachine_USCOREquerySavedScreenshotPNGSize(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREquerySavedScreenshotPNGSizeResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREquerySavedScreenshotPNGSizeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREreadSavedScreenshotPNGToArray:
		return (void*)soap_instantiate__vbox__IMachine_USCOREreadSavedScreenshotPNGToArray(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMachine_USCOREreadSavedScreenshotPNGToArrayResponse:
		return (void*)soap_instantiate__vbox__IMachine_USCOREreadSavedScreenshotPNGToArrayResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREgetMachine:
		return (void*)soap_instantiate__vbox__IConsole_USCOREgetMachine(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREgetMachineResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREgetMachineResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREgetState:
		return (void*)soap_instantiate__vbox__IConsole_USCOREgetState(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREgetStateResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREgetStateResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREgetGuest:
		return (void*)soap_instantiate__vbox__IConsole_USCOREgetGuest(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREgetGuestResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREgetGuestResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREgetKeyboard:
		return (void*)soap_instantiate__vbox__IConsole_USCOREgetKeyboard(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREgetKeyboardResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREgetKeyboardResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREgetMouse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREgetMouse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREgetMouseResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREgetMouseResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREgetDisplay:
		return (void*)soap_instantiate__vbox__IConsole_USCOREgetDisplay(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREgetDisplayResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREgetDisplayResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREgetUSBDevices:
		return (void*)soap_instantiate__vbox__IConsole_USCOREgetUSBDevices(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREgetUSBDevicesResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREgetUSBDevicesResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREgetRemoteUSBDevices:
		return (void*)soap_instantiate__vbox__IConsole_USCOREgetRemoteUSBDevices(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREgetRemoteUSBDevicesResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREgetRemoteUSBDevicesResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREgetSharedFolders:
		return (void*)soap_instantiate__vbox__IConsole_USCOREgetSharedFolders(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREgetSharedFoldersResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREgetSharedFoldersResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREgetRemoteDisplayInfo:
		return (void*)soap_instantiate__vbox__IConsole_USCOREgetRemoteDisplayInfo(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREgetRemoteDisplayInfoResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREgetRemoteDisplayInfoResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREpowerUp:
		return (void*)soap_instantiate__vbox__IConsole_USCOREpowerUp(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREpowerUpResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREpowerUpResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREpowerUpPaused:
		return (void*)soap_instantiate__vbox__IConsole_USCOREpowerUpPaused(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREpowerUpPausedResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREpowerUpPausedResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREpowerDown:
		return (void*)soap_instantiate__vbox__IConsole_USCOREpowerDown(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREpowerDownResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREpowerDownResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREreset:
		return (void*)soap_instantiate__vbox__IConsole_USCOREreset(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREresetResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREresetResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREpause:
		return (void*)soap_instantiate__vbox__IConsole_USCOREpause(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREpauseResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREpauseResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREresume:
		return (void*)soap_instantiate__vbox__IConsole_USCOREresume(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREresumeResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREresumeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREpowerButton:
		return (void*)soap_instantiate__vbox__IConsole_USCOREpowerButton(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREpowerButtonResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREpowerButtonResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREsleepButton:
		return (void*)soap_instantiate__vbox__IConsole_USCOREsleepButton(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREsleepButtonResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREsleepButtonResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREgetPowerButtonHandled:
		return (void*)soap_instantiate__vbox__IConsole_USCOREgetPowerButtonHandled(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREgetPowerButtonHandledResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREgetPowerButtonHandledResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREgetGuestEnteredACPIMode:
		return (void*)soap_instantiate__vbox__IConsole_USCOREgetGuestEnteredACPIMode(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREgetGuestEnteredACPIModeResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREgetGuestEnteredACPIModeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREsaveState:
		return (void*)soap_instantiate__vbox__IConsole_USCOREsaveState(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREsaveStateResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREsaveStateResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREadoptSavedState:
		return (void*)soap_instantiate__vbox__IConsole_USCOREadoptSavedState(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREadoptSavedStateResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREadoptSavedStateResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREforgetSavedState:
		return (void*)soap_instantiate__vbox__IConsole_USCOREforgetSavedState(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREforgetSavedStateResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREforgetSavedStateResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREgetDeviceActivity:
		return (void*)soap_instantiate__vbox__IConsole_USCOREgetDeviceActivity(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREgetDeviceActivityResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREgetDeviceActivityResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREattachUSBDevice:
		return (void*)soap_instantiate__vbox__IConsole_USCOREattachUSBDevice(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREattachUSBDeviceResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREattachUSBDeviceResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREdetachUSBDevice:
		return (void*)soap_instantiate__vbox__IConsole_USCOREdetachUSBDevice(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREdetachUSBDeviceResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREdetachUSBDeviceResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREfindUSBDeviceByAddress:
		return (void*)soap_instantiate__vbox__IConsole_USCOREfindUSBDeviceByAddress(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREfindUSBDeviceByAddressResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREfindUSBDeviceByAddressResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREfindUSBDeviceById:
		return (void*)soap_instantiate__vbox__IConsole_USCOREfindUSBDeviceById(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREfindUSBDeviceByIdResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREfindUSBDeviceByIdResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREcreateSharedFolder:
		return (void*)soap_instantiate__vbox__IConsole_USCOREcreateSharedFolder(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREcreateSharedFolderResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREcreateSharedFolderResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREremoveSharedFolder:
		return (void*)soap_instantiate__vbox__IConsole_USCOREremoveSharedFolder(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREremoveSharedFolderResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREremoveSharedFolderResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREtakeSnapshot:
		return (void*)soap_instantiate__vbox__IConsole_USCOREtakeSnapshot(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREtakeSnapshotResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREtakeSnapshotResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREdeleteSnapshot:
		return (void*)soap_instantiate__vbox__IConsole_USCOREdeleteSnapshot(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREdeleteSnapshotResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREdeleteSnapshotResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCORErestoreSnapshot:
		return (void*)soap_instantiate__vbox__IConsole_USCORErestoreSnapshot(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCORErestoreSnapshotResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCORErestoreSnapshotResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREteleport:
		return (void*)soap_instantiate__vbox__IConsole_USCOREteleport(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IConsole_USCOREteleportResponse:
		return (void*)soap_instantiate__vbox__IConsole_USCOREteleportResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetName:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREgetName(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetNameResponse:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREgetNameResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetId:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREgetId(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetIdResponse:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREgetIdResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetNetworkName:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREgetNetworkName(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetNetworkNameResponse:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREgetNetworkNameResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetDhcpEnabled:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREgetDhcpEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetDhcpEnabledResponse:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREgetDhcpEnabledResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetIPAddress:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREgetIPAddress(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetIPAddressResponse:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREgetIPAddressResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetNetworkMask:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREgetNetworkMask(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetNetworkMaskResponse:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREgetNetworkMaskResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetIPV6Supported:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREgetIPV6Supported(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetIPV6SupportedResponse:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREgetIPV6SupportedResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetIPV6Address:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREgetIPV6Address(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetIPV6AddressResponse:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREgetIPV6AddressResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetIPV6NetworkMaskPrefixLength:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREgetIPV6NetworkMaskPrefixLength(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetIPV6NetworkMaskPrefixLengthResponse:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREgetIPV6NetworkMaskPrefixLengthResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetHardwareAddress:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREgetHardwareAddress(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetHardwareAddressResponse:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREgetHardwareAddressResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetMediumType:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREgetMediumType(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetMediumTypeResponse:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREgetMediumTypeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetStatus:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREgetStatus(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetStatusResponse:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREgetStatusResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetInterfaceType:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREgetInterfaceType(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetInterfaceTypeResponse:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREgetInterfaceTypeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREenableStaticIpConfig:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREenableStaticIpConfig(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREenableStaticIpConfigResponse:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREenableStaticIpConfigResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREenableStaticIpConfigV6:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREenableStaticIpConfigV6(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREenableStaticIpConfigV6Response:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREenableStaticIpConfigV6Response(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREenableDynamicIpConfig:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREenableDynamicIpConfig(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREenableDynamicIpConfigResponse:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREenableDynamicIpConfigResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREdhcpRediscover:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREdhcpRediscover(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREdhcpRediscoverResponse:
		return (void*)soap_instantiate__vbox__IHostNetworkInterface_USCOREdhcpRediscoverResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetDVDDrives:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetDVDDrives(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetDVDDrivesResponse:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetDVDDrivesResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetFloppyDrives:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetFloppyDrives(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetFloppyDrivesResponse:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetFloppyDrivesResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetUSBDevices:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetUSBDevices(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetUSBDevicesResponse:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetUSBDevicesResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetUSBDeviceFilters:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetUSBDeviceFilters(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetUSBDeviceFiltersResponse:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetUSBDeviceFiltersResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetNetworkInterfaces:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetNetworkInterfaces(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetNetworkInterfacesResponse:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetNetworkInterfacesResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorCount:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetProcessorCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorCountResponse:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetProcessorCountResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorOnlineCount:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetProcessorOnlineCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorOnlineCountResponse:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetProcessorOnlineCountResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetMemorySize:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetMemorySize(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetMemorySizeResponse:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetMemorySizeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetMemoryAvailable:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetMemoryAvailable(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetMemoryAvailableResponse:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetMemoryAvailableResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetOperatingSystem:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetOperatingSystem(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetOperatingSystemResponse:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetOperatingSystemResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetOSVersion:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetOSVersion(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetOSVersionResponse:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetOSVersionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetUTCTime:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetUTCTime(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetUTCTimeResponse:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetUTCTimeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetAcceleration3DAvailable:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetAcceleration3DAvailable(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetAcceleration3DAvailableResponse:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetAcceleration3DAvailableResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorSpeed:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetProcessorSpeed(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorSpeedResponse:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetProcessorSpeedResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorFeature:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetProcessorFeature(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorFeatureResponse:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetProcessorFeatureResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorDescription:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetProcessorDescription(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorDescriptionResponse:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetProcessorDescriptionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorCpuIdLeaf:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetProcessorCpuIdLeaf(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorCpuIdLeafResponse:
		return (void*)soap_instantiate__vbox__IHost_USCOREgetProcessorCpuIdLeafResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREcreateHostOnlyNetworkInterface:
		return (void*)soap_instantiate__vbox__IHost_USCOREcreateHostOnlyNetworkInterface(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREcreateHostOnlyNetworkInterfaceResponse:
		return (void*)soap_instantiate__vbox__IHost_USCOREcreateHostOnlyNetworkInterfaceResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREremoveHostOnlyNetworkInterface:
		return (void*)soap_instantiate__vbox__IHost_USCOREremoveHostOnlyNetworkInterface(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREremoveHostOnlyNetworkInterfaceResponse:
		return (void*)soap_instantiate__vbox__IHost_USCOREremoveHostOnlyNetworkInterfaceResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREcreateUSBDeviceFilter:
		return (void*)soap_instantiate__vbox__IHost_USCOREcreateUSBDeviceFilter(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREcreateUSBDeviceFilterResponse:
		return (void*)soap_instantiate__vbox__IHost_USCOREcreateUSBDeviceFilterResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREinsertUSBDeviceFilter:
		return (void*)soap_instantiate__vbox__IHost_USCOREinsertUSBDeviceFilter(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREinsertUSBDeviceFilterResponse:
		return (void*)soap_instantiate__vbox__IHost_USCOREinsertUSBDeviceFilterResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREremoveUSBDeviceFilter:
		return (void*)soap_instantiate__vbox__IHost_USCOREremoveUSBDeviceFilter(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREremoveUSBDeviceFilterResponse:
		return (void*)soap_instantiate__vbox__IHost_USCOREremoveUSBDeviceFilterResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREfindHostDVDDrive:
		return (void*)soap_instantiate__vbox__IHost_USCOREfindHostDVDDrive(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREfindHostDVDDriveResponse:
		return (void*)soap_instantiate__vbox__IHost_USCOREfindHostDVDDriveResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREfindHostFloppyDrive:
		return (void*)soap_instantiate__vbox__IHost_USCOREfindHostFloppyDrive(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREfindHostFloppyDriveResponse:
		return (void*)soap_instantiate__vbox__IHost_USCOREfindHostFloppyDriveResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREfindHostNetworkInterfaceByName:
		return (void*)soap_instantiate__vbox__IHost_USCOREfindHostNetworkInterfaceByName(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREfindHostNetworkInterfaceByNameResponse:
		return (void*)soap_instantiate__vbox__IHost_USCOREfindHostNetworkInterfaceByNameResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREfindHostNetworkInterfaceById:
		return (void*)soap_instantiate__vbox__IHost_USCOREfindHostNetworkInterfaceById(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREfindHostNetworkInterfaceByIdResponse:
		return (void*)soap_instantiate__vbox__IHost_USCOREfindHostNetworkInterfaceByIdResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREfindHostNetworkInterfacesOfType:
		return (void*)soap_instantiate__vbox__IHost_USCOREfindHostNetworkInterfacesOfType(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREfindHostNetworkInterfacesOfTypeResponse:
		return (void*)soap_instantiate__vbox__IHost_USCOREfindHostNetworkInterfacesOfTypeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREfindUSBDeviceById:
		return (void*)soap_instantiate__vbox__IHost_USCOREfindUSBDeviceById(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREfindUSBDeviceByIdResponse:
		return (void*)soap_instantiate__vbox__IHost_USCOREfindUSBDeviceByIdResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREfindUSBDeviceByAddress:
		return (void*)soap_instantiate__vbox__IHost_USCOREfindUSBDeviceByAddress(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHost_USCOREfindUSBDeviceByAddressResponse:
		return (void*)soap_instantiate__vbox__IHost_USCOREfindUSBDeviceByAddressResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMinGuestRAM:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetMinGuestRAM(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMinGuestRAMResponse:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetMinGuestRAMResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxGuestRAM:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetMaxGuestRAM(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxGuestRAMResponse:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetMaxGuestRAMResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMinGuestVRAM:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetMinGuestVRAM(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMinGuestVRAMResponse:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetMinGuestVRAMResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxGuestVRAM:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetMaxGuestVRAM(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxGuestVRAMResponse:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetMaxGuestVRAMResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMinGuestCPUCount:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetMinGuestCPUCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMinGuestCPUCountResponse:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetMinGuestCPUCountResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxGuestCPUCount:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetMaxGuestCPUCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxGuestCPUCountResponse:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetMaxGuestCPUCountResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxVDISize:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetMaxVDISize(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxVDISizeResponse:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetMaxVDISizeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetNetworkAdapterCount:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetNetworkAdapterCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetNetworkAdapterCountResponse:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetNetworkAdapterCountResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetSerialPortCount:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetSerialPortCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetSerialPortCountResponse:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetSerialPortCountResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetParallelPortCount:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetParallelPortCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetParallelPortCountResponse:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetParallelPortCountResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxBootPosition:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetMaxBootPosition(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxBootPositionResponse:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetMaxBootPositionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDefaultMachineFolder:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetDefaultMachineFolder(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDefaultMachineFolderResponse:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetDefaultMachineFolderResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetDefaultMachineFolder:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREsetDefaultMachineFolder(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetDefaultMachineFolderResponse:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREsetDefaultMachineFolderResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDefaultHardDiskFolder:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetDefaultHardDiskFolder(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDefaultHardDiskFolderResponse:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetDefaultHardDiskFolderResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetDefaultHardDiskFolder:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREsetDefaultHardDiskFolder(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetDefaultHardDiskFolderResponse:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREsetDefaultHardDiskFolderResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMediumFormats:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetMediumFormats(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMediumFormatsResponse:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetMediumFormatsResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDefaultHardDiskFormat:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetDefaultHardDiskFormat(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDefaultHardDiskFormatResponse:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetDefaultHardDiskFormatResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetDefaultHardDiskFormat:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREsetDefaultHardDiskFormat(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetDefaultHardDiskFormatResponse:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREsetDefaultHardDiskFormatResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetRemoteDisplayAuthLibrary:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetRemoteDisplayAuthLibrary(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetRemoteDisplayAuthLibraryResponse:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetRemoteDisplayAuthLibraryResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetRemoteDisplayAuthLibrary:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREsetRemoteDisplayAuthLibrary(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetRemoteDisplayAuthLibraryResponse:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREsetRemoteDisplayAuthLibraryResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetWebServiceAuthLibrary:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetWebServiceAuthLibrary(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetWebServiceAuthLibraryResponse:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetWebServiceAuthLibraryResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetWebServiceAuthLibrary:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREsetWebServiceAuthLibrary(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetWebServiceAuthLibraryResponse:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREsetWebServiceAuthLibraryResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetLogHistoryCount:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetLogHistoryCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetLogHistoryCountResponse:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetLogHistoryCountResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetLogHistoryCount:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREsetLogHistoryCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetLogHistoryCountResponse:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREsetLogHistoryCountResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDefaultAudioDriver:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetDefaultAudioDriver(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDefaultAudioDriverResponse:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetDefaultAudioDriverResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxDevicesPerPortForStorageBus:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetMaxDevicesPerPortForStorageBus(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxDevicesPerPortForStorageBusResponse:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetMaxDevicesPerPortForStorageBusResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMinPortCountForStorageBus:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetMinPortCountForStorageBus(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMinPortCountForStorageBusResponse:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetMinPortCountForStorageBusResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxPortCountForStorageBus:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetMaxPortCountForStorageBus(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxPortCountForStorageBusResponse:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetMaxPortCountForStorageBusResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxInstancesOfStorageBus:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetMaxInstancesOfStorageBus(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxInstancesOfStorageBusResponse:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetMaxInstancesOfStorageBusResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDeviceTypesForStorageBus:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetDeviceTypesForStorageBus(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDeviceTypesForStorageBusResponse:
		return (void*)soap_instantiate__vbox__ISystemProperties_USCOREgetDeviceTypesForStorageBusResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IGuest_USCOREgetOSTypeId:
		return (void*)soap_instantiate__vbox__IGuest_USCOREgetOSTypeId(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IGuest_USCOREgetOSTypeIdResponse:
		return (void*)soap_instantiate__vbox__IGuest_USCOREgetOSTypeIdResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IGuest_USCOREgetAdditionsActive:
		return (void*)soap_instantiate__vbox__IGuest_USCOREgetAdditionsActive(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IGuest_USCOREgetAdditionsActiveResponse:
		return (void*)soap_instantiate__vbox__IGuest_USCOREgetAdditionsActiveResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IGuest_USCOREgetAdditionsVersion:
		return (void*)soap_instantiate__vbox__IGuest_USCOREgetAdditionsVersion(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IGuest_USCOREgetAdditionsVersionResponse:
		return (void*)soap_instantiate__vbox__IGuest_USCOREgetAdditionsVersionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IGuest_USCOREgetSupportsSeamless:
		return (void*)soap_instantiate__vbox__IGuest_USCOREgetSupportsSeamless(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IGuest_USCOREgetSupportsSeamlessResponse:
		return (void*)soap_instantiate__vbox__IGuest_USCOREgetSupportsSeamlessResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IGuest_USCOREgetSupportsGraphics:
		return (void*)soap_instantiate__vbox__IGuest_USCOREgetSupportsGraphics(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IGuest_USCOREgetSupportsGraphicsResponse:
		return (void*)soap_instantiate__vbox__IGuest_USCOREgetSupportsGraphicsResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IGuest_USCOREgetMemoryBalloonSize:
		return (void*)soap_instantiate__vbox__IGuest_USCOREgetMemoryBalloonSize(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IGuest_USCOREgetMemoryBalloonSizeResponse:
		return (void*)soap_instantiate__vbox__IGuest_USCOREgetMemoryBalloonSizeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IGuest_USCOREsetMemoryBalloonSize:
		return (void*)soap_instantiate__vbox__IGuest_USCOREsetMemoryBalloonSize(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IGuest_USCOREsetMemoryBalloonSizeResponse:
		return (void*)soap_instantiate__vbox__IGuest_USCOREsetMemoryBalloonSizeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IGuest_USCOREgetStatisticsUpdateInterval:
		return (void*)soap_instantiate__vbox__IGuest_USCOREgetStatisticsUpdateInterval(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IGuest_USCOREgetStatisticsUpdateIntervalResponse:
		return (void*)soap_instantiate__vbox__IGuest_USCOREgetStatisticsUpdateIntervalResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IGuest_USCOREsetStatisticsUpdateInterval:
		return (void*)soap_instantiate__vbox__IGuest_USCOREsetStatisticsUpdateInterval(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IGuest_USCOREsetStatisticsUpdateIntervalResponse:
		return (void*)soap_instantiate__vbox__IGuest_USCOREsetStatisticsUpdateIntervalResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IGuest_USCOREsetCredentials:
		return (void*)soap_instantiate__vbox__IGuest_USCOREsetCredentials(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IGuest_USCOREsetCredentialsResponse:
		return (void*)soap_instantiate__vbox__IGuest_USCOREsetCredentialsResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IGuest_USCOREgetStatistic:
		return (void*)soap_instantiate__vbox__IGuest_USCOREgetStatistic(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IGuest_USCOREgetStatisticResponse:
		return (void*)soap_instantiate__vbox__IGuest_USCOREgetStatisticResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREgetId:
		return (void*)soap_instantiate__vbox__IProgress_USCOREgetId(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREgetIdResponse:
		return (void*)soap_instantiate__vbox__IProgress_USCOREgetIdResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREgetDescription:
		return (void*)soap_instantiate__vbox__IProgress_USCOREgetDescription(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREgetDescriptionResponse:
		return (void*)soap_instantiate__vbox__IProgress_USCOREgetDescriptionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREgetInitiator:
		return (void*)soap_instantiate__vbox__IProgress_USCOREgetInitiator(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREgetInitiatorResponse:
		return (void*)soap_instantiate__vbox__IProgress_USCOREgetInitiatorResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREgetCancelable:
		return (void*)soap_instantiate__vbox__IProgress_USCOREgetCancelable(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREgetCancelableResponse:
		return (void*)soap_instantiate__vbox__IProgress_USCOREgetCancelableResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREgetPercent:
		return (void*)soap_instantiate__vbox__IProgress_USCOREgetPercent(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREgetPercentResponse:
		return (void*)soap_instantiate__vbox__IProgress_USCOREgetPercentResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREgetTimeRemaining:
		return (void*)soap_instantiate__vbox__IProgress_USCOREgetTimeRemaining(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREgetTimeRemainingResponse:
		return (void*)soap_instantiate__vbox__IProgress_USCOREgetTimeRemainingResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREgetCompleted:
		return (void*)soap_instantiate__vbox__IProgress_USCOREgetCompleted(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREgetCompletedResponse:
		return (void*)soap_instantiate__vbox__IProgress_USCOREgetCompletedResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREgetCanceled:
		return (void*)soap_instantiate__vbox__IProgress_USCOREgetCanceled(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREgetCanceledResponse:
		return (void*)soap_instantiate__vbox__IProgress_USCOREgetCanceledResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREgetResultCode:
		return (void*)soap_instantiate__vbox__IProgress_USCOREgetResultCode(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREgetResultCodeResponse:
		return (void*)soap_instantiate__vbox__IProgress_USCOREgetResultCodeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREgetErrorInfo:
		return (void*)soap_instantiate__vbox__IProgress_USCOREgetErrorInfo(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREgetErrorInfoResponse:
		return (void*)soap_instantiate__vbox__IProgress_USCOREgetErrorInfoResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREgetOperationCount:
		return (void*)soap_instantiate__vbox__IProgress_USCOREgetOperationCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREgetOperationCountResponse:
		return (void*)soap_instantiate__vbox__IProgress_USCOREgetOperationCountResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREgetOperation:
		return (void*)soap_instantiate__vbox__IProgress_USCOREgetOperation(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREgetOperationResponse:
		return (void*)soap_instantiate__vbox__IProgress_USCOREgetOperationResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREgetOperationDescription:
		return (void*)soap_instantiate__vbox__IProgress_USCOREgetOperationDescription(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREgetOperationDescriptionResponse:
		return (void*)soap_instantiate__vbox__IProgress_USCOREgetOperationDescriptionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREgetOperationPercent:
		return (void*)soap_instantiate__vbox__IProgress_USCOREgetOperationPercent(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREgetOperationPercentResponse:
		return (void*)soap_instantiate__vbox__IProgress_USCOREgetOperationPercentResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREgetTimeout:
		return (void*)soap_instantiate__vbox__IProgress_USCOREgetTimeout(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREgetTimeoutResponse:
		return (void*)soap_instantiate__vbox__IProgress_USCOREgetTimeoutResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREsetTimeout:
		return (void*)soap_instantiate__vbox__IProgress_USCOREsetTimeout(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREsetTimeoutResponse:
		return (void*)soap_instantiate__vbox__IProgress_USCOREsetTimeoutResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREsetCurrentOperationProgress:
		return (void*)soap_instantiate__vbox__IProgress_USCOREsetCurrentOperationProgress(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREsetCurrentOperationProgressResponse:
		return (void*)soap_instantiate__vbox__IProgress_USCOREsetCurrentOperationProgressResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREsetNextOperation:
		return (void*)soap_instantiate__vbox__IProgress_USCOREsetNextOperation(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREsetNextOperationResponse:
		return (void*)soap_instantiate__vbox__IProgress_USCOREsetNextOperationResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREwaitForCompletion:
		return (void*)soap_instantiate__vbox__IProgress_USCOREwaitForCompletion(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREwaitForCompletionResponse:
		return (void*)soap_instantiate__vbox__IProgress_USCOREwaitForCompletionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREwaitForOperationCompletion:
		return (void*)soap_instantiate__vbox__IProgress_USCOREwaitForOperationCompletion(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREwaitForOperationCompletionResponse:
		return (void*)soap_instantiate__vbox__IProgress_USCOREwaitForOperationCompletionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREcancel:
		return (void*)soap_instantiate__vbox__IProgress_USCOREcancel(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IProgress_USCOREcancelResponse:
		return (void*)soap_instantiate__vbox__IProgress_USCOREcancelResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetId:
		return (void*)soap_instantiate__vbox__ISnapshot_USCOREgetId(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetIdResponse:
		return (void*)soap_instantiate__vbox__ISnapshot_USCOREgetIdResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetName:
		return (void*)soap_instantiate__vbox__ISnapshot_USCOREgetName(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetNameResponse:
		return (void*)soap_instantiate__vbox__ISnapshot_USCOREgetNameResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISnapshot_USCOREsetName:
		return (void*)soap_instantiate__vbox__ISnapshot_USCOREsetName(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISnapshot_USCOREsetNameResponse:
		return (void*)soap_instantiate__vbox__ISnapshot_USCOREsetNameResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetDescription:
		return (void*)soap_instantiate__vbox__ISnapshot_USCOREgetDescription(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetDescriptionResponse:
		return (void*)soap_instantiate__vbox__ISnapshot_USCOREgetDescriptionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISnapshot_USCOREsetDescription:
		return (void*)soap_instantiate__vbox__ISnapshot_USCOREsetDescription(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISnapshot_USCOREsetDescriptionResponse:
		return (void*)soap_instantiate__vbox__ISnapshot_USCOREsetDescriptionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetTimeStamp:
		return (void*)soap_instantiate__vbox__ISnapshot_USCOREgetTimeStamp(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetTimeStampResponse:
		return (void*)soap_instantiate__vbox__ISnapshot_USCOREgetTimeStampResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetOnline:
		return (void*)soap_instantiate__vbox__ISnapshot_USCOREgetOnline(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetOnlineResponse:
		return (void*)soap_instantiate__vbox__ISnapshot_USCOREgetOnlineResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetMachine:
		return (void*)soap_instantiate__vbox__ISnapshot_USCOREgetMachine(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetMachineResponse:
		return (void*)soap_instantiate__vbox__ISnapshot_USCOREgetMachineResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetParent:
		return (void*)soap_instantiate__vbox__ISnapshot_USCOREgetParent(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetParentResponse:
		return (void*)soap_instantiate__vbox__ISnapshot_USCOREgetParentResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetChildren:
		return (void*)soap_instantiate__vbox__ISnapshot_USCOREgetChildren(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetChildrenResponse:
		return (void*)soap_instantiate__vbox__ISnapshot_USCOREgetChildrenResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetId:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetId(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetIdResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetIdResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetDescription:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetDescription(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetDescriptionResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetDescriptionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREsetDescription:
		return (void*)soap_instantiate__vbox__IMedium_USCOREsetDescription(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREsetDescriptionResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREsetDescriptionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetState:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetState(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetStateResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetStateResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetLocation:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetLocation(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetLocationResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetLocationResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREsetLocation:
		return (void*)soap_instantiate__vbox__IMedium_USCOREsetLocation(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREsetLocationResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREsetLocationResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetName:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetName(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetNameResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetNameResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetDeviceType:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetDeviceType(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetDeviceTypeResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetDeviceTypeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetHostDrive:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetHostDrive(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetHostDriveResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetHostDriveResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetSize:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetSize(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetSizeResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetSizeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetFormat:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetFormat(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetFormatResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetFormatResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetType:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetType(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetTypeResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetTypeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREsetType:
		return (void*)soap_instantiate__vbox__IMedium_USCOREsetType(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREsetTypeResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREsetTypeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetParent:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetParent(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetParentResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetParentResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetChildren:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetChildren(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetChildrenResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetChildrenResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetBase:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetBase(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetBaseResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetBaseResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetReadOnly:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetReadOnly(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetReadOnlyResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetReadOnlyResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetLogicalSize:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetLogicalSize(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetLogicalSizeResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetLogicalSizeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetAutoReset:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetAutoReset(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetAutoResetResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetAutoResetResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREsetAutoReset:
		return (void*)soap_instantiate__vbox__IMedium_USCOREsetAutoReset(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREsetAutoResetResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREsetAutoResetResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetLastAccessError:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetLastAccessError(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetLastAccessErrorResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetLastAccessErrorResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetMachineIds:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetMachineIds(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetMachineIdsResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetMachineIdsResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCORErefreshState:
		return (void*)soap_instantiate__vbox__IMedium_USCORErefreshState(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCORErefreshStateResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCORErefreshStateResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetSnapshotIds:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetSnapshotIds(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetSnapshotIdsResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetSnapshotIdsResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCORElockRead:
		return (void*)soap_instantiate__vbox__IMedium_USCORElockRead(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCORElockReadResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCORElockReadResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREunlockRead:
		return (void*)soap_instantiate__vbox__IMedium_USCOREunlockRead(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREunlockReadResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREunlockReadResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCORElockWrite:
		return (void*)soap_instantiate__vbox__IMedium_USCORElockWrite(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCORElockWriteResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCORElockWriteResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREunlockWrite:
		return (void*)soap_instantiate__vbox__IMedium_USCOREunlockWrite(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREunlockWriteResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREunlockWriteResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREclose:
		return (void*)soap_instantiate__vbox__IMedium_USCOREclose(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREcloseResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREcloseResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetProperty:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetProperty(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetPropertyResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetPropertyResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREsetProperty:
		return (void*)soap_instantiate__vbox__IMedium_USCOREsetProperty(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREsetPropertyResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREsetPropertyResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetProperties:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetProperties(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREgetPropertiesResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREgetPropertiesResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREsetProperties:
		return (void*)soap_instantiate__vbox__IMedium_USCOREsetProperties(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREsetPropertiesResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREsetPropertiesResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREcreateBaseStorage:
		return (void*)soap_instantiate__vbox__IMedium_USCOREcreateBaseStorage(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREcreateBaseStorageResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREcreateBaseStorageResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREdeleteStorage:
		return (void*)soap_instantiate__vbox__IMedium_USCOREdeleteStorage(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREdeleteStorageResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREdeleteStorageResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREcreateDiffStorage:
		return (void*)soap_instantiate__vbox__IMedium_USCOREcreateDiffStorage(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREcreateDiffStorageResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREcreateDiffStorageResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREmergeTo:
		return (void*)soap_instantiate__vbox__IMedium_USCOREmergeTo(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREmergeToResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREmergeToResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREcloneTo:
		return (void*)soap_instantiate__vbox__IMedium_USCOREcloneTo(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREcloneToResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREcloneToResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREcompact:
		return (void*)soap_instantiate__vbox__IMedium_USCOREcompact(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREcompactResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREcompactResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREresize:
		return (void*)soap_instantiate__vbox__IMedium_USCOREresize(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREresizeResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREresizeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREreset:
		return (void*)soap_instantiate__vbox__IMedium_USCOREreset(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMedium_USCOREresetResponse:
		return (void*)soap_instantiate__vbox__IMedium_USCOREresetResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMediumFormat_USCOREgetId:
		return (void*)soap_instantiate__vbox__IMediumFormat_USCOREgetId(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMediumFormat_USCOREgetIdResponse:
		return (void*)soap_instantiate__vbox__IMediumFormat_USCOREgetIdResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMediumFormat_USCOREgetName:
		return (void*)soap_instantiate__vbox__IMediumFormat_USCOREgetName(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMediumFormat_USCOREgetNameResponse:
		return (void*)soap_instantiate__vbox__IMediumFormat_USCOREgetNameResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMediumFormat_USCOREgetFileExtensions:
		return (void*)soap_instantiate__vbox__IMediumFormat_USCOREgetFileExtensions(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMediumFormat_USCOREgetFileExtensionsResponse:
		return (void*)soap_instantiate__vbox__IMediumFormat_USCOREgetFileExtensionsResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMediumFormat_USCOREgetCapabilities:
		return (void*)soap_instantiate__vbox__IMediumFormat_USCOREgetCapabilities(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMediumFormat_USCOREgetCapabilitiesResponse:
		return (void*)soap_instantiate__vbox__IMediumFormat_USCOREgetCapabilitiesResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMediumFormat_USCOREdescribeProperties:
		return (void*)soap_instantiate__vbox__IMediumFormat_USCOREdescribeProperties(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMediumFormat_USCOREdescribePropertiesResponse:
		return (void*)soap_instantiate__vbox__IMediumFormat_USCOREdescribePropertiesResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IKeyboard_USCOREputScancode:
		return (void*)soap_instantiate__vbox__IKeyboard_USCOREputScancode(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IKeyboard_USCOREputScancodeResponse:
		return (void*)soap_instantiate__vbox__IKeyboard_USCOREputScancodeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IKeyboard_USCOREputScancodes:
		return (void*)soap_instantiate__vbox__IKeyboard_USCOREputScancodes(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IKeyboard_USCOREputScancodesResponse:
		return (void*)soap_instantiate__vbox__IKeyboard_USCOREputScancodesResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IKeyboard_USCOREputCAD:
		return (void*)soap_instantiate__vbox__IKeyboard_USCOREputCAD(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IKeyboard_USCOREputCADResponse:
		return (void*)soap_instantiate__vbox__IKeyboard_USCOREputCADResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMouse_USCOREgetAbsoluteSupported:
		return (void*)soap_instantiate__vbox__IMouse_USCOREgetAbsoluteSupported(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMouse_USCOREgetAbsoluteSupportedResponse:
		return (void*)soap_instantiate__vbox__IMouse_USCOREgetAbsoluteSupportedResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMouse_USCOREputMouseEvent:
		return (void*)soap_instantiate__vbox__IMouse_USCOREputMouseEvent(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMouse_USCOREputMouseEventResponse:
		return (void*)soap_instantiate__vbox__IMouse_USCOREputMouseEventResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMouse_USCOREputMouseEventAbsolute:
		return (void*)soap_instantiate__vbox__IMouse_USCOREputMouseEventAbsolute(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IMouse_USCOREputMouseEventAbsoluteResponse:
		return (void*)soap_instantiate__vbox__IMouse_USCOREputMouseEventAbsoluteResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDisplay_USCOREgetWidth:
		return (void*)soap_instantiate__vbox__IDisplay_USCOREgetWidth(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDisplay_USCOREgetWidthResponse:
		return (void*)soap_instantiate__vbox__IDisplay_USCOREgetWidthResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDisplay_USCOREgetHeight:
		return (void*)soap_instantiate__vbox__IDisplay_USCOREgetHeight(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDisplay_USCOREgetHeightResponse:
		return (void*)soap_instantiate__vbox__IDisplay_USCOREgetHeightResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDisplay_USCOREgetBitsPerPixel:
		return (void*)soap_instantiate__vbox__IDisplay_USCOREgetBitsPerPixel(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDisplay_USCOREgetBitsPerPixelResponse:
		return (void*)soap_instantiate__vbox__IDisplay_USCOREgetBitsPerPixelResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDisplay_USCOREsetVideoModeHint:
		return (void*)soap_instantiate__vbox__IDisplay_USCOREsetVideoModeHint(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDisplay_USCOREsetVideoModeHintResponse:
		return (void*)soap_instantiate__vbox__IDisplay_USCOREsetVideoModeHintResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDisplay_USCOREsetSeamlessMode:
		return (void*)soap_instantiate__vbox__IDisplay_USCOREsetSeamlessMode(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDisplay_USCOREsetSeamlessModeResponse:
		return (void*)soap_instantiate__vbox__IDisplay_USCOREsetSeamlessModeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDisplay_USCOREtakeScreenShotSlow:
		return (void*)soap_instantiate__vbox__IDisplay_USCOREtakeScreenShotSlow(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDisplay_USCOREtakeScreenShotSlowResponse:
		return (void*)soap_instantiate__vbox__IDisplay_USCOREtakeScreenShotSlowResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDisplay_USCOREinvalidateAndUpdate:
		return (void*)soap_instantiate__vbox__IDisplay_USCOREinvalidateAndUpdate(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDisplay_USCOREinvalidateAndUpdateResponse:
		return (void*)soap_instantiate__vbox__IDisplay_USCOREinvalidateAndUpdateResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDisplay_USCOREresizeCompleted:
		return (void*)soap_instantiate__vbox__IDisplay_USCOREresizeCompleted(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDisplay_USCOREresizeCompletedResponse:
		return (void*)soap_instantiate__vbox__IDisplay_USCOREresizeCompletedResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDisplay_USCOREupdateCompleted:
		return (void*)soap_instantiate__vbox__IDisplay_USCOREupdateCompleted(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IDisplay_USCOREupdateCompletedResponse:
		return (void*)soap_instantiate__vbox__IDisplay_USCOREupdateCompletedResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetAdapterType:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREgetAdapterType(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetAdapterTypeResponse:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREgetAdapterTypeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetAdapterType:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREsetAdapterType(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetAdapterTypeResponse:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREsetAdapterTypeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetSlot:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREgetSlot(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetSlotResponse:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREgetSlotResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetEnabled:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREgetEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetEnabledResponse:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREgetEnabledResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetEnabled:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREsetEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetEnabledResponse:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREsetEnabledResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetMACAddress:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREgetMACAddress(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetMACAddressResponse:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREgetMACAddressResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetMACAddress:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREsetMACAddress(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetMACAddressResponse:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREsetMACAddressResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetAttachmentType:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREgetAttachmentType(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetAttachmentTypeResponse:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREgetAttachmentTypeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetHostInterface:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREgetHostInterface(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetHostInterfaceResponse:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREgetHostInterfaceResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetHostInterface:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREsetHostInterface(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetHostInterfaceResponse:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREsetHostInterfaceResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetInternalNetwork:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREgetInternalNetwork(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetInternalNetworkResponse:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREgetInternalNetworkResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetInternalNetwork:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREsetInternalNetwork(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetInternalNetworkResponse:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREsetInternalNetworkResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetNATNetwork:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREgetNATNetwork(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetNATNetworkResponse:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREgetNATNetworkResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetNATNetwork:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREsetNATNetwork(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetNATNetworkResponse:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREsetNATNetworkResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetCableConnected:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREgetCableConnected(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetCableConnectedResponse:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREgetCableConnectedResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetCableConnected:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREsetCableConnected(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetCableConnectedResponse:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREsetCableConnectedResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetLineSpeed:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREgetLineSpeed(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetLineSpeedResponse:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREgetLineSpeedResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetLineSpeed:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREsetLineSpeed(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetLineSpeedResponse:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREsetLineSpeedResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetTraceEnabled:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREgetTraceEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetTraceEnabledResponse:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREgetTraceEnabledResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetTraceEnabled:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREsetTraceEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetTraceEnabledResponse:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREsetTraceEnabledResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetTraceFile:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREgetTraceFile(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetTraceFileResponse:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREgetTraceFileResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetTraceFile:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREsetTraceFile(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetTraceFileResponse:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREsetTraceFileResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREattachToNAT:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREattachToNAT(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREattachToNATResponse:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREattachToNATResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREattachToBridgedInterface:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREattachToBridgedInterface(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREattachToBridgedInterfaceResponse:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREattachToBridgedInterfaceResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREattachToInternalNetwork:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREattachToInternalNetwork(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREattachToInternalNetworkResponse:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREattachToInternalNetworkResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREattachToHostOnlyInterface:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREattachToHostOnlyInterface(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREattachToHostOnlyInterfaceResponse:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREattachToHostOnlyInterfaceResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREdetach:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREdetach(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREdetachResponse:
		return (void*)soap_instantiate__vbox__INetworkAdapter_USCOREdetachResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetSlot:
		return (void*)soap_instantiate__vbox__ISerialPort_USCOREgetSlot(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetSlotResponse:
		return (void*)soap_instantiate__vbox__ISerialPort_USCOREgetSlotResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetEnabled:
		return (void*)soap_instantiate__vbox__ISerialPort_USCOREgetEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetEnabledResponse:
		return (void*)soap_instantiate__vbox__ISerialPort_USCOREgetEnabledResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetEnabled:
		return (void*)soap_instantiate__vbox__ISerialPort_USCOREsetEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetEnabledResponse:
		return (void*)soap_instantiate__vbox__ISerialPort_USCOREsetEnabledResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetIOBase:
		return (void*)soap_instantiate__vbox__ISerialPort_USCOREgetIOBase(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetIOBaseResponse:
		return (void*)soap_instantiate__vbox__ISerialPort_USCOREgetIOBaseResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetIOBase:
		return (void*)soap_instantiate__vbox__ISerialPort_USCOREsetIOBase(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetIOBaseResponse:
		return (void*)soap_instantiate__vbox__ISerialPort_USCOREsetIOBaseResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetIRQ:
		return (void*)soap_instantiate__vbox__ISerialPort_USCOREgetIRQ(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetIRQResponse:
		return (void*)soap_instantiate__vbox__ISerialPort_USCOREgetIRQResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetIRQ:
		return (void*)soap_instantiate__vbox__ISerialPort_USCOREsetIRQ(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetIRQResponse:
		return (void*)soap_instantiate__vbox__ISerialPort_USCOREsetIRQResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetHostMode:
		return (void*)soap_instantiate__vbox__ISerialPort_USCOREgetHostMode(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetHostModeResponse:
		return (void*)soap_instantiate__vbox__ISerialPort_USCOREgetHostModeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetHostMode:
		return (void*)soap_instantiate__vbox__ISerialPort_USCOREsetHostMode(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetHostModeResponse:
		return (void*)soap_instantiate__vbox__ISerialPort_USCOREsetHostModeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetServer:
		return (void*)soap_instantiate__vbox__ISerialPort_USCOREgetServer(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetServerResponse:
		return (void*)soap_instantiate__vbox__ISerialPort_USCOREgetServerResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetServer:
		return (void*)soap_instantiate__vbox__ISerialPort_USCOREsetServer(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetServerResponse:
		return (void*)soap_instantiate__vbox__ISerialPort_USCOREsetServerResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetPath:
		return (void*)soap_instantiate__vbox__ISerialPort_USCOREgetPath(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetPathResponse:
		return (void*)soap_instantiate__vbox__ISerialPort_USCOREgetPathResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetPath:
		return (void*)soap_instantiate__vbox__ISerialPort_USCOREsetPath(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetPathResponse:
		return (void*)soap_instantiate__vbox__ISerialPort_USCOREsetPathResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IParallelPort_USCOREgetSlot:
		return (void*)soap_instantiate__vbox__IParallelPort_USCOREgetSlot(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IParallelPort_USCOREgetSlotResponse:
		return (void*)soap_instantiate__vbox__IParallelPort_USCOREgetSlotResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IParallelPort_USCOREgetEnabled:
		return (void*)soap_instantiate__vbox__IParallelPort_USCOREgetEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IParallelPort_USCOREgetEnabledResponse:
		return (void*)soap_instantiate__vbox__IParallelPort_USCOREgetEnabledResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IParallelPort_USCOREsetEnabled:
		return (void*)soap_instantiate__vbox__IParallelPort_USCOREsetEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IParallelPort_USCOREsetEnabledResponse:
		return (void*)soap_instantiate__vbox__IParallelPort_USCOREsetEnabledResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IParallelPort_USCOREgetIOBase:
		return (void*)soap_instantiate__vbox__IParallelPort_USCOREgetIOBase(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IParallelPort_USCOREgetIOBaseResponse:
		return (void*)soap_instantiate__vbox__IParallelPort_USCOREgetIOBaseResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IParallelPort_USCOREsetIOBase:
		return (void*)soap_instantiate__vbox__IParallelPort_USCOREsetIOBase(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IParallelPort_USCOREsetIOBaseResponse:
		return (void*)soap_instantiate__vbox__IParallelPort_USCOREsetIOBaseResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IParallelPort_USCOREgetIRQ:
		return (void*)soap_instantiate__vbox__IParallelPort_USCOREgetIRQ(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IParallelPort_USCOREgetIRQResponse:
		return (void*)soap_instantiate__vbox__IParallelPort_USCOREgetIRQResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IParallelPort_USCOREsetIRQ:
		return (void*)soap_instantiate__vbox__IParallelPort_USCOREsetIRQ(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IParallelPort_USCOREsetIRQResponse:
		return (void*)soap_instantiate__vbox__IParallelPort_USCOREsetIRQResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IParallelPort_USCOREgetPath:
		return (void*)soap_instantiate__vbox__IParallelPort_USCOREgetPath(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IParallelPort_USCOREgetPathResponse:
		return (void*)soap_instantiate__vbox__IParallelPort_USCOREgetPathResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IParallelPort_USCOREsetPath:
		return (void*)soap_instantiate__vbox__IParallelPort_USCOREsetPath(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IParallelPort_USCOREsetPathResponse:
		return (void*)soap_instantiate__vbox__IParallelPort_USCOREsetPathResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBController_USCOREgetEnabled:
		return (void*)soap_instantiate__vbox__IUSBController_USCOREgetEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBController_USCOREgetEnabledResponse:
		return (void*)soap_instantiate__vbox__IUSBController_USCOREgetEnabledResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBController_USCOREsetEnabled:
		return (void*)soap_instantiate__vbox__IUSBController_USCOREsetEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBController_USCOREsetEnabledResponse:
		return (void*)soap_instantiate__vbox__IUSBController_USCOREsetEnabledResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBController_USCOREgetEnabledEhci:
		return (void*)soap_instantiate__vbox__IUSBController_USCOREgetEnabledEhci(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBController_USCOREgetEnabledEhciResponse:
		return (void*)soap_instantiate__vbox__IUSBController_USCOREgetEnabledEhciResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBController_USCOREsetEnabledEhci:
		return (void*)soap_instantiate__vbox__IUSBController_USCOREsetEnabledEhci(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBController_USCOREsetEnabledEhciResponse:
		return (void*)soap_instantiate__vbox__IUSBController_USCOREsetEnabledEhciResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBController_USCOREgetUSBStandard:
		return (void*)soap_instantiate__vbox__IUSBController_USCOREgetUSBStandard(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBController_USCOREgetUSBStandardResponse:
		return (void*)soap_instantiate__vbox__IUSBController_USCOREgetUSBStandardResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBController_USCOREgetDeviceFilters:
		return (void*)soap_instantiate__vbox__IUSBController_USCOREgetDeviceFilters(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBController_USCOREgetDeviceFiltersResponse:
		return (void*)soap_instantiate__vbox__IUSBController_USCOREgetDeviceFiltersResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBController_USCOREcreateDeviceFilter:
		return (void*)soap_instantiate__vbox__IUSBController_USCOREcreateDeviceFilter(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBController_USCOREcreateDeviceFilterResponse:
		return (void*)soap_instantiate__vbox__IUSBController_USCOREcreateDeviceFilterResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBController_USCOREinsertDeviceFilter:
		return (void*)soap_instantiate__vbox__IUSBController_USCOREinsertDeviceFilter(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBController_USCOREinsertDeviceFilterResponse:
		return (void*)soap_instantiate__vbox__IUSBController_USCOREinsertDeviceFilterResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBController_USCOREremoveDeviceFilter:
		return (void*)soap_instantiate__vbox__IUSBController_USCOREremoveDeviceFilter(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBController_USCOREremoveDeviceFilterResponse:
		return (void*)soap_instantiate__vbox__IUSBController_USCOREremoveDeviceFilterResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetId:
		return (void*)soap_instantiate__vbox__IUSBDevice_USCOREgetId(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetIdResponse:
		return (void*)soap_instantiate__vbox__IUSBDevice_USCOREgetIdResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetVendorId:
		return (void*)soap_instantiate__vbox__IUSBDevice_USCOREgetVendorId(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetVendorIdResponse:
		return (void*)soap_instantiate__vbox__IUSBDevice_USCOREgetVendorIdResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetProductId:
		return (void*)soap_instantiate__vbox__IUSBDevice_USCOREgetProductId(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetProductIdResponse:
		return (void*)soap_instantiate__vbox__IUSBDevice_USCOREgetProductIdResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetRevision:
		return (void*)soap_instantiate__vbox__IUSBDevice_USCOREgetRevision(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetRevisionResponse:
		return (void*)soap_instantiate__vbox__IUSBDevice_USCOREgetRevisionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetManufacturer:
		return (void*)soap_instantiate__vbox__IUSBDevice_USCOREgetManufacturer(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetManufacturerResponse:
		return (void*)soap_instantiate__vbox__IUSBDevice_USCOREgetManufacturerResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetProduct:
		return (void*)soap_instantiate__vbox__IUSBDevice_USCOREgetProduct(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetProductResponse:
		return (void*)soap_instantiate__vbox__IUSBDevice_USCOREgetProductResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetSerialNumber:
		return (void*)soap_instantiate__vbox__IUSBDevice_USCOREgetSerialNumber(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetSerialNumberResponse:
		return (void*)soap_instantiate__vbox__IUSBDevice_USCOREgetSerialNumberResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetAddress:
		return (void*)soap_instantiate__vbox__IUSBDevice_USCOREgetAddress(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetAddressResponse:
		return (void*)soap_instantiate__vbox__IUSBDevice_USCOREgetAddressResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetPort:
		return (void*)soap_instantiate__vbox__IUSBDevice_USCOREgetPort(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetPortResponse:
		return (void*)soap_instantiate__vbox__IUSBDevice_USCOREgetPortResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetVersion:
		return (void*)soap_instantiate__vbox__IUSBDevice_USCOREgetVersion(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetVersionResponse:
		return (void*)soap_instantiate__vbox__IUSBDevice_USCOREgetVersionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetPortVersion:
		return (void*)soap_instantiate__vbox__IUSBDevice_USCOREgetPortVersion(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetPortVersionResponse:
		return (void*)soap_instantiate__vbox__IUSBDevice_USCOREgetPortVersionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetRemote:
		return (void*)soap_instantiate__vbox__IUSBDevice_USCOREgetRemote(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetRemoteResponse:
		return (void*)soap_instantiate__vbox__IUSBDevice_USCOREgetRemoteResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetName:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREgetName(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetNameResponse:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREgetNameResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetName:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREsetName(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetNameResponse:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREsetNameResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetActive:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREgetActive(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetActiveResponse:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREgetActiveResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetActive:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREsetActive(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetActiveResponse:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREsetActiveResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetVendorId:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREgetVendorId(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetVendorIdResponse:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREgetVendorIdResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetVendorId:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREsetVendorId(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetVendorIdResponse:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREsetVendorIdResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetProductId:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREgetProductId(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetProductIdResponse:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREgetProductIdResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetProductId:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREsetProductId(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetProductIdResponse:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREsetProductIdResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetRevision:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREgetRevision(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetRevisionResponse:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREgetRevisionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetRevision:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREsetRevision(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetRevisionResponse:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREsetRevisionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetManufacturer:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREgetManufacturer(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetManufacturerResponse:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREgetManufacturerResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetManufacturer:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREsetManufacturer(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetManufacturerResponse:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREsetManufacturerResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetProduct:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREgetProduct(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetProductResponse:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREgetProductResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetProduct:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREsetProduct(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetProductResponse:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREsetProductResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetSerialNumber:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREgetSerialNumber(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetSerialNumberResponse:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREgetSerialNumberResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetSerialNumber:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREsetSerialNumber(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetSerialNumberResponse:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREsetSerialNumberResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetPort:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREgetPort(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetPortResponse:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREgetPortResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetPort:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREsetPort(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetPortResponse:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREsetPortResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetRemote:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREgetRemote(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetRemoteResponse:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREgetRemoteResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetRemote:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREsetRemote(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetRemoteResponse:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREsetRemoteResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetMaskedInterfaces:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREgetMaskedInterfaces(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetMaskedInterfacesResponse:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREgetMaskedInterfacesResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetMaskedInterfaces:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREsetMaskedInterfaces(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetMaskedInterfacesResponse:
		return (void*)soap_instantiate__vbox__IUSBDeviceFilter_USCOREsetMaskedInterfacesResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostUSBDevice_USCOREgetState:
		return (void*)soap_instantiate__vbox__IHostUSBDevice_USCOREgetState(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostUSBDevice_USCOREgetStateResponse:
		return (void*)soap_instantiate__vbox__IHostUSBDevice_USCOREgetStateResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREgetAction:
		return (void*)soap_instantiate__vbox__IHostUSBDeviceFilter_USCOREgetAction(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREgetActionResponse:
		return (void*)soap_instantiate__vbox__IHostUSBDeviceFilter_USCOREgetActionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREsetAction:
		return (void*)soap_instantiate__vbox__IHostUSBDeviceFilter_USCOREsetAction(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREsetActionResponse:
		return (void*)soap_instantiate__vbox__IHostUSBDeviceFilter_USCOREsetActionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREgetEnabled:
		return (void*)soap_instantiate__vbox__IAudioAdapter_USCOREgetEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREgetEnabledResponse:
		return (void*)soap_instantiate__vbox__IAudioAdapter_USCOREgetEnabledResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREsetEnabled:
		return (void*)soap_instantiate__vbox__IAudioAdapter_USCOREsetEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREsetEnabledResponse:
		return (void*)soap_instantiate__vbox__IAudioAdapter_USCOREsetEnabledResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioController:
		return (void*)soap_instantiate__vbox__IAudioAdapter_USCOREgetAudioController(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioControllerResponse:
		return (void*)soap_instantiate__vbox__IAudioAdapter_USCOREgetAudioControllerResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioController:
		return (void*)soap_instantiate__vbox__IAudioAdapter_USCOREsetAudioController(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioControllerResponse:
		return (void*)soap_instantiate__vbox__IAudioAdapter_USCOREsetAudioControllerResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioDriver:
		return (void*)soap_instantiate__vbox__IAudioAdapter_USCOREgetAudioDriver(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioDriverResponse:
		return (void*)soap_instantiate__vbox__IAudioAdapter_USCOREgetAudioDriverResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioDriver:
		return (void*)soap_instantiate__vbox__IAudioAdapter_USCOREsetAudioDriver(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioDriverResponse:
		return (void*)soap_instantiate__vbox__IAudioAdapter_USCOREsetAudioDriverResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVRDPServer_USCOREgetEnabled:
		return (void*)soap_instantiate__vbox__IVRDPServer_USCOREgetEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVRDPServer_USCOREgetEnabledResponse:
		return (void*)soap_instantiate__vbox__IVRDPServer_USCOREgetEnabledResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVRDPServer_USCOREsetEnabled:
		return (void*)soap_instantiate__vbox__IVRDPServer_USCOREsetEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVRDPServer_USCOREsetEnabledResponse:
		return (void*)soap_instantiate__vbox__IVRDPServer_USCOREsetEnabledResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVRDPServer_USCOREgetPorts:
		return (void*)soap_instantiate__vbox__IVRDPServer_USCOREgetPorts(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVRDPServer_USCOREgetPortsResponse:
		return (void*)soap_instantiate__vbox__IVRDPServer_USCOREgetPortsResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVRDPServer_USCOREsetPorts:
		return (void*)soap_instantiate__vbox__IVRDPServer_USCOREsetPorts(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVRDPServer_USCOREsetPortsResponse:
		return (void*)soap_instantiate__vbox__IVRDPServer_USCOREsetPortsResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVRDPServer_USCOREgetNetAddress:
		return (void*)soap_instantiate__vbox__IVRDPServer_USCOREgetNetAddress(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVRDPServer_USCOREgetNetAddressResponse:
		return (void*)soap_instantiate__vbox__IVRDPServer_USCOREgetNetAddressResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVRDPServer_USCOREsetNetAddress:
		return (void*)soap_instantiate__vbox__IVRDPServer_USCOREsetNetAddress(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVRDPServer_USCOREsetNetAddressResponse:
		return (void*)soap_instantiate__vbox__IVRDPServer_USCOREsetNetAddressResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVRDPServer_USCOREgetAuthType:
		return (void*)soap_instantiate__vbox__IVRDPServer_USCOREgetAuthType(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVRDPServer_USCOREgetAuthTypeResponse:
		return (void*)soap_instantiate__vbox__IVRDPServer_USCOREgetAuthTypeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVRDPServer_USCOREsetAuthType:
		return (void*)soap_instantiate__vbox__IVRDPServer_USCOREsetAuthType(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVRDPServer_USCOREsetAuthTypeResponse:
		return (void*)soap_instantiate__vbox__IVRDPServer_USCOREsetAuthTypeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVRDPServer_USCOREgetAuthTimeout:
		return (void*)soap_instantiate__vbox__IVRDPServer_USCOREgetAuthTimeout(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVRDPServer_USCOREgetAuthTimeoutResponse:
		return (void*)soap_instantiate__vbox__IVRDPServer_USCOREgetAuthTimeoutResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVRDPServer_USCOREsetAuthTimeout:
		return (void*)soap_instantiate__vbox__IVRDPServer_USCOREsetAuthTimeout(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVRDPServer_USCOREsetAuthTimeoutResponse:
		return (void*)soap_instantiate__vbox__IVRDPServer_USCOREsetAuthTimeoutResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVRDPServer_USCOREgetAllowMultiConnection:
		return (void*)soap_instantiate__vbox__IVRDPServer_USCOREgetAllowMultiConnection(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse:
		return (void*)soap_instantiate__vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVRDPServer_USCOREsetAllowMultiConnection:
		return (void*)soap_instantiate__vbox__IVRDPServer_USCOREsetAllowMultiConnection(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse:
		return (void*)soap_instantiate__vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVRDPServer_USCOREgetReuseSingleConnection:
		return (void*)soap_instantiate__vbox__IVRDPServer_USCOREgetReuseSingleConnection(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse:
		return (void*)soap_instantiate__vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVRDPServer_USCOREsetReuseSingleConnection:
		return (void*)soap_instantiate__vbox__IVRDPServer_USCOREsetReuseSingleConnection(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse:
		return (void*)soap_instantiate__vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISession_USCOREgetState:
		return (void*)soap_instantiate__vbox__ISession_USCOREgetState(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISession_USCOREgetStateResponse:
		return (void*)soap_instantiate__vbox__ISession_USCOREgetStateResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISession_USCOREgetType:
		return (void*)soap_instantiate__vbox__ISession_USCOREgetType(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISession_USCOREgetTypeResponse:
		return (void*)soap_instantiate__vbox__ISession_USCOREgetTypeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISession_USCOREgetMachine:
		return (void*)soap_instantiate__vbox__ISession_USCOREgetMachine(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISession_USCOREgetMachineResponse:
		return (void*)soap_instantiate__vbox__ISession_USCOREgetMachineResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISession_USCOREgetConsole:
		return (void*)soap_instantiate__vbox__ISession_USCOREgetConsole(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISession_USCOREgetConsoleResponse:
		return (void*)soap_instantiate__vbox__ISession_USCOREgetConsoleResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISession_USCOREclose:
		return (void*)soap_instantiate__vbox__ISession_USCOREclose(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__ISession_USCOREcloseResponse:
		return (void*)soap_instantiate__vbox__ISession_USCOREcloseResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IStorageController_USCOREgetName:
		return (void*)soap_instantiate__vbox__IStorageController_USCOREgetName(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IStorageController_USCOREgetNameResponse:
		return (void*)soap_instantiate__vbox__IStorageController_USCOREgetNameResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IStorageController_USCOREgetMaxDevicesPerPortCount:
		return (void*)soap_instantiate__vbox__IStorageController_USCOREgetMaxDevicesPerPortCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse:
		return (void*)soap_instantiate__vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IStorageController_USCOREgetMinPortCount:
		return (void*)soap_instantiate__vbox__IStorageController_USCOREgetMinPortCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IStorageController_USCOREgetMinPortCountResponse:
		return (void*)soap_instantiate__vbox__IStorageController_USCOREgetMinPortCountResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IStorageController_USCOREgetMaxPortCount:
		return (void*)soap_instantiate__vbox__IStorageController_USCOREgetMaxPortCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IStorageController_USCOREgetMaxPortCountResponse:
		return (void*)soap_instantiate__vbox__IStorageController_USCOREgetMaxPortCountResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IStorageController_USCOREgetInstance:
		return (void*)soap_instantiate__vbox__IStorageController_USCOREgetInstance(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IStorageController_USCOREgetInstanceResponse:
		return (void*)soap_instantiate__vbox__IStorageController_USCOREgetInstanceResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IStorageController_USCOREsetInstance:
		return (void*)soap_instantiate__vbox__IStorageController_USCOREsetInstance(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IStorageController_USCOREsetInstanceResponse:
		return (void*)soap_instantiate__vbox__IStorageController_USCOREsetInstanceResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IStorageController_USCOREgetPortCount:
		return (void*)soap_instantiate__vbox__IStorageController_USCOREgetPortCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IStorageController_USCOREgetPortCountResponse:
		return (void*)soap_instantiate__vbox__IStorageController_USCOREgetPortCountResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IStorageController_USCOREsetPortCount:
		return (void*)soap_instantiate__vbox__IStorageController_USCOREsetPortCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IStorageController_USCOREsetPortCountResponse:
		return (void*)soap_instantiate__vbox__IStorageController_USCOREsetPortCountResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IStorageController_USCOREgetBus:
		return (void*)soap_instantiate__vbox__IStorageController_USCOREgetBus(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IStorageController_USCOREgetBusResponse:
		return (void*)soap_instantiate__vbox__IStorageController_USCOREgetBusResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IStorageController_USCOREgetControllerType:
		return (void*)soap_instantiate__vbox__IStorageController_USCOREgetControllerType(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IStorageController_USCOREgetControllerTypeResponse:
		return (void*)soap_instantiate__vbox__IStorageController_USCOREgetControllerTypeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IStorageController_USCOREsetControllerType:
		return (void*)soap_instantiate__vbox__IStorageController_USCOREsetControllerType(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IStorageController_USCOREsetControllerTypeResponse:
		return (void*)soap_instantiate__vbox__IStorageController_USCOREsetControllerTypeResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IStorageController_USCOREGetIDEEmulationPort:
		return (void*)soap_instantiate__vbox__IStorageController_USCOREGetIDEEmulationPort(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IStorageController_USCOREGetIDEEmulationPortResponse:
		return (void*)soap_instantiate__vbox__IStorageController_USCOREGetIDEEmulationPortResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IStorageController_USCORESetIDEEmulationPort:
		return (void*)soap_instantiate__vbox__IStorageController_USCORESetIDEEmulationPort(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IStorageController_USCORESetIDEEmulationPortResponse:
		return (void*)soap_instantiate__vbox__IStorageController_USCORESetIDEEmulationPortResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IManagedObjectRef_USCOREgetInterfaceName:
		return (void*)soap_instantiate__vbox__IManagedObjectRef_USCOREgetInterfaceName(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse:
		return (void*)soap_instantiate__vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IManagedObjectRef_USCORErelease:
		return (void*)soap_instantiate__vbox__IManagedObjectRef_USCORErelease(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IManagedObjectRef_USCOREreleaseResponse:
		return (void*)soap_instantiate__vbox__IManagedObjectRef_USCOREreleaseResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IWebsessionManager_USCORElogon:
		return (void*)soap_instantiate__vbox__IWebsessionManager_USCORElogon(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IWebsessionManager_USCORElogonResponse:
		return (void*)soap_instantiate__vbox__IWebsessionManager_USCORElogonResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IWebsessionManager_USCOREgetSessionObject:
		return (void*)soap_instantiate__vbox__IWebsessionManager_USCOREgetSessionObject(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IWebsessionManager_USCOREgetSessionObjectResponse:
		return (void*)soap_instantiate__vbox__IWebsessionManager_USCOREgetSessionObjectResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IWebsessionManager_USCORElogoff:
		return (void*)soap_instantiate__vbox__IWebsessionManager_USCORElogoff(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IWebsessionManager_USCORElogoffResponse:
		return (void*)soap_instantiate__vbox__IWebsessionManager_USCORElogoffResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMetricName:
		return (void*)soap_instantiate__vbox__IPerformanceMetric_USCOREgetMetricName(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMetricNameResponse:
		return (void*)soap_instantiate__vbox__IPerformanceMetric_USCOREgetMetricNameResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetObject:
		return (void*)soap_instantiate__vbox__IPerformanceMetric_USCOREgetObject(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetObjectResponse:
		return (void*)soap_instantiate__vbox__IPerformanceMetric_USCOREgetObjectResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetDescription:
		return (void*)soap_instantiate__vbox__IPerformanceMetric_USCOREgetDescription(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetDescriptionResponse:
		return (void*)soap_instantiate__vbox__IPerformanceMetric_USCOREgetDescriptionResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetPeriod:
		return (void*)soap_instantiate__vbox__IPerformanceMetric_USCOREgetPeriod(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetPeriodResponse:
		return (void*)soap_instantiate__vbox__IPerformanceMetric_USCOREgetPeriodResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetCount:
		return (void*)soap_instantiate__vbox__IPerformanceMetric_USCOREgetCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetCountResponse:
		return (void*)soap_instantiate__vbox__IPerformanceMetric_USCOREgetCountResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetUnit:
		return (void*)soap_instantiate__vbox__IPerformanceMetric_USCOREgetUnit(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetUnitResponse:
		return (void*)soap_instantiate__vbox__IPerformanceMetric_USCOREgetUnitResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMinimumValue:
		return (void*)soap_instantiate__vbox__IPerformanceMetric_USCOREgetMinimumValue(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMinimumValueResponse:
		return (void*)soap_instantiate__vbox__IPerformanceMetric_USCOREgetMinimumValueResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMaximumValue:
		return (void*)soap_instantiate__vbox__IPerformanceMetric_USCOREgetMaximumValue(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMaximumValueResponse:
		return (void*)soap_instantiate__vbox__IPerformanceMetric_USCOREgetMaximumValueResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetricNames:
		return (void*)soap_instantiate__vbox__IPerformanceCollector_USCOREgetMetricNames(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetricNamesResponse:
		return (void*)soap_instantiate__vbox__IPerformanceCollector_USCOREgetMetricNamesResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetrics:
		return (void*)soap_instantiate__vbox__IPerformanceCollector_USCOREgetMetrics(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetricsResponse:
		return (void*)soap_instantiate__vbox__IPerformanceCollector_USCOREgetMetricsResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREsetupMetrics:
		return (void*)soap_instantiate__vbox__IPerformanceCollector_USCOREsetupMetrics(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREsetupMetricsResponse:
		return (void*)soap_instantiate__vbox__IPerformanceCollector_USCOREsetupMetricsResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREenableMetrics:
		return (void*)soap_instantiate__vbox__IPerformanceCollector_USCOREenableMetrics(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREenableMetricsResponse:
		return (void*)soap_instantiate__vbox__IPerformanceCollector_USCOREenableMetricsResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREdisableMetrics:
		return (void*)soap_instantiate__vbox__IPerformanceCollector_USCOREdisableMetrics(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREdisableMetricsResponse:
		return (void*)soap_instantiate__vbox__IPerformanceCollector_USCOREdisableMetricsResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREqueryMetricsData:
		return (void*)soap_instantiate__vbox__IPerformanceCollector_USCOREqueryMetricsData(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse:
		return (void*)soap_instantiate__vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__InvalidObjectFault:
		return (void*)soap_instantiate__vbox__InvalidObjectFault(soap, -1, type, arrayType, n);
	case SOAP_TYPE__vbox__RuntimeFault:
		return (void*)soap_instantiate__vbox__RuntimeFault(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBoxErrorInfo_USCOREgetResultCode:
		return (void*)soap_instantiate___vbox__IVirtualBoxErrorInfo_USCOREgetResultCode(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBoxErrorInfo_USCOREgetInterfaceID:
		return (void*)soap_instantiate___vbox__IVirtualBoxErrorInfo_USCOREgetInterfaceID(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBoxErrorInfo_USCOREgetComponent:
		return (void*)soap_instantiate___vbox__IVirtualBoxErrorInfo_USCOREgetComponent(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBoxErrorInfo_USCOREgetText:
		return (void*)soap_instantiate___vbox__IVirtualBoxErrorInfo_USCOREgetText(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBoxErrorInfo_USCOREgetNext:
		return (void*)soap_instantiate___vbox__IVirtualBoxErrorInfo_USCOREgetNext(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IDHCPServer_USCOREgetEnabled:
		return (void*)soap_instantiate___vbox__IDHCPServer_USCOREgetEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IDHCPServer_USCOREsetEnabled:
		return (void*)soap_instantiate___vbox__IDHCPServer_USCOREsetEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IDHCPServer_USCOREgetIPAddress:
		return (void*)soap_instantiate___vbox__IDHCPServer_USCOREgetIPAddress(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IDHCPServer_USCOREgetNetworkMask:
		return (void*)soap_instantiate___vbox__IDHCPServer_USCOREgetNetworkMask(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IDHCPServer_USCOREgetNetworkName:
		return (void*)soap_instantiate___vbox__IDHCPServer_USCOREgetNetworkName(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IDHCPServer_USCOREgetLowerIP:
		return (void*)soap_instantiate___vbox__IDHCPServer_USCOREgetLowerIP(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IDHCPServer_USCOREgetUpperIP:
		return (void*)soap_instantiate___vbox__IDHCPServer_USCOREgetUpperIP(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IDHCPServer_USCOREsetConfiguration:
		return (void*)soap_instantiate___vbox__IDHCPServer_USCOREsetConfiguration(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IDHCPServer_USCOREstart:
		return (void*)soap_instantiate___vbox__IDHCPServer_USCOREstart(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IDHCPServer_USCOREstop:
		return (void*)soap_instantiate___vbox__IDHCPServer_USCOREstop(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetVersion:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREgetVersion(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetRevision:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREgetRevision(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetPackageType:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREgetPackageType(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetHomeFolder:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREgetHomeFolder(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetSettingsFilePath:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREgetSettingsFilePath(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetHost:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREgetHost(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetSystemProperties:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREgetSystemProperties(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetMachines:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREgetMachines(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetHardDisks:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREgetHardDisks(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetDVDImages:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREgetDVDImages(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetFloppyImages:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREgetFloppyImages(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetProgressOperations:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREgetProgressOperations(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetGuestOSTypes:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREgetGuestOSTypes(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetSharedFolders:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREgetSharedFolders(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetPerformanceCollector:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREgetPerformanceCollector(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetDHCPServers:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREgetDHCPServers(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREcreateMachine:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREcreateMachine(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREcreateLegacyMachine:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREcreateLegacyMachine(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREopenMachine:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREopenMachine(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREregisterMachine:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREregisterMachine(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetMachine:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREgetMachine(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREfindMachine:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREfindMachine(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREunregisterMachine:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREunregisterMachine(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREcreateAppliance:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREcreateAppliance(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREcreateHardDisk:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREcreateHardDisk(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREopenHardDisk:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREopenHardDisk(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetHardDisk:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREgetHardDisk(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREfindHardDisk:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREfindHardDisk(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREopenDVDImage:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREopenDVDImage(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetDVDImage:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREgetDVDImage(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREfindDVDImage:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREfindDVDImage(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREopenFloppyImage:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREopenFloppyImage(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetFloppyImage:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREgetFloppyImage(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREfindFloppyImage:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREfindFloppyImage(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetGuestOSType:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREgetGuestOSType(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREcreateSharedFolder:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREcreateSharedFolder(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREremoveSharedFolder:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREremoveSharedFolder(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetExtraDataKeys:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREgetExtraDataKeys(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetExtraData:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREgetExtraData(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREsetExtraData:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREsetExtraData(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREopenSession:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREopenSession(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREopenRemoteSession:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREopenRemoteSession(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREopenExistingSession:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREopenExistingSession(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREwaitForPropertyChange:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREwaitForPropertyChange(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREcreateDHCPServer:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREcreateDHCPServer(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREfindDHCPServerByNetworkName:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREfindDHCPServerByNetworkName(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREremoveDHCPServer:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREremoveDHCPServer(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualBox_USCOREcheckFirmwarePresent:
		return (void*)soap_instantiate___vbox__IVirtualBox_USCOREcheckFirmwarePresent(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVFSExplorer_USCOREgetPath:
		return (void*)soap_instantiate___vbox__IVFSExplorer_USCOREgetPath(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVFSExplorer_USCOREgetType:
		return (void*)soap_instantiate___vbox__IVFSExplorer_USCOREgetType(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVFSExplorer_USCOREupdate:
		return (void*)soap_instantiate___vbox__IVFSExplorer_USCOREupdate(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVFSExplorer_USCOREcd:
		return (void*)soap_instantiate___vbox__IVFSExplorer_USCOREcd(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVFSExplorer_USCOREcdUp:
		return (void*)soap_instantiate___vbox__IVFSExplorer_USCOREcdUp(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVFSExplorer_USCOREentryList:
		return (void*)soap_instantiate___vbox__IVFSExplorer_USCOREentryList(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVFSExplorer_USCOREexists:
		return (void*)soap_instantiate___vbox__IVFSExplorer_USCOREexists(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVFSExplorer_USCOREremove:
		return (void*)soap_instantiate___vbox__IVFSExplorer_USCOREremove(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IAppliance_USCOREgetPath:
		return (void*)soap_instantiate___vbox__IAppliance_USCOREgetPath(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IAppliance_USCOREgetDisks:
		return (void*)soap_instantiate___vbox__IAppliance_USCOREgetDisks(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IAppliance_USCOREgetVirtualSystemDescriptions:
		return (void*)soap_instantiate___vbox__IAppliance_USCOREgetVirtualSystemDescriptions(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IAppliance_USCOREread:
		return (void*)soap_instantiate___vbox__IAppliance_USCOREread(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IAppliance_USCOREinterpret:
		return (void*)soap_instantiate___vbox__IAppliance_USCOREinterpret(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IAppliance_USCOREimportMachines:
		return (void*)soap_instantiate___vbox__IAppliance_USCOREimportMachines(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IAppliance_USCOREcreateVFSExplorer:
		return (void*)soap_instantiate___vbox__IAppliance_USCOREcreateVFSExplorer(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IAppliance_USCOREwrite:
		return (void*)soap_instantiate___vbox__IAppliance_USCOREwrite(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IAppliance_USCOREgetWarnings:
		return (void*)soap_instantiate___vbox__IAppliance_USCOREgetWarnings(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualSystemDescription_USCOREgetCount:
		return (void*)soap_instantiate___vbox__IVirtualSystemDescription_USCOREgetCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualSystemDescription_USCOREgetDescription:
		return (void*)soap_instantiate___vbox__IVirtualSystemDescription_USCOREgetDescription(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualSystemDescription_USCOREgetDescriptionByType:
		return (void*)soap_instantiate___vbox__IVirtualSystemDescription_USCOREgetDescriptionByType(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualSystemDescription_USCOREgetValuesByType:
		return (void*)soap_instantiate___vbox__IVirtualSystemDescription_USCOREgetValuesByType(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualSystemDescription_USCOREsetFinalValues:
		return (void*)soap_instantiate___vbox__IVirtualSystemDescription_USCOREsetFinalValues(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVirtualSystemDescription_USCOREaddDescription:
		return (void*)soap_instantiate___vbox__IVirtualSystemDescription_USCOREaddDescription(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREgetLogoFadeIn:
		return (void*)soap_instantiate___vbox__IBIOSSettings_USCOREgetLogoFadeIn(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREsetLogoFadeIn:
		return (void*)soap_instantiate___vbox__IBIOSSettings_USCOREsetLogoFadeIn(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREgetLogoFadeOut:
		return (void*)soap_instantiate___vbox__IBIOSSettings_USCOREgetLogoFadeOut(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREsetLogoFadeOut:
		return (void*)soap_instantiate___vbox__IBIOSSettings_USCOREsetLogoFadeOut(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREgetLogoDisplayTime:
		return (void*)soap_instantiate___vbox__IBIOSSettings_USCOREgetLogoDisplayTime(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREsetLogoDisplayTime:
		return (void*)soap_instantiate___vbox__IBIOSSettings_USCOREsetLogoDisplayTime(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREgetLogoImagePath:
		return (void*)soap_instantiate___vbox__IBIOSSettings_USCOREgetLogoImagePath(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREsetLogoImagePath:
		return (void*)soap_instantiate___vbox__IBIOSSettings_USCOREsetLogoImagePath(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREgetBootMenuMode:
		return (void*)soap_instantiate___vbox__IBIOSSettings_USCOREgetBootMenuMode(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREsetBootMenuMode:
		return (void*)soap_instantiate___vbox__IBIOSSettings_USCOREsetBootMenuMode(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREgetACPIEnabled:
		return (void*)soap_instantiate___vbox__IBIOSSettings_USCOREgetACPIEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREsetACPIEnabled:
		return (void*)soap_instantiate___vbox__IBIOSSettings_USCOREsetACPIEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREgetIOAPICEnabled:
		return (void*)soap_instantiate___vbox__IBIOSSettings_USCOREgetIOAPICEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREsetIOAPICEnabled:
		return (void*)soap_instantiate___vbox__IBIOSSettings_USCOREsetIOAPICEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREgetTimeOffset:
		return (void*)soap_instantiate___vbox__IBIOSSettings_USCOREgetTimeOffset(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREsetTimeOffset:
		return (void*)soap_instantiate___vbox__IBIOSSettings_USCOREsetTimeOffset(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREgetPXEDebugEnabled:
		return (void*)soap_instantiate___vbox__IBIOSSettings_USCOREgetPXEDebugEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREsetPXEDebugEnabled:
		return (void*)soap_instantiate___vbox__IBIOSSettings_USCOREsetPXEDebugEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetParent:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetParent(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetAccessible:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetAccessible(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetAccessError:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetAccessError(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetName:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetName(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREsetName:
		return (void*)soap_instantiate___vbox__IMachine_USCOREsetName(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetDescription:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetDescription(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREsetDescription:
		return (void*)soap_instantiate___vbox__IMachine_USCOREsetDescription(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetId:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetId(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetOSTypeId:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetOSTypeId(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREsetOSTypeId:
		return (void*)soap_instantiate___vbox__IMachine_USCOREsetOSTypeId(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetHardwareVersion:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetHardwareVersion(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREsetHardwareVersion:
		return (void*)soap_instantiate___vbox__IMachine_USCOREsetHardwareVersion(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetHardwareUUID:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetHardwareUUID(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREsetHardwareUUID:
		return (void*)soap_instantiate___vbox__IMachine_USCOREsetHardwareUUID(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetCPUCount:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetCPUCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREsetCPUCount:
		return (void*)soap_instantiate___vbox__IMachine_USCOREsetCPUCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetMemorySize:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetMemorySize(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREsetMemorySize:
		return (void*)soap_instantiate___vbox__IMachine_USCOREsetMemorySize(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetMemoryBalloonSize:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetMemoryBalloonSize(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREsetMemoryBalloonSize:
		return (void*)soap_instantiate___vbox__IMachine_USCOREsetMemoryBalloonSize(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetStatisticsUpdateInterval:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetStatisticsUpdateInterval(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREsetStatisticsUpdateInterval:
		return (void*)soap_instantiate___vbox__IMachine_USCOREsetStatisticsUpdateInterval(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetVRAMSize:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetVRAMSize(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREsetVRAMSize:
		return (void*)soap_instantiate___vbox__IMachine_USCOREsetVRAMSize(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetAccelerate3DEnabled:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetAccelerate3DEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREsetAccelerate3DEnabled:
		return (void*)soap_instantiate___vbox__IMachine_USCOREsetAccelerate3DEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetAccelerate2DVideoEnabled:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetAccelerate2DVideoEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREsetAccelerate2DVideoEnabled:
		return (void*)soap_instantiate___vbox__IMachine_USCOREsetAccelerate2DVideoEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetMonitorCount:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetMonitorCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREsetMonitorCount:
		return (void*)soap_instantiate___vbox__IMachine_USCOREsetMonitorCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetBIOSSettings:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetBIOSSettings(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetFirmwareType:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetFirmwareType(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREsetFirmwareType:
		return (void*)soap_instantiate___vbox__IMachine_USCOREsetFirmwareType(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetSnapshotFolder:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetSnapshotFolder(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREsetSnapshotFolder:
		return (void*)soap_instantiate___vbox__IMachine_USCOREsetSnapshotFolder(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetVRDPServer:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetVRDPServer(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetMediumAttachments:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetMediumAttachments(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetUSBController:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetUSBController(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetAudioAdapter:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetAudioAdapter(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetStorageControllers:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetStorageControllers(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetSettingsFilePath:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetSettingsFilePath(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetSettingsModified:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetSettingsModified(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetSessionState:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetSessionState(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetSessionType:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetSessionType(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetSessionPid:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetSessionPid(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetState:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetState(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetLastStateChange:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetLastStateChange(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetStateFilePath:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetStateFilePath(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetLogFolder:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetLogFolder(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetCurrentSnapshot:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetCurrentSnapshot(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetSnapshotCount:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetSnapshotCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetCurrentStateModified:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetCurrentStateModified(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetSharedFolders:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetSharedFolders(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetClipboardMode:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetClipboardMode(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREsetClipboardMode:
		return (void*)soap_instantiate___vbox__IMachine_USCOREsetClipboardMode(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetGuestPropertyNotificationPatterns:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetGuestPropertyNotificationPatterns(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREsetGuestPropertyNotificationPatterns:
		return (void*)soap_instantiate___vbox__IMachine_USCOREsetGuestPropertyNotificationPatterns(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetTeleporterEnabled:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetTeleporterEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREsetTeleporterEnabled:
		return (void*)soap_instantiate___vbox__IMachine_USCOREsetTeleporterEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetTeleporterPort:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetTeleporterPort(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREsetTeleporterPort:
		return (void*)soap_instantiate___vbox__IMachine_USCOREsetTeleporterPort(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetTeleporterAddress:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetTeleporterAddress(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREsetTeleporterAddress:
		return (void*)soap_instantiate___vbox__IMachine_USCOREsetTeleporterAddress(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetTeleporterPassword:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetTeleporterPassword(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREsetTeleporterPassword:
		return (void*)soap_instantiate___vbox__IMachine_USCOREsetTeleporterPassword(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREsetBootOrder:
		return (void*)soap_instantiate___vbox__IMachine_USCOREsetBootOrder(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetBootOrder:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetBootOrder(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREattachDevice:
		return (void*)soap_instantiate___vbox__IMachine_USCOREattachDevice(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREdetachDevice:
		return (void*)soap_instantiate___vbox__IMachine_USCOREdetachDevice(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREpassthroughDevice:
		return (void*)soap_instantiate___vbox__IMachine_USCOREpassthroughDevice(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREmountMedium:
		return (void*)soap_instantiate___vbox__IMachine_USCOREmountMedium(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetMedium:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetMedium(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetMediumAttachmentsOfController:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetMediumAttachmentsOfController(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetMediumAttachment:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetMediumAttachment(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetNetworkAdapter:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetNetworkAdapter(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREaddStorageController:
		return (void*)soap_instantiate___vbox__IMachine_USCOREaddStorageController(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetStorageControllerByName:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetStorageControllerByName(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetStorageControllerByInstance:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetStorageControllerByInstance(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREremoveStorageController:
		return (void*)soap_instantiate___vbox__IMachine_USCOREremoveStorageController(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetSerialPort:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetSerialPort(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetParallelPort:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetParallelPort(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetExtraDataKeys:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetExtraDataKeys(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetExtraData:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetExtraData(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREsetExtraData:
		return (void*)soap_instantiate___vbox__IMachine_USCOREsetExtraData(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetCpuProperty:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetCpuProperty(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREsetCpuProperty:
		return (void*)soap_instantiate___vbox__IMachine_USCOREsetCpuProperty(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetCpuIdLeaf:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetCpuIdLeaf(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREsetCpuIdLeaf:
		return (void*)soap_instantiate___vbox__IMachine_USCOREsetCpuIdLeaf(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREremoveCpuIdLeaf:
		return (void*)soap_instantiate___vbox__IMachine_USCOREremoveCpuIdLeaf(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREremoveAllCpuIdLeafs:
		return (void*)soap_instantiate___vbox__IMachine_USCOREremoveAllCpuIdLeafs(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetHWVirtExProperty:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetHWVirtExProperty(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREsetHWVirtExProperty:
		return (void*)soap_instantiate___vbox__IMachine_USCOREsetHWVirtExProperty(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREsaveSettings:
		return (void*)soap_instantiate___vbox__IMachine_USCOREsaveSettings(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREdiscardSettings:
		return (void*)soap_instantiate___vbox__IMachine_USCOREdiscardSettings(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREdeleteSettings:
		return (void*)soap_instantiate___vbox__IMachine_USCOREdeleteSettings(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREexport:
		return (void*)soap_instantiate___vbox__IMachine_USCOREexport(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetSnapshot:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetSnapshot(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREfindSnapshot:
		return (void*)soap_instantiate___vbox__IMachine_USCOREfindSnapshot(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREsetCurrentSnapshot:
		return (void*)soap_instantiate___vbox__IMachine_USCOREsetCurrentSnapshot(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREcreateSharedFolder:
		return (void*)soap_instantiate___vbox__IMachine_USCOREcreateSharedFolder(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREremoveSharedFolder:
		return (void*)soap_instantiate___vbox__IMachine_USCOREremoveSharedFolder(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREcanShowConsoleWindow:
		return (void*)soap_instantiate___vbox__IMachine_USCOREcanShowConsoleWindow(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREshowConsoleWindow:
		return (void*)soap_instantiate___vbox__IMachine_USCOREshowConsoleWindow(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetGuestProperty:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetGuestProperty(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetGuestPropertyValue:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetGuestPropertyValue(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREgetGuestPropertyTimestamp:
		return (void*)soap_instantiate___vbox__IMachine_USCOREgetGuestPropertyTimestamp(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREsetGuestProperty:
		return (void*)soap_instantiate___vbox__IMachine_USCOREsetGuestProperty(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREsetGuestPropertyValue:
		return (void*)soap_instantiate___vbox__IMachine_USCOREsetGuestPropertyValue(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREenumerateGuestProperties:
		return (void*)soap_instantiate___vbox__IMachine_USCOREenumerateGuestProperties(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREquerySavedThumbnailSize:
		return (void*)soap_instantiate___vbox__IMachine_USCOREquerySavedThumbnailSize(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREreadSavedThumbnailToArray:
		return (void*)soap_instantiate___vbox__IMachine_USCOREreadSavedThumbnailToArray(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREquerySavedScreenshotPNGSize:
		return (void*)soap_instantiate___vbox__IMachine_USCOREquerySavedScreenshotPNGSize(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMachine_USCOREreadSavedScreenshotPNGToArray:
		return (void*)soap_instantiate___vbox__IMachine_USCOREreadSavedScreenshotPNGToArray(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCOREgetMachine:
		return (void*)soap_instantiate___vbox__IConsole_USCOREgetMachine(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCOREgetState:
		return (void*)soap_instantiate___vbox__IConsole_USCOREgetState(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCOREgetGuest:
		return (void*)soap_instantiate___vbox__IConsole_USCOREgetGuest(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCOREgetKeyboard:
		return (void*)soap_instantiate___vbox__IConsole_USCOREgetKeyboard(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCOREgetMouse:
		return (void*)soap_instantiate___vbox__IConsole_USCOREgetMouse(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCOREgetDisplay:
		return (void*)soap_instantiate___vbox__IConsole_USCOREgetDisplay(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCOREgetUSBDevices:
		return (void*)soap_instantiate___vbox__IConsole_USCOREgetUSBDevices(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCOREgetRemoteUSBDevices:
		return (void*)soap_instantiate___vbox__IConsole_USCOREgetRemoteUSBDevices(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCOREgetSharedFolders:
		return (void*)soap_instantiate___vbox__IConsole_USCOREgetSharedFolders(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCOREgetRemoteDisplayInfo:
		return (void*)soap_instantiate___vbox__IConsole_USCOREgetRemoteDisplayInfo(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCOREpowerUp:
		return (void*)soap_instantiate___vbox__IConsole_USCOREpowerUp(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCOREpowerUpPaused:
		return (void*)soap_instantiate___vbox__IConsole_USCOREpowerUpPaused(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCOREpowerDown:
		return (void*)soap_instantiate___vbox__IConsole_USCOREpowerDown(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCOREreset:
		return (void*)soap_instantiate___vbox__IConsole_USCOREreset(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCOREpause:
		return (void*)soap_instantiate___vbox__IConsole_USCOREpause(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCOREresume:
		return (void*)soap_instantiate___vbox__IConsole_USCOREresume(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCOREpowerButton:
		return (void*)soap_instantiate___vbox__IConsole_USCOREpowerButton(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCOREsleepButton:
		return (void*)soap_instantiate___vbox__IConsole_USCOREsleepButton(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCOREgetPowerButtonHandled:
		return (void*)soap_instantiate___vbox__IConsole_USCOREgetPowerButtonHandled(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCOREgetGuestEnteredACPIMode:
		return (void*)soap_instantiate___vbox__IConsole_USCOREgetGuestEnteredACPIMode(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCOREsaveState:
		return (void*)soap_instantiate___vbox__IConsole_USCOREsaveState(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCOREadoptSavedState:
		return (void*)soap_instantiate___vbox__IConsole_USCOREadoptSavedState(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCOREforgetSavedState:
		return (void*)soap_instantiate___vbox__IConsole_USCOREforgetSavedState(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCOREgetDeviceActivity:
		return (void*)soap_instantiate___vbox__IConsole_USCOREgetDeviceActivity(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCOREattachUSBDevice:
		return (void*)soap_instantiate___vbox__IConsole_USCOREattachUSBDevice(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCOREdetachUSBDevice:
		return (void*)soap_instantiate___vbox__IConsole_USCOREdetachUSBDevice(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCOREfindUSBDeviceByAddress:
		return (void*)soap_instantiate___vbox__IConsole_USCOREfindUSBDeviceByAddress(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCOREfindUSBDeviceById:
		return (void*)soap_instantiate___vbox__IConsole_USCOREfindUSBDeviceById(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCOREcreateSharedFolder:
		return (void*)soap_instantiate___vbox__IConsole_USCOREcreateSharedFolder(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCOREremoveSharedFolder:
		return (void*)soap_instantiate___vbox__IConsole_USCOREremoveSharedFolder(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCOREtakeSnapshot:
		return (void*)soap_instantiate___vbox__IConsole_USCOREtakeSnapshot(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCOREdeleteSnapshot:
		return (void*)soap_instantiate___vbox__IConsole_USCOREdeleteSnapshot(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCORErestoreSnapshot:
		return (void*)soap_instantiate___vbox__IConsole_USCORErestoreSnapshot(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IConsole_USCOREteleport:
		return (void*)soap_instantiate___vbox__IConsole_USCOREteleport(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetName:
		return (void*)soap_instantiate___vbox__IHostNetworkInterface_USCOREgetName(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetId:
		return (void*)soap_instantiate___vbox__IHostNetworkInterface_USCOREgetId(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetNetworkName:
		return (void*)soap_instantiate___vbox__IHostNetworkInterface_USCOREgetNetworkName(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetDhcpEnabled:
		return (void*)soap_instantiate___vbox__IHostNetworkInterface_USCOREgetDhcpEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetIPAddress:
		return (void*)soap_instantiate___vbox__IHostNetworkInterface_USCOREgetIPAddress(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetNetworkMask:
		return (void*)soap_instantiate___vbox__IHostNetworkInterface_USCOREgetNetworkMask(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetIPV6Supported:
		return (void*)soap_instantiate___vbox__IHostNetworkInterface_USCOREgetIPV6Supported(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetIPV6Address:
		return (void*)soap_instantiate___vbox__IHostNetworkInterface_USCOREgetIPV6Address(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetIPV6NetworkMaskPrefixLength:
		return (void*)soap_instantiate___vbox__IHostNetworkInterface_USCOREgetIPV6NetworkMaskPrefixLength(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetHardwareAddress:
		return (void*)soap_instantiate___vbox__IHostNetworkInterface_USCOREgetHardwareAddress(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetMediumType:
		return (void*)soap_instantiate___vbox__IHostNetworkInterface_USCOREgetMediumType(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetStatus:
		return (void*)soap_instantiate___vbox__IHostNetworkInterface_USCOREgetStatus(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetInterfaceType:
		return (void*)soap_instantiate___vbox__IHostNetworkInterface_USCOREgetInterfaceType(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREenableStaticIpConfig:
		return (void*)soap_instantiate___vbox__IHostNetworkInterface_USCOREenableStaticIpConfig(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREenableStaticIpConfigV6:
		return (void*)soap_instantiate___vbox__IHostNetworkInterface_USCOREenableStaticIpConfigV6(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREenableDynamicIpConfig:
		return (void*)soap_instantiate___vbox__IHostNetworkInterface_USCOREenableDynamicIpConfig(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREdhcpRediscover:
		return (void*)soap_instantiate___vbox__IHostNetworkInterface_USCOREdhcpRediscover(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHost_USCOREgetDVDDrives:
		return (void*)soap_instantiate___vbox__IHost_USCOREgetDVDDrives(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHost_USCOREgetFloppyDrives:
		return (void*)soap_instantiate___vbox__IHost_USCOREgetFloppyDrives(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHost_USCOREgetUSBDevices:
		return (void*)soap_instantiate___vbox__IHost_USCOREgetUSBDevices(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHost_USCOREgetUSBDeviceFilters:
		return (void*)soap_instantiate___vbox__IHost_USCOREgetUSBDeviceFilters(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHost_USCOREgetNetworkInterfaces:
		return (void*)soap_instantiate___vbox__IHost_USCOREgetNetworkInterfaces(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHost_USCOREgetProcessorCount:
		return (void*)soap_instantiate___vbox__IHost_USCOREgetProcessorCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHost_USCOREgetProcessorOnlineCount:
		return (void*)soap_instantiate___vbox__IHost_USCOREgetProcessorOnlineCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHost_USCOREgetMemorySize:
		return (void*)soap_instantiate___vbox__IHost_USCOREgetMemorySize(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHost_USCOREgetMemoryAvailable:
		return (void*)soap_instantiate___vbox__IHost_USCOREgetMemoryAvailable(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHost_USCOREgetOperatingSystem:
		return (void*)soap_instantiate___vbox__IHost_USCOREgetOperatingSystem(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHost_USCOREgetOSVersion:
		return (void*)soap_instantiate___vbox__IHost_USCOREgetOSVersion(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHost_USCOREgetUTCTime:
		return (void*)soap_instantiate___vbox__IHost_USCOREgetUTCTime(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHost_USCOREgetAcceleration3DAvailable:
		return (void*)soap_instantiate___vbox__IHost_USCOREgetAcceleration3DAvailable(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHost_USCOREgetProcessorSpeed:
		return (void*)soap_instantiate___vbox__IHost_USCOREgetProcessorSpeed(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHost_USCOREgetProcessorFeature:
		return (void*)soap_instantiate___vbox__IHost_USCOREgetProcessorFeature(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHost_USCOREgetProcessorDescription:
		return (void*)soap_instantiate___vbox__IHost_USCOREgetProcessorDescription(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHost_USCOREgetProcessorCpuIdLeaf:
		return (void*)soap_instantiate___vbox__IHost_USCOREgetProcessorCpuIdLeaf(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHost_USCOREcreateHostOnlyNetworkInterface:
		return (void*)soap_instantiate___vbox__IHost_USCOREcreateHostOnlyNetworkInterface(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHost_USCOREremoveHostOnlyNetworkInterface:
		return (void*)soap_instantiate___vbox__IHost_USCOREremoveHostOnlyNetworkInterface(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHost_USCOREcreateUSBDeviceFilter:
		return (void*)soap_instantiate___vbox__IHost_USCOREcreateUSBDeviceFilter(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHost_USCOREinsertUSBDeviceFilter:
		return (void*)soap_instantiate___vbox__IHost_USCOREinsertUSBDeviceFilter(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHost_USCOREremoveUSBDeviceFilter:
		return (void*)soap_instantiate___vbox__IHost_USCOREremoveUSBDeviceFilter(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHost_USCOREfindHostDVDDrive:
		return (void*)soap_instantiate___vbox__IHost_USCOREfindHostDVDDrive(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHost_USCOREfindHostFloppyDrive:
		return (void*)soap_instantiate___vbox__IHost_USCOREfindHostFloppyDrive(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHost_USCOREfindHostNetworkInterfaceByName:
		return (void*)soap_instantiate___vbox__IHost_USCOREfindHostNetworkInterfaceByName(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHost_USCOREfindHostNetworkInterfaceById:
		return (void*)soap_instantiate___vbox__IHost_USCOREfindHostNetworkInterfaceById(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHost_USCOREfindHostNetworkInterfacesOfType:
		return (void*)soap_instantiate___vbox__IHost_USCOREfindHostNetworkInterfacesOfType(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHost_USCOREfindUSBDeviceById:
		return (void*)soap_instantiate___vbox__IHost_USCOREfindUSBDeviceById(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHost_USCOREfindUSBDeviceByAddress:
		return (void*)soap_instantiate___vbox__IHost_USCOREfindUSBDeviceByAddress(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMinGuestRAM:
		return (void*)soap_instantiate___vbox__ISystemProperties_USCOREgetMinGuestRAM(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMaxGuestRAM:
		return (void*)soap_instantiate___vbox__ISystemProperties_USCOREgetMaxGuestRAM(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMinGuestVRAM:
		return (void*)soap_instantiate___vbox__ISystemProperties_USCOREgetMinGuestVRAM(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMaxGuestVRAM:
		return (void*)soap_instantiate___vbox__ISystemProperties_USCOREgetMaxGuestVRAM(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMinGuestCPUCount:
		return (void*)soap_instantiate___vbox__ISystemProperties_USCOREgetMinGuestCPUCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMaxGuestCPUCount:
		return (void*)soap_instantiate___vbox__ISystemProperties_USCOREgetMaxGuestCPUCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMaxVDISize:
		return (void*)soap_instantiate___vbox__ISystemProperties_USCOREgetMaxVDISize(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetNetworkAdapterCount:
		return (void*)soap_instantiate___vbox__ISystemProperties_USCOREgetNetworkAdapterCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetSerialPortCount:
		return (void*)soap_instantiate___vbox__ISystemProperties_USCOREgetSerialPortCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetParallelPortCount:
		return (void*)soap_instantiate___vbox__ISystemProperties_USCOREgetParallelPortCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMaxBootPosition:
		return (void*)soap_instantiate___vbox__ISystemProperties_USCOREgetMaxBootPosition(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetDefaultMachineFolder:
		return (void*)soap_instantiate___vbox__ISystemProperties_USCOREgetDefaultMachineFolder(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISystemProperties_USCOREsetDefaultMachineFolder:
		return (void*)soap_instantiate___vbox__ISystemProperties_USCOREsetDefaultMachineFolder(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetDefaultHardDiskFolder:
		return (void*)soap_instantiate___vbox__ISystemProperties_USCOREgetDefaultHardDiskFolder(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISystemProperties_USCOREsetDefaultHardDiskFolder:
		return (void*)soap_instantiate___vbox__ISystemProperties_USCOREsetDefaultHardDiskFolder(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMediumFormats:
		return (void*)soap_instantiate___vbox__ISystemProperties_USCOREgetMediumFormats(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetDefaultHardDiskFormat:
		return (void*)soap_instantiate___vbox__ISystemProperties_USCOREgetDefaultHardDiskFormat(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISystemProperties_USCOREsetDefaultHardDiskFormat:
		return (void*)soap_instantiate___vbox__ISystemProperties_USCOREsetDefaultHardDiskFormat(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetRemoteDisplayAuthLibrary:
		return (void*)soap_instantiate___vbox__ISystemProperties_USCOREgetRemoteDisplayAuthLibrary(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISystemProperties_USCOREsetRemoteDisplayAuthLibrary:
		return (void*)soap_instantiate___vbox__ISystemProperties_USCOREsetRemoteDisplayAuthLibrary(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetWebServiceAuthLibrary:
		return (void*)soap_instantiate___vbox__ISystemProperties_USCOREgetWebServiceAuthLibrary(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISystemProperties_USCOREsetWebServiceAuthLibrary:
		return (void*)soap_instantiate___vbox__ISystemProperties_USCOREsetWebServiceAuthLibrary(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetLogHistoryCount:
		return (void*)soap_instantiate___vbox__ISystemProperties_USCOREgetLogHistoryCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISystemProperties_USCOREsetLogHistoryCount:
		return (void*)soap_instantiate___vbox__ISystemProperties_USCOREsetLogHistoryCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetDefaultAudioDriver:
		return (void*)soap_instantiate___vbox__ISystemProperties_USCOREgetDefaultAudioDriver(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMaxDevicesPerPortForStorageBus:
		return (void*)soap_instantiate___vbox__ISystemProperties_USCOREgetMaxDevicesPerPortForStorageBus(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMinPortCountForStorageBus:
		return (void*)soap_instantiate___vbox__ISystemProperties_USCOREgetMinPortCountForStorageBus(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMaxPortCountForStorageBus:
		return (void*)soap_instantiate___vbox__ISystemProperties_USCOREgetMaxPortCountForStorageBus(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMaxInstancesOfStorageBus:
		return (void*)soap_instantiate___vbox__ISystemProperties_USCOREgetMaxInstancesOfStorageBus(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetDeviceTypesForStorageBus:
		return (void*)soap_instantiate___vbox__ISystemProperties_USCOREgetDeviceTypesForStorageBus(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IGuest_USCOREgetOSTypeId:
		return (void*)soap_instantiate___vbox__IGuest_USCOREgetOSTypeId(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IGuest_USCOREgetAdditionsActive:
		return (void*)soap_instantiate___vbox__IGuest_USCOREgetAdditionsActive(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IGuest_USCOREgetAdditionsVersion:
		return (void*)soap_instantiate___vbox__IGuest_USCOREgetAdditionsVersion(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IGuest_USCOREgetSupportsSeamless:
		return (void*)soap_instantiate___vbox__IGuest_USCOREgetSupportsSeamless(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IGuest_USCOREgetSupportsGraphics:
		return (void*)soap_instantiate___vbox__IGuest_USCOREgetSupportsGraphics(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IGuest_USCOREgetMemoryBalloonSize:
		return (void*)soap_instantiate___vbox__IGuest_USCOREgetMemoryBalloonSize(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IGuest_USCOREsetMemoryBalloonSize:
		return (void*)soap_instantiate___vbox__IGuest_USCOREsetMemoryBalloonSize(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IGuest_USCOREgetStatisticsUpdateInterval:
		return (void*)soap_instantiate___vbox__IGuest_USCOREgetStatisticsUpdateInterval(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IGuest_USCOREsetStatisticsUpdateInterval:
		return (void*)soap_instantiate___vbox__IGuest_USCOREsetStatisticsUpdateInterval(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IGuest_USCOREsetCredentials:
		return (void*)soap_instantiate___vbox__IGuest_USCOREsetCredentials(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IGuest_USCOREgetStatistic:
		return (void*)soap_instantiate___vbox__IGuest_USCOREgetStatistic(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IProgress_USCOREgetId:
		return (void*)soap_instantiate___vbox__IProgress_USCOREgetId(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IProgress_USCOREgetDescription:
		return (void*)soap_instantiate___vbox__IProgress_USCOREgetDescription(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IProgress_USCOREgetInitiator:
		return (void*)soap_instantiate___vbox__IProgress_USCOREgetInitiator(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IProgress_USCOREgetCancelable:
		return (void*)soap_instantiate___vbox__IProgress_USCOREgetCancelable(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IProgress_USCOREgetPercent:
		return (void*)soap_instantiate___vbox__IProgress_USCOREgetPercent(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IProgress_USCOREgetTimeRemaining:
		return (void*)soap_instantiate___vbox__IProgress_USCOREgetTimeRemaining(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IProgress_USCOREgetCompleted:
		return (void*)soap_instantiate___vbox__IProgress_USCOREgetCompleted(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IProgress_USCOREgetCanceled:
		return (void*)soap_instantiate___vbox__IProgress_USCOREgetCanceled(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IProgress_USCOREgetResultCode:
		return (void*)soap_instantiate___vbox__IProgress_USCOREgetResultCode(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IProgress_USCOREgetErrorInfo:
		return (void*)soap_instantiate___vbox__IProgress_USCOREgetErrorInfo(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IProgress_USCOREgetOperationCount:
		return (void*)soap_instantiate___vbox__IProgress_USCOREgetOperationCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IProgress_USCOREgetOperation:
		return (void*)soap_instantiate___vbox__IProgress_USCOREgetOperation(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IProgress_USCOREgetOperationDescription:
		return (void*)soap_instantiate___vbox__IProgress_USCOREgetOperationDescription(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IProgress_USCOREgetOperationPercent:
		return (void*)soap_instantiate___vbox__IProgress_USCOREgetOperationPercent(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IProgress_USCOREgetTimeout:
		return (void*)soap_instantiate___vbox__IProgress_USCOREgetTimeout(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IProgress_USCOREsetTimeout:
		return (void*)soap_instantiate___vbox__IProgress_USCOREsetTimeout(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IProgress_USCOREsetCurrentOperationProgress:
		return (void*)soap_instantiate___vbox__IProgress_USCOREsetCurrentOperationProgress(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IProgress_USCOREsetNextOperation:
		return (void*)soap_instantiate___vbox__IProgress_USCOREsetNextOperation(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IProgress_USCOREwaitForCompletion:
		return (void*)soap_instantiate___vbox__IProgress_USCOREwaitForCompletion(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IProgress_USCOREwaitForOperationCompletion:
		return (void*)soap_instantiate___vbox__IProgress_USCOREwaitForOperationCompletion(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IProgress_USCOREcancel:
		return (void*)soap_instantiate___vbox__IProgress_USCOREcancel(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISnapshot_USCOREgetId:
		return (void*)soap_instantiate___vbox__ISnapshot_USCOREgetId(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISnapshot_USCOREgetName:
		return (void*)soap_instantiate___vbox__ISnapshot_USCOREgetName(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISnapshot_USCOREsetName:
		return (void*)soap_instantiate___vbox__ISnapshot_USCOREsetName(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISnapshot_USCOREgetDescription:
		return (void*)soap_instantiate___vbox__ISnapshot_USCOREgetDescription(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISnapshot_USCOREsetDescription:
		return (void*)soap_instantiate___vbox__ISnapshot_USCOREsetDescription(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISnapshot_USCOREgetTimeStamp:
		return (void*)soap_instantiate___vbox__ISnapshot_USCOREgetTimeStamp(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISnapshot_USCOREgetOnline:
		return (void*)soap_instantiate___vbox__ISnapshot_USCOREgetOnline(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISnapshot_USCOREgetMachine:
		return (void*)soap_instantiate___vbox__ISnapshot_USCOREgetMachine(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISnapshot_USCOREgetParent:
		return (void*)soap_instantiate___vbox__ISnapshot_USCOREgetParent(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISnapshot_USCOREgetChildren:
		return (void*)soap_instantiate___vbox__ISnapshot_USCOREgetChildren(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREgetId:
		return (void*)soap_instantiate___vbox__IMedium_USCOREgetId(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREgetDescription:
		return (void*)soap_instantiate___vbox__IMedium_USCOREgetDescription(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREsetDescription:
		return (void*)soap_instantiate___vbox__IMedium_USCOREsetDescription(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREgetState:
		return (void*)soap_instantiate___vbox__IMedium_USCOREgetState(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREgetLocation:
		return (void*)soap_instantiate___vbox__IMedium_USCOREgetLocation(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREsetLocation:
		return (void*)soap_instantiate___vbox__IMedium_USCOREsetLocation(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREgetName:
		return (void*)soap_instantiate___vbox__IMedium_USCOREgetName(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREgetDeviceType:
		return (void*)soap_instantiate___vbox__IMedium_USCOREgetDeviceType(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREgetHostDrive:
		return (void*)soap_instantiate___vbox__IMedium_USCOREgetHostDrive(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREgetSize:
		return (void*)soap_instantiate___vbox__IMedium_USCOREgetSize(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREgetFormat:
		return (void*)soap_instantiate___vbox__IMedium_USCOREgetFormat(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREgetType:
		return (void*)soap_instantiate___vbox__IMedium_USCOREgetType(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREsetType:
		return (void*)soap_instantiate___vbox__IMedium_USCOREsetType(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREgetParent:
		return (void*)soap_instantiate___vbox__IMedium_USCOREgetParent(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREgetChildren:
		return (void*)soap_instantiate___vbox__IMedium_USCOREgetChildren(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREgetBase:
		return (void*)soap_instantiate___vbox__IMedium_USCOREgetBase(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREgetReadOnly:
		return (void*)soap_instantiate___vbox__IMedium_USCOREgetReadOnly(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREgetLogicalSize:
		return (void*)soap_instantiate___vbox__IMedium_USCOREgetLogicalSize(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREgetAutoReset:
		return (void*)soap_instantiate___vbox__IMedium_USCOREgetAutoReset(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREsetAutoReset:
		return (void*)soap_instantiate___vbox__IMedium_USCOREsetAutoReset(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREgetLastAccessError:
		return (void*)soap_instantiate___vbox__IMedium_USCOREgetLastAccessError(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREgetMachineIds:
		return (void*)soap_instantiate___vbox__IMedium_USCOREgetMachineIds(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCORErefreshState:
		return (void*)soap_instantiate___vbox__IMedium_USCORErefreshState(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREgetSnapshotIds:
		return (void*)soap_instantiate___vbox__IMedium_USCOREgetSnapshotIds(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCORElockRead:
		return (void*)soap_instantiate___vbox__IMedium_USCORElockRead(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREunlockRead:
		return (void*)soap_instantiate___vbox__IMedium_USCOREunlockRead(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCORElockWrite:
		return (void*)soap_instantiate___vbox__IMedium_USCORElockWrite(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREunlockWrite:
		return (void*)soap_instantiate___vbox__IMedium_USCOREunlockWrite(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREclose:
		return (void*)soap_instantiate___vbox__IMedium_USCOREclose(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREgetProperty:
		return (void*)soap_instantiate___vbox__IMedium_USCOREgetProperty(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREsetProperty:
		return (void*)soap_instantiate___vbox__IMedium_USCOREsetProperty(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREgetProperties:
		return (void*)soap_instantiate___vbox__IMedium_USCOREgetProperties(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREsetProperties:
		return (void*)soap_instantiate___vbox__IMedium_USCOREsetProperties(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREcreateBaseStorage:
		return (void*)soap_instantiate___vbox__IMedium_USCOREcreateBaseStorage(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREdeleteStorage:
		return (void*)soap_instantiate___vbox__IMedium_USCOREdeleteStorage(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREcreateDiffStorage:
		return (void*)soap_instantiate___vbox__IMedium_USCOREcreateDiffStorage(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREmergeTo:
		return (void*)soap_instantiate___vbox__IMedium_USCOREmergeTo(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREcloneTo:
		return (void*)soap_instantiate___vbox__IMedium_USCOREcloneTo(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREcompact:
		return (void*)soap_instantiate___vbox__IMedium_USCOREcompact(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREresize:
		return (void*)soap_instantiate___vbox__IMedium_USCOREresize(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMedium_USCOREreset:
		return (void*)soap_instantiate___vbox__IMedium_USCOREreset(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMediumFormat_USCOREgetId:
		return (void*)soap_instantiate___vbox__IMediumFormat_USCOREgetId(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMediumFormat_USCOREgetName:
		return (void*)soap_instantiate___vbox__IMediumFormat_USCOREgetName(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMediumFormat_USCOREgetFileExtensions:
		return (void*)soap_instantiate___vbox__IMediumFormat_USCOREgetFileExtensions(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMediumFormat_USCOREgetCapabilities:
		return (void*)soap_instantiate___vbox__IMediumFormat_USCOREgetCapabilities(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMediumFormat_USCOREdescribeProperties:
		return (void*)soap_instantiate___vbox__IMediumFormat_USCOREdescribeProperties(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IKeyboard_USCOREputScancode:
		return (void*)soap_instantiate___vbox__IKeyboard_USCOREputScancode(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IKeyboard_USCOREputScancodes:
		return (void*)soap_instantiate___vbox__IKeyboard_USCOREputScancodes(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IKeyboard_USCOREputCAD:
		return (void*)soap_instantiate___vbox__IKeyboard_USCOREputCAD(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMouse_USCOREgetAbsoluteSupported:
		return (void*)soap_instantiate___vbox__IMouse_USCOREgetAbsoluteSupported(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMouse_USCOREputMouseEvent:
		return (void*)soap_instantiate___vbox__IMouse_USCOREputMouseEvent(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IMouse_USCOREputMouseEventAbsolute:
		return (void*)soap_instantiate___vbox__IMouse_USCOREputMouseEventAbsolute(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IDisplay_USCOREgetWidth:
		return (void*)soap_instantiate___vbox__IDisplay_USCOREgetWidth(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IDisplay_USCOREgetHeight:
		return (void*)soap_instantiate___vbox__IDisplay_USCOREgetHeight(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IDisplay_USCOREgetBitsPerPixel:
		return (void*)soap_instantiate___vbox__IDisplay_USCOREgetBitsPerPixel(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IDisplay_USCOREsetVideoModeHint:
		return (void*)soap_instantiate___vbox__IDisplay_USCOREsetVideoModeHint(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IDisplay_USCOREsetSeamlessMode:
		return (void*)soap_instantiate___vbox__IDisplay_USCOREsetSeamlessMode(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IDisplay_USCOREtakeScreenShotSlow:
		return (void*)soap_instantiate___vbox__IDisplay_USCOREtakeScreenShotSlow(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IDisplay_USCOREinvalidateAndUpdate:
		return (void*)soap_instantiate___vbox__IDisplay_USCOREinvalidateAndUpdate(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IDisplay_USCOREresizeCompleted:
		return (void*)soap_instantiate___vbox__IDisplay_USCOREresizeCompleted(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IDisplay_USCOREupdateCompleted:
		return (void*)soap_instantiate___vbox__IDisplay_USCOREupdateCompleted(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetAdapterType:
		return (void*)soap_instantiate___vbox__INetworkAdapter_USCOREgetAdapterType(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetAdapterType:
		return (void*)soap_instantiate___vbox__INetworkAdapter_USCOREsetAdapterType(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetSlot:
		return (void*)soap_instantiate___vbox__INetworkAdapter_USCOREgetSlot(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetEnabled:
		return (void*)soap_instantiate___vbox__INetworkAdapter_USCOREgetEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetEnabled:
		return (void*)soap_instantiate___vbox__INetworkAdapter_USCOREsetEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetMACAddress:
		return (void*)soap_instantiate___vbox__INetworkAdapter_USCOREgetMACAddress(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetMACAddress:
		return (void*)soap_instantiate___vbox__INetworkAdapter_USCOREsetMACAddress(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetAttachmentType:
		return (void*)soap_instantiate___vbox__INetworkAdapter_USCOREgetAttachmentType(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetHostInterface:
		return (void*)soap_instantiate___vbox__INetworkAdapter_USCOREgetHostInterface(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetHostInterface:
		return (void*)soap_instantiate___vbox__INetworkAdapter_USCOREsetHostInterface(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetInternalNetwork:
		return (void*)soap_instantiate___vbox__INetworkAdapter_USCOREgetInternalNetwork(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetInternalNetwork:
		return (void*)soap_instantiate___vbox__INetworkAdapter_USCOREsetInternalNetwork(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetNATNetwork:
		return (void*)soap_instantiate___vbox__INetworkAdapter_USCOREgetNATNetwork(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetNATNetwork:
		return (void*)soap_instantiate___vbox__INetworkAdapter_USCOREsetNATNetwork(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetCableConnected:
		return (void*)soap_instantiate___vbox__INetworkAdapter_USCOREgetCableConnected(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetCableConnected:
		return (void*)soap_instantiate___vbox__INetworkAdapter_USCOREsetCableConnected(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetLineSpeed:
		return (void*)soap_instantiate___vbox__INetworkAdapter_USCOREgetLineSpeed(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetLineSpeed:
		return (void*)soap_instantiate___vbox__INetworkAdapter_USCOREsetLineSpeed(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetTraceEnabled:
		return (void*)soap_instantiate___vbox__INetworkAdapter_USCOREgetTraceEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetTraceEnabled:
		return (void*)soap_instantiate___vbox__INetworkAdapter_USCOREsetTraceEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetTraceFile:
		return (void*)soap_instantiate___vbox__INetworkAdapter_USCOREgetTraceFile(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetTraceFile:
		return (void*)soap_instantiate___vbox__INetworkAdapter_USCOREsetTraceFile(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREattachToNAT:
		return (void*)soap_instantiate___vbox__INetworkAdapter_USCOREattachToNAT(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREattachToBridgedInterface:
		return (void*)soap_instantiate___vbox__INetworkAdapter_USCOREattachToBridgedInterface(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREattachToInternalNetwork:
		return (void*)soap_instantiate___vbox__INetworkAdapter_USCOREattachToInternalNetwork(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREattachToHostOnlyInterface:
		return (void*)soap_instantiate___vbox__INetworkAdapter_USCOREattachToHostOnlyInterface(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREdetach:
		return (void*)soap_instantiate___vbox__INetworkAdapter_USCOREdetach(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISerialPort_USCOREgetSlot:
		return (void*)soap_instantiate___vbox__ISerialPort_USCOREgetSlot(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISerialPort_USCOREgetEnabled:
		return (void*)soap_instantiate___vbox__ISerialPort_USCOREgetEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISerialPort_USCOREsetEnabled:
		return (void*)soap_instantiate___vbox__ISerialPort_USCOREsetEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISerialPort_USCOREgetIOBase:
		return (void*)soap_instantiate___vbox__ISerialPort_USCOREgetIOBase(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISerialPort_USCOREsetIOBase:
		return (void*)soap_instantiate___vbox__ISerialPort_USCOREsetIOBase(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISerialPort_USCOREgetIRQ:
		return (void*)soap_instantiate___vbox__ISerialPort_USCOREgetIRQ(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISerialPort_USCOREsetIRQ:
		return (void*)soap_instantiate___vbox__ISerialPort_USCOREsetIRQ(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISerialPort_USCOREgetHostMode:
		return (void*)soap_instantiate___vbox__ISerialPort_USCOREgetHostMode(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISerialPort_USCOREsetHostMode:
		return (void*)soap_instantiate___vbox__ISerialPort_USCOREsetHostMode(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISerialPort_USCOREgetServer:
		return (void*)soap_instantiate___vbox__ISerialPort_USCOREgetServer(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISerialPort_USCOREsetServer:
		return (void*)soap_instantiate___vbox__ISerialPort_USCOREsetServer(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISerialPort_USCOREgetPath:
		return (void*)soap_instantiate___vbox__ISerialPort_USCOREgetPath(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISerialPort_USCOREsetPath:
		return (void*)soap_instantiate___vbox__ISerialPort_USCOREsetPath(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IParallelPort_USCOREgetSlot:
		return (void*)soap_instantiate___vbox__IParallelPort_USCOREgetSlot(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IParallelPort_USCOREgetEnabled:
		return (void*)soap_instantiate___vbox__IParallelPort_USCOREgetEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IParallelPort_USCOREsetEnabled:
		return (void*)soap_instantiate___vbox__IParallelPort_USCOREsetEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IParallelPort_USCOREgetIOBase:
		return (void*)soap_instantiate___vbox__IParallelPort_USCOREgetIOBase(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IParallelPort_USCOREsetIOBase:
		return (void*)soap_instantiate___vbox__IParallelPort_USCOREsetIOBase(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IParallelPort_USCOREgetIRQ:
		return (void*)soap_instantiate___vbox__IParallelPort_USCOREgetIRQ(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IParallelPort_USCOREsetIRQ:
		return (void*)soap_instantiate___vbox__IParallelPort_USCOREsetIRQ(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IParallelPort_USCOREgetPath:
		return (void*)soap_instantiate___vbox__IParallelPort_USCOREgetPath(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IParallelPort_USCOREsetPath:
		return (void*)soap_instantiate___vbox__IParallelPort_USCOREsetPath(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBController_USCOREgetEnabled:
		return (void*)soap_instantiate___vbox__IUSBController_USCOREgetEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBController_USCOREsetEnabled:
		return (void*)soap_instantiate___vbox__IUSBController_USCOREsetEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBController_USCOREgetEnabledEhci:
		return (void*)soap_instantiate___vbox__IUSBController_USCOREgetEnabledEhci(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBController_USCOREsetEnabledEhci:
		return (void*)soap_instantiate___vbox__IUSBController_USCOREsetEnabledEhci(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBController_USCOREgetUSBStandard:
		return (void*)soap_instantiate___vbox__IUSBController_USCOREgetUSBStandard(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBController_USCOREgetDeviceFilters:
		return (void*)soap_instantiate___vbox__IUSBController_USCOREgetDeviceFilters(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBController_USCOREcreateDeviceFilter:
		return (void*)soap_instantiate___vbox__IUSBController_USCOREcreateDeviceFilter(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBController_USCOREinsertDeviceFilter:
		return (void*)soap_instantiate___vbox__IUSBController_USCOREinsertDeviceFilter(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBController_USCOREremoveDeviceFilter:
		return (void*)soap_instantiate___vbox__IUSBController_USCOREremoveDeviceFilter(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetId:
		return (void*)soap_instantiate___vbox__IUSBDevice_USCOREgetId(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetVendorId:
		return (void*)soap_instantiate___vbox__IUSBDevice_USCOREgetVendorId(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetProductId:
		return (void*)soap_instantiate___vbox__IUSBDevice_USCOREgetProductId(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetRevision:
		return (void*)soap_instantiate___vbox__IUSBDevice_USCOREgetRevision(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetManufacturer:
		return (void*)soap_instantiate___vbox__IUSBDevice_USCOREgetManufacturer(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetProduct:
		return (void*)soap_instantiate___vbox__IUSBDevice_USCOREgetProduct(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetSerialNumber:
		return (void*)soap_instantiate___vbox__IUSBDevice_USCOREgetSerialNumber(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetAddress:
		return (void*)soap_instantiate___vbox__IUSBDevice_USCOREgetAddress(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetPort:
		return (void*)soap_instantiate___vbox__IUSBDevice_USCOREgetPort(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetVersion:
		return (void*)soap_instantiate___vbox__IUSBDevice_USCOREgetVersion(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetPortVersion:
		return (void*)soap_instantiate___vbox__IUSBDevice_USCOREgetPortVersion(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetRemote:
		return (void*)soap_instantiate___vbox__IUSBDevice_USCOREgetRemote(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREgetName:
		return (void*)soap_instantiate___vbox__IUSBDeviceFilter_USCOREgetName(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREsetName:
		return (void*)soap_instantiate___vbox__IUSBDeviceFilter_USCOREsetName(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREgetActive:
		return (void*)soap_instantiate___vbox__IUSBDeviceFilter_USCOREgetActive(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREsetActive:
		return (void*)soap_instantiate___vbox__IUSBDeviceFilter_USCOREsetActive(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREgetVendorId:
		return (void*)soap_instantiate___vbox__IUSBDeviceFilter_USCOREgetVendorId(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREsetVendorId:
		return (void*)soap_instantiate___vbox__IUSBDeviceFilter_USCOREsetVendorId(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREgetProductId:
		return (void*)soap_instantiate___vbox__IUSBDeviceFilter_USCOREgetProductId(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREsetProductId:
		return (void*)soap_instantiate___vbox__IUSBDeviceFilter_USCOREsetProductId(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREgetRevision:
		return (void*)soap_instantiate___vbox__IUSBDeviceFilter_USCOREgetRevision(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREsetRevision:
		return (void*)soap_instantiate___vbox__IUSBDeviceFilter_USCOREsetRevision(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREgetManufacturer:
		return (void*)soap_instantiate___vbox__IUSBDeviceFilter_USCOREgetManufacturer(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREsetManufacturer:
		return (void*)soap_instantiate___vbox__IUSBDeviceFilter_USCOREsetManufacturer(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREgetProduct:
		return (void*)soap_instantiate___vbox__IUSBDeviceFilter_USCOREgetProduct(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREsetProduct:
		return (void*)soap_instantiate___vbox__IUSBDeviceFilter_USCOREsetProduct(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREgetSerialNumber:
		return (void*)soap_instantiate___vbox__IUSBDeviceFilter_USCOREgetSerialNumber(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREsetSerialNumber:
		return (void*)soap_instantiate___vbox__IUSBDeviceFilter_USCOREsetSerialNumber(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREgetPort:
		return (void*)soap_instantiate___vbox__IUSBDeviceFilter_USCOREgetPort(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREsetPort:
		return (void*)soap_instantiate___vbox__IUSBDeviceFilter_USCOREsetPort(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREgetRemote:
		return (void*)soap_instantiate___vbox__IUSBDeviceFilter_USCOREgetRemote(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREsetRemote:
		return (void*)soap_instantiate___vbox__IUSBDeviceFilter_USCOREsetRemote(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREgetMaskedInterfaces:
		return (void*)soap_instantiate___vbox__IUSBDeviceFilter_USCOREgetMaskedInterfaces(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREsetMaskedInterfaces:
		return (void*)soap_instantiate___vbox__IUSBDeviceFilter_USCOREsetMaskedInterfaces(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHostUSBDevice_USCOREgetState:
		return (void*)soap_instantiate___vbox__IHostUSBDevice_USCOREgetState(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHostUSBDeviceFilter_USCOREgetAction:
		return (void*)soap_instantiate___vbox__IHostUSBDeviceFilter_USCOREgetAction(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IHostUSBDeviceFilter_USCOREsetAction:
		return (void*)soap_instantiate___vbox__IHostUSBDeviceFilter_USCOREsetAction(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IAudioAdapter_USCOREgetEnabled:
		return (void*)soap_instantiate___vbox__IAudioAdapter_USCOREgetEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IAudioAdapter_USCOREsetEnabled:
		return (void*)soap_instantiate___vbox__IAudioAdapter_USCOREsetEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IAudioAdapter_USCOREgetAudioController:
		return (void*)soap_instantiate___vbox__IAudioAdapter_USCOREgetAudioController(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IAudioAdapter_USCOREsetAudioController:
		return (void*)soap_instantiate___vbox__IAudioAdapter_USCOREsetAudioController(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IAudioAdapter_USCOREgetAudioDriver:
		return (void*)soap_instantiate___vbox__IAudioAdapter_USCOREgetAudioDriver(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IAudioAdapter_USCOREsetAudioDriver:
		return (void*)soap_instantiate___vbox__IAudioAdapter_USCOREsetAudioDriver(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVRDPServer_USCOREgetEnabled:
		return (void*)soap_instantiate___vbox__IVRDPServer_USCOREgetEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVRDPServer_USCOREsetEnabled:
		return (void*)soap_instantiate___vbox__IVRDPServer_USCOREsetEnabled(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVRDPServer_USCOREgetPorts:
		return (void*)soap_instantiate___vbox__IVRDPServer_USCOREgetPorts(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVRDPServer_USCOREsetPorts:
		return (void*)soap_instantiate___vbox__IVRDPServer_USCOREsetPorts(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVRDPServer_USCOREgetNetAddress:
		return (void*)soap_instantiate___vbox__IVRDPServer_USCOREgetNetAddress(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVRDPServer_USCOREsetNetAddress:
		return (void*)soap_instantiate___vbox__IVRDPServer_USCOREsetNetAddress(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVRDPServer_USCOREgetAuthType:
		return (void*)soap_instantiate___vbox__IVRDPServer_USCOREgetAuthType(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVRDPServer_USCOREsetAuthType:
		return (void*)soap_instantiate___vbox__IVRDPServer_USCOREsetAuthType(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVRDPServer_USCOREgetAuthTimeout:
		return (void*)soap_instantiate___vbox__IVRDPServer_USCOREgetAuthTimeout(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVRDPServer_USCOREsetAuthTimeout:
		return (void*)soap_instantiate___vbox__IVRDPServer_USCOREsetAuthTimeout(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVRDPServer_USCOREgetAllowMultiConnection:
		return (void*)soap_instantiate___vbox__IVRDPServer_USCOREgetAllowMultiConnection(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVRDPServer_USCOREsetAllowMultiConnection:
		return (void*)soap_instantiate___vbox__IVRDPServer_USCOREsetAllowMultiConnection(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVRDPServer_USCOREgetReuseSingleConnection:
		return (void*)soap_instantiate___vbox__IVRDPServer_USCOREgetReuseSingleConnection(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IVRDPServer_USCOREsetReuseSingleConnection:
		return (void*)soap_instantiate___vbox__IVRDPServer_USCOREsetReuseSingleConnection(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISession_USCOREgetState:
		return (void*)soap_instantiate___vbox__ISession_USCOREgetState(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISession_USCOREgetType:
		return (void*)soap_instantiate___vbox__ISession_USCOREgetType(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISession_USCOREgetMachine:
		return (void*)soap_instantiate___vbox__ISession_USCOREgetMachine(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISession_USCOREgetConsole:
		return (void*)soap_instantiate___vbox__ISession_USCOREgetConsole(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__ISession_USCOREclose:
		return (void*)soap_instantiate___vbox__ISession_USCOREclose(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IStorageController_USCOREgetName:
		return (void*)soap_instantiate___vbox__IStorageController_USCOREgetName(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IStorageController_USCOREgetMaxDevicesPerPortCount:
		return (void*)soap_instantiate___vbox__IStorageController_USCOREgetMaxDevicesPerPortCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IStorageController_USCOREgetMinPortCount:
		return (void*)soap_instantiate___vbox__IStorageController_USCOREgetMinPortCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IStorageController_USCOREgetMaxPortCount:
		return (void*)soap_instantiate___vbox__IStorageController_USCOREgetMaxPortCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IStorageController_USCOREgetInstance:
		return (void*)soap_instantiate___vbox__IStorageController_USCOREgetInstance(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IStorageController_USCOREsetInstance:
		return (void*)soap_instantiate___vbox__IStorageController_USCOREsetInstance(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IStorageController_USCOREgetPortCount:
		return (void*)soap_instantiate___vbox__IStorageController_USCOREgetPortCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IStorageController_USCOREsetPortCount:
		return (void*)soap_instantiate___vbox__IStorageController_USCOREsetPortCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IStorageController_USCOREgetBus:
		return (void*)soap_instantiate___vbox__IStorageController_USCOREgetBus(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IStorageController_USCOREgetControllerType:
		return (void*)soap_instantiate___vbox__IStorageController_USCOREgetControllerType(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IStorageController_USCOREsetControllerType:
		return (void*)soap_instantiate___vbox__IStorageController_USCOREsetControllerType(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IStorageController_USCOREGetIDEEmulationPort:
		return (void*)soap_instantiate___vbox__IStorageController_USCOREGetIDEEmulationPort(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IStorageController_USCORESetIDEEmulationPort:
		return (void*)soap_instantiate___vbox__IStorageController_USCORESetIDEEmulationPort(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IManagedObjectRef_USCOREgetInterfaceName:
		return (void*)soap_instantiate___vbox__IManagedObjectRef_USCOREgetInterfaceName(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IManagedObjectRef_USCORErelease:
		return (void*)soap_instantiate___vbox__IManagedObjectRef_USCORErelease(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IWebsessionManager_USCORElogon:
		return (void*)soap_instantiate___vbox__IWebsessionManager_USCORElogon(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IWebsessionManager_USCOREgetSessionObject:
		return (void*)soap_instantiate___vbox__IWebsessionManager_USCOREgetSessionObject(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IWebsessionManager_USCORElogoff:
		return (void*)soap_instantiate___vbox__IWebsessionManager_USCORElogoff(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IPerformanceMetric_USCOREgetMetricName:
		return (void*)soap_instantiate___vbox__IPerformanceMetric_USCOREgetMetricName(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IPerformanceMetric_USCOREgetObject:
		return (void*)soap_instantiate___vbox__IPerformanceMetric_USCOREgetObject(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IPerformanceMetric_USCOREgetDescription:
		return (void*)soap_instantiate___vbox__IPerformanceMetric_USCOREgetDescription(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IPerformanceMetric_USCOREgetPeriod:
		return (void*)soap_instantiate___vbox__IPerformanceMetric_USCOREgetPeriod(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IPerformanceMetric_USCOREgetCount:
		return (void*)soap_instantiate___vbox__IPerformanceMetric_USCOREgetCount(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IPerformanceMetric_USCOREgetUnit:
		return (void*)soap_instantiate___vbox__IPerformanceMetric_USCOREgetUnit(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IPerformanceMetric_USCOREgetMinimumValue:
		return (void*)soap_instantiate___vbox__IPerformanceMetric_USCOREgetMinimumValue(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IPerformanceMetric_USCOREgetMaximumValue:
		return (void*)soap_instantiate___vbox__IPerformanceMetric_USCOREgetMaximumValue(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IPerformanceCollector_USCOREgetMetricNames:
		return (void*)soap_instantiate___vbox__IPerformanceCollector_USCOREgetMetricNames(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IPerformanceCollector_USCOREgetMetrics:
		return (void*)soap_instantiate___vbox__IPerformanceCollector_USCOREgetMetrics(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IPerformanceCollector_USCOREsetupMetrics:
		return (void*)soap_instantiate___vbox__IPerformanceCollector_USCOREsetupMetrics(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IPerformanceCollector_USCOREenableMetrics:
		return (void*)soap_instantiate___vbox__IPerformanceCollector_USCOREenableMetrics(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IPerformanceCollector_USCOREdisableMetrics:
		return (void*)soap_instantiate___vbox__IPerformanceCollector_USCOREdisableMetrics(soap, -1, type, arrayType, n);
	case SOAP_TYPE___vbox__IPerformanceCollector_USCOREqueryMetricsData:
		return (void*)soap_instantiate___vbox__IPerformanceCollector_USCOREqueryMetricsData(soap, -1, type, arrayType, n);
#ifndef WITH_NOGLOBAL
	case SOAP_TYPE_SOAP_ENV__Header:
		return (void*)soap_instantiate_SOAP_ENV__Header(soap, -1, type, arrayType, n);
#endif
#ifndef WITH_NOGLOBAL
	case SOAP_TYPE_SOAP_ENV__Code:
		return (void*)soap_instantiate_SOAP_ENV__Code(soap, -1, type, arrayType, n);
#endif
#ifndef WITH_NOGLOBAL
	case SOAP_TYPE_SOAP_ENV__Reason:
		return (void*)soap_instantiate_SOAP_ENV__Reason(soap, -1, type, arrayType, n);
#endif
#ifndef WITH_NOGLOBAL
	case SOAP_TYPE_SOAP_ENV__Fault:
		return (void*)soap_instantiate_SOAP_ENV__Fault(soap, -1, type, arrayType, n);
#endif
	case SOAP_TYPE_std__vectorTemplateOfint:
		return (void*)soap_instantiate_std__vectorTemplateOfint(soap, -1, type, arrayType, n);
	case SOAP_TYPE_std__vectorTemplateOfvbox__DataType:
		return (void*)soap_instantiate_std__vectorTemplateOfvbox__DataType(soap, -1, type, arrayType, n);
	case SOAP_TYPE_std__vectorTemplateOfvbox__DeviceType:
		return (void*)soap_instantiate_std__vectorTemplateOfvbox__DeviceType(soap, -1, type, arrayType, n);
	case SOAP_TYPE_std__vectorTemplateOfunsignedByte:
		return (void*)soap_instantiate_std__vectorTemplateOfunsignedByte(soap, -1, type, arrayType, n);
	case SOAP_TYPE_std__vectorTemplateOfunsignedLONG64:
		return (void*)soap_instantiate_std__vectorTemplateOfunsignedLONG64(soap, -1, type, arrayType, n);
	case SOAP_TYPE_std__vectorTemplateOfPointerTovbox__IMediumAttachment:
		return (void*)soap_instantiate_std__vectorTemplateOfPointerTovbox__IMediumAttachment(soap, -1, type, arrayType, n);
	case SOAP_TYPE_std__vectorTemplateOfbool:
		return (void*)soap_instantiate_std__vectorTemplateOfbool(soap, -1, type, arrayType, n);
	case SOAP_TYPE_std__vectorTemplateOfvbox__VirtualSystemDescriptionType:
		return (void*)soap_instantiate_std__vectorTemplateOfvbox__VirtualSystemDescriptionType(soap, -1, type, arrayType, n);
	case SOAP_TYPE_std__vectorTemplateOfunsignedInt:
		return (void*)soap_instantiate_std__vectorTemplateOfunsignedInt(soap, -1, type, arrayType, n);
	case SOAP_TYPE_std__vectorTemplateOfPointerTovbox__ISharedFolder:
		return (void*)soap_instantiate_std__vectorTemplateOfPointerTovbox__ISharedFolder(soap, -1, type, arrayType, n);
	case SOAP_TYPE_std__vectorTemplateOfPointerTovbox__IGuestOSType:
		return (void*)soap_instantiate_std__vectorTemplateOfPointerTovbox__IGuestOSType(soap, -1, type, arrayType, n);
	case SOAP_TYPE_std__vectorTemplateOfstd__string:
		return (void*)soap_instantiate_std__vectorTemplateOfstd__string(soap, -1, type, arrayType, n);
	}
	return NULL;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_fdelete(struct soap_clist *p)
{	switch (p->type)
	{
	case SOAP_TYPE_SOAP_ENV__Detail:
		if (p->size < 0)
			delete (struct SOAP_ENV__Detail*)p->ptr;
		else
			delete[] (struct SOAP_ENV__Detail*)p->ptr;
		break;
	case SOAP_TYPE_std__string:
		if (p->size < 0)
			delete (std::string*)p->ptr;
		else
			delete[] (std::string*)p->ptr;
		break;
	case SOAP_TYPE_vbox__IRemoteDisplayInfo:
		if (p->size < 0)
			delete (vbox__IRemoteDisplayInfo*)p->ptr;
		else
			delete[] (vbox__IRemoteDisplayInfo*)p->ptr;
		break;
	case SOAP_TYPE_vbox__IGuestOSType:
		if (p->size < 0)
			delete (vbox__IGuestOSType*)p->ptr;
		else
			delete[] (vbox__IGuestOSType*)p->ptr;
		break;
	case SOAP_TYPE_vbox__IMediumAttachment:
		if (p->size < 0)
			delete (vbox__IMediumAttachment*)p->ptr;
		else
			delete[] (vbox__IMediumAttachment*)p->ptr;
		break;
	case SOAP_TYPE_vbox__ISharedFolder:
		if (p->size < 0)
			delete (vbox__ISharedFolder*)p->ptr;
		else
			delete[] (vbox__ISharedFolder*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBoxErrorInfo_USCOREgetResultCode:
		if (p->size < 0)
			delete (_vbox__IVirtualBoxErrorInfo_USCOREgetResultCode*)p->ptr;
		else
			delete[] (_vbox__IVirtualBoxErrorInfo_USCOREgetResultCode*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBoxErrorInfo_USCOREgetResultCodeResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBoxErrorInfo_USCOREgetResultCodeResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBoxErrorInfo_USCOREgetResultCodeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBoxErrorInfo_USCOREgetInterfaceID:
		if (p->size < 0)
			delete (_vbox__IVirtualBoxErrorInfo_USCOREgetInterfaceID*)p->ptr;
		else
			delete[] (_vbox__IVirtualBoxErrorInfo_USCOREgetInterfaceID*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBoxErrorInfo_USCOREgetInterfaceIDResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBoxErrorInfo_USCOREgetInterfaceIDResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBoxErrorInfo_USCOREgetInterfaceIDResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBoxErrorInfo_USCOREgetComponent:
		if (p->size < 0)
			delete (_vbox__IVirtualBoxErrorInfo_USCOREgetComponent*)p->ptr;
		else
			delete[] (_vbox__IVirtualBoxErrorInfo_USCOREgetComponent*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBoxErrorInfo_USCOREgetComponentResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBoxErrorInfo_USCOREgetComponentResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBoxErrorInfo_USCOREgetComponentResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBoxErrorInfo_USCOREgetText:
		if (p->size < 0)
			delete (_vbox__IVirtualBoxErrorInfo_USCOREgetText*)p->ptr;
		else
			delete[] (_vbox__IVirtualBoxErrorInfo_USCOREgetText*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBoxErrorInfo_USCOREgetTextResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBoxErrorInfo_USCOREgetTextResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBoxErrorInfo_USCOREgetTextResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBoxErrorInfo_USCOREgetNext:
		if (p->size < 0)
			delete (_vbox__IVirtualBoxErrorInfo_USCOREgetNext*)p->ptr;
		else
			delete[] (_vbox__IVirtualBoxErrorInfo_USCOREgetNext*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBoxErrorInfo_USCOREgetNextResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBoxErrorInfo_USCOREgetNextResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBoxErrorInfo_USCOREgetNextResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetEnabled:
		if (p->size < 0)
			delete (_vbox__IDHCPServer_USCOREgetEnabled*)p->ptr;
		else
			delete[] (_vbox__IDHCPServer_USCOREgetEnabled*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetEnabledResponse:
		if (p->size < 0)
			delete (_vbox__IDHCPServer_USCOREgetEnabledResponse*)p->ptr;
		else
			delete[] (_vbox__IDHCPServer_USCOREgetEnabledResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREsetEnabled:
		if (p->size < 0)
			delete (_vbox__IDHCPServer_USCOREsetEnabled*)p->ptr;
		else
			delete[] (_vbox__IDHCPServer_USCOREsetEnabled*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREsetEnabledResponse:
		if (p->size < 0)
			delete (_vbox__IDHCPServer_USCOREsetEnabledResponse*)p->ptr;
		else
			delete[] (_vbox__IDHCPServer_USCOREsetEnabledResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetIPAddress:
		if (p->size < 0)
			delete (_vbox__IDHCPServer_USCOREgetIPAddress*)p->ptr;
		else
			delete[] (_vbox__IDHCPServer_USCOREgetIPAddress*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetIPAddressResponse:
		if (p->size < 0)
			delete (_vbox__IDHCPServer_USCOREgetIPAddressResponse*)p->ptr;
		else
			delete[] (_vbox__IDHCPServer_USCOREgetIPAddressResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetNetworkMask:
		if (p->size < 0)
			delete (_vbox__IDHCPServer_USCOREgetNetworkMask*)p->ptr;
		else
			delete[] (_vbox__IDHCPServer_USCOREgetNetworkMask*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetNetworkMaskResponse:
		if (p->size < 0)
			delete (_vbox__IDHCPServer_USCOREgetNetworkMaskResponse*)p->ptr;
		else
			delete[] (_vbox__IDHCPServer_USCOREgetNetworkMaskResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetNetworkName:
		if (p->size < 0)
			delete (_vbox__IDHCPServer_USCOREgetNetworkName*)p->ptr;
		else
			delete[] (_vbox__IDHCPServer_USCOREgetNetworkName*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetNetworkNameResponse:
		if (p->size < 0)
			delete (_vbox__IDHCPServer_USCOREgetNetworkNameResponse*)p->ptr;
		else
			delete[] (_vbox__IDHCPServer_USCOREgetNetworkNameResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetLowerIP:
		if (p->size < 0)
			delete (_vbox__IDHCPServer_USCOREgetLowerIP*)p->ptr;
		else
			delete[] (_vbox__IDHCPServer_USCOREgetLowerIP*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetLowerIPResponse:
		if (p->size < 0)
			delete (_vbox__IDHCPServer_USCOREgetLowerIPResponse*)p->ptr;
		else
			delete[] (_vbox__IDHCPServer_USCOREgetLowerIPResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetUpperIP:
		if (p->size < 0)
			delete (_vbox__IDHCPServer_USCOREgetUpperIP*)p->ptr;
		else
			delete[] (_vbox__IDHCPServer_USCOREgetUpperIP*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetUpperIPResponse:
		if (p->size < 0)
			delete (_vbox__IDHCPServer_USCOREgetUpperIPResponse*)p->ptr;
		else
			delete[] (_vbox__IDHCPServer_USCOREgetUpperIPResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREsetConfiguration:
		if (p->size < 0)
			delete (_vbox__IDHCPServer_USCOREsetConfiguration*)p->ptr;
		else
			delete[] (_vbox__IDHCPServer_USCOREsetConfiguration*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREsetConfigurationResponse:
		if (p->size < 0)
			delete (_vbox__IDHCPServer_USCOREsetConfigurationResponse*)p->ptr;
		else
			delete[] (_vbox__IDHCPServer_USCOREsetConfigurationResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREstart:
		if (p->size < 0)
			delete (_vbox__IDHCPServer_USCOREstart*)p->ptr;
		else
			delete[] (_vbox__IDHCPServer_USCOREstart*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREstartResponse:
		if (p->size < 0)
			delete (_vbox__IDHCPServer_USCOREstartResponse*)p->ptr;
		else
			delete[] (_vbox__IDHCPServer_USCOREstartResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREstop:
		if (p->size < 0)
			delete (_vbox__IDHCPServer_USCOREstop*)p->ptr;
		else
			delete[] (_vbox__IDHCPServer_USCOREstop*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREstopResponse:
		if (p->size < 0)
			delete (_vbox__IDHCPServer_USCOREstopResponse*)p->ptr;
		else
			delete[] (_vbox__IDHCPServer_USCOREstopResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetVersion:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetVersion*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetVersion*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetVersionResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetVersionResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetVersionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetRevision:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetRevision*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetRevision*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetRevisionResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetRevisionResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetRevisionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetPackageType:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetPackageType*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetPackageType*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetPackageTypeResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetPackageTypeResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetPackageTypeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetHomeFolder:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetHomeFolder*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetHomeFolder*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetHomeFolderResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetHomeFolderResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetHomeFolderResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetSettingsFilePath:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetSettingsFilePath*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetSettingsFilePath*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetSettingsFilePathResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetSettingsFilePathResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetSettingsFilePathResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetHost:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetHost*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetHost*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetHostResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetHostResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetHostResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetSystemProperties:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetSystemProperties*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetSystemProperties*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetSystemPropertiesResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetSystemPropertiesResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetSystemPropertiesResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetMachines:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetMachines*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetMachines*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetMachinesResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetMachinesResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetMachinesResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetHardDisks:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetHardDisks*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetHardDisks*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetHardDisksResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetHardDisksResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetHardDisksResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetDVDImages:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetDVDImages*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetDVDImages*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetDVDImagesResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetDVDImagesResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetDVDImagesResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetFloppyImages:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetFloppyImages*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetFloppyImages*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetFloppyImagesResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetFloppyImagesResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetFloppyImagesResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetProgressOperations:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetProgressOperations*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetProgressOperations*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetProgressOperationsResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetProgressOperationsResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetProgressOperationsResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetGuestOSTypes:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetGuestOSTypes*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetGuestOSTypes*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetGuestOSTypesResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetGuestOSTypesResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetGuestOSTypesResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetSharedFolders:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetSharedFolders*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetSharedFolders*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetSharedFoldersResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetSharedFoldersResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetSharedFoldersResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetPerformanceCollector:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetPerformanceCollector*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetPerformanceCollector*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetPerformanceCollectorResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetPerformanceCollectorResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetPerformanceCollectorResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetDHCPServers:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetDHCPServers*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetDHCPServers*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetDHCPServersResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetDHCPServersResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetDHCPServersResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateMachine:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREcreateMachine*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREcreateMachine*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateMachineResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREcreateMachineResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREcreateMachineResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateLegacyMachine:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREcreateLegacyMachine*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREcreateLegacyMachine*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateLegacyMachineResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREcreateLegacyMachineResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREcreateLegacyMachineResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREopenMachine:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREopenMachine*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREopenMachine*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREopenMachineResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREopenMachineResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREopenMachineResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREregisterMachine:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREregisterMachine*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREregisterMachine*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREregisterMachineResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREregisterMachineResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREregisterMachineResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetMachine:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetMachine*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetMachine*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetMachineResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetMachineResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetMachineResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREfindMachine:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREfindMachine*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREfindMachine*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREfindMachineResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREfindMachineResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREfindMachineResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREunregisterMachine:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREunregisterMachine*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREunregisterMachine*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREunregisterMachineResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREunregisterMachineResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREunregisterMachineResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateAppliance:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREcreateAppliance*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREcreateAppliance*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateApplianceResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREcreateApplianceResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREcreateApplianceResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateHardDisk:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREcreateHardDisk*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREcreateHardDisk*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateHardDiskResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREcreateHardDiskResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREcreateHardDiskResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREopenHardDisk:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREopenHardDisk*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREopenHardDisk*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREopenHardDiskResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREopenHardDiskResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREopenHardDiskResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetHardDisk:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetHardDisk*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetHardDisk*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetHardDiskResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetHardDiskResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetHardDiskResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREfindHardDisk:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREfindHardDisk*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREfindHardDisk*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREfindHardDiskResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREfindHardDiskResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREfindHardDiskResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREopenDVDImage:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREopenDVDImage*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREopenDVDImage*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREopenDVDImageResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREopenDVDImageResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREopenDVDImageResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetDVDImage:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetDVDImage*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetDVDImage*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetDVDImageResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetDVDImageResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetDVDImageResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREfindDVDImage:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREfindDVDImage*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREfindDVDImage*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREfindDVDImageResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREfindDVDImageResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREfindDVDImageResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREopenFloppyImage:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREopenFloppyImage*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREopenFloppyImage*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREopenFloppyImageResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREopenFloppyImageResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREopenFloppyImageResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetFloppyImage:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetFloppyImage*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetFloppyImage*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetFloppyImageResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetFloppyImageResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetFloppyImageResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREfindFloppyImage:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREfindFloppyImage*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREfindFloppyImage*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREfindFloppyImageResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREfindFloppyImageResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREfindFloppyImageResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetGuestOSType:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetGuestOSType*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetGuestOSType*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetGuestOSTypeResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetGuestOSTypeResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetGuestOSTypeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateSharedFolder:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREcreateSharedFolder*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREcreateSharedFolder*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateSharedFolderResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREcreateSharedFolderResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREcreateSharedFolderResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREremoveSharedFolder:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREremoveSharedFolder*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREremoveSharedFolder*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREremoveSharedFolderResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREremoveSharedFolderResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREremoveSharedFolderResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetExtraDataKeys:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetExtraDataKeys*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetExtraDataKeys*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetExtraDataKeysResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetExtraDataKeysResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetExtraDataKeysResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetExtraData:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetExtraData*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetExtraData*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetExtraDataResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREgetExtraDataResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREgetExtraDataResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREsetExtraData:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREsetExtraData*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREsetExtraData*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREsetExtraDataResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREsetExtraDataResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREsetExtraDataResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREopenSession:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREopenSession*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREopenSession*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREopenSessionResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREopenSessionResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREopenSessionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREopenRemoteSession:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREopenRemoteSession*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREopenRemoteSession*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREopenRemoteSessionResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREopenRemoteSessionResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREopenRemoteSessionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREopenExistingSession:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREopenExistingSession*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREopenExistingSession*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREopenExistingSessionResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREopenExistingSessionResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREopenExistingSessionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREwaitForPropertyChange:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREwaitForPropertyChange*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREwaitForPropertyChange*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREwaitForPropertyChangeResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREwaitForPropertyChangeResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREwaitForPropertyChangeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateDHCPServer:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREcreateDHCPServer*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREcreateDHCPServer*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateDHCPServerResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREcreateDHCPServerResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREcreateDHCPServerResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREfindDHCPServerByNetworkName:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREfindDHCPServerByNetworkName*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREfindDHCPServerByNetworkName*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREfindDHCPServerByNetworkNameResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREfindDHCPServerByNetworkNameResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREfindDHCPServerByNetworkNameResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREremoveDHCPServer:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREremoveDHCPServer*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREremoveDHCPServer*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREremoveDHCPServerResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREremoveDHCPServerResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREremoveDHCPServerResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcheckFirmwarePresent:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREcheckFirmwarePresent*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREcheckFirmwarePresent*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcheckFirmwarePresentResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualBox_USCOREcheckFirmwarePresentResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualBox_USCOREcheckFirmwarePresentResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREgetPath:
		if (p->size < 0)
			delete (_vbox__IVFSExplorer_USCOREgetPath*)p->ptr;
		else
			delete[] (_vbox__IVFSExplorer_USCOREgetPath*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREgetPathResponse:
		if (p->size < 0)
			delete (_vbox__IVFSExplorer_USCOREgetPathResponse*)p->ptr;
		else
			delete[] (_vbox__IVFSExplorer_USCOREgetPathResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREgetType:
		if (p->size < 0)
			delete (_vbox__IVFSExplorer_USCOREgetType*)p->ptr;
		else
			delete[] (_vbox__IVFSExplorer_USCOREgetType*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREgetTypeResponse:
		if (p->size < 0)
			delete (_vbox__IVFSExplorer_USCOREgetTypeResponse*)p->ptr;
		else
			delete[] (_vbox__IVFSExplorer_USCOREgetTypeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREupdate:
		if (p->size < 0)
			delete (_vbox__IVFSExplorer_USCOREupdate*)p->ptr;
		else
			delete[] (_vbox__IVFSExplorer_USCOREupdate*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREupdateResponse:
		if (p->size < 0)
			delete (_vbox__IVFSExplorer_USCOREupdateResponse*)p->ptr;
		else
			delete[] (_vbox__IVFSExplorer_USCOREupdateResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREcd:
		if (p->size < 0)
			delete (_vbox__IVFSExplorer_USCOREcd*)p->ptr;
		else
			delete[] (_vbox__IVFSExplorer_USCOREcd*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREcdResponse:
		if (p->size < 0)
			delete (_vbox__IVFSExplorer_USCOREcdResponse*)p->ptr;
		else
			delete[] (_vbox__IVFSExplorer_USCOREcdResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREcdUp:
		if (p->size < 0)
			delete (_vbox__IVFSExplorer_USCOREcdUp*)p->ptr;
		else
			delete[] (_vbox__IVFSExplorer_USCOREcdUp*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREcdUpResponse:
		if (p->size < 0)
			delete (_vbox__IVFSExplorer_USCOREcdUpResponse*)p->ptr;
		else
			delete[] (_vbox__IVFSExplorer_USCOREcdUpResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREentryList:
		if (p->size < 0)
			delete (_vbox__IVFSExplorer_USCOREentryList*)p->ptr;
		else
			delete[] (_vbox__IVFSExplorer_USCOREentryList*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREentryListResponse:
		if (p->size < 0)
			delete (_vbox__IVFSExplorer_USCOREentryListResponse*)p->ptr;
		else
			delete[] (_vbox__IVFSExplorer_USCOREentryListResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREexists:
		if (p->size < 0)
			delete (_vbox__IVFSExplorer_USCOREexists*)p->ptr;
		else
			delete[] (_vbox__IVFSExplorer_USCOREexists*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREexistsResponse:
		if (p->size < 0)
			delete (_vbox__IVFSExplorer_USCOREexistsResponse*)p->ptr;
		else
			delete[] (_vbox__IVFSExplorer_USCOREexistsResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREremove:
		if (p->size < 0)
			delete (_vbox__IVFSExplorer_USCOREremove*)p->ptr;
		else
			delete[] (_vbox__IVFSExplorer_USCOREremove*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREremoveResponse:
		if (p->size < 0)
			delete (_vbox__IVFSExplorer_USCOREremoveResponse*)p->ptr;
		else
			delete[] (_vbox__IVFSExplorer_USCOREremoveResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREgetPath:
		if (p->size < 0)
			delete (_vbox__IAppliance_USCOREgetPath*)p->ptr;
		else
			delete[] (_vbox__IAppliance_USCOREgetPath*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREgetPathResponse:
		if (p->size < 0)
			delete (_vbox__IAppliance_USCOREgetPathResponse*)p->ptr;
		else
			delete[] (_vbox__IAppliance_USCOREgetPathResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREgetDisks:
		if (p->size < 0)
			delete (_vbox__IAppliance_USCOREgetDisks*)p->ptr;
		else
			delete[] (_vbox__IAppliance_USCOREgetDisks*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREgetDisksResponse:
		if (p->size < 0)
			delete (_vbox__IAppliance_USCOREgetDisksResponse*)p->ptr;
		else
			delete[] (_vbox__IAppliance_USCOREgetDisksResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREgetVirtualSystemDescriptions:
		if (p->size < 0)
			delete (_vbox__IAppliance_USCOREgetVirtualSystemDescriptions*)p->ptr;
		else
			delete[] (_vbox__IAppliance_USCOREgetVirtualSystemDescriptions*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREgetVirtualSystemDescriptionsResponse:
		if (p->size < 0)
			delete (_vbox__IAppliance_USCOREgetVirtualSystemDescriptionsResponse*)p->ptr;
		else
			delete[] (_vbox__IAppliance_USCOREgetVirtualSystemDescriptionsResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREread:
		if (p->size < 0)
			delete (_vbox__IAppliance_USCOREread*)p->ptr;
		else
			delete[] (_vbox__IAppliance_USCOREread*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREreadResponse:
		if (p->size < 0)
			delete (_vbox__IAppliance_USCOREreadResponse*)p->ptr;
		else
			delete[] (_vbox__IAppliance_USCOREreadResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREinterpret:
		if (p->size < 0)
			delete (_vbox__IAppliance_USCOREinterpret*)p->ptr;
		else
			delete[] (_vbox__IAppliance_USCOREinterpret*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREinterpretResponse:
		if (p->size < 0)
			delete (_vbox__IAppliance_USCOREinterpretResponse*)p->ptr;
		else
			delete[] (_vbox__IAppliance_USCOREinterpretResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREimportMachines:
		if (p->size < 0)
			delete (_vbox__IAppliance_USCOREimportMachines*)p->ptr;
		else
			delete[] (_vbox__IAppliance_USCOREimportMachines*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREimportMachinesResponse:
		if (p->size < 0)
			delete (_vbox__IAppliance_USCOREimportMachinesResponse*)p->ptr;
		else
			delete[] (_vbox__IAppliance_USCOREimportMachinesResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREcreateVFSExplorer:
		if (p->size < 0)
			delete (_vbox__IAppliance_USCOREcreateVFSExplorer*)p->ptr;
		else
			delete[] (_vbox__IAppliance_USCOREcreateVFSExplorer*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREcreateVFSExplorerResponse:
		if (p->size < 0)
			delete (_vbox__IAppliance_USCOREcreateVFSExplorerResponse*)p->ptr;
		else
			delete[] (_vbox__IAppliance_USCOREcreateVFSExplorerResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREwrite:
		if (p->size < 0)
			delete (_vbox__IAppliance_USCOREwrite*)p->ptr;
		else
			delete[] (_vbox__IAppliance_USCOREwrite*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREwriteResponse:
		if (p->size < 0)
			delete (_vbox__IAppliance_USCOREwriteResponse*)p->ptr;
		else
			delete[] (_vbox__IAppliance_USCOREwriteResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREgetWarnings:
		if (p->size < 0)
			delete (_vbox__IAppliance_USCOREgetWarnings*)p->ptr;
		else
			delete[] (_vbox__IAppliance_USCOREgetWarnings*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREgetWarningsResponse:
		if (p->size < 0)
			delete (_vbox__IAppliance_USCOREgetWarningsResponse*)p->ptr;
		else
			delete[] (_vbox__IAppliance_USCOREgetWarningsResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREgetCount:
		if (p->size < 0)
			delete (_vbox__IVirtualSystemDescription_USCOREgetCount*)p->ptr;
		else
			delete[] (_vbox__IVirtualSystemDescription_USCOREgetCount*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREgetCountResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualSystemDescription_USCOREgetCountResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualSystemDescription_USCOREgetCountResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREgetDescription:
		if (p->size < 0)
			delete (_vbox__IVirtualSystemDescription_USCOREgetDescription*)p->ptr;
		else
			delete[] (_vbox__IVirtualSystemDescription_USCOREgetDescription*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREgetDescriptionResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualSystemDescription_USCOREgetDescriptionResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualSystemDescription_USCOREgetDescriptionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREgetDescriptionByType:
		if (p->size < 0)
			delete (_vbox__IVirtualSystemDescription_USCOREgetDescriptionByType*)p->ptr;
		else
			delete[] (_vbox__IVirtualSystemDescription_USCOREgetDescriptionByType*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREgetDescriptionByTypeResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualSystemDescription_USCOREgetDescriptionByTypeResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualSystemDescription_USCOREgetDescriptionByTypeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREgetValuesByType:
		if (p->size < 0)
			delete (_vbox__IVirtualSystemDescription_USCOREgetValuesByType*)p->ptr;
		else
			delete[] (_vbox__IVirtualSystemDescription_USCOREgetValuesByType*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREgetValuesByTypeResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualSystemDescription_USCOREgetValuesByTypeResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualSystemDescription_USCOREgetValuesByTypeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREsetFinalValues:
		if (p->size < 0)
			delete (_vbox__IVirtualSystemDescription_USCOREsetFinalValues*)p->ptr;
		else
			delete[] (_vbox__IVirtualSystemDescription_USCOREsetFinalValues*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREsetFinalValuesResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualSystemDescription_USCOREsetFinalValuesResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualSystemDescription_USCOREsetFinalValuesResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREaddDescription:
		if (p->size < 0)
			delete (_vbox__IVirtualSystemDescription_USCOREaddDescription*)p->ptr;
		else
			delete[] (_vbox__IVirtualSystemDescription_USCOREaddDescription*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREaddDescriptionResponse:
		if (p->size < 0)
			delete (_vbox__IVirtualSystemDescription_USCOREaddDescriptionResponse*)p->ptr;
		else
			delete[] (_vbox__IVirtualSystemDescription_USCOREaddDescriptionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetLogoFadeIn:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREgetLogoFadeIn*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREgetLogoFadeIn*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetLogoFadeInResponse:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREgetLogoFadeInResponse*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREgetLogoFadeInResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetLogoFadeIn:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREsetLogoFadeIn*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREsetLogoFadeIn*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetLogoFadeInResponse:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREsetLogoFadeInResponse*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREsetLogoFadeInResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetLogoFadeOut:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREgetLogoFadeOut*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREgetLogoFadeOut*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetLogoFadeOutResponse:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREgetLogoFadeOutResponse*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREgetLogoFadeOutResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetLogoFadeOut:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREsetLogoFadeOut*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREsetLogoFadeOut*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetLogoFadeOutResponse:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREsetLogoFadeOutResponse*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREsetLogoFadeOutResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetLogoDisplayTime:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREgetLogoDisplayTime*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREgetLogoDisplayTime*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetLogoDisplayTimeResponse:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREgetLogoDisplayTimeResponse*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREgetLogoDisplayTimeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetLogoDisplayTime:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREsetLogoDisplayTime*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREsetLogoDisplayTime*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetLogoDisplayTimeResponse:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREsetLogoDisplayTimeResponse*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREsetLogoDisplayTimeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetLogoImagePath:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREgetLogoImagePath*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREgetLogoImagePath*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetLogoImagePathResponse:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREgetLogoImagePathResponse*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREgetLogoImagePathResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetLogoImagePath:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREsetLogoImagePath*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREsetLogoImagePath*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetLogoImagePathResponse:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREsetLogoImagePathResponse*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREsetLogoImagePathResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetBootMenuMode:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREgetBootMenuMode*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREgetBootMenuMode*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetBootMenuModeResponse:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREgetBootMenuModeResponse*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREgetBootMenuModeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetBootMenuMode:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREsetBootMenuMode*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREsetBootMenuMode*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetBootMenuModeResponse:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREsetBootMenuModeResponse*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREsetBootMenuModeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetACPIEnabled:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREgetACPIEnabled*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREgetACPIEnabled*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetACPIEnabledResponse:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREgetACPIEnabledResponse*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREgetACPIEnabledResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetACPIEnabled:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREsetACPIEnabled*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREsetACPIEnabled*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetACPIEnabledResponse:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREsetACPIEnabledResponse*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREsetACPIEnabledResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetIOAPICEnabled:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREgetIOAPICEnabled*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREgetIOAPICEnabled*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetIOAPICEnabledResponse:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREgetIOAPICEnabledResponse*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREgetIOAPICEnabledResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetIOAPICEnabled:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREsetIOAPICEnabled*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREsetIOAPICEnabled*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetIOAPICEnabledResponse:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREsetIOAPICEnabledResponse*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREsetIOAPICEnabledResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetTimeOffset:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREgetTimeOffset*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREgetTimeOffset*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetTimeOffsetResponse:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREgetTimeOffsetResponse*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREgetTimeOffsetResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetTimeOffset:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREsetTimeOffset*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREsetTimeOffset*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetTimeOffsetResponse:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREsetTimeOffsetResponse*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREsetTimeOffsetResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetPXEDebugEnabled:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREgetPXEDebugEnabled*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREgetPXEDebugEnabled*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetPXEDebugEnabledResponse:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREgetPXEDebugEnabledResponse*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREgetPXEDebugEnabledResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetPXEDebugEnabled:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREsetPXEDebugEnabled*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREsetPXEDebugEnabled*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetPXEDebugEnabledResponse:
		if (p->size < 0)
			delete (_vbox__IBIOSSettings_USCOREsetPXEDebugEnabledResponse*)p->ptr;
		else
			delete[] (_vbox__IBIOSSettings_USCOREsetPXEDebugEnabledResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetParent:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetParent*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetParent*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetParentResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetParentResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetParentResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetAccessible:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetAccessible*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetAccessible*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetAccessibleResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetAccessibleResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetAccessibleResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetAccessError:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetAccessError*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetAccessError*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetAccessErrorResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetAccessErrorResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetAccessErrorResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetName:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetName*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetName*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetNameResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetNameResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetNameResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetName:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetName*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetName*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetNameResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetNameResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetNameResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetDescription:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetDescription*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetDescription*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetDescriptionResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetDescriptionResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetDescriptionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetDescription:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetDescription*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetDescription*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetDescriptionResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetDescriptionResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetDescriptionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetId:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetId*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetId*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetIdResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetIdResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetIdResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetOSTypeId:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetOSTypeId*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetOSTypeId*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetOSTypeIdResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetOSTypeIdResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetOSTypeIdResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetOSTypeId:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetOSTypeId*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetOSTypeId*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetOSTypeIdResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetOSTypeIdResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetOSTypeIdResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetHardwareVersion:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetHardwareVersion*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetHardwareVersion*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetHardwareVersionResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetHardwareVersionResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetHardwareVersionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetHardwareVersion:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetHardwareVersion*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetHardwareVersion*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetHardwareVersionResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetHardwareVersionResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetHardwareVersionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetHardwareUUID:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetHardwareUUID*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetHardwareUUID*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetHardwareUUIDResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetHardwareUUIDResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetHardwareUUIDResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetHardwareUUID:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetHardwareUUID*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetHardwareUUID*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetHardwareUUIDResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetHardwareUUIDResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetHardwareUUIDResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetCPUCount:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetCPUCount*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetCPUCount*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetCPUCountResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetCPUCountResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetCPUCountResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetCPUCount:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetCPUCount*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetCPUCount*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetCPUCountResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetCPUCountResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetCPUCountResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetMemorySize:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetMemorySize*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetMemorySize*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetMemorySizeResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetMemorySizeResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetMemorySizeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetMemorySize:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetMemorySize*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetMemorySize*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetMemorySizeResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetMemorySizeResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetMemorySizeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetMemoryBalloonSize:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetMemoryBalloonSize*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetMemoryBalloonSize*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetMemoryBalloonSizeResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetMemoryBalloonSizeResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetMemoryBalloonSizeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetMemoryBalloonSize:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetMemoryBalloonSize*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetMemoryBalloonSize*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetMemoryBalloonSizeResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetMemoryBalloonSizeResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetMemoryBalloonSizeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetStatisticsUpdateInterval:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetStatisticsUpdateInterval*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetStatisticsUpdateInterval*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetStatisticsUpdateIntervalResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetStatisticsUpdateIntervalResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetStatisticsUpdateIntervalResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetStatisticsUpdateInterval:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetStatisticsUpdateInterval*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetStatisticsUpdateInterval*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetStatisticsUpdateIntervalResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetStatisticsUpdateIntervalResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetStatisticsUpdateIntervalResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetVRAMSize:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetVRAMSize*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetVRAMSize*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetVRAMSizeResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetVRAMSizeResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetVRAMSizeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetVRAMSize:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetVRAMSize*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetVRAMSize*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetVRAMSizeResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetVRAMSizeResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetVRAMSizeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetAccelerate3DEnabled:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetAccelerate3DEnabled*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetAccelerate3DEnabled*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetAccelerate3DEnabledResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetAccelerate3DEnabledResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetAccelerate3DEnabledResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetAccelerate3DEnabled:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetAccelerate3DEnabled*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetAccelerate3DEnabled*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetAccelerate3DEnabledResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetAccelerate3DEnabledResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetAccelerate3DEnabledResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetAccelerate2DVideoEnabled:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetAccelerate2DVideoEnabled*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetAccelerate2DVideoEnabled*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetAccelerate2DVideoEnabledResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetAccelerate2DVideoEnabledResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetAccelerate2DVideoEnabledResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetAccelerate2DVideoEnabled:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetAccelerate2DVideoEnabled*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetAccelerate2DVideoEnabled*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetAccelerate2DVideoEnabledResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetAccelerate2DVideoEnabledResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetAccelerate2DVideoEnabledResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetMonitorCount:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetMonitorCount*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetMonitorCount*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetMonitorCountResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetMonitorCountResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetMonitorCountResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetMonitorCount:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetMonitorCount*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetMonitorCount*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetMonitorCountResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetMonitorCountResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetMonitorCountResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetBIOSSettings:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetBIOSSettings*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetBIOSSettings*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetBIOSSettingsResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetBIOSSettingsResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetBIOSSettingsResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetFirmwareType:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetFirmwareType*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetFirmwareType*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetFirmwareTypeResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetFirmwareTypeResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetFirmwareTypeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetFirmwareType:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetFirmwareType*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetFirmwareType*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetFirmwareTypeResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetFirmwareTypeResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetFirmwareTypeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSnapshotFolder:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetSnapshotFolder*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetSnapshotFolder*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSnapshotFolderResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetSnapshotFolderResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetSnapshotFolderResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetSnapshotFolder:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetSnapshotFolder*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetSnapshotFolder*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetSnapshotFolderResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetSnapshotFolderResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetSnapshotFolderResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetVRDPServer:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetVRDPServer*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetVRDPServer*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetVRDPServerResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetVRDPServerResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetVRDPServerResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetMediumAttachments:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetMediumAttachments*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetMediumAttachments*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetMediumAttachmentsResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetMediumAttachmentsResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetMediumAttachmentsResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetUSBController:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetUSBController*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetUSBController*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetUSBControllerResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetUSBControllerResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetUSBControllerResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetAudioAdapter:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetAudioAdapter*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetAudioAdapter*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetAudioAdapterResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetAudioAdapterResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetAudioAdapterResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetStorageControllers:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetStorageControllers*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetStorageControllers*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetStorageControllersResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetStorageControllersResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetStorageControllersResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSettingsFilePath:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetSettingsFilePath*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetSettingsFilePath*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSettingsFilePathResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetSettingsFilePathResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetSettingsFilePathResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSettingsModified:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetSettingsModified*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetSettingsModified*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSettingsModifiedResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetSettingsModifiedResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetSettingsModifiedResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSessionState:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetSessionState*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetSessionState*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSessionStateResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetSessionStateResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetSessionStateResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSessionType:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetSessionType*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetSessionType*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSessionTypeResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetSessionTypeResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetSessionTypeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSessionPid:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetSessionPid*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetSessionPid*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSessionPidResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetSessionPidResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetSessionPidResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetState:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetState*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetState*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetStateResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetStateResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetStateResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetLastStateChange:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetLastStateChange*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetLastStateChange*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetLastStateChangeResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetLastStateChangeResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetLastStateChangeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetStateFilePath:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetStateFilePath*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetStateFilePath*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetStateFilePathResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetStateFilePathResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetStateFilePathResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetLogFolder:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetLogFolder*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetLogFolder*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetLogFolderResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetLogFolderResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetLogFolderResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetCurrentSnapshot:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetCurrentSnapshot*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetCurrentSnapshot*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetCurrentSnapshotResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetCurrentSnapshotResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetCurrentSnapshotResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSnapshotCount:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetSnapshotCount*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetSnapshotCount*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSnapshotCountResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetSnapshotCountResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetSnapshotCountResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetCurrentStateModified:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetCurrentStateModified*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetCurrentStateModified*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetCurrentStateModifiedResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetCurrentStateModifiedResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetCurrentStateModifiedResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSharedFolders:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetSharedFolders*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetSharedFolders*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSharedFoldersResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetSharedFoldersResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetSharedFoldersResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetClipboardMode:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetClipboardMode*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetClipboardMode*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetClipboardModeResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetClipboardModeResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetClipboardModeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetClipboardMode:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetClipboardMode*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetClipboardMode*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetClipboardModeResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetClipboardModeResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetClipboardModeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetGuestPropertyNotificationPatterns:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetGuestPropertyNotificationPatterns*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetGuestPropertyNotificationPatterns*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetGuestPropertyNotificationPatternsResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetGuestPropertyNotificationPatternsResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetGuestPropertyNotificationPatternsResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetGuestPropertyNotificationPatterns:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetGuestPropertyNotificationPatterns*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetGuestPropertyNotificationPatterns*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetGuestPropertyNotificationPatternsResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetGuestPropertyNotificationPatternsResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetGuestPropertyNotificationPatternsResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetTeleporterEnabled:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetTeleporterEnabled*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetTeleporterEnabled*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetTeleporterEnabledResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetTeleporterEnabledResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetTeleporterEnabledResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetTeleporterEnabled:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetTeleporterEnabled*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetTeleporterEnabled*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetTeleporterEnabledResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetTeleporterEnabledResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetTeleporterEnabledResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetTeleporterPort:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetTeleporterPort*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetTeleporterPort*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetTeleporterPortResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetTeleporterPortResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetTeleporterPortResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetTeleporterPort:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetTeleporterPort*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetTeleporterPort*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetTeleporterPortResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetTeleporterPortResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetTeleporterPortResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetTeleporterAddress:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetTeleporterAddress*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetTeleporterAddress*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetTeleporterAddressResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetTeleporterAddressResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetTeleporterAddressResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetTeleporterAddress:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetTeleporterAddress*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetTeleporterAddress*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetTeleporterAddressResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetTeleporterAddressResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetTeleporterAddressResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetTeleporterPassword:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetTeleporterPassword*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetTeleporterPassword*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetTeleporterPasswordResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetTeleporterPasswordResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetTeleporterPasswordResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetTeleporterPassword:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetTeleporterPassword*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetTeleporterPassword*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetTeleporterPasswordResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetTeleporterPasswordResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetTeleporterPasswordResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetBootOrder:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetBootOrder*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetBootOrder*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetBootOrderResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetBootOrderResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetBootOrderResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetBootOrder:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetBootOrder*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetBootOrder*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetBootOrderResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetBootOrderResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetBootOrderResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREattachDevice:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREattachDevice*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREattachDevice*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREattachDeviceResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREattachDeviceResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREattachDeviceResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREdetachDevice:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREdetachDevice*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREdetachDevice*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREdetachDeviceResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREdetachDeviceResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREdetachDeviceResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREpassthroughDevice:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREpassthroughDevice*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREpassthroughDevice*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREpassthroughDeviceResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREpassthroughDeviceResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREpassthroughDeviceResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREmountMedium:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREmountMedium*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREmountMedium*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREmountMediumResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREmountMediumResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREmountMediumResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetMedium:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetMedium*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetMedium*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetMediumResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetMediumResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetMediumResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetMediumAttachmentsOfController:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetMediumAttachmentsOfController*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetMediumAttachmentsOfController*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetMediumAttachmentsOfControllerResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetMediumAttachmentsOfControllerResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetMediumAttachmentsOfControllerResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetMediumAttachment:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetMediumAttachment*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetMediumAttachment*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetMediumAttachmentResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetMediumAttachmentResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetMediumAttachmentResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetNetworkAdapter:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetNetworkAdapter*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetNetworkAdapter*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetNetworkAdapterResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetNetworkAdapterResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetNetworkAdapterResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREaddStorageController:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREaddStorageController*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREaddStorageController*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREaddStorageControllerResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREaddStorageControllerResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREaddStorageControllerResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetStorageControllerByName:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetStorageControllerByName*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetStorageControllerByName*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetStorageControllerByNameResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetStorageControllerByNameResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetStorageControllerByNameResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetStorageControllerByInstance:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetStorageControllerByInstance*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetStorageControllerByInstance*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetStorageControllerByInstanceResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetStorageControllerByInstanceResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetStorageControllerByInstanceResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREremoveStorageController:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREremoveStorageController*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREremoveStorageController*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREremoveStorageControllerResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREremoveStorageControllerResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREremoveStorageControllerResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSerialPort:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetSerialPort*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetSerialPort*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSerialPortResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetSerialPortResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetSerialPortResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetParallelPort:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetParallelPort*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetParallelPort*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetParallelPortResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetParallelPortResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetParallelPortResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetExtraDataKeys:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetExtraDataKeys*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetExtraDataKeys*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetExtraDataKeysResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetExtraDataKeysResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetExtraDataKeysResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetExtraData:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetExtraData*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetExtraData*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetExtraDataResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetExtraDataResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetExtraDataResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetExtraData:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetExtraData*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetExtraData*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetExtraDataResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetExtraDataResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetExtraDataResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetCpuProperty:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetCpuProperty*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetCpuProperty*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetCpuPropertyResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetCpuPropertyResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetCpuPropertyResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetCpuProperty:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetCpuProperty*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetCpuProperty*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetCpuPropertyResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetCpuPropertyResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetCpuPropertyResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetCpuIdLeaf:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetCpuIdLeaf*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetCpuIdLeaf*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetCpuIdLeafResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetCpuIdLeafResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetCpuIdLeafResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetCpuIdLeaf:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetCpuIdLeaf*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetCpuIdLeaf*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetCpuIdLeafResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetCpuIdLeafResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetCpuIdLeafResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREremoveCpuIdLeaf:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREremoveCpuIdLeaf*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREremoveCpuIdLeaf*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREremoveCpuIdLeafResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREremoveCpuIdLeafResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREremoveCpuIdLeafResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREremoveAllCpuIdLeafs:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREremoveAllCpuIdLeafs*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREremoveAllCpuIdLeafs*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREremoveAllCpuIdLeafsResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREremoveAllCpuIdLeafsResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREremoveAllCpuIdLeafsResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetHWVirtExProperty:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetHWVirtExProperty*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetHWVirtExProperty*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetHWVirtExPropertyResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetHWVirtExPropertyResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetHWVirtExPropertyResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetHWVirtExProperty:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetHWVirtExProperty*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetHWVirtExProperty*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetHWVirtExPropertyResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetHWVirtExPropertyResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetHWVirtExPropertyResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsaveSettings:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsaveSettings*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsaveSettings*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsaveSettingsResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsaveSettingsResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsaveSettingsResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREdiscardSettings:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREdiscardSettings*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREdiscardSettings*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREdiscardSettingsResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREdiscardSettingsResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREdiscardSettingsResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREdeleteSettings:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREdeleteSettings*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREdeleteSettings*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREdeleteSettingsResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREdeleteSettingsResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREdeleteSettingsResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREexport:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREexport*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREexport*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREexportResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREexportResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREexportResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSnapshot:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetSnapshot*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetSnapshot*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSnapshotResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetSnapshotResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetSnapshotResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREfindSnapshot:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREfindSnapshot*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREfindSnapshot*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREfindSnapshotResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREfindSnapshotResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREfindSnapshotResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetCurrentSnapshot:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetCurrentSnapshot*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetCurrentSnapshot*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetCurrentSnapshotResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetCurrentSnapshotResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetCurrentSnapshotResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREcreateSharedFolder:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREcreateSharedFolder*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREcreateSharedFolder*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREcreateSharedFolderResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREcreateSharedFolderResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREcreateSharedFolderResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREremoveSharedFolder:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREremoveSharedFolder*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREremoveSharedFolder*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREremoveSharedFolderResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREremoveSharedFolderResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREremoveSharedFolderResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREcanShowConsoleWindow:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREcanShowConsoleWindow*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREcanShowConsoleWindow*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREcanShowConsoleWindowResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREcanShowConsoleWindowResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREcanShowConsoleWindowResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREshowConsoleWindow:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREshowConsoleWindow*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREshowConsoleWindow*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREshowConsoleWindowResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREshowConsoleWindowResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREshowConsoleWindowResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetGuestProperty:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetGuestProperty*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetGuestProperty*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetGuestPropertyResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetGuestPropertyResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetGuestPropertyResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetGuestPropertyValue:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetGuestPropertyValue*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetGuestPropertyValue*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetGuestPropertyValueResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetGuestPropertyValueResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetGuestPropertyValueResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetGuestPropertyTimestamp:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetGuestPropertyTimestamp*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetGuestPropertyTimestamp*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetGuestPropertyTimestampResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREgetGuestPropertyTimestampResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREgetGuestPropertyTimestampResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetGuestProperty:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetGuestProperty*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetGuestProperty*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetGuestPropertyResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetGuestPropertyResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetGuestPropertyResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetGuestPropertyValue:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetGuestPropertyValue*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetGuestPropertyValue*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetGuestPropertyValueResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREsetGuestPropertyValueResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREsetGuestPropertyValueResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREenumerateGuestProperties:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREenumerateGuestProperties*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREenumerateGuestProperties*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREenumerateGuestPropertiesResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREenumerateGuestPropertiesResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREenumerateGuestPropertiesResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREquerySavedThumbnailSize:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREquerySavedThumbnailSize*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREquerySavedThumbnailSize*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREquerySavedThumbnailSizeResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREquerySavedThumbnailSizeResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREquerySavedThumbnailSizeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREreadSavedThumbnailToArray:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREreadSavedThumbnailToArray*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREreadSavedThumbnailToArray*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREreadSavedThumbnailToArrayResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREreadSavedThumbnailToArrayResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREreadSavedThumbnailToArrayResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREquerySavedScreenshotPNGSize:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREquerySavedScreenshotPNGSize*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREquerySavedScreenshotPNGSize*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREquerySavedScreenshotPNGSizeResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREquerySavedScreenshotPNGSizeResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREquerySavedScreenshotPNGSizeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREreadSavedScreenshotPNGToArray:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREreadSavedScreenshotPNGToArray*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREreadSavedScreenshotPNGToArray*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREreadSavedScreenshotPNGToArrayResponse:
		if (p->size < 0)
			delete (_vbox__IMachine_USCOREreadSavedScreenshotPNGToArrayResponse*)p->ptr;
		else
			delete[] (_vbox__IMachine_USCOREreadSavedScreenshotPNGToArrayResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetMachine:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREgetMachine*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREgetMachine*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetMachineResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREgetMachineResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREgetMachineResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetState:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREgetState*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREgetState*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetStateResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREgetStateResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREgetStateResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetGuest:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREgetGuest*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREgetGuest*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetGuestResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREgetGuestResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREgetGuestResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetKeyboard:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREgetKeyboard*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREgetKeyboard*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetKeyboardResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREgetKeyboardResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREgetKeyboardResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetMouse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREgetMouse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREgetMouse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetMouseResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREgetMouseResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREgetMouseResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetDisplay:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREgetDisplay*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREgetDisplay*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetDisplayResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREgetDisplayResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREgetDisplayResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetUSBDevices:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREgetUSBDevices*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREgetUSBDevices*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetUSBDevicesResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREgetUSBDevicesResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREgetUSBDevicesResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetRemoteUSBDevices:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREgetRemoteUSBDevices*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREgetRemoteUSBDevices*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetRemoteUSBDevicesResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREgetRemoteUSBDevicesResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREgetRemoteUSBDevicesResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetSharedFolders:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREgetSharedFolders*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREgetSharedFolders*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetSharedFoldersResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREgetSharedFoldersResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREgetSharedFoldersResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetRemoteDisplayInfo:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREgetRemoteDisplayInfo*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREgetRemoteDisplayInfo*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetRemoteDisplayInfoResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREgetRemoteDisplayInfoResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREgetRemoteDisplayInfoResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREpowerUp:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREpowerUp*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREpowerUp*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREpowerUpResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREpowerUpResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREpowerUpResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREpowerUpPaused:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREpowerUpPaused*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREpowerUpPaused*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREpowerUpPausedResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREpowerUpPausedResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREpowerUpPausedResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREpowerDown:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREpowerDown*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREpowerDown*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREpowerDownResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREpowerDownResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREpowerDownResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREreset:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREreset*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREreset*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREresetResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREresetResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREresetResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREpause:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREpause*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREpause*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREpauseResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREpauseResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREpauseResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREresume:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREresume*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREresume*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREresumeResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREresumeResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREresumeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREpowerButton:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREpowerButton*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREpowerButton*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREpowerButtonResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREpowerButtonResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREpowerButtonResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREsleepButton:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREsleepButton*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREsleepButton*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREsleepButtonResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREsleepButtonResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREsleepButtonResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetPowerButtonHandled:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREgetPowerButtonHandled*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREgetPowerButtonHandled*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetPowerButtonHandledResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREgetPowerButtonHandledResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREgetPowerButtonHandledResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetGuestEnteredACPIMode:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREgetGuestEnteredACPIMode*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREgetGuestEnteredACPIMode*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetGuestEnteredACPIModeResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREgetGuestEnteredACPIModeResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREgetGuestEnteredACPIModeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREsaveState:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREsaveState*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREsaveState*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREsaveStateResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREsaveStateResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREsaveStateResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREadoptSavedState:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREadoptSavedState*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREadoptSavedState*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREadoptSavedStateResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREadoptSavedStateResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREadoptSavedStateResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREforgetSavedState:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREforgetSavedState*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREforgetSavedState*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREforgetSavedStateResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREforgetSavedStateResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREforgetSavedStateResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetDeviceActivity:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREgetDeviceActivity*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREgetDeviceActivity*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetDeviceActivityResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREgetDeviceActivityResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREgetDeviceActivityResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREattachUSBDevice:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREattachUSBDevice*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREattachUSBDevice*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREattachUSBDeviceResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREattachUSBDeviceResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREattachUSBDeviceResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREdetachUSBDevice:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREdetachUSBDevice*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREdetachUSBDevice*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREdetachUSBDeviceResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREdetachUSBDeviceResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREdetachUSBDeviceResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREfindUSBDeviceByAddress:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREfindUSBDeviceByAddress*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREfindUSBDeviceByAddress*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREfindUSBDeviceByAddressResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREfindUSBDeviceByAddressResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREfindUSBDeviceByAddressResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREfindUSBDeviceById:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREfindUSBDeviceById*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREfindUSBDeviceById*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREfindUSBDeviceByIdResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREfindUSBDeviceByIdResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREfindUSBDeviceByIdResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREcreateSharedFolder:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREcreateSharedFolder*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREcreateSharedFolder*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREcreateSharedFolderResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREcreateSharedFolderResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREcreateSharedFolderResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREremoveSharedFolder:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREremoveSharedFolder*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREremoveSharedFolder*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREremoveSharedFolderResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREremoveSharedFolderResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREremoveSharedFolderResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREtakeSnapshot:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREtakeSnapshot*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREtakeSnapshot*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREtakeSnapshotResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREtakeSnapshotResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREtakeSnapshotResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREdeleteSnapshot:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREdeleteSnapshot*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREdeleteSnapshot*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREdeleteSnapshotResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREdeleteSnapshotResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREdeleteSnapshotResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCORErestoreSnapshot:
		if (p->size < 0)
			delete (_vbox__IConsole_USCORErestoreSnapshot*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCORErestoreSnapshot*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCORErestoreSnapshotResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCORErestoreSnapshotResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCORErestoreSnapshotResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREteleport:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREteleport*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREteleport*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREteleportResponse:
		if (p->size < 0)
			delete (_vbox__IConsole_USCOREteleportResponse*)p->ptr;
		else
			delete[] (_vbox__IConsole_USCOREteleportResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetName:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREgetName*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREgetName*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetNameResponse:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREgetNameResponse*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREgetNameResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetId:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREgetId*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREgetId*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetIdResponse:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREgetIdResponse*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREgetIdResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetNetworkName:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREgetNetworkName*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREgetNetworkName*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetNetworkNameResponse:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREgetNetworkNameResponse*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREgetNetworkNameResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetDhcpEnabled:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREgetDhcpEnabled*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREgetDhcpEnabled*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetDhcpEnabledResponse:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREgetDhcpEnabledResponse*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREgetDhcpEnabledResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetIPAddress:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREgetIPAddress*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREgetIPAddress*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetIPAddressResponse:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREgetIPAddressResponse*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREgetIPAddressResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetNetworkMask:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREgetNetworkMask*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREgetNetworkMask*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetNetworkMaskResponse:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREgetNetworkMaskResponse*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREgetNetworkMaskResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetIPV6Supported:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREgetIPV6Supported*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREgetIPV6Supported*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetIPV6SupportedResponse:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREgetIPV6SupportedResponse*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREgetIPV6SupportedResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetIPV6Address:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREgetIPV6Address*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREgetIPV6Address*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetIPV6AddressResponse:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREgetIPV6AddressResponse*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREgetIPV6AddressResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetIPV6NetworkMaskPrefixLength:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREgetIPV6NetworkMaskPrefixLength*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREgetIPV6NetworkMaskPrefixLength*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetIPV6NetworkMaskPrefixLengthResponse:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREgetIPV6NetworkMaskPrefixLengthResponse*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREgetIPV6NetworkMaskPrefixLengthResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetHardwareAddress:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREgetHardwareAddress*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREgetHardwareAddress*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetHardwareAddressResponse:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREgetHardwareAddressResponse*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREgetHardwareAddressResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetMediumType:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREgetMediumType*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREgetMediumType*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetMediumTypeResponse:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREgetMediumTypeResponse*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREgetMediumTypeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetStatus:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREgetStatus*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREgetStatus*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetStatusResponse:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREgetStatusResponse*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREgetStatusResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetInterfaceType:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREgetInterfaceType*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREgetInterfaceType*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetInterfaceTypeResponse:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREgetInterfaceTypeResponse*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREgetInterfaceTypeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREenableStaticIpConfig:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREenableStaticIpConfig*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREenableStaticIpConfig*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREenableStaticIpConfigResponse:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREenableStaticIpConfigResponse*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREenableStaticIpConfigResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREenableStaticIpConfigV6:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREenableStaticIpConfigV6*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREenableStaticIpConfigV6*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREenableStaticIpConfigV6Response:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREenableStaticIpConfigV6Response*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREenableStaticIpConfigV6Response*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREenableDynamicIpConfig:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREenableDynamicIpConfig*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREenableDynamicIpConfig*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREenableDynamicIpConfigResponse:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREenableDynamicIpConfigResponse*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREenableDynamicIpConfigResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREdhcpRediscover:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREdhcpRediscover*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREdhcpRediscover*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREdhcpRediscoverResponse:
		if (p->size < 0)
			delete (_vbox__IHostNetworkInterface_USCOREdhcpRediscoverResponse*)p->ptr;
		else
			delete[] (_vbox__IHostNetworkInterface_USCOREdhcpRediscoverResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetDVDDrives:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetDVDDrives*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetDVDDrives*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetDVDDrivesResponse:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetDVDDrivesResponse*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetDVDDrivesResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetFloppyDrives:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetFloppyDrives*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetFloppyDrives*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetFloppyDrivesResponse:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetFloppyDrivesResponse*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetFloppyDrivesResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetUSBDevices:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetUSBDevices*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetUSBDevices*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetUSBDevicesResponse:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetUSBDevicesResponse*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetUSBDevicesResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetUSBDeviceFilters:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetUSBDeviceFilters*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetUSBDeviceFilters*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetUSBDeviceFiltersResponse:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetUSBDeviceFiltersResponse*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetUSBDeviceFiltersResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetNetworkInterfaces:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetNetworkInterfaces*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetNetworkInterfaces*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetNetworkInterfacesResponse:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetNetworkInterfacesResponse*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetNetworkInterfacesResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorCount:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetProcessorCount*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetProcessorCount*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorCountResponse:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetProcessorCountResponse*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetProcessorCountResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorOnlineCount:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetProcessorOnlineCount*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetProcessorOnlineCount*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorOnlineCountResponse:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetProcessorOnlineCountResponse*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetProcessorOnlineCountResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetMemorySize:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetMemorySize*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetMemorySize*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetMemorySizeResponse:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetMemorySizeResponse*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetMemorySizeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetMemoryAvailable:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetMemoryAvailable*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetMemoryAvailable*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetMemoryAvailableResponse:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetMemoryAvailableResponse*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetMemoryAvailableResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetOperatingSystem:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetOperatingSystem*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetOperatingSystem*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetOperatingSystemResponse:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetOperatingSystemResponse*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetOperatingSystemResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetOSVersion:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetOSVersion*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetOSVersion*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetOSVersionResponse:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetOSVersionResponse*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetOSVersionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetUTCTime:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetUTCTime*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetUTCTime*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetUTCTimeResponse:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetUTCTimeResponse*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetUTCTimeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetAcceleration3DAvailable:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetAcceleration3DAvailable*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetAcceleration3DAvailable*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetAcceleration3DAvailableResponse:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetAcceleration3DAvailableResponse*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetAcceleration3DAvailableResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorSpeed:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetProcessorSpeed*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetProcessorSpeed*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorSpeedResponse:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetProcessorSpeedResponse*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetProcessorSpeedResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorFeature:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetProcessorFeature*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetProcessorFeature*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorFeatureResponse:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetProcessorFeatureResponse*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetProcessorFeatureResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorDescription:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetProcessorDescription*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetProcessorDescription*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorDescriptionResponse:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetProcessorDescriptionResponse*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetProcessorDescriptionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorCpuIdLeaf:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetProcessorCpuIdLeaf*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetProcessorCpuIdLeaf*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorCpuIdLeafResponse:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREgetProcessorCpuIdLeafResponse*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREgetProcessorCpuIdLeafResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREcreateHostOnlyNetworkInterface:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREcreateHostOnlyNetworkInterface*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREcreateHostOnlyNetworkInterface*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREcreateHostOnlyNetworkInterfaceResponse:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREcreateHostOnlyNetworkInterfaceResponse*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREcreateHostOnlyNetworkInterfaceResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREremoveHostOnlyNetworkInterface:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREremoveHostOnlyNetworkInterface*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREremoveHostOnlyNetworkInterface*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREremoveHostOnlyNetworkInterfaceResponse:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREremoveHostOnlyNetworkInterfaceResponse*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREremoveHostOnlyNetworkInterfaceResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREcreateUSBDeviceFilter:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREcreateUSBDeviceFilter*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREcreateUSBDeviceFilter*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREcreateUSBDeviceFilterResponse:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREcreateUSBDeviceFilterResponse*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREcreateUSBDeviceFilterResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREinsertUSBDeviceFilter:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREinsertUSBDeviceFilter*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREinsertUSBDeviceFilter*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREinsertUSBDeviceFilterResponse:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREinsertUSBDeviceFilterResponse*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREinsertUSBDeviceFilterResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREremoveUSBDeviceFilter:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREremoveUSBDeviceFilter*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREremoveUSBDeviceFilter*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREremoveUSBDeviceFilterResponse:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREremoveUSBDeviceFilterResponse*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREremoveUSBDeviceFilterResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREfindHostDVDDrive:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREfindHostDVDDrive*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREfindHostDVDDrive*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREfindHostDVDDriveResponse:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREfindHostDVDDriveResponse*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREfindHostDVDDriveResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREfindHostFloppyDrive:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREfindHostFloppyDrive*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREfindHostFloppyDrive*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREfindHostFloppyDriveResponse:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREfindHostFloppyDriveResponse*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREfindHostFloppyDriveResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREfindHostNetworkInterfaceByName:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREfindHostNetworkInterfaceByName*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREfindHostNetworkInterfaceByName*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREfindHostNetworkInterfaceByNameResponse:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREfindHostNetworkInterfaceByNameResponse*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREfindHostNetworkInterfaceByNameResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREfindHostNetworkInterfaceById:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREfindHostNetworkInterfaceById*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREfindHostNetworkInterfaceById*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREfindHostNetworkInterfaceByIdResponse:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREfindHostNetworkInterfaceByIdResponse*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREfindHostNetworkInterfaceByIdResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREfindHostNetworkInterfacesOfType:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREfindHostNetworkInterfacesOfType*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREfindHostNetworkInterfacesOfType*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREfindHostNetworkInterfacesOfTypeResponse:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREfindHostNetworkInterfacesOfTypeResponse*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREfindHostNetworkInterfacesOfTypeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREfindUSBDeviceById:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREfindUSBDeviceById*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREfindUSBDeviceById*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREfindUSBDeviceByIdResponse:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREfindUSBDeviceByIdResponse*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREfindUSBDeviceByIdResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREfindUSBDeviceByAddress:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREfindUSBDeviceByAddress*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREfindUSBDeviceByAddress*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREfindUSBDeviceByAddressResponse:
		if (p->size < 0)
			delete (_vbox__IHost_USCOREfindUSBDeviceByAddressResponse*)p->ptr;
		else
			delete[] (_vbox__IHost_USCOREfindUSBDeviceByAddressResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMinGuestRAM:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetMinGuestRAM*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetMinGuestRAM*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMinGuestRAMResponse:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetMinGuestRAMResponse*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetMinGuestRAMResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxGuestRAM:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetMaxGuestRAM*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetMaxGuestRAM*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxGuestRAMResponse:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetMaxGuestRAMResponse*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetMaxGuestRAMResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMinGuestVRAM:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetMinGuestVRAM*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetMinGuestVRAM*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMinGuestVRAMResponse:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetMinGuestVRAMResponse*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetMinGuestVRAMResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxGuestVRAM:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetMaxGuestVRAM*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetMaxGuestVRAM*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxGuestVRAMResponse:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetMaxGuestVRAMResponse*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetMaxGuestVRAMResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMinGuestCPUCount:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetMinGuestCPUCount*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetMinGuestCPUCount*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMinGuestCPUCountResponse:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetMinGuestCPUCountResponse*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetMinGuestCPUCountResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxGuestCPUCount:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetMaxGuestCPUCount*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetMaxGuestCPUCount*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxGuestCPUCountResponse:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetMaxGuestCPUCountResponse*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetMaxGuestCPUCountResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxVDISize:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetMaxVDISize*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetMaxVDISize*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxVDISizeResponse:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetMaxVDISizeResponse*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetMaxVDISizeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetNetworkAdapterCount:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetNetworkAdapterCount*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetNetworkAdapterCount*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetNetworkAdapterCountResponse:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetNetworkAdapterCountResponse*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetNetworkAdapterCountResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetSerialPortCount:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetSerialPortCount*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetSerialPortCount*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetSerialPortCountResponse:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetSerialPortCountResponse*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetSerialPortCountResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetParallelPortCount:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetParallelPortCount*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetParallelPortCount*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetParallelPortCountResponse:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetParallelPortCountResponse*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetParallelPortCountResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxBootPosition:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetMaxBootPosition*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetMaxBootPosition*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxBootPositionResponse:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetMaxBootPositionResponse*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetMaxBootPositionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDefaultMachineFolder:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetDefaultMachineFolder*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetDefaultMachineFolder*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDefaultMachineFolderResponse:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetDefaultMachineFolderResponse*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetDefaultMachineFolderResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetDefaultMachineFolder:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREsetDefaultMachineFolder*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREsetDefaultMachineFolder*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetDefaultMachineFolderResponse:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREsetDefaultMachineFolderResponse*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREsetDefaultMachineFolderResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDefaultHardDiskFolder:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetDefaultHardDiskFolder*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetDefaultHardDiskFolder*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDefaultHardDiskFolderResponse:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetDefaultHardDiskFolderResponse*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetDefaultHardDiskFolderResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetDefaultHardDiskFolder:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREsetDefaultHardDiskFolder*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREsetDefaultHardDiskFolder*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetDefaultHardDiskFolderResponse:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREsetDefaultHardDiskFolderResponse*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREsetDefaultHardDiskFolderResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMediumFormats:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetMediumFormats*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetMediumFormats*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMediumFormatsResponse:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetMediumFormatsResponse*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetMediumFormatsResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDefaultHardDiskFormat:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetDefaultHardDiskFormat*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetDefaultHardDiskFormat*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDefaultHardDiskFormatResponse:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetDefaultHardDiskFormatResponse*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetDefaultHardDiskFormatResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetDefaultHardDiskFormat:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREsetDefaultHardDiskFormat*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREsetDefaultHardDiskFormat*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetDefaultHardDiskFormatResponse:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREsetDefaultHardDiskFormatResponse*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREsetDefaultHardDiskFormatResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetRemoteDisplayAuthLibrary:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetRemoteDisplayAuthLibrary*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetRemoteDisplayAuthLibrary*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetRemoteDisplayAuthLibraryResponse:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetRemoteDisplayAuthLibraryResponse*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetRemoteDisplayAuthLibraryResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetRemoteDisplayAuthLibrary:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREsetRemoteDisplayAuthLibrary*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREsetRemoteDisplayAuthLibrary*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetRemoteDisplayAuthLibraryResponse:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREsetRemoteDisplayAuthLibraryResponse*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREsetRemoteDisplayAuthLibraryResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetWebServiceAuthLibrary:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetWebServiceAuthLibrary*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetWebServiceAuthLibrary*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetWebServiceAuthLibraryResponse:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetWebServiceAuthLibraryResponse*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetWebServiceAuthLibraryResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetWebServiceAuthLibrary:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREsetWebServiceAuthLibrary*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREsetWebServiceAuthLibrary*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetWebServiceAuthLibraryResponse:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREsetWebServiceAuthLibraryResponse*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREsetWebServiceAuthLibraryResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetLogHistoryCount:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetLogHistoryCount*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetLogHistoryCount*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetLogHistoryCountResponse:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetLogHistoryCountResponse*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetLogHistoryCountResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetLogHistoryCount:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREsetLogHistoryCount*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREsetLogHistoryCount*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetLogHistoryCountResponse:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREsetLogHistoryCountResponse*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREsetLogHistoryCountResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDefaultAudioDriver:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetDefaultAudioDriver*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetDefaultAudioDriver*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDefaultAudioDriverResponse:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetDefaultAudioDriverResponse*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetDefaultAudioDriverResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxDevicesPerPortForStorageBus:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetMaxDevicesPerPortForStorageBus*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetMaxDevicesPerPortForStorageBus*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxDevicesPerPortForStorageBusResponse:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetMaxDevicesPerPortForStorageBusResponse*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetMaxDevicesPerPortForStorageBusResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMinPortCountForStorageBus:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetMinPortCountForStorageBus*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetMinPortCountForStorageBus*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMinPortCountForStorageBusResponse:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetMinPortCountForStorageBusResponse*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetMinPortCountForStorageBusResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxPortCountForStorageBus:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetMaxPortCountForStorageBus*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetMaxPortCountForStorageBus*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxPortCountForStorageBusResponse:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetMaxPortCountForStorageBusResponse*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetMaxPortCountForStorageBusResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxInstancesOfStorageBus:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetMaxInstancesOfStorageBus*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetMaxInstancesOfStorageBus*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxInstancesOfStorageBusResponse:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetMaxInstancesOfStorageBusResponse*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetMaxInstancesOfStorageBusResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDeviceTypesForStorageBus:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetDeviceTypesForStorageBus*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetDeviceTypesForStorageBus*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDeviceTypesForStorageBusResponse:
		if (p->size < 0)
			delete (_vbox__ISystemProperties_USCOREgetDeviceTypesForStorageBusResponse*)p->ptr;
		else
			delete[] (_vbox__ISystemProperties_USCOREgetDeviceTypesForStorageBusResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetOSTypeId:
		if (p->size < 0)
			delete (_vbox__IGuest_USCOREgetOSTypeId*)p->ptr;
		else
			delete[] (_vbox__IGuest_USCOREgetOSTypeId*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetOSTypeIdResponse:
		if (p->size < 0)
			delete (_vbox__IGuest_USCOREgetOSTypeIdResponse*)p->ptr;
		else
			delete[] (_vbox__IGuest_USCOREgetOSTypeIdResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetAdditionsActive:
		if (p->size < 0)
			delete (_vbox__IGuest_USCOREgetAdditionsActive*)p->ptr;
		else
			delete[] (_vbox__IGuest_USCOREgetAdditionsActive*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetAdditionsActiveResponse:
		if (p->size < 0)
			delete (_vbox__IGuest_USCOREgetAdditionsActiveResponse*)p->ptr;
		else
			delete[] (_vbox__IGuest_USCOREgetAdditionsActiveResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetAdditionsVersion:
		if (p->size < 0)
			delete (_vbox__IGuest_USCOREgetAdditionsVersion*)p->ptr;
		else
			delete[] (_vbox__IGuest_USCOREgetAdditionsVersion*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetAdditionsVersionResponse:
		if (p->size < 0)
			delete (_vbox__IGuest_USCOREgetAdditionsVersionResponse*)p->ptr;
		else
			delete[] (_vbox__IGuest_USCOREgetAdditionsVersionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetSupportsSeamless:
		if (p->size < 0)
			delete (_vbox__IGuest_USCOREgetSupportsSeamless*)p->ptr;
		else
			delete[] (_vbox__IGuest_USCOREgetSupportsSeamless*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetSupportsSeamlessResponse:
		if (p->size < 0)
			delete (_vbox__IGuest_USCOREgetSupportsSeamlessResponse*)p->ptr;
		else
			delete[] (_vbox__IGuest_USCOREgetSupportsSeamlessResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetSupportsGraphics:
		if (p->size < 0)
			delete (_vbox__IGuest_USCOREgetSupportsGraphics*)p->ptr;
		else
			delete[] (_vbox__IGuest_USCOREgetSupportsGraphics*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetSupportsGraphicsResponse:
		if (p->size < 0)
			delete (_vbox__IGuest_USCOREgetSupportsGraphicsResponse*)p->ptr;
		else
			delete[] (_vbox__IGuest_USCOREgetSupportsGraphicsResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetMemoryBalloonSize:
		if (p->size < 0)
			delete (_vbox__IGuest_USCOREgetMemoryBalloonSize*)p->ptr;
		else
			delete[] (_vbox__IGuest_USCOREgetMemoryBalloonSize*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetMemoryBalloonSizeResponse:
		if (p->size < 0)
			delete (_vbox__IGuest_USCOREgetMemoryBalloonSizeResponse*)p->ptr;
		else
			delete[] (_vbox__IGuest_USCOREgetMemoryBalloonSizeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREsetMemoryBalloonSize:
		if (p->size < 0)
			delete (_vbox__IGuest_USCOREsetMemoryBalloonSize*)p->ptr;
		else
			delete[] (_vbox__IGuest_USCOREsetMemoryBalloonSize*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREsetMemoryBalloonSizeResponse:
		if (p->size < 0)
			delete (_vbox__IGuest_USCOREsetMemoryBalloonSizeResponse*)p->ptr;
		else
			delete[] (_vbox__IGuest_USCOREsetMemoryBalloonSizeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetStatisticsUpdateInterval:
		if (p->size < 0)
			delete (_vbox__IGuest_USCOREgetStatisticsUpdateInterval*)p->ptr;
		else
			delete[] (_vbox__IGuest_USCOREgetStatisticsUpdateInterval*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetStatisticsUpdateIntervalResponse:
		if (p->size < 0)
			delete (_vbox__IGuest_USCOREgetStatisticsUpdateIntervalResponse*)p->ptr;
		else
			delete[] (_vbox__IGuest_USCOREgetStatisticsUpdateIntervalResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREsetStatisticsUpdateInterval:
		if (p->size < 0)
			delete (_vbox__IGuest_USCOREsetStatisticsUpdateInterval*)p->ptr;
		else
			delete[] (_vbox__IGuest_USCOREsetStatisticsUpdateInterval*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREsetStatisticsUpdateIntervalResponse:
		if (p->size < 0)
			delete (_vbox__IGuest_USCOREsetStatisticsUpdateIntervalResponse*)p->ptr;
		else
			delete[] (_vbox__IGuest_USCOREsetStatisticsUpdateIntervalResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREsetCredentials:
		if (p->size < 0)
			delete (_vbox__IGuest_USCOREsetCredentials*)p->ptr;
		else
			delete[] (_vbox__IGuest_USCOREsetCredentials*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREsetCredentialsResponse:
		if (p->size < 0)
			delete (_vbox__IGuest_USCOREsetCredentialsResponse*)p->ptr;
		else
			delete[] (_vbox__IGuest_USCOREsetCredentialsResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetStatistic:
		if (p->size < 0)
			delete (_vbox__IGuest_USCOREgetStatistic*)p->ptr;
		else
			delete[] (_vbox__IGuest_USCOREgetStatistic*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetStatisticResponse:
		if (p->size < 0)
			delete (_vbox__IGuest_USCOREgetStatisticResponse*)p->ptr;
		else
			delete[] (_vbox__IGuest_USCOREgetStatisticResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetId:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREgetId*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREgetId*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetIdResponse:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREgetIdResponse*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREgetIdResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetDescription:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREgetDescription*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREgetDescription*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetDescriptionResponse:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREgetDescriptionResponse*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREgetDescriptionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetInitiator:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREgetInitiator*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREgetInitiator*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetInitiatorResponse:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREgetInitiatorResponse*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREgetInitiatorResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetCancelable:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREgetCancelable*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREgetCancelable*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetCancelableResponse:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREgetCancelableResponse*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREgetCancelableResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetPercent:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREgetPercent*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREgetPercent*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetPercentResponse:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREgetPercentResponse*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREgetPercentResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetTimeRemaining:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREgetTimeRemaining*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREgetTimeRemaining*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetTimeRemainingResponse:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREgetTimeRemainingResponse*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREgetTimeRemainingResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetCompleted:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREgetCompleted*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREgetCompleted*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetCompletedResponse:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREgetCompletedResponse*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREgetCompletedResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetCanceled:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREgetCanceled*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREgetCanceled*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetCanceledResponse:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREgetCanceledResponse*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREgetCanceledResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetResultCode:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREgetResultCode*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREgetResultCode*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetResultCodeResponse:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREgetResultCodeResponse*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREgetResultCodeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetErrorInfo:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREgetErrorInfo*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREgetErrorInfo*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetErrorInfoResponse:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREgetErrorInfoResponse*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREgetErrorInfoResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetOperationCount:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREgetOperationCount*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREgetOperationCount*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetOperationCountResponse:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREgetOperationCountResponse*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREgetOperationCountResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetOperation:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREgetOperation*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREgetOperation*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetOperationResponse:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREgetOperationResponse*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREgetOperationResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetOperationDescription:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREgetOperationDescription*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREgetOperationDescription*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetOperationDescriptionResponse:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREgetOperationDescriptionResponse*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREgetOperationDescriptionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetOperationPercent:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREgetOperationPercent*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREgetOperationPercent*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetOperationPercentResponse:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREgetOperationPercentResponse*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREgetOperationPercentResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetTimeout:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREgetTimeout*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREgetTimeout*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetTimeoutResponse:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREgetTimeoutResponse*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREgetTimeoutResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREsetTimeout:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREsetTimeout*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREsetTimeout*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREsetTimeoutResponse:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREsetTimeoutResponse*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREsetTimeoutResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREsetCurrentOperationProgress:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREsetCurrentOperationProgress*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREsetCurrentOperationProgress*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREsetCurrentOperationProgressResponse:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREsetCurrentOperationProgressResponse*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREsetCurrentOperationProgressResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREsetNextOperation:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREsetNextOperation*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREsetNextOperation*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREsetNextOperationResponse:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREsetNextOperationResponse*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREsetNextOperationResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREwaitForCompletion:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREwaitForCompletion*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREwaitForCompletion*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREwaitForCompletionResponse:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREwaitForCompletionResponse*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREwaitForCompletionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREwaitForOperationCompletion:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREwaitForOperationCompletion*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREwaitForOperationCompletion*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREwaitForOperationCompletionResponse:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREwaitForOperationCompletionResponse*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREwaitForOperationCompletionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREcancel:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREcancel*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREcancel*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREcancelResponse:
		if (p->size < 0)
			delete (_vbox__IProgress_USCOREcancelResponse*)p->ptr;
		else
			delete[] (_vbox__IProgress_USCOREcancelResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetId:
		if (p->size < 0)
			delete (_vbox__ISnapshot_USCOREgetId*)p->ptr;
		else
			delete[] (_vbox__ISnapshot_USCOREgetId*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetIdResponse:
		if (p->size < 0)
			delete (_vbox__ISnapshot_USCOREgetIdResponse*)p->ptr;
		else
			delete[] (_vbox__ISnapshot_USCOREgetIdResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetName:
		if (p->size < 0)
			delete (_vbox__ISnapshot_USCOREgetName*)p->ptr;
		else
			delete[] (_vbox__ISnapshot_USCOREgetName*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetNameResponse:
		if (p->size < 0)
			delete (_vbox__ISnapshot_USCOREgetNameResponse*)p->ptr;
		else
			delete[] (_vbox__ISnapshot_USCOREgetNameResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREsetName:
		if (p->size < 0)
			delete (_vbox__ISnapshot_USCOREsetName*)p->ptr;
		else
			delete[] (_vbox__ISnapshot_USCOREsetName*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREsetNameResponse:
		if (p->size < 0)
			delete (_vbox__ISnapshot_USCOREsetNameResponse*)p->ptr;
		else
			delete[] (_vbox__ISnapshot_USCOREsetNameResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetDescription:
		if (p->size < 0)
			delete (_vbox__ISnapshot_USCOREgetDescription*)p->ptr;
		else
			delete[] (_vbox__ISnapshot_USCOREgetDescription*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetDescriptionResponse:
		if (p->size < 0)
			delete (_vbox__ISnapshot_USCOREgetDescriptionResponse*)p->ptr;
		else
			delete[] (_vbox__ISnapshot_USCOREgetDescriptionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREsetDescription:
		if (p->size < 0)
			delete (_vbox__ISnapshot_USCOREsetDescription*)p->ptr;
		else
			delete[] (_vbox__ISnapshot_USCOREsetDescription*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREsetDescriptionResponse:
		if (p->size < 0)
			delete (_vbox__ISnapshot_USCOREsetDescriptionResponse*)p->ptr;
		else
			delete[] (_vbox__ISnapshot_USCOREsetDescriptionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetTimeStamp:
		if (p->size < 0)
			delete (_vbox__ISnapshot_USCOREgetTimeStamp*)p->ptr;
		else
			delete[] (_vbox__ISnapshot_USCOREgetTimeStamp*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetTimeStampResponse:
		if (p->size < 0)
			delete (_vbox__ISnapshot_USCOREgetTimeStampResponse*)p->ptr;
		else
			delete[] (_vbox__ISnapshot_USCOREgetTimeStampResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetOnline:
		if (p->size < 0)
			delete (_vbox__ISnapshot_USCOREgetOnline*)p->ptr;
		else
			delete[] (_vbox__ISnapshot_USCOREgetOnline*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetOnlineResponse:
		if (p->size < 0)
			delete (_vbox__ISnapshot_USCOREgetOnlineResponse*)p->ptr;
		else
			delete[] (_vbox__ISnapshot_USCOREgetOnlineResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetMachine:
		if (p->size < 0)
			delete (_vbox__ISnapshot_USCOREgetMachine*)p->ptr;
		else
			delete[] (_vbox__ISnapshot_USCOREgetMachine*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetMachineResponse:
		if (p->size < 0)
			delete (_vbox__ISnapshot_USCOREgetMachineResponse*)p->ptr;
		else
			delete[] (_vbox__ISnapshot_USCOREgetMachineResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetParent:
		if (p->size < 0)
			delete (_vbox__ISnapshot_USCOREgetParent*)p->ptr;
		else
			delete[] (_vbox__ISnapshot_USCOREgetParent*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetParentResponse:
		if (p->size < 0)
			delete (_vbox__ISnapshot_USCOREgetParentResponse*)p->ptr;
		else
			delete[] (_vbox__ISnapshot_USCOREgetParentResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetChildren:
		if (p->size < 0)
			delete (_vbox__ISnapshot_USCOREgetChildren*)p->ptr;
		else
			delete[] (_vbox__ISnapshot_USCOREgetChildren*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetChildrenResponse:
		if (p->size < 0)
			delete (_vbox__ISnapshot_USCOREgetChildrenResponse*)p->ptr;
		else
			delete[] (_vbox__ISnapshot_USCOREgetChildrenResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetId:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetId*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetId*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetIdResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetIdResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetIdResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetDescription:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetDescription*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetDescription*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetDescriptionResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetDescriptionResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetDescriptionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREsetDescription:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREsetDescription*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREsetDescription*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREsetDescriptionResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREsetDescriptionResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREsetDescriptionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetState:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetState*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetState*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetStateResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetStateResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetStateResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetLocation:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetLocation*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetLocation*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetLocationResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetLocationResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetLocationResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREsetLocation:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREsetLocation*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREsetLocation*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREsetLocationResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREsetLocationResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREsetLocationResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetName:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetName*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetName*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetNameResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetNameResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetNameResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetDeviceType:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetDeviceType*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetDeviceType*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetDeviceTypeResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetDeviceTypeResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetDeviceTypeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetHostDrive:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetHostDrive*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetHostDrive*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetHostDriveResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetHostDriveResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetHostDriveResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetSize:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetSize*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetSize*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetSizeResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetSizeResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetSizeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetFormat:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetFormat*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetFormat*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetFormatResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetFormatResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetFormatResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetType:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetType*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetType*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetTypeResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetTypeResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetTypeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREsetType:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREsetType*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREsetType*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREsetTypeResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREsetTypeResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREsetTypeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetParent:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetParent*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetParent*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetParentResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetParentResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetParentResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetChildren:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetChildren*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetChildren*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetChildrenResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetChildrenResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetChildrenResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetBase:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetBase*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetBase*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetBaseResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetBaseResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetBaseResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetReadOnly:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetReadOnly*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetReadOnly*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetReadOnlyResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetReadOnlyResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetReadOnlyResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetLogicalSize:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetLogicalSize*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetLogicalSize*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetLogicalSizeResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetLogicalSizeResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetLogicalSizeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetAutoReset:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetAutoReset*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetAutoReset*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetAutoResetResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetAutoResetResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetAutoResetResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREsetAutoReset:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREsetAutoReset*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREsetAutoReset*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREsetAutoResetResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREsetAutoResetResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREsetAutoResetResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetLastAccessError:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetLastAccessError*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetLastAccessError*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetLastAccessErrorResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetLastAccessErrorResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetLastAccessErrorResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetMachineIds:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetMachineIds*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetMachineIds*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetMachineIdsResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetMachineIdsResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetMachineIdsResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCORErefreshState:
		if (p->size < 0)
			delete (_vbox__IMedium_USCORErefreshState*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCORErefreshState*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCORErefreshStateResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCORErefreshStateResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCORErefreshStateResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetSnapshotIds:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetSnapshotIds*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetSnapshotIds*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetSnapshotIdsResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetSnapshotIdsResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetSnapshotIdsResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCORElockRead:
		if (p->size < 0)
			delete (_vbox__IMedium_USCORElockRead*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCORElockRead*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCORElockReadResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCORElockReadResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCORElockReadResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREunlockRead:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREunlockRead*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREunlockRead*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREunlockReadResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREunlockReadResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREunlockReadResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCORElockWrite:
		if (p->size < 0)
			delete (_vbox__IMedium_USCORElockWrite*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCORElockWrite*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCORElockWriteResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCORElockWriteResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCORElockWriteResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREunlockWrite:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREunlockWrite*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREunlockWrite*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREunlockWriteResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREunlockWriteResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREunlockWriteResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREclose:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREclose*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREclose*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREcloseResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREcloseResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREcloseResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetProperty:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetProperty*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetProperty*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetPropertyResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetPropertyResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetPropertyResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREsetProperty:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREsetProperty*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREsetProperty*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREsetPropertyResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREsetPropertyResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREsetPropertyResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetProperties:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetProperties*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetProperties*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetPropertiesResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREgetPropertiesResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREgetPropertiesResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREsetProperties:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREsetProperties*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREsetProperties*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREsetPropertiesResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREsetPropertiesResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREsetPropertiesResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREcreateBaseStorage:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREcreateBaseStorage*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREcreateBaseStorage*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREcreateBaseStorageResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREcreateBaseStorageResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREcreateBaseStorageResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREdeleteStorage:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREdeleteStorage*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREdeleteStorage*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREdeleteStorageResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREdeleteStorageResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREdeleteStorageResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREcreateDiffStorage:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREcreateDiffStorage*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREcreateDiffStorage*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREcreateDiffStorageResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREcreateDiffStorageResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREcreateDiffStorageResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREmergeTo:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREmergeTo*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREmergeTo*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREmergeToResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREmergeToResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREmergeToResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREcloneTo:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREcloneTo*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREcloneTo*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREcloneToResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREcloneToResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREcloneToResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREcompact:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREcompact*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREcompact*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREcompactResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREcompactResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREcompactResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREresize:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREresize*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREresize*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREresizeResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREresizeResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREresizeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREreset:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREreset*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREreset*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREresetResponse:
		if (p->size < 0)
			delete (_vbox__IMedium_USCOREresetResponse*)p->ptr;
		else
			delete[] (_vbox__IMedium_USCOREresetResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMediumFormat_USCOREgetId:
		if (p->size < 0)
			delete (_vbox__IMediumFormat_USCOREgetId*)p->ptr;
		else
			delete[] (_vbox__IMediumFormat_USCOREgetId*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMediumFormat_USCOREgetIdResponse:
		if (p->size < 0)
			delete (_vbox__IMediumFormat_USCOREgetIdResponse*)p->ptr;
		else
			delete[] (_vbox__IMediumFormat_USCOREgetIdResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMediumFormat_USCOREgetName:
		if (p->size < 0)
			delete (_vbox__IMediumFormat_USCOREgetName*)p->ptr;
		else
			delete[] (_vbox__IMediumFormat_USCOREgetName*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMediumFormat_USCOREgetNameResponse:
		if (p->size < 0)
			delete (_vbox__IMediumFormat_USCOREgetNameResponse*)p->ptr;
		else
			delete[] (_vbox__IMediumFormat_USCOREgetNameResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMediumFormat_USCOREgetFileExtensions:
		if (p->size < 0)
			delete (_vbox__IMediumFormat_USCOREgetFileExtensions*)p->ptr;
		else
			delete[] (_vbox__IMediumFormat_USCOREgetFileExtensions*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMediumFormat_USCOREgetFileExtensionsResponse:
		if (p->size < 0)
			delete (_vbox__IMediumFormat_USCOREgetFileExtensionsResponse*)p->ptr;
		else
			delete[] (_vbox__IMediumFormat_USCOREgetFileExtensionsResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMediumFormat_USCOREgetCapabilities:
		if (p->size < 0)
			delete (_vbox__IMediumFormat_USCOREgetCapabilities*)p->ptr;
		else
			delete[] (_vbox__IMediumFormat_USCOREgetCapabilities*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMediumFormat_USCOREgetCapabilitiesResponse:
		if (p->size < 0)
			delete (_vbox__IMediumFormat_USCOREgetCapabilitiesResponse*)p->ptr;
		else
			delete[] (_vbox__IMediumFormat_USCOREgetCapabilitiesResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMediumFormat_USCOREdescribeProperties:
		if (p->size < 0)
			delete (_vbox__IMediumFormat_USCOREdescribeProperties*)p->ptr;
		else
			delete[] (_vbox__IMediumFormat_USCOREdescribeProperties*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMediumFormat_USCOREdescribePropertiesResponse:
		if (p->size < 0)
			delete (_vbox__IMediumFormat_USCOREdescribePropertiesResponse*)p->ptr;
		else
			delete[] (_vbox__IMediumFormat_USCOREdescribePropertiesResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IKeyboard_USCOREputScancode:
		if (p->size < 0)
			delete (_vbox__IKeyboard_USCOREputScancode*)p->ptr;
		else
			delete[] (_vbox__IKeyboard_USCOREputScancode*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IKeyboard_USCOREputScancodeResponse:
		if (p->size < 0)
			delete (_vbox__IKeyboard_USCOREputScancodeResponse*)p->ptr;
		else
			delete[] (_vbox__IKeyboard_USCOREputScancodeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IKeyboard_USCOREputScancodes:
		if (p->size < 0)
			delete (_vbox__IKeyboard_USCOREputScancodes*)p->ptr;
		else
			delete[] (_vbox__IKeyboard_USCOREputScancodes*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IKeyboard_USCOREputScancodesResponse:
		if (p->size < 0)
			delete (_vbox__IKeyboard_USCOREputScancodesResponse*)p->ptr;
		else
			delete[] (_vbox__IKeyboard_USCOREputScancodesResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IKeyboard_USCOREputCAD:
		if (p->size < 0)
			delete (_vbox__IKeyboard_USCOREputCAD*)p->ptr;
		else
			delete[] (_vbox__IKeyboard_USCOREputCAD*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IKeyboard_USCOREputCADResponse:
		if (p->size < 0)
			delete (_vbox__IKeyboard_USCOREputCADResponse*)p->ptr;
		else
			delete[] (_vbox__IKeyboard_USCOREputCADResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMouse_USCOREgetAbsoluteSupported:
		if (p->size < 0)
			delete (_vbox__IMouse_USCOREgetAbsoluteSupported*)p->ptr;
		else
			delete[] (_vbox__IMouse_USCOREgetAbsoluteSupported*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMouse_USCOREgetAbsoluteSupportedResponse:
		if (p->size < 0)
			delete (_vbox__IMouse_USCOREgetAbsoluteSupportedResponse*)p->ptr;
		else
			delete[] (_vbox__IMouse_USCOREgetAbsoluteSupportedResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMouse_USCOREputMouseEvent:
		if (p->size < 0)
			delete (_vbox__IMouse_USCOREputMouseEvent*)p->ptr;
		else
			delete[] (_vbox__IMouse_USCOREputMouseEvent*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMouse_USCOREputMouseEventResponse:
		if (p->size < 0)
			delete (_vbox__IMouse_USCOREputMouseEventResponse*)p->ptr;
		else
			delete[] (_vbox__IMouse_USCOREputMouseEventResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMouse_USCOREputMouseEventAbsolute:
		if (p->size < 0)
			delete (_vbox__IMouse_USCOREputMouseEventAbsolute*)p->ptr;
		else
			delete[] (_vbox__IMouse_USCOREputMouseEventAbsolute*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IMouse_USCOREputMouseEventAbsoluteResponse:
		if (p->size < 0)
			delete (_vbox__IMouse_USCOREputMouseEventAbsoluteResponse*)p->ptr;
		else
			delete[] (_vbox__IMouse_USCOREputMouseEventAbsoluteResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREgetWidth:
		if (p->size < 0)
			delete (_vbox__IDisplay_USCOREgetWidth*)p->ptr;
		else
			delete[] (_vbox__IDisplay_USCOREgetWidth*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREgetWidthResponse:
		if (p->size < 0)
			delete (_vbox__IDisplay_USCOREgetWidthResponse*)p->ptr;
		else
			delete[] (_vbox__IDisplay_USCOREgetWidthResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREgetHeight:
		if (p->size < 0)
			delete (_vbox__IDisplay_USCOREgetHeight*)p->ptr;
		else
			delete[] (_vbox__IDisplay_USCOREgetHeight*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREgetHeightResponse:
		if (p->size < 0)
			delete (_vbox__IDisplay_USCOREgetHeightResponse*)p->ptr;
		else
			delete[] (_vbox__IDisplay_USCOREgetHeightResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREgetBitsPerPixel:
		if (p->size < 0)
			delete (_vbox__IDisplay_USCOREgetBitsPerPixel*)p->ptr;
		else
			delete[] (_vbox__IDisplay_USCOREgetBitsPerPixel*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREgetBitsPerPixelResponse:
		if (p->size < 0)
			delete (_vbox__IDisplay_USCOREgetBitsPerPixelResponse*)p->ptr;
		else
			delete[] (_vbox__IDisplay_USCOREgetBitsPerPixelResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREsetVideoModeHint:
		if (p->size < 0)
			delete (_vbox__IDisplay_USCOREsetVideoModeHint*)p->ptr;
		else
			delete[] (_vbox__IDisplay_USCOREsetVideoModeHint*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREsetVideoModeHintResponse:
		if (p->size < 0)
			delete (_vbox__IDisplay_USCOREsetVideoModeHintResponse*)p->ptr;
		else
			delete[] (_vbox__IDisplay_USCOREsetVideoModeHintResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREsetSeamlessMode:
		if (p->size < 0)
			delete (_vbox__IDisplay_USCOREsetSeamlessMode*)p->ptr;
		else
			delete[] (_vbox__IDisplay_USCOREsetSeamlessMode*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREsetSeamlessModeResponse:
		if (p->size < 0)
			delete (_vbox__IDisplay_USCOREsetSeamlessModeResponse*)p->ptr;
		else
			delete[] (_vbox__IDisplay_USCOREsetSeamlessModeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREtakeScreenShotSlow:
		if (p->size < 0)
			delete (_vbox__IDisplay_USCOREtakeScreenShotSlow*)p->ptr;
		else
			delete[] (_vbox__IDisplay_USCOREtakeScreenShotSlow*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREtakeScreenShotSlowResponse:
		if (p->size < 0)
			delete (_vbox__IDisplay_USCOREtakeScreenShotSlowResponse*)p->ptr;
		else
			delete[] (_vbox__IDisplay_USCOREtakeScreenShotSlowResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREinvalidateAndUpdate:
		if (p->size < 0)
			delete (_vbox__IDisplay_USCOREinvalidateAndUpdate*)p->ptr;
		else
			delete[] (_vbox__IDisplay_USCOREinvalidateAndUpdate*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREinvalidateAndUpdateResponse:
		if (p->size < 0)
			delete (_vbox__IDisplay_USCOREinvalidateAndUpdateResponse*)p->ptr;
		else
			delete[] (_vbox__IDisplay_USCOREinvalidateAndUpdateResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREresizeCompleted:
		if (p->size < 0)
			delete (_vbox__IDisplay_USCOREresizeCompleted*)p->ptr;
		else
			delete[] (_vbox__IDisplay_USCOREresizeCompleted*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREresizeCompletedResponse:
		if (p->size < 0)
			delete (_vbox__IDisplay_USCOREresizeCompletedResponse*)p->ptr;
		else
			delete[] (_vbox__IDisplay_USCOREresizeCompletedResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREupdateCompleted:
		if (p->size < 0)
			delete (_vbox__IDisplay_USCOREupdateCompleted*)p->ptr;
		else
			delete[] (_vbox__IDisplay_USCOREupdateCompleted*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREupdateCompletedResponse:
		if (p->size < 0)
			delete (_vbox__IDisplay_USCOREupdateCompletedResponse*)p->ptr;
		else
			delete[] (_vbox__IDisplay_USCOREupdateCompletedResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetAdapterType:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREgetAdapterType*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREgetAdapterType*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetAdapterTypeResponse:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREgetAdapterTypeResponse*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREgetAdapterTypeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetAdapterType:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREsetAdapterType*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREsetAdapterType*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetAdapterTypeResponse:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREsetAdapterTypeResponse*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREsetAdapterTypeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetSlot:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREgetSlot*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREgetSlot*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetSlotResponse:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREgetSlotResponse*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREgetSlotResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetEnabled:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREgetEnabled*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREgetEnabled*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetEnabledResponse:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREgetEnabledResponse*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREgetEnabledResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetEnabled:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREsetEnabled*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREsetEnabled*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetEnabledResponse:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREsetEnabledResponse*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREsetEnabledResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetMACAddress:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREgetMACAddress*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREgetMACAddress*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetMACAddressResponse:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREgetMACAddressResponse*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREgetMACAddressResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetMACAddress:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREsetMACAddress*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREsetMACAddress*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetMACAddressResponse:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREsetMACAddressResponse*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREsetMACAddressResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetAttachmentType:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREgetAttachmentType*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREgetAttachmentType*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetAttachmentTypeResponse:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREgetAttachmentTypeResponse*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREgetAttachmentTypeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetHostInterface:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREgetHostInterface*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREgetHostInterface*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetHostInterfaceResponse:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREgetHostInterfaceResponse*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREgetHostInterfaceResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetHostInterface:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREsetHostInterface*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREsetHostInterface*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetHostInterfaceResponse:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREsetHostInterfaceResponse*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREsetHostInterfaceResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetInternalNetwork:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREgetInternalNetwork*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREgetInternalNetwork*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetInternalNetworkResponse:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREgetInternalNetworkResponse*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREgetInternalNetworkResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetInternalNetwork:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREsetInternalNetwork*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREsetInternalNetwork*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetInternalNetworkResponse:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREsetInternalNetworkResponse*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREsetInternalNetworkResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetNATNetwork:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREgetNATNetwork*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREgetNATNetwork*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetNATNetworkResponse:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREgetNATNetworkResponse*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREgetNATNetworkResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetNATNetwork:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREsetNATNetwork*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREsetNATNetwork*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetNATNetworkResponse:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREsetNATNetworkResponse*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREsetNATNetworkResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetCableConnected:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREgetCableConnected*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREgetCableConnected*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetCableConnectedResponse:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREgetCableConnectedResponse*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREgetCableConnectedResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetCableConnected:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREsetCableConnected*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREsetCableConnected*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetCableConnectedResponse:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREsetCableConnectedResponse*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREsetCableConnectedResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetLineSpeed:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREgetLineSpeed*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREgetLineSpeed*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetLineSpeedResponse:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREgetLineSpeedResponse*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREgetLineSpeedResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetLineSpeed:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREsetLineSpeed*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREsetLineSpeed*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetLineSpeedResponse:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREsetLineSpeedResponse*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREsetLineSpeedResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetTraceEnabled:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREgetTraceEnabled*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREgetTraceEnabled*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetTraceEnabledResponse:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREgetTraceEnabledResponse*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREgetTraceEnabledResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetTraceEnabled:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREsetTraceEnabled*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREsetTraceEnabled*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetTraceEnabledResponse:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREsetTraceEnabledResponse*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREsetTraceEnabledResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetTraceFile:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREgetTraceFile*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREgetTraceFile*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetTraceFileResponse:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREgetTraceFileResponse*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREgetTraceFileResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetTraceFile:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREsetTraceFile*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREsetTraceFile*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetTraceFileResponse:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREsetTraceFileResponse*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREsetTraceFileResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREattachToNAT:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREattachToNAT*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREattachToNAT*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREattachToNATResponse:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREattachToNATResponse*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREattachToNATResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREattachToBridgedInterface:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREattachToBridgedInterface*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREattachToBridgedInterface*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREattachToBridgedInterfaceResponse:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREattachToBridgedInterfaceResponse*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREattachToBridgedInterfaceResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREattachToInternalNetwork:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREattachToInternalNetwork*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREattachToInternalNetwork*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREattachToInternalNetworkResponse:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREattachToInternalNetworkResponse*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREattachToInternalNetworkResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREattachToHostOnlyInterface:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREattachToHostOnlyInterface*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREattachToHostOnlyInterface*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREattachToHostOnlyInterfaceResponse:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREattachToHostOnlyInterfaceResponse*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREattachToHostOnlyInterfaceResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREdetach:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREdetach*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREdetach*)p->ptr;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREdetachResponse:
		if (p->size < 0)
			delete (_vbox__INetworkAdapter_USCOREdetachResponse*)p->ptr;
		else
			delete[] (_vbox__INetworkAdapter_USCOREdetachResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetSlot:
		if (p->size < 0)
			delete (_vbox__ISerialPort_USCOREgetSlot*)p->ptr;
		else
			delete[] (_vbox__ISerialPort_USCOREgetSlot*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetSlotResponse:
		if (p->size < 0)
			delete (_vbox__ISerialPort_USCOREgetSlotResponse*)p->ptr;
		else
			delete[] (_vbox__ISerialPort_USCOREgetSlotResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetEnabled:
		if (p->size < 0)
			delete (_vbox__ISerialPort_USCOREgetEnabled*)p->ptr;
		else
			delete[] (_vbox__ISerialPort_USCOREgetEnabled*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetEnabledResponse:
		if (p->size < 0)
			delete (_vbox__ISerialPort_USCOREgetEnabledResponse*)p->ptr;
		else
			delete[] (_vbox__ISerialPort_USCOREgetEnabledResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetEnabled:
		if (p->size < 0)
			delete (_vbox__ISerialPort_USCOREsetEnabled*)p->ptr;
		else
			delete[] (_vbox__ISerialPort_USCOREsetEnabled*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetEnabledResponse:
		if (p->size < 0)
			delete (_vbox__ISerialPort_USCOREsetEnabledResponse*)p->ptr;
		else
			delete[] (_vbox__ISerialPort_USCOREsetEnabledResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetIOBase:
		if (p->size < 0)
			delete (_vbox__ISerialPort_USCOREgetIOBase*)p->ptr;
		else
			delete[] (_vbox__ISerialPort_USCOREgetIOBase*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetIOBaseResponse:
		if (p->size < 0)
			delete (_vbox__ISerialPort_USCOREgetIOBaseResponse*)p->ptr;
		else
			delete[] (_vbox__ISerialPort_USCOREgetIOBaseResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetIOBase:
		if (p->size < 0)
			delete (_vbox__ISerialPort_USCOREsetIOBase*)p->ptr;
		else
			delete[] (_vbox__ISerialPort_USCOREsetIOBase*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetIOBaseResponse:
		if (p->size < 0)
			delete (_vbox__ISerialPort_USCOREsetIOBaseResponse*)p->ptr;
		else
			delete[] (_vbox__ISerialPort_USCOREsetIOBaseResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetIRQ:
		if (p->size < 0)
			delete (_vbox__ISerialPort_USCOREgetIRQ*)p->ptr;
		else
			delete[] (_vbox__ISerialPort_USCOREgetIRQ*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetIRQResponse:
		if (p->size < 0)
			delete (_vbox__ISerialPort_USCOREgetIRQResponse*)p->ptr;
		else
			delete[] (_vbox__ISerialPort_USCOREgetIRQResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetIRQ:
		if (p->size < 0)
			delete (_vbox__ISerialPort_USCOREsetIRQ*)p->ptr;
		else
			delete[] (_vbox__ISerialPort_USCOREsetIRQ*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetIRQResponse:
		if (p->size < 0)
			delete (_vbox__ISerialPort_USCOREsetIRQResponse*)p->ptr;
		else
			delete[] (_vbox__ISerialPort_USCOREsetIRQResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetHostMode:
		if (p->size < 0)
			delete (_vbox__ISerialPort_USCOREgetHostMode*)p->ptr;
		else
			delete[] (_vbox__ISerialPort_USCOREgetHostMode*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetHostModeResponse:
		if (p->size < 0)
			delete (_vbox__ISerialPort_USCOREgetHostModeResponse*)p->ptr;
		else
			delete[] (_vbox__ISerialPort_USCOREgetHostModeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetHostMode:
		if (p->size < 0)
			delete (_vbox__ISerialPort_USCOREsetHostMode*)p->ptr;
		else
			delete[] (_vbox__ISerialPort_USCOREsetHostMode*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetHostModeResponse:
		if (p->size < 0)
			delete (_vbox__ISerialPort_USCOREsetHostModeResponse*)p->ptr;
		else
			delete[] (_vbox__ISerialPort_USCOREsetHostModeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetServer:
		if (p->size < 0)
			delete (_vbox__ISerialPort_USCOREgetServer*)p->ptr;
		else
			delete[] (_vbox__ISerialPort_USCOREgetServer*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetServerResponse:
		if (p->size < 0)
			delete (_vbox__ISerialPort_USCOREgetServerResponse*)p->ptr;
		else
			delete[] (_vbox__ISerialPort_USCOREgetServerResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetServer:
		if (p->size < 0)
			delete (_vbox__ISerialPort_USCOREsetServer*)p->ptr;
		else
			delete[] (_vbox__ISerialPort_USCOREsetServer*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetServerResponse:
		if (p->size < 0)
			delete (_vbox__ISerialPort_USCOREsetServerResponse*)p->ptr;
		else
			delete[] (_vbox__ISerialPort_USCOREsetServerResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetPath:
		if (p->size < 0)
			delete (_vbox__ISerialPort_USCOREgetPath*)p->ptr;
		else
			delete[] (_vbox__ISerialPort_USCOREgetPath*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetPathResponse:
		if (p->size < 0)
			delete (_vbox__ISerialPort_USCOREgetPathResponse*)p->ptr;
		else
			delete[] (_vbox__ISerialPort_USCOREgetPathResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetPath:
		if (p->size < 0)
			delete (_vbox__ISerialPort_USCOREsetPath*)p->ptr;
		else
			delete[] (_vbox__ISerialPort_USCOREsetPath*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetPathResponse:
		if (p->size < 0)
			delete (_vbox__ISerialPort_USCOREsetPathResponse*)p->ptr;
		else
			delete[] (_vbox__ISerialPort_USCOREsetPathResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREgetSlot:
		if (p->size < 0)
			delete (_vbox__IParallelPort_USCOREgetSlot*)p->ptr;
		else
			delete[] (_vbox__IParallelPort_USCOREgetSlot*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREgetSlotResponse:
		if (p->size < 0)
			delete (_vbox__IParallelPort_USCOREgetSlotResponse*)p->ptr;
		else
			delete[] (_vbox__IParallelPort_USCOREgetSlotResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREgetEnabled:
		if (p->size < 0)
			delete (_vbox__IParallelPort_USCOREgetEnabled*)p->ptr;
		else
			delete[] (_vbox__IParallelPort_USCOREgetEnabled*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREgetEnabledResponse:
		if (p->size < 0)
			delete (_vbox__IParallelPort_USCOREgetEnabledResponse*)p->ptr;
		else
			delete[] (_vbox__IParallelPort_USCOREgetEnabledResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREsetEnabled:
		if (p->size < 0)
			delete (_vbox__IParallelPort_USCOREsetEnabled*)p->ptr;
		else
			delete[] (_vbox__IParallelPort_USCOREsetEnabled*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREsetEnabledResponse:
		if (p->size < 0)
			delete (_vbox__IParallelPort_USCOREsetEnabledResponse*)p->ptr;
		else
			delete[] (_vbox__IParallelPort_USCOREsetEnabledResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREgetIOBase:
		if (p->size < 0)
			delete (_vbox__IParallelPort_USCOREgetIOBase*)p->ptr;
		else
			delete[] (_vbox__IParallelPort_USCOREgetIOBase*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREgetIOBaseResponse:
		if (p->size < 0)
			delete (_vbox__IParallelPort_USCOREgetIOBaseResponse*)p->ptr;
		else
			delete[] (_vbox__IParallelPort_USCOREgetIOBaseResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREsetIOBase:
		if (p->size < 0)
			delete (_vbox__IParallelPort_USCOREsetIOBase*)p->ptr;
		else
			delete[] (_vbox__IParallelPort_USCOREsetIOBase*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREsetIOBaseResponse:
		if (p->size < 0)
			delete (_vbox__IParallelPort_USCOREsetIOBaseResponse*)p->ptr;
		else
			delete[] (_vbox__IParallelPort_USCOREsetIOBaseResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREgetIRQ:
		if (p->size < 0)
			delete (_vbox__IParallelPort_USCOREgetIRQ*)p->ptr;
		else
			delete[] (_vbox__IParallelPort_USCOREgetIRQ*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREgetIRQResponse:
		if (p->size < 0)
			delete (_vbox__IParallelPort_USCOREgetIRQResponse*)p->ptr;
		else
			delete[] (_vbox__IParallelPort_USCOREgetIRQResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREsetIRQ:
		if (p->size < 0)
			delete (_vbox__IParallelPort_USCOREsetIRQ*)p->ptr;
		else
			delete[] (_vbox__IParallelPort_USCOREsetIRQ*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREsetIRQResponse:
		if (p->size < 0)
			delete (_vbox__IParallelPort_USCOREsetIRQResponse*)p->ptr;
		else
			delete[] (_vbox__IParallelPort_USCOREsetIRQResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREgetPath:
		if (p->size < 0)
			delete (_vbox__IParallelPort_USCOREgetPath*)p->ptr;
		else
			delete[] (_vbox__IParallelPort_USCOREgetPath*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREgetPathResponse:
		if (p->size < 0)
			delete (_vbox__IParallelPort_USCOREgetPathResponse*)p->ptr;
		else
			delete[] (_vbox__IParallelPort_USCOREgetPathResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREsetPath:
		if (p->size < 0)
			delete (_vbox__IParallelPort_USCOREsetPath*)p->ptr;
		else
			delete[] (_vbox__IParallelPort_USCOREsetPath*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREsetPathResponse:
		if (p->size < 0)
			delete (_vbox__IParallelPort_USCOREsetPathResponse*)p->ptr;
		else
			delete[] (_vbox__IParallelPort_USCOREsetPathResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBController_USCOREgetEnabled:
		if (p->size < 0)
			delete (_vbox__IUSBController_USCOREgetEnabled*)p->ptr;
		else
			delete[] (_vbox__IUSBController_USCOREgetEnabled*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBController_USCOREgetEnabledResponse:
		if (p->size < 0)
			delete (_vbox__IUSBController_USCOREgetEnabledResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBController_USCOREgetEnabledResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBController_USCOREsetEnabled:
		if (p->size < 0)
			delete (_vbox__IUSBController_USCOREsetEnabled*)p->ptr;
		else
			delete[] (_vbox__IUSBController_USCOREsetEnabled*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBController_USCOREsetEnabledResponse:
		if (p->size < 0)
			delete (_vbox__IUSBController_USCOREsetEnabledResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBController_USCOREsetEnabledResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBController_USCOREgetEnabledEhci:
		if (p->size < 0)
			delete (_vbox__IUSBController_USCOREgetEnabledEhci*)p->ptr;
		else
			delete[] (_vbox__IUSBController_USCOREgetEnabledEhci*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBController_USCOREgetEnabledEhciResponse:
		if (p->size < 0)
			delete (_vbox__IUSBController_USCOREgetEnabledEhciResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBController_USCOREgetEnabledEhciResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBController_USCOREsetEnabledEhci:
		if (p->size < 0)
			delete (_vbox__IUSBController_USCOREsetEnabledEhci*)p->ptr;
		else
			delete[] (_vbox__IUSBController_USCOREsetEnabledEhci*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBController_USCOREsetEnabledEhciResponse:
		if (p->size < 0)
			delete (_vbox__IUSBController_USCOREsetEnabledEhciResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBController_USCOREsetEnabledEhciResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBController_USCOREgetUSBStandard:
		if (p->size < 0)
			delete (_vbox__IUSBController_USCOREgetUSBStandard*)p->ptr;
		else
			delete[] (_vbox__IUSBController_USCOREgetUSBStandard*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBController_USCOREgetUSBStandardResponse:
		if (p->size < 0)
			delete (_vbox__IUSBController_USCOREgetUSBStandardResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBController_USCOREgetUSBStandardResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBController_USCOREgetDeviceFilters:
		if (p->size < 0)
			delete (_vbox__IUSBController_USCOREgetDeviceFilters*)p->ptr;
		else
			delete[] (_vbox__IUSBController_USCOREgetDeviceFilters*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBController_USCOREgetDeviceFiltersResponse:
		if (p->size < 0)
			delete (_vbox__IUSBController_USCOREgetDeviceFiltersResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBController_USCOREgetDeviceFiltersResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBController_USCOREcreateDeviceFilter:
		if (p->size < 0)
			delete (_vbox__IUSBController_USCOREcreateDeviceFilter*)p->ptr;
		else
			delete[] (_vbox__IUSBController_USCOREcreateDeviceFilter*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBController_USCOREcreateDeviceFilterResponse:
		if (p->size < 0)
			delete (_vbox__IUSBController_USCOREcreateDeviceFilterResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBController_USCOREcreateDeviceFilterResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBController_USCOREinsertDeviceFilter:
		if (p->size < 0)
			delete (_vbox__IUSBController_USCOREinsertDeviceFilter*)p->ptr;
		else
			delete[] (_vbox__IUSBController_USCOREinsertDeviceFilter*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBController_USCOREinsertDeviceFilterResponse:
		if (p->size < 0)
			delete (_vbox__IUSBController_USCOREinsertDeviceFilterResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBController_USCOREinsertDeviceFilterResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBController_USCOREremoveDeviceFilter:
		if (p->size < 0)
			delete (_vbox__IUSBController_USCOREremoveDeviceFilter*)p->ptr;
		else
			delete[] (_vbox__IUSBController_USCOREremoveDeviceFilter*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBController_USCOREremoveDeviceFilterResponse:
		if (p->size < 0)
			delete (_vbox__IUSBController_USCOREremoveDeviceFilterResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBController_USCOREremoveDeviceFilterResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetId:
		if (p->size < 0)
			delete (_vbox__IUSBDevice_USCOREgetId*)p->ptr;
		else
			delete[] (_vbox__IUSBDevice_USCOREgetId*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetIdResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDevice_USCOREgetIdResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDevice_USCOREgetIdResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetVendorId:
		if (p->size < 0)
			delete (_vbox__IUSBDevice_USCOREgetVendorId*)p->ptr;
		else
			delete[] (_vbox__IUSBDevice_USCOREgetVendorId*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetVendorIdResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDevice_USCOREgetVendorIdResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDevice_USCOREgetVendorIdResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetProductId:
		if (p->size < 0)
			delete (_vbox__IUSBDevice_USCOREgetProductId*)p->ptr;
		else
			delete[] (_vbox__IUSBDevice_USCOREgetProductId*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetProductIdResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDevice_USCOREgetProductIdResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDevice_USCOREgetProductIdResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetRevision:
		if (p->size < 0)
			delete (_vbox__IUSBDevice_USCOREgetRevision*)p->ptr;
		else
			delete[] (_vbox__IUSBDevice_USCOREgetRevision*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetRevisionResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDevice_USCOREgetRevisionResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDevice_USCOREgetRevisionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetManufacturer:
		if (p->size < 0)
			delete (_vbox__IUSBDevice_USCOREgetManufacturer*)p->ptr;
		else
			delete[] (_vbox__IUSBDevice_USCOREgetManufacturer*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetManufacturerResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDevice_USCOREgetManufacturerResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDevice_USCOREgetManufacturerResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetProduct:
		if (p->size < 0)
			delete (_vbox__IUSBDevice_USCOREgetProduct*)p->ptr;
		else
			delete[] (_vbox__IUSBDevice_USCOREgetProduct*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetProductResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDevice_USCOREgetProductResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDevice_USCOREgetProductResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetSerialNumber:
		if (p->size < 0)
			delete (_vbox__IUSBDevice_USCOREgetSerialNumber*)p->ptr;
		else
			delete[] (_vbox__IUSBDevice_USCOREgetSerialNumber*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetSerialNumberResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDevice_USCOREgetSerialNumberResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDevice_USCOREgetSerialNumberResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetAddress:
		if (p->size < 0)
			delete (_vbox__IUSBDevice_USCOREgetAddress*)p->ptr;
		else
			delete[] (_vbox__IUSBDevice_USCOREgetAddress*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetAddressResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDevice_USCOREgetAddressResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDevice_USCOREgetAddressResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetPort:
		if (p->size < 0)
			delete (_vbox__IUSBDevice_USCOREgetPort*)p->ptr;
		else
			delete[] (_vbox__IUSBDevice_USCOREgetPort*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetPortResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDevice_USCOREgetPortResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDevice_USCOREgetPortResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetVersion:
		if (p->size < 0)
			delete (_vbox__IUSBDevice_USCOREgetVersion*)p->ptr;
		else
			delete[] (_vbox__IUSBDevice_USCOREgetVersion*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetVersionResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDevice_USCOREgetVersionResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDevice_USCOREgetVersionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetPortVersion:
		if (p->size < 0)
			delete (_vbox__IUSBDevice_USCOREgetPortVersion*)p->ptr;
		else
			delete[] (_vbox__IUSBDevice_USCOREgetPortVersion*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetPortVersionResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDevice_USCOREgetPortVersionResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDevice_USCOREgetPortVersionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetRemote:
		if (p->size < 0)
			delete (_vbox__IUSBDevice_USCOREgetRemote*)p->ptr;
		else
			delete[] (_vbox__IUSBDevice_USCOREgetRemote*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetRemoteResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDevice_USCOREgetRemoteResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDevice_USCOREgetRemoteResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetName:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREgetName*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREgetName*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetNameResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREgetNameResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREgetNameResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetName:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREsetName*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREsetName*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetNameResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREsetNameResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREsetNameResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetActive:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREgetActive*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREgetActive*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetActiveResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREgetActiveResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREgetActiveResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetActive:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREsetActive*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREsetActive*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetActiveResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREsetActiveResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREsetActiveResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetVendorId:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREgetVendorId*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREgetVendorId*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetVendorIdResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREgetVendorIdResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREgetVendorIdResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetVendorId:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREsetVendorId*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREsetVendorId*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetVendorIdResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREsetVendorIdResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREsetVendorIdResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetProductId:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREgetProductId*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREgetProductId*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetProductIdResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREgetProductIdResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREgetProductIdResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetProductId:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREsetProductId*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREsetProductId*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetProductIdResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREsetProductIdResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREsetProductIdResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetRevision:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREgetRevision*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREgetRevision*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetRevisionResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREgetRevisionResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREgetRevisionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetRevision:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREsetRevision*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREsetRevision*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetRevisionResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREsetRevisionResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREsetRevisionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetManufacturer:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREgetManufacturer*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREgetManufacturer*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetManufacturerResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREgetManufacturerResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREgetManufacturerResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetManufacturer:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREsetManufacturer*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREsetManufacturer*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetManufacturerResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREsetManufacturerResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREsetManufacturerResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetProduct:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREgetProduct*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREgetProduct*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetProductResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREgetProductResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREgetProductResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetProduct:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREsetProduct*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREsetProduct*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetProductResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREsetProductResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREsetProductResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetSerialNumber:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREgetSerialNumber*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREgetSerialNumber*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetSerialNumberResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREgetSerialNumberResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREgetSerialNumberResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetSerialNumber:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREsetSerialNumber*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREsetSerialNumber*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetSerialNumberResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREsetSerialNumberResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREsetSerialNumberResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetPort:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREgetPort*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREgetPort*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetPortResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREgetPortResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREgetPortResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetPort:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREsetPort*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREsetPort*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetPortResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREsetPortResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREsetPortResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetRemote:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREgetRemote*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREgetRemote*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetRemoteResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREgetRemoteResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREgetRemoteResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetRemote:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREsetRemote*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREsetRemote*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetRemoteResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREsetRemoteResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREsetRemoteResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetMaskedInterfaces:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREgetMaskedInterfaces*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREgetMaskedInterfaces*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetMaskedInterfacesResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREgetMaskedInterfacesResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREgetMaskedInterfacesResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetMaskedInterfaces:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREsetMaskedInterfaces*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREsetMaskedInterfaces*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetMaskedInterfacesResponse:
		if (p->size < 0)
			delete (_vbox__IUSBDeviceFilter_USCOREsetMaskedInterfacesResponse*)p->ptr;
		else
			delete[] (_vbox__IUSBDeviceFilter_USCOREsetMaskedInterfacesResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostUSBDevice_USCOREgetState:
		if (p->size < 0)
			delete (_vbox__IHostUSBDevice_USCOREgetState*)p->ptr;
		else
			delete[] (_vbox__IHostUSBDevice_USCOREgetState*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostUSBDevice_USCOREgetStateResponse:
		if (p->size < 0)
			delete (_vbox__IHostUSBDevice_USCOREgetStateResponse*)p->ptr;
		else
			delete[] (_vbox__IHostUSBDevice_USCOREgetStateResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREgetAction:
		if (p->size < 0)
			delete (_vbox__IHostUSBDeviceFilter_USCOREgetAction*)p->ptr;
		else
			delete[] (_vbox__IHostUSBDeviceFilter_USCOREgetAction*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREgetActionResponse:
		if (p->size < 0)
			delete (_vbox__IHostUSBDeviceFilter_USCOREgetActionResponse*)p->ptr;
		else
			delete[] (_vbox__IHostUSBDeviceFilter_USCOREgetActionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREsetAction:
		if (p->size < 0)
			delete (_vbox__IHostUSBDeviceFilter_USCOREsetAction*)p->ptr;
		else
			delete[] (_vbox__IHostUSBDeviceFilter_USCOREsetAction*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREsetActionResponse:
		if (p->size < 0)
			delete (_vbox__IHostUSBDeviceFilter_USCOREsetActionResponse*)p->ptr;
		else
			delete[] (_vbox__IHostUSBDeviceFilter_USCOREsetActionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREgetEnabled:
		if (p->size < 0)
			delete (_vbox__IAudioAdapter_USCOREgetEnabled*)p->ptr;
		else
			delete[] (_vbox__IAudioAdapter_USCOREgetEnabled*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREgetEnabledResponse:
		if (p->size < 0)
			delete (_vbox__IAudioAdapter_USCOREgetEnabledResponse*)p->ptr;
		else
			delete[] (_vbox__IAudioAdapter_USCOREgetEnabledResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREsetEnabled:
		if (p->size < 0)
			delete (_vbox__IAudioAdapter_USCOREsetEnabled*)p->ptr;
		else
			delete[] (_vbox__IAudioAdapter_USCOREsetEnabled*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREsetEnabledResponse:
		if (p->size < 0)
			delete (_vbox__IAudioAdapter_USCOREsetEnabledResponse*)p->ptr;
		else
			delete[] (_vbox__IAudioAdapter_USCOREsetEnabledResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioController:
		if (p->size < 0)
			delete (_vbox__IAudioAdapter_USCOREgetAudioController*)p->ptr;
		else
			delete[] (_vbox__IAudioAdapter_USCOREgetAudioController*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioControllerResponse:
		if (p->size < 0)
			delete (_vbox__IAudioAdapter_USCOREgetAudioControllerResponse*)p->ptr;
		else
			delete[] (_vbox__IAudioAdapter_USCOREgetAudioControllerResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioController:
		if (p->size < 0)
			delete (_vbox__IAudioAdapter_USCOREsetAudioController*)p->ptr;
		else
			delete[] (_vbox__IAudioAdapter_USCOREsetAudioController*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioControllerResponse:
		if (p->size < 0)
			delete (_vbox__IAudioAdapter_USCOREsetAudioControllerResponse*)p->ptr;
		else
			delete[] (_vbox__IAudioAdapter_USCOREsetAudioControllerResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioDriver:
		if (p->size < 0)
			delete (_vbox__IAudioAdapter_USCOREgetAudioDriver*)p->ptr;
		else
			delete[] (_vbox__IAudioAdapter_USCOREgetAudioDriver*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioDriverResponse:
		if (p->size < 0)
			delete (_vbox__IAudioAdapter_USCOREgetAudioDriverResponse*)p->ptr;
		else
			delete[] (_vbox__IAudioAdapter_USCOREgetAudioDriverResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioDriver:
		if (p->size < 0)
			delete (_vbox__IAudioAdapter_USCOREsetAudioDriver*)p->ptr;
		else
			delete[] (_vbox__IAudioAdapter_USCOREsetAudioDriver*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioDriverResponse:
		if (p->size < 0)
			delete (_vbox__IAudioAdapter_USCOREsetAudioDriverResponse*)p->ptr;
		else
			delete[] (_vbox__IAudioAdapter_USCOREsetAudioDriverResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVRDPServer_USCOREgetEnabled:
		if (p->size < 0)
			delete (_vbox__IVRDPServer_USCOREgetEnabled*)p->ptr;
		else
			delete[] (_vbox__IVRDPServer_USCOREgetEnabled*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVRDPServer_USCOREgetEnabledResponse:
		if (p->size < 0)
			delete (_vbox__IVRDPServer_USCOREgetEnabledResponse*)p->ptr;
		else
			delete[] (_vbox__IVRDPServer_USCOREgetEnabledResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVRDPServer_USCOREsetEnabled:
		if (p->size < 0)
			delete (_vbox__IVRDPServer_USCOREsetEnabled*)p->ptr;
		else
			delete[] (_vbox__IVRDPServer_USCOREsetEnabled*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVRDPServer_USCOREsetEnabledResponse:
		if (p->size < 0)
			delete (_vbox__IVRDPServer_USCOREsetEnabledResponse*)p->ptr;
		else
			delete[] (_vbox__IVRDPServer_USCOREsetEnabledResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVRDPServer_USCOREgetPorts:
		if (p->size < 0)
			delete (_vbox__IVRDPServer_USCOREgetPorts*)p->ptr;
		else
			delete[] (_vbox__IVRDPServer_USCOREgetPorts*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVRDPServer_USCOREgetPortsResponse:
		if (p->size < 0)
			delete (_vbox__IVRDPServer_USCOREgetPortsResponse*)p->ptr;
		else
			delete[] (_vbox__IVRDPServer_USCOREgetPortsResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVRDPServer_USCOREsetPorts:
		if (p->size < 0)
			delete (_vbox__IVRDPServer_USCOREsetPorts*)p->ptr;
		else
			delete[] (_vbox__IVRDPServer_USCOREsetPorts*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVRDPServer_USCOREsetPortsResponse:
		if (p->size < 0)
			delete (_vbox__IVRDPServer_USCOREsetPortsResponse*)p->ptr;
		else
			delete[] (_vbox__IVRDPServer_USCOREsetPortsResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVRDPServer_USCOREgetNetAddress:
		if (p->size < 0)
			delete (_vbox__IVRDPServer_USCOREgetNetAddress*)p->ptr;
		else
			delete[] (_vbox__IVRDPServer_USCOREgetNetAddress*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVRDPServer_USCOREgetNetAddressResponse:
		if (p->size < 0)
			delete (_vbox__IVRDPServer_USCOREgetNetAddressResponse*)p->ptr;
		else
			delete[] (_vbox__IVRDPServer_USCOREgetNetAddressResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVRDPServer_USCOREsetNetAddress:
		if (p->size < 0)
			delete (_vbox__IVRDPServer_USCOREsetNetAddress*)p->ptr;
		else
			delete[] (_vbox__IVRDPServer_USCOREsetNetAddress*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVRDPServer_USCOREsetNetAddressResponse:
		if (p->size < 0)
			delete (_vbox__IVRDPServer_USCOREsetNetAddressResponse*)p->ptr;
		else
			delete[] (_vbox__IVRDPServer_USCOREsetNetAddressResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVRDPServer_USCOREgetAuthType:
		if (p->size < 0)
			delete (_vbox__IVRDPServer_USCOREgetAuthType*)p->ptr;
		else
			delete[] (_vbox__IVRDPServer_USCOREgetAuthType*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVRDPServer_USCOREgetAuthTypeResponse:
		if (p->size < 0)
			delete (_vbox__IVRDPServer_USCOREgetAuthTypeResponse*)p->ptr;
		else
			delete[] (_vbox__IVRDPServer_USCOREgetAuthTypeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVRDPServer_USCOREsetAuthType:
		if (p->size < 0)
			delete (_vbox__IVRDPServer_USCOREsetAuthType*)p->ptr;
		else
			delete[] (_vbox__IVRDPServer_USCOREsetAuthType*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVRDPServer_USCOREsetAuthTypeResponse:
		if (p->size < 0)
			delete (_vbox__IVRDPServer_USCOREsetAuthTypeResponse*)p->ptr;
		else
			delete[] (_vbox__IVRDPServer_USCOREsetAuthTypeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVRDPServer_USCOREgetAuthTimeout:
		if (p->size < 0)
			delete (_vbox__IVRDPServer_USCOREgetAuthTimeout*)p->ptr;
		else
			delete[] (_vbox__IVRDPServer_USCOREgetAuthTimeout*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVRDPServer_USCOREgetAuthTimeoutResponse:
		if (p->size < 0)
			delete (_vbox__IVRDPServer_USCOREgetAuthTimeoutResponse*)p->ptr;
		else
			delete[] (_vbox__IVRDPServer_USCOREgetAuthTimeoutResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVRDPServer_USCOREsetAuthTimeout:
		if (p->size < 0)
			delete (_vbox__IVRDPServer_USCOREsetAuthTimeout*)p->ptr;
		else
			delete[] (_vbox__IVRDPServer_USCOREsetAuthTimeout*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVRDPServer_USCOREsetAuthTimeoutResponse:
		if (p->size < 0)
			delete (_vbox__IVRDPServer_USCOREsetAuthTimeoutResponse*)p->ptr;
		else
			delete[] (_vbox__IVRDPServer_USCOREsetAuthTimeoutResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVRDPServer_USCOREgetAllowMultiConnection:
		if (p->size < 0)
			delete (_vbox__IVRDPServer_USCOREgetAllowMultiConnection*)p->ptr;
		else
			delete[] (_vbox__IVRDPServer_USCOREgetAllowMultiConnection*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse:
		if (p->size < 0)
			delete (_vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse*)p->ptr;
		else
			delete[] (_vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVRDPServer_USCOREsetAllowMultiConnection:
		if (p->size < 0)
			delete (_vbox__IVRDPServer_USCOREsetAllowMultiConnection*)p->ptr;
		else
			delete[] (_vbox__IVRDPServer_USCOREsetAllowMultiConnection*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse:
		if (p->size < 0)
			delete (_vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse*)p->ptr;
		else
			delete[] (_vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVRDPServer_USCOREgetReuseSingleConnection:
		if (p->size < 0)
			delete (_vbox__IVRDPServer_USCOREgetReuseSingleConnection*)p->ptr;
		else
			delete[] (_vbox__IVRDPServer_USCOREgetReuseSingleConnection*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse:
		if (p->size < 0)
			delete (_vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse*)p->ptr;
		else
			delete[] (_vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVRDPServer_USCOREsetReuseSingleConnection:
		if (p->size < 0)
			delete (_vbox__IVRDPServer_USCOREsetReuseSingleConnection*)p->ptr;
		else
			delete[] (_vbox__IVRDPServer_USCOREsetReuseSingleConnection*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse:
		if (p->size < 0)
			delete (_vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse*)p->ptr;
		else
			delete[] (_vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISession_USCOREgetState:
		if (p->size < 0)
			delete (_vbox__ISession_USCOREgetState*)p->ptr;
		else
			delete[] (_vbox__ISession_USCOREgetState*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISession_USCOREgetStateResponse:
		if (p->size < 0)
			delete (_vbox__ISession_USCOREgetStateResponse*)p->ptr;
		else
			delete[] (_vbox__ISession_USCOREgetStateResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISession_USCOREgetType:
		if (p->size < 0)
			delete (_vbox__ISession_USCOREgetType*)p->ptr;
		else
			delete[] (_vbox__ISession_USCOREgetType*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISession_USCOREgetTypeResponse:
		if (p->size < 0)
			delete (_vbox__ISession_USCOREgetTypeResponse*)p->ptr;
		else
			delete[] (_vbox__ISession_USCOREgetTypeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISession_USCOREgetMachine:
		if (p->size < 0)
			delete (_vbox__ISession_USCOREgetMachine*)p->ptr;
		else
			delete[] (_vbox__ISession_USCOREgetMachine*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISession_USCOREgetMachineResponse:
		if (p->size < 0)
			delete (_vbox__ISession_USCOREgetMachineResponse*)p->ptr;
		else
			delete[] (_vbox__ISession_USCOREgetMachineResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISession_USCOREgetConsole:
		if (p->size < 0)
			delete (_vbox__ISession_USCOREgetConsole*)p->ptr;
		else
			delete[] (_vbox__ISession_USCOREgetConsole*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISession_USCOREgetConsoleResponse:
		if (p->size < 0)
			delete (_vbox__ISession_USCOREgetConsoleResponse*)p->ptr;
		else
			delete[] (_vbox__ISession_USCOREgetConsoleResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISession_USCOREclose:
		if (p->size < 0)
			delete (_vbox__ISession_USCOREclose*)p->ptr;
		else
			delete[] (_vbox__ISession_USCOREclose*)p->ptr;
		break;
	case SOAP_TYPE__vbox__ISession_USCOREcloseResponse:
		if (p->size < 0)
			delete (_vbox__ISession_USCOREcloseResponse*)p->ptr;
		else
			delete[] (_vbox__ISession_USCOREcloseResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetName:
		if (p->size < 0)
			delete (_vbox__IStorageController_USCOREgetName*)p->ptr;
		else
			delete[] (_vbox__IStorageController_USCOREgetName*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetNameResponse:
		if (p->size < 0)
			delete (_vbox__IStorageController_USCOREgetNameResponse*)p->ptr;
		else
			delete[] (_vbox__IStorageController_USCOREgetNameResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetMaxDevicesPerPortCount:
		if (p->size < 0)
			delete (_vbox__IStorageController_USCOREgetMaxDevicesPerPortCount*)p->ptr;
		else
			delete[] (_vbox__IStorageController_USCOREgetMaxDevicesPerPortCount*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse:
		if (p->size < 0)
			delete (_vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse*)p->ptr;
		else
			delete[] (_vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetMinPortCount:
		if (p->size < 0)
			delete (_vbox__IStorageController_USCOREgetMinPortCount*)p->ptr;
		else
			delete[] (_vbox__IStorageController_USCOREgetMinPortCount*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetMinPortCountResponse:
		if (p->size < 0)
			delete (_vbox__IStorageController_USCOREgetMinPortCountResponse*)p->ptr;
		else
			delete[] (_vbox__IStorageController_USCOREgetMinPortCountResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetMaxPortCount:
		if (p->size < 0)
			delete (_vbox__IStorageController_USCOREgetMaxPortCount*)p->ptr;
		else
			delete[] (_vbox__IStorageController_USCOREgetMaxPortCount*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetMaxPortCountResponse:
		if (p->size < 0)
			delete (_vbox__IStorageController_USCOREgetMaxPortCountResponse*)p->ptr;
		else
			delete[] (_vbox__IStorageController_USCOREgetMaxPortCountResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetInstance:
		if (p->size < 0)
			delete (_vbox__IStorageController_USCOREgetInstance*)p->ptr;
		else
			delete[] (_vbox__IStorageController_USCOREgetInstance*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetInstanceResponse:
		if (p->size < 0)
			delete (_vbox__IStorageController_USCOREgetInstanceResponse*)p->ptr;
		else
			delete[] (_vbox__IStorageController_USCOREgetInstanceResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREsetInstance:
		if (p->size < 0)
			delete (_vbox__IStorageController_USCOREsetInstance*)p->ptr;
		else
			delete[] (_vbox__IStorageController_USCOREsetInstance*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREsetInstanceResponse:
		if (p->size < 0)
			delete (_vbox__IStorageController_USCOREsetInstanceResponse*)p->ptr;
		else
			delete[] (_vbox__IStorageController_USCOREsetInstanceResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetPortCount:
		if (p->size < 0)
			delete (_vbox__IStorageController_USCOREgetPortCount*)p->ptr;
		else
			delete[] (_vbox__IStorageController_USCOREgetPortCount*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetPortCountResponse:
		if (p->size < 0)
			delete (_vbox__IStorageController_USCOREgetPortCountResponse*)p->ptr;
		else
			delete[] (_vbox__IStorageController_USCOREgetPortCountResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREsetPortCount:
		if (p->size < 0)
			delete (_vbox__IStorageController_USCOREsetPortCount*)p->ptr;
		else
			delete[] (_vbox__IStorageController_USCOREsetPortCount*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREsetPortCountResponse:
		if (p->size < 0)
			delete (_vbox__IStorageController_USCOREsetPortCountResponse*)p->ptr;
		else
			delete[] (_vbox__IStorageController_USCOREsetPortCountResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetBus:
		if (p->size < 0)
			delete (_vbox__IStorageController_USCOREgetBus*)p->ptr;
		else
			delete[] (_vbox__IStorageController_USCOREgetBus*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetBusResponse:
		if (p->size < 0)
			delete (_vbox__IStorageController_USCOREgetBusResponse*)p->ptr;
		else
			delete[] (_vbox__IStorageController_USCOREgetBusResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetControllerType:
		if (p->size < 0)
			delete (_vbox__IStorageController_USCOREgetControllerType*)p->ptr;
		else
			delete[] (_vbox__IStorageController_USCOREgetControllerType*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetControllerTypeResponse:
		if (p->size < 0)
			delete (_vbox__IStorageController_USCOREgetControllerTypeResponse*)p->ptr;
		else
			delete[] (_vbox__IStorageController_USCOREgetControllerTypeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREsetControllerType:
		if (p->size < 0)
			delete (_vbox__IStorageController_USCOREsetControllerType*)p->ptr;
		else
			delete[] (_vbox__IStorageController_USCOREsetControllerType*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREsetControllerTypeResponse:
		if (p->size < 0)
			delete (_vbox__IStorageController_USCOREsetControllerTypeResponse*)p->ptr;
		else
			delete[] (_vbox__IStorageController_USCOREsetControllerTypeResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREGetIDEEmulationPort:
		if (p->size < 0)
			delete (_vbox__IStorageController_USCOREGetIDEEmulationPort*)p->ptr;
		else
			delete[] (_vbox__IStorageController_USCOREGetIDEEmulationPort*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREGetIDEEmulationPortResponse:
		if (p->size < 0)
			delete (_vbox__IStorageController_USCOREGetIDEEmulationPortResponse*)p->ptr;
		else
			delete[] (_vbox__IStorageController_USCOREGetIDEEmulationPortResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCORESetIDEEmulationPort:
		if (p->size < 0)
			delete (_vbox__IStorageController_USCORESetIDEEmulationPort*)p->ptr;
		else
			delete[] (_vbox__IStorageController_USCORESetIDEEmulationPort*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCORESetIDEEmulationPortResponse:
		if (p->size < 0)
			delete (_vbox__IStorageController_USCORESetIDEEmulationPortResponse*)p->ptr;
		else
			delete[] (_vbox__IStorageController_USCORESetIDEEmulationPortResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IManagedObjectRef_USCOREgetInterfaceName:
		if (p->size < 0)
			delete (_vbox__IManagedObjectRef_USCOREgetInterfaceName*)p->ptr;
		else
			delete[] (_vbox__IManagedObjectRef_USCOREgetInterfaceName*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse:
		if (p->size < 0)
			delete (_vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse*)p->ptr;
		else
			delete[] (_vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IManagedObjectRef_USCORErelease:
		if (p->size < 0)
			delete (_vbox__IManagedObjectRef_USCORErelease*)p->ptr;
		else
			delete[] (_vbox__IManagedObjectRef_USCORErelease*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IManagedObjectRef_USCOREreleaseResponse:
		if (p->size < 0)
			delete (_vbox__IManagedObjectRef_USCOREreleaseResponse*)p->ptr;
		else
			delete[] (_vbox__IManagedObjectRef_USCOREreleaseResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IWebsessionManager_USCORElogon:
		if (p->size < 0)
			delete (_vbox__IWebsessionManager_USCORElogon*)p->ptr;
		else
			delete[] (_vbox__IWebsessionManager_USCORElogon*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IWebsessionManager_USCORElogonResponse:
		if (p->size < 0)
			delete (_vbox__IWebsessionManager_USCORElogonResponse*)p->ptr;
		else
			delete[] (_vbox__IWebsessionManager_USCORElogonResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IWebsessionManager_USCOREgetSessionObject:
		if (p->size < 0)
			delete (_vbox__IWebsessionManager_USCOREgetSessionObject*)p->ptr;
		else
			delete[] (_vbox__IWebsessionManager_USCOREgetSessionObject*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IWebsessionManager_USCOREgetSessionObjectResponse:
		if (p->size < 0)
			delete (_vbox__IWebsessionManager_USCOREgetSessionObjectResponse*)p->ptr;
		else
			delete[] (_vbox__IWebsessionManager_USCOREgetSessionObjectResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IWebsessionManager_USCORElogoff:
		if (p->size < 0)
			delete (_vbox__IWebsessionManager_USCORElogoff*)p->ptr;
		else
			delete[] (_vbox__IWebsessionManager_USCORElogoff*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IWebsessionManager_USCORElogoffResponse:
		if (p->size < 0)
			delete (_vbox__IWebsessionManager_USCORElogoffResponse*)p->ptr;
		else
			delete[] (_vbox__IWebsessionManager_USCORElogoffResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMetricName:
		if (p->size < 0)
			delete (_vbox__IPerformanceMetric_USCOREgetMetricName*)p->ptr;
		else
			delete[] (_vbox__IPerformanceMetric_USCOREgetMetricName*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMetricNameResponse:
		if (p->size < 0)
			delete (_vbox__IPerformanceMetric_USCOREgetMetricNameResponse*)p->ptr;
		else
			delete[] (_vbox__IPerformanceMetric_USCOREgetMetricNameResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetObject:
		if (p->size < 0)
			delete (_vbox__IPerformanceMetric_USCOREgetObject*)p->ptr;
		else
			delete[] (_vbox__IPerformanceMetric_USCOREgetObject*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetObjectResponse:
		if (p->size < 0)
			delete (_vbox__IPerformanceMetric_USCOREgetObjectResponse*)p->ptr;
		else
			delete[] (_vbox__IPerformanceMetric_USCOREgetObjectResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetDescription:
		if (p->size < 0)
			delete (_vbox__IPerformanceMetric_USCOREgetDescription*)p->ptr;
		else
			delete[] (_vbox__IPerformanceMetric_USCOREgetDescription*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetDescriptionResponse:
		if (p->size < 0)
			delete (_vbox__IPerformanceMetric_USCOREgetDescriptionResponse*)p->ptr;
		else
			delete[] (_vbox__IPerformanceMetric_USCOREgetDescriptionResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetPeriod:
		if (p->size < 0)
			delete (_vbox__IPerformanceMetric_USCOREgetPeriod*)p->ptr;
		else
			delete[] (_vbox__IPerformanceMetric_USCOREgetPeriod*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetPeriodResponse:
		if (p->size < 0)
			delete (_vbox__IPerformanceMetric_USCOREgetPeriodResponse*)p->ptr;
		else
			delete[] (_vbox__IPerformanceMetric_USCOREgetPeriodResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetCount:
		if (p->size < 0)
			delete (_vbox__IPerformanceMetric_USCOREgetCount*)p->ptr;
		else
			delete[] (_vbox__IPerformanceMetric_USCOREgetCount*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetCountResponse:
		if (p->size < 0)
			delete (_vbox__IPerformanceMetric_USCOREgetCountResponse*)p->ptr;
		else
			delete[] (_vbox__IPerformanceMetric_USCOREgetCountResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetUnit:
		if (p->size < 0)
			delete (_vbox__IPerformanceMetric_USCOREgetUnit*)p->ptr;
		else
			delete[] (_vbox__IPerformanceMetric_USCOREgetUnit*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetUnitResponse:
		if (p->size < 0)
			delete (_vbox__IPerformanceMetric_USCOREgetUnitResponse*)p->ptr;
		else
			delete[] (_vbox__IPerformanceMetric_USCOREgetUnitResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMinimumValue:
		if (p->size < 0)
			delete (_vbox__IPerformanceMetric_USCOREgetMinimumValue*)p->ptr;
		else
			delete[] (_vbox__IPerformanceMetric_USCOREgetMinimumValue*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMinimumValueResponse:
		if (p->size < 0)
			delete (_vbox__IPerformanceMetric_USCOREgetMinimumValueResponse*)p->ptr;
		else
			delete[] (_vbox__IPerformanceMetric_USCOREgetMinimumValueResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMaximumValue:
		if (p->size < 0)
			delete (_vbox__IPerformanceMetric_USCOREgetMaximumValue*)p->ptr;
		else
			delete[] (_vbox__IPerformanceMetric_USCOREgetMaximumValue*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMaximumValueResponse:
		if (p->size < 0)
			delete (_vbox__IPerformanceMetric_USCOREgetMaximumValueResponse*)p->ptr;
		else
			delete[] (_vbox__IPerformanceMetric_USCOREgetMaximumValueResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetricNames:
		if (p->size < 0)
			delete (_vbox__IPerformanceCollector_USCOREgetMetricNames*)p->ptr;
		else
			delete[] (_vbox__IPerformanceCollector_USCOREgetMetricNames*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetricNamesResponse:
		if (p->size < 0)
			delete (_vbox__IPerformanceCollector_USCOREgetMetricNamesResponse*)p->ptr;
		else
			delete[] (_vbox__IPerformanceCollector_USCOREgetMetricNamesResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetrics:
		if (p->size < 0)
			delete (_vbox__IPerformanceCollector_USCOREgetMetrics*)p->ptr;
		else
			delete[] (_vbox__IPerformanceCollector_USCOREgetMetrics*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetricsResponse:
		if (p->size < 0)
			delete (_vbox__IPerformanceCollector_USCOREgetMetricsResponse*)p->ptr;
		else
			delete[] (_vbox__IPerformanceCollector_USCOREgetMetricsResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREsetupMetrics:
		if (p->size < 0)
			delete (_vbox__IPerformanceCollector_USCOREsetupMetrics*)p->ptr;
		else
			delete[] (_vbox__IPerformanceCollector_USCOREsetupMetrics*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREsetupMetricsResponse:
		if (p->size < 0)
			delete (_vbox__IPerformanceCollector_USCOREsetupMetricsResponse*)p->ptr;
		else
			delete[] (_vbox__IPerformanceCollector_USCOREsetupMetricsResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREenableMetrics:
		if (p->size < 0)
			delete (_vbox__IPerformanceCollector_USCOREenableMetrics*)p->ptr;
		else
			delete[] (_vbox__IPerformanceCollector_USCOREenableMetrics*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREenableMetricsResponse:
		if (p->size < 0)
			delete (_vbox__IPerformanceCollector_USCOREenableMetricsResponse*)p->ptr;
		else
			delete[] (_vbox__IPerformanceCollector_USCOREenableMetricsResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREdisableMetrics:
		if (p->size < 0)
			delete (_vbox__IPerformanceCollector_USCOREdisableMetrics*)p->ptr;
		else
			delete[] (_vbox__IPerformanceCollector_USCOREdisableMetrics*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREdisableMetricsResponse:
		if (p->size < 0)
			delete (_vbox__IPerformanceCollector_USCOREdisableMetricsResponse*)p->ptr;
		else
			delete[] (_vbox__IPerformanceCollector_USCOREdisableMetricsResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREqueryMetricsData:
		if (p->size < 0)
			delete (_vbox__IPerformanceCollector_USCOREqueryMetricsData*)p->ptr;
		else
			delete[] (_vbox__IPerformanceCollector_USCOREqueryMetricsData*)p->ptr;
		break;
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse:
		if (p->size < 0)
			delete (_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse*)p->ptr;
		else
			delete[] (_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse*)p->ptr;
		break;
	case SOAP_TYPE__vbox__InvalidObjectFault:
		if (p->size < 0)
			delete (_vbox__InvalidObjectFault*)p->ptr;
		else
			delete[] (_vbox__InvalidObjectFault*)p->ptr;
		break;
	case SOAP_TYPE__vbox__RuntimeFault:
		if (p->size < 0)
			delete (_vbox__RuntimeFault*)p->ptr;
		else
			delete[] (_vbox__RuntimeFault*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBoxErrorInfo_USCOREgetResultCode:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBoxErrorInfo_USCOREgetResultCode*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBoxErrorInfo_USCOREgetResultCode*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBoxErrorInfo_USCOREgetInterfaceID:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBoxErrorInfo_USCOREgetInterfaceID*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBoxErrorInfo_USCOREgetInterfaceID*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBoxErrorInfo_USCOREgetComponent:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBoxErrorInfo_USCOREgetComponent*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBoxErrorInfo_USCOREgetComponent*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBoxErrorInfo_USCOREgetText:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBoxErrorInfo_USCOREgetText*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBoxErrorInfo_USCOREgetText*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBoxErrorInfo_USCOREgetNext:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBoxErrorInfo_USCOREgetNext*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBoxErrorInfo_USCOREgetNext*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IDHCPServer_USCOREgetEnabled:
		if (p->size < 0)
			delete (struct __vbox__IDHCPServer_USCOREgetEnabled*)p->ptr;
		else
			delete[] (struct __vbox__IDHCPServer_USCOREgetEnabled*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IDHCPServer_USCOREsetEnabled:
		if (p->size < 0)
			delete (struct __vbox__IDHCPServer_USCOREsetEnabled*)p->ptr;
		else
			delete[] (struct __vbox__IDHCPServer_USCOREsetEnabled*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IDHCPServer_USCOREgetIPAddress:
		if (p->size < 0)
			delete (struct __vbox__IDHCPServer_USCOREgetIPAddress*)p->ptr;
		else
			delete[] (struct __vbox__IDHCPServer_USCOREgetIPAddress*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IDHCPServer_USCOREgetNetworkMask:
		if (p->size < 0)
			delete (struct __vbox__IDHCPServer_USCOREgetNetworkMask*)p->ptr;
		else
			delete[] (struct __vbox__IDHCPServer_USCOREgetNetworkMask*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IDHCPServer_USCOREgetNetworkName:
		if (p->size < 0)
			delete (struct __vbox__IDHCPServer_USCOREgetNetworkName*)p->ptr;
		else
			delete[] (struct __vbox__IDHCPServer_USCOREgetNetworkName*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IDHCPServer_USCOREgetLowerIP:
		if (p->size < 0)
			delete (struct __vbox__IDHCPServer_USCOREgetLowerIP*)p->ptr;
		else
			delete[] (struct __vbox__IDHCPServer_USCOREgetLowerIP*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IDHCPServer_USCOREgetUpperIP:
		if (p->size < 0)
			delete (struct __vbox__IDHCPServer_USCOREgetUpperIP*)p->ptr;
		else
			delete[] (struct __vbox__IDHCPServer_USCOREgetUpperIP*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IDHCPServer_USCOREsetConfiguration:
		if (p->size < 0)
			delete (struct __vbox__IDHCPServer_USCOREsetConfiguration*)p->ptr;
		else
			delete[] (struct __vbox__IDHCPServer_USCOREsetConfiguration*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IDHCPServer_USCOREstart:
		if (p->size < 0)
			delete (struct __vbox__IDHCPServer_USCOREstart*)p->ptr;
		else
			delete[] (struct __vbox__IDHCPServer_USCOREstart*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IDHCPServer_USCOREstop:
		if (p->size < 0)
			delete (struct __vbox__IDHCPServer_USCOREstop*)p->ptr;
		else
			delete[] (struct __vbox__IDHCPServer_USCOREstop*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetVersion:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREgetVersion*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREgetVersion*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetRevision:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREgetRevision*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREgetRevision*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetPackageType:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREgetPackageType*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREgetPackageType*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetHomeFolder:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREgetHomeFolder*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREgetHomeFolder*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetSettingsFilePath:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREgetSettingsFilePath*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREgetSettingsFilePath*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetHost:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREgetHost*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREgetHost*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetSystemProperties:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREgetSystemProperties*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREgetSystemProperties*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetMachines:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREgetMachines*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREgetMachines*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetHardDisks:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREgetHardDisks*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREgetHardDisks*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetDVDImages:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREgetDVDImages*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREgetDVDImages*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetFloppyImages:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREgetFloppyImages*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREgetFloppyImages*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetProgressOperations:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREgetProgressOperations*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREgetProgressOperations*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetGuestOSTypes:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREgetGuestOSTypes*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREgetGuestOSTypes*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetSharedFolders:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREgetSharedFolders*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREgetSharedFolders*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetPerformanceCollector:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREgetPerformanceCollector*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREgetPerformanceCollector*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetDHCPServers:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREgetDHCPServers*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREgetDHCPServers*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREcreateMachine:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREcreateMachine*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREcreateMachine*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREcreateLegacyMachine:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREcreateLegacyMachine*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREcreateLegacyMachine*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREopenMachine:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREopenMachine*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREopenMachine*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREregisterMachine:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREregisterMachine*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREregisterMachine*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetMachine:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREgetMachine*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREgetMachine*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREfindMachine:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREfindMachine*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREfindMachine*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREunregisterMachine:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREunregisterMachine*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREunregisterMachine*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREcreateAppliance:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREcreateAppliance*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREcreateAppliance*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREcreateHardDisk:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREcreateHardDisk*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREcreateHardDisk*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREopenHardDisk:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREopenHardDisk*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREopenHardDisk*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetHardDisk:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREgetHardDisk*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREgetHardDisk*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREfindHardDisk:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREfindHardDisk*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREfindHardDisk*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREopenDVDImage:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREopenDVDImage*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREopenDVDImage*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetDVDImage:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREgetDVDImage*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREgetDVDImage*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREfindDVDImage:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREfindDVDImage*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREfindDVDImage*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREopenFloppyImage:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREopenFloppyImage*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREopenFloppyImage*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetFloppyImage:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREgetFloppyImage*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREgetFloppyImage*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREfindFloppyImage:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREfindFloppyImage*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREfindFloppyImage*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetGuestOSType:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREgetGuestOSType*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREgetGuestOSType*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREcreateSharedFolder:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREcreateSharedFolder*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREcreateSharedFolder*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREremoveSharedFolder:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREremoveSharedFolder*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREremoveSharedFolder*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetExtraDataKeys:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREgetExtraDataKeys*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREgetExtraDataKeys*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetExtraData:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREgetExtraData*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREgetExtraData*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREsetExtraData:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREsetExtraData*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREsetExtraData*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREopenSession:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREopenSession*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREopenSession*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREopenRemoteSession:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREopenRemoteSession*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREopenRemoteSession*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREopenExistingSession:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREopenExistingSession*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREopenExistingSession*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREwaitForPropertyChange:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREwaitForPropertyChange*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREwaitForPropertyChange*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREcreateDHCPServer:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREcreateDHCPServer*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREcreateDHCPServer*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREfindDHCPServerByNetworkName:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREfindDHCPServerByNetworkName*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREfindDHCPServerByNetworkName*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREremoveDHCPServer:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREremoveDHCPServer*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREremoveDHCPServer*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREcheckFirmwarePresent:
		if (p->size < 0)
			delete (struct __vbox__IVirtualBox_USCOREcheckFirmwarePresent*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualBox_USCOREcheckFirmwarePresent*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVFSExplorer_USCOREgetPath:
		if (p->size < 0)
			delete (struct __vbox__IVFSExplorer_USCOREgetPath*)p->ptr;
		else
			delete[] (struct __vbox__IVFSExplorer_USCOREgetPath*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVFSExplorer_USCOREgetType:
		if (p->size < 0)
			delete (struct __vbox__IVFSExplorer_USCOREgetType*)p->ptr;
		else
			delete[] (struct __vbox__IVFSExplorer_USCOREgetType*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVFSExplorer_USCOREupdate:
		if (p->size < 0)
			delete (struct __vbox__IVFSExplorer_USCOREupdate*)p->ptr;
		else
			delete[] (struct __vbox__IVFSExplorer_USCOREupdate*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVFSExplorer_USCOREcd:
		if (p->size < 0)
			delete (struct __vbox__IVFSExplorer_USCOREcd*)p->ptr;
		else
			delete[] (struct __vbox__IVFSExplorer_USCOREcd*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVFSExplorer_USCOREcdUp:
		if (p->size < 0)
			delete (struct __vbox__IVFSExplorer_USCOREcdUp*)p->ptr;
		else
			delete[] (struct __vbox__IVFSExplorer_USCOREcdUp*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVFSExplorer_USCOREentryList:
		if (p->size < 0)
			delete (struct __vbox__IVFSExplorer_USCOREentryList*)p->ptr;
		else
			delete[] (struct __vbox__IVFSExplorer_USCOREentryList*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVFSExplorer_USCOREexists:
		if (p->size < 0)
			delete (struct __vbox__IVFSExplorer_USCOREexists*)p->ptr;
		else
			delete[] (struct __vbox__IVFSExplorer_USCOREexists*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVFSExplorer_USCOREremove:
		if (p->size < 0)
			delete (struct __vbox__IVFSExplorer_USCOREremove*)p->ptr;
		else
			delete[] (struct __vbox__IVFSExplorer_USCOREremove*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IAppliance_USCOREgetPath:
		if (p->size < 0)
			delete (struct __vbox__IAppliance_USCOREgetPath*)p->ptr;
		else
			delete[] (struct __vbox__IAppliance_USCOREgetPath*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IAppliance_USCOREgetDisks:
		if (p->size < 0)
			delete (struct __vbox__IAppliance_USCOREgetDisks*)p->ptr;
		else
			delete[] (struct __vbox__IAppliance_USCOREgetDisks*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IAppliance_USCOREgetVirtualSystemDescriptions:
		if (p->size < 0)
			delete (struct __vbox__IAppliance_USCOREgetVirtualSystemDescriptions*)p->ptr;
		else
			delete[] (struct __vbox__IAppliance_USCOREgetVirtualSystemDescriptions*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IAppliance_USCOREread:
		if (p->size < 0)
			delete (struct __vbox__IAppliance_USCOREread*)p->ptr;
		else
			delete[] (struct __vbox__IAppliance_USCOREread*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IAppliance_USCOREinterpret:
		if (p->size < 0)
			delete (struct __vbox__IAppliance_USCOREinterpret*)p->ptr;
		else
			delete[] (struct __vbox__IAppliance_USCOREinterpret*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IAppliance_USCOREimportMachines:
		if (p->size < 0)
			delete (struct __vbox__IAppliance_USCOREimportMachines*)p->ptr;
		else
			delete[] (struct __vbox__IAppliance_USCOREimportMachines*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IAppliance_USCOREcreateVFSExplorer:
		if (p->size < 0)
			delete (struct __vbox__IAppliance_USCOREcreateVFSExplorer*)p->ptr;
		else
			delete[] (struct __vbox__IAppliance_USCOREcreateVFSExplorer*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IAppliance_USCOREwrite:
		if (p->size < 0)
			delete (struct __vbox__IAppliance_USCOREwrite*)p->ptr;
		else
			delete[] (struct __vbox__IAppliance_USCOREwrite*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IAppliance_USCOREgetWarnings:
		if (p->size < 0)
			delete (struct __vbox__IAppliance_USCOREgetWarnings*)p->ptr;
		else
			delete[] (struct __vbox__IAppliance_USCOREgetWarnings*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualSystemDescription_USCOREgetCount:
		if (p->size < 0)
			delete (struct __vbox__IVirtualSystemDescription_USCOREgetCount*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualSystemDescription_USCOREgetCount*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualSystemDescription_USCOREgetDescription:
		if (p->size < 0)
			delete (struct __vbox__IVirtualSystemDescription_USCOREgetDescription*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualSystemDescription_USCOREgetDescription*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualSystemDescription_USCOREgetDescriptionByType:
		if (p->size < 0)
			delete (struct __vbox__IVirtualSystemDescription_USCOREgetDescriptionByType*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualSystemDescription_USCOREgetDescriptionByType*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualSystemDescription_USCOREgetValuesByType:
		if (p->size < 0)
			delete (struct __vbox__IVirtualSystemDescription_USCOREgetValuesByType*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualSystemDescription_USCOREgetValuesByType*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualSystemDescription_USCOREsetFinalValues:
		if (p->size < 0)
			delete (struct __vbox__IVirtualSystemDescription_USCOREsetFinalValues*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualSystemDescription_USCOREsetFinalValues*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVirtualSystemDescription_USCOREaddDescription:
		if (p->size < 0)
			delete (struct __vbox__IVirtualSystemDescription_USCOREaddDescription*)p->ptr;
		else
			delete[] (struct __vbox__IVirtualSystemDescription_USCOREaddDescription*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREgetLogoFadeIn:
		if (p->size < 0)
			delete (struct __vbox__IBIOSSettings_USCOREgetLogoFadeIn*)p->ptr;
		else
			delete[] (struct __vbox__IBIOSSettings_USCOREgetLogoFadeIn*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREsetLogoFadeIn:
		if (p->size < 0)
			delete (struct __vbox__IBIOSSettings_USCOREsetLogoFadeIn*)p->ptr;
		else
			delete[] (struct __vbox__IBIOSSettings_USCOREsetLogoFadeIn*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREgetLogoFadeOut:
		if (p->size < 0)
			delete (struct __vbox__IBIOSSettings_USCOREgetLogoFadeOut*)p->ptr;
		else
			delete[] (struct __vbox__IBIOSSettings_USCOREgetLogoFadeOut*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREsetLogoFadeOut:
		if (p->size < 0)
			delete (struct __vbox__IBIOSSettings_USCOREsetLogoFadeOut*)p->ptr;
		else
			delete[] (struct __vbox__IBIOSSettings_USCOREsetLogoFadeOut*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREgetLogoDisplayTime:
		if (p->size < 0)
			delete (struct __vbox__IBIOSSettings_USCOREgetLogoDisplayTime*)p->ptr;
		else
			delete[] (struct __vbox__IBIOSSettings_USCOREgetLogoDisplayTime*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREsetLogoDisplayTime:
		if (p->size < 0)
			delete (struct __vbox__IBIOSSettings_USCOREsetLogoDisplayTime*)p->ptr;
		else
			delete[] (struct __vbox__IBIOSSettings_USCOREsetLogoDisplayTime*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREgetLogoImagePath:
		if (p->size < 0)
			delete (struct __vbox__IBIOSSettings_USCOREgetLogoImagePath*)p->ptr;
		else
			delete[] (struct __vbox__IBIOSSettings_USCOREgetLogoImagePath*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREsetLogoImagePath:
		if (p->size < 0)
			delete (struct __vbox__IBIOSSettings_USCOREsetLogoImagePath*)p->ptr;
		else
			delete[] (struct __vbox__IBIOSSettings_USCOREsetLogoImagePath*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREgetBootMenuMode:
		if (p->size < 0)
			delete (struct __vbox__IBIOSSettings_USCOREgetBootMenuMode*)p->ptr;
		else
			delete[] (struct __vbox__IBIOSSettings_USCOREgetBootMenuMode*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREsetBootMenuMode:
		if (p->size < 0)
			delete (struct __vbox__IBIOSSettings_USCOREsetBootMenuMode*)p->ptr;
		else
			delete[] (struct __vbox__IBIOSSettings_USCOREsetBootMenuMode*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREgetACPIEnabled:
		if (p->size < 0)
			delete (struct __vbox__IBIOSSettings_USCOREgetACPIEnabled*)p->ptr;
		else
			delete[] (struct __vbox__IBIOSSettings_USCOREgetACPIEnabled*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREsetACPIEnabled:
		if (p->size < 0)
			delete (struct __vbox__IBIOSSettings_USCOREsetACPIEnabled*)p->ptr;
		else
			delete[] (struct __vbox__IBIOSSettings_USCOREsetACPIEnabled*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREgetIOAPICEnabled:
		if (p->size < 0)
			delete (struct __vbox__IBIOSSettings_USCOREgetIOAPICEnabled*)p->ptr;
		else
			delete[] (struct __vbox__IBIOSSettings_USCOREgetIOAPICEnabled*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREsetIOAPICEnabled:
		if (p->size < 0)
			delete (struct __vbox__IBIOSSettings_USCOREsetIOAPICEnabled*)p->ptr;
		else
			delete[] (struct __vbox__IBIOSSettings_USCOREsetIOAPICEnabled*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREgetTimeOffset:
		if (p->size < 0)
			delete (struct __vbox__IBIOSSettings_USCOREgetTimeOffset*)p->ptr;
		else
			delete[] (struct __vbox__IBIOSSettings_USCOREgetTimeOffset*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREsetTimeOffset:
		if (p->size < 0)
			delete (struct __vbox__IBIOSSettings_USCOREsetTimeOffset*)p->ptr;
		else
			delete[] (struct __vbox__IBIOSSettings_USCOREsetTimeOffset*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREgetPXEDebugEnabled:
		if (p->size < 0)
			delete (struct __vbox__IBIOSSettings_USCOREgetPXEDebugEnabled*)p->ptr;
		else
			delete[] (struct __vbox__IBIOSSettings_USCOREgetPXEDebugEnabled*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREsetPXEDebugEnabled:
		if (p->size < 0)
			delete (struct __vbox__IBIOSSettings_USCOREsetPXEDebugEnabled*)p->ptr;
		else
			delete[] (struct __vbox__IBIOSSettings_USCOREsetPXEDebugEnabled*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetParent:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetParent*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetParent*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetAccessible:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetAccessible*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetAccessible*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetAccessError:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetAccessError*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetAccessError*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetName:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetName*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetName*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetName:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREsetName*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREsetName*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetDescription:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetDescription*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetDescription*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetDescription:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREsetDescription*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREsetDescription*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetId:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetId*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetId*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetOSTypeId:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetOSTypeId*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetOSTypeId*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetOSTypeId:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREsetOSTypeId*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREsetOSTypeId*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetHardwareVersion:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetHardwareVersion*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetHardwareVersion*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetHardwareVersion:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREsetHardwareVersion*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREsetHardwareVersion*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetHardwareUUID:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetHardwareUUID*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetHardwareUUID*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetHardwareUUID:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREsetHardwareUUID*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREsetHardwareUUID*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetCPUCount:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetCPUCount*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetCPUCount*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetCPUCount:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREsetCPUCount*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREsetCPUCount*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetMemorySize:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetMemorySize*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetMemorySize*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetMemorySize:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREsetMemorySize*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREsetMemorySize*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetMemoryBalloonSize:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetMemoryBalloonSize*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetMemoryBalloonSize*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetMemoryBalloonSize:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREsetMemoryBalloonSize*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREsetMemoryBalloonSize*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetStatisticsUpdateInterval:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetStatisticsUpdateInterval*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetStatisticsUpdateInterval*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetStatisticsUpdateInterval:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREsetStatisticsUpdateInterval*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREsetStatisticsUpdateInterval*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetVRAMSize:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetVRAMSize*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetVRAMSize*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetVRAMSize:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREsetVRAMSize*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREsetVRAMSize*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetAccelerate3DEnabled:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetAccelerate3DEnabled*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetAccelerate3DEnabled*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetAccelerate3DEnabled:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREsetAccelerate3DEnabled*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREsetAccelerate3DEnabled*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetAccelerate2DVideoEnabled:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetAccelerate2DVideoEnabled*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetAccelerate2DVideoEnabled*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetAccelerate2DVideoEnabled:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREsetAccelerate2DVideoEnabled*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREsetAccelerate2DVideoEnabled*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetMonitorCount:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetMonitorCount*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetMonitorCount*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetMonitorCount:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREsetMonitorCount*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREsetMonitorCount*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetBIOSSettings:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetBIOSSettings*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetBIOSSettings*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetFirmwareType:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetFirmwareType*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetFirmwareType*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetFirmwareType:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREsetFirmwareType*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREsetFirmwareType*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetSnapshotFolder:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetSnapshotFolder*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetSnapshotFolder*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetSnapshotFolder:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREsetSnapshotFolder*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREsetSnapshotFolder*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetVRDPServer:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetVRDPServer*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetVRDPServer*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetMediumAttachments:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetMediumAttachments*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetMediumAttachments*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetUSBController:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetUSBController*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetUSBController*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetAudioAdapter:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetAudioAdapter*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetAudioAdapter*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetStorageControllers:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetStorageControllers*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetStorageControllers*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetSettingsFilePath:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetSettingsFilePath*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetSettingsFilePath*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetSettingsModified:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetSettingsModified*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetSettingsModified*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetSessionState:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetSessionState*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetSessionState*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetSessionType:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetSessionType*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetSessionType*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetSessionPid:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetSessionPid*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetSessionPid*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetState:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetState*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetState*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetLastStateChange:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetLastStateChange*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetLastStateChange*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetStateFilePath:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetStateFilePath*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetStateFilePath*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetLogFolder:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetLogFolder*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetLogFolder*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetCurrentSnapshot:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetCurrentSnapshot*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetCurrentSnapshot*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetSnapshotCount:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetSnapshotCount*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetSnapshotCount*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetCurrentStateModified:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetCurrentStateModified*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetCurrentStateModified*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetSharedFolders:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetSharedFolders*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetSharedFolders*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetClipboardMode:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetClipboardMode*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetClipboardMode*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetClipboardMode:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREsetClipboardMode*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREsetClipboardMode*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetGuestPropertyNotificationPatterns:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetGuestPropertyNotificationPatterns*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetGuestPropertyNotificationPatterns*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetGuestPropertyNotificationPatterns:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREsetGuestPropertyNotificationPatterns*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREsetGuestPropertyNotificationPatterns*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetTeleporterEnabled:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetTeleporterEnabled*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetTeleporterEnabled*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetTeleporterEnabled:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREsetTeleporterEnabled*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREsetTeleporterEnabled*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetTeleporterPort:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetTeleporterPort*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetTeleporterPort*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetTeleporterPort:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREsetTeleporterPort*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREsetTeleporterPort*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetTeleporterAddress:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetTeleporterAddress*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetTeleporterAddress*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetTeleporterAddress:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREsetTeleporterAddress*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREsetTeleporterAddress*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetTeleporterPassword:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetTeleporterPassword*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetTeleporterPassword*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetTeleporterPassword:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREsetTeleporterPassword*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREsetTeleporterPassword*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetBootOrder:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREsetBootOrder*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREsetBootOrder*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetBootOrder:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetBootOrder*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetBootOrder*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREattachDevice:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREattachDevice*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREattachDevice*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREdetachDevice:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREdetachDevice*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREdetachDevice*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREpassthroughDevice:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREpassthroughDevice*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREpassthroughDevice*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREmountMedium:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREmountMedium*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREmountMedium*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetMedium:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetMedium*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetMedium*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetMediumAttachmentsOfController:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetMediumAttachmentsOfController*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetMediumAttachmentsOfController*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetMediumAttachment:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetMediumAttachment*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetMediumAttachment*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetNetworkAdapter:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetNetworkAdapter*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetNetworkAdapter*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREaddStorageController:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREaddStorageController*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREaddStorageController*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetStorageControllerByName:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetStorageControllerByName*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetStorageControllerByName*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetStorageControllerByInstance:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetStorageControllerByInstance*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetStorageControllerByInstance*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREremoveStorageController:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREremoveStorageController*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREremoveStorageController*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetSerialPort:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetSerialPort*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetSerialPort*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetParallelPort:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetParallelPort*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetParallelPort*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetExtraDataKeys:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetExtraDataKeys*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetExtraDataKeys*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetExtraData:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetExtraData*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetExtraData*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetExtraData:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREsetExtraData*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREsetExtraData*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetCpuProperty:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetCpuProperty*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetCpuProperty*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetCpuProperty:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREsetCpuProperty*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREsetCpuProperty*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetCpuIdLeaf:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetCpuIdLeaf*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetCpuIdLeaf*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetCpuIdLeaf:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREsetCpuIdLeaf*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREsetCpuIdLeaf*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREremoveCpuIdLeaf:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREremoveCpuIdLeaf*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREremoveCpuIdLeaf*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREremoveAllCpuIdLeafs:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREremoveAllCpuIdLeafs*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREremoveAllCpuIdLeafs*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetHWVirtExProperty:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetHWVirtExProperty*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetHWVirtExProperty*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetHWVirtExProperty:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREsetHWVirtExProperty*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREsetHWVirtExProperty*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsaveSettings:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREsaveSettings*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREsaveSettings*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREdiscardSettings:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREdiscardSettings*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREdiscardSettings*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREdeleteSettings:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREdeleteSettings*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREdeleteSettings*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREexport:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREexport*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREexport*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetSnapshot:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetSnapshot*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetSnapshot*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREfindSnapshot:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREfindSnapshot*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREfindSnapshot*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetCurrentSnapshot:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREsetCurrentSnapshot*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREsetCurrentSnapshot*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREcreateSharedFolder:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREcreateSharedFolder*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREcreateSharedFolder*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREremoveSharedFolder:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREremoveSharedFolder*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREremoveSharedFolder*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREcanShowConsoleWindow:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREcanShowConsoleWindow*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREcanShowConsoleWindow*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREshowConsoleWindow:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREshowConsoleWindow*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREshowConsoleWindow*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetGuestProperty:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetGuestProperty*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetGuestProperty*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetGuestPropertyValue:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetGuestPropertyValue*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetGuestPropertyValue*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetGuestPropertyTimestamp:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREgetGuestPropertyTimestamp*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREgetGuestPropertyTimestamp*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetGuestProperty:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREsetGuestProperty*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREsetGuestProperty*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetGuestPropertyValue:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREsetGuestPropertyValue*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREsetGuestPropertyValue*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREenumerateGuestProperties:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREenumerateGuestProperties*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREenumerateGuestProperties*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREquerySavedThumbnailSize:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREquerySavedThumbnailSize*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREquerySavedThumbnailSize*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREreadSavedThumbnailToArray:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREreadSavedThumbnailToArray*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREreadSavedThumbnailToArray*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREquerySavedScreenshotPNGSize:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREquerySavedScreenshotPNGSize*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREquerySavedScreenshotPNGSize*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREreadSavedScreenshotPNGToArray:
		if (p->size < 0)
			delete (struct __vbox__IMachine_USCOREreadSavedScreenshotPNGToArray*)p->ptr;
		else
			delete[] (struct __vbox__IMachine_USCOREreadSavedScreenshotPNGToArray*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREgetMachine:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCOREgetMachine*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCOREgetMachine*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREgetState:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCOREgetState*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCOREgetState*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREgetGuest:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCOREgetGuest*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCOREgetGuest*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREgetKeyboard:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCOREgetKeyboard*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCOREgetKeyboard*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREgetMouse:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCOREgetMouse*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCOREgetMouse*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREgetDisplay:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCOREgetDisplay*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCOREgetDisplay*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREgetUSBDevices:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCOREgetUSBDevices*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCOREgetUSBDevices*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREgetRemoteUSBDevices:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCOREgetRemoteUSBDevices*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCOREgetRemoteUSBDevices*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREgetSharedFolders:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCOREgetSharedFolders*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCOREgetSharedFolders*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREgetRemoteDisplayInfo:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCOREgetRemoteDisplayInfo*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCOREgetRemoteDisplayInfo*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREpowerUp:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCOREpowerUp*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCOREpowerUp*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREpowerUpPaused:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCOREpowerUpPaused*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCOREpowerUpPaused*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREpowerDown:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCOREpowerDown*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCOREpowerDown*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREreset:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCOREreset*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCOREreset*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREpause:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCOREpause*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCOREpause*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREresume:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCOREresume*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCOREresume*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREpowerButton:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCOREpowerButton*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCOREpowerButton*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREsleepButton:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCOREsleepButton*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCOREsleepButton*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREgetPowerButtonHandled:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCOREgetPowerButtonHandled*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCOREgetPowerButtonHandled*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREgetGuestEnteredACPIMode:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCOREgetGuestEnteredACPIMode*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCOREgetGuestEnteredACPIMode*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREsaveState:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCOREsaveState*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCOREsaveState*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREadoptSavedState:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCOREadoptSavedState*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCOREadoptSavedState*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREforgetSavedState:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCOREforgetSavedState*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCOREforgetSavedState*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREgetDeviceActivity:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCOREgetDeviceActivity*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCOREgetDeviceActivity*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREattachUSBDevice:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCOREattachUSBDevice*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCOREattachUSBDevice*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREdetachUSBDevice:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCOREdetachUSBDevice*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCOREdetachUSBDevice*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREfindUSBDeviceByAddress:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCOREfindUSBDeviceByAddress*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCOREfindUSBDeviceByAddress*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREfindUSBDeviceById:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCOREfindUSBDeviceById*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCOREfindUSBDeviceById*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREcreateSharedFolder:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCOREcreateSharedFolder*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCOREcreateSharedFolder*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREremoveSharedFolder:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCOREremoveSharedFolder*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCOREremoveSharedFolder*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREtakeSnapshot:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCOREtakeSnapshot*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCOREtakeSnapshot*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREdeleteSnapshot:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCOREdeleteSnapshot*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCOREdeleteSnapshot*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCORErestoreSnapshot:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCORErestoreSnapshot*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCORErestoreSnapshot*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREteleport:
		if (p->size < 0)
			delete (struct __vbox__IConsole_USCOREteleport*)p->ptr;
		else
			delete[] (struct __vbox__IConsole_USCOREteleport*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetName:
		if (p->size < 0)
			delete (struct __vbox__IHostNetworkInterface_USCOREgetName*)p->ptr;
		else
			delete[] (struct __vbox__IHostNetworkInterface_USCOREgetName*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetId:
		if (p->size < 0)
			delete (struct __vbox__IHostNetworkInterface_USCOREgetId*)p->ptr;
		else
			delete[] (struct __vbox__IHostNetworkInterface_USCOREgetId*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetNetworkName:
		if (p->size < 0)
			delete (struct __vbox__IHostNetworkInterface_USCOREgetNetworkName*)p->ptr;
		else
			delete[] (struct __vbox__IHostNetworkInterface_USCOREgetNetworkName*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetDhcpEnabled:
		if (p->size < 0)
			delete (struct __vbox__IHostNetworkInterface_USCOREgetDhcpEnabled*)p->ptr;
		else
			delete[] (struct __vbox__IHostNetworkInterface_USCOREgetDhcpEnabled*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetIPAddress:
		if (p->size < 0)
			delete (struct __vbox__IHostNetworkInterface_USCOREgetIPAddress*)p->ptr;
		else
			delete[] (struct __vbox__IHostNetworkInterface_USCOREgetIPAddress*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetNetworkMask:
		if (p->size < 0)
			delete (struct __vbox__IHostNetworkInterface_USCOREgetNetworkMask*)p->ptr;
		else
			delete[] (struct __vbox__IHostNetworkInterface_USCOREgetNetworkMask*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetIPV6Supported:
		if (p->size < 0)
			delete (struct __vbox__IHostNetworkInterface_USCOREgetIPV6Supported*)p->ptr;
		else
			delete[] (struct __vbox__IHostNetworkInterface_USCOREgetIPV6Supported*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetIPV6Address:
		if (p->size < 0)
			delete (struct __vbox__IHostNetworkInterface_USCOREgetIPV6Address*)p->ptr;
		else
			delete[] (struct __vbox__IHostNetworkInterface_USCOREgetIPV6Address*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetIPV6NetworkMaskPrefixLength:
		if (p->size < 0)
			delete (struct __vbox__IHostNetworkInterface_USCOREgetIPV6NetworkMaskPrefixLength*)p->ptr;
		else
			delete[] (struct __vbox__IHostNetworkInterface_USCOREgetIPV6NetworkMaskPrefixLength*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetHardwareAddress:
		if (p->size < 0)
			delete (struct __vbox__IHostNetworkInterface_USCOREgetHardwareAddress*)p->ptr;
		else
			delete[] (struct __vbox__IHostNetworkInterface_USCOREgetHardwareAddress*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetMediumType:
		if (p->size < 0)
			delete (struct __vbox__IHostNetworkInterface_USCOREgetMediumType*)p->ptr;
		else
			delete[] (struct __vbox__IHostNetworkInterface_USCOREgetMediumType*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetStatus:
		if (p->size < 0)
			delete (struct __vbox__IHostNetworkInterface_USCOREgetStatus*)p->ptr;
		else
			delete[] (struct __vbox__IHostNetworkInterface_USCOREgetStatus*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetInterfaceType:
		if (p->size < 0)
			delete (struct __vbox__IHostNetworkInterface_USCOREgetInterfaceType*)p->ptr;
		else
			delete[] (struct __vbox__IHostNetworkInterface_USCOREgetInterfaceType*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREenableStaticIpConfig:
		if (p->size < 0)
			delete (struct __vbox__IHostNetworkInterface_USCOREenableStaticIpConfig*)p->ptr;
		else
			delete[] (struct __vbox__IHostNetworkInterface_USCOREenableStaticIpConfig*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREenableStaticIpConfigV6:
		if (p->size < 0)
			delete (struct __vbox__IHostNetworkInterface_USCOREenableStaticIpConfigV6*)p->ptr;
		else
			delete[] (struct __vbox__IHostNetworkInterface_USCOREenableStaticIpConfigV6*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREenableDynamicIpConfig:
		if (p->size < 0)
			delete (struct __vbox__IHostNetworkInterface_USCOREenableDynamicIpConfig*)p->ptr;
		else
			delete[] (struct __vbox__IHostNetworkInterface_USCOREenableDynamicIpConfig*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREdhcpRediscover:
		if (p->size < 0)
			delete (struct __vbox__IHostNetworkInterface_USCOREdhcpRediscover*)p->ptr;
		else
			delete[] (struct __vbox__IHostNetworkInterface_USCOREdhcpRediscover*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetDVDDrives:
		if (p->size < 0)
			delete (struct __vbox__IHost_USCOREgetDVDDrives*)p->ptr;
		else
			delete[] (struct __vbox__IHost_USCOREgetDVDDrives*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetFloppyDrives:
		if (p->size < 0)
			delete (struct __vbox__IHost_USCOREgetFloppyDrives*)p->ptr;
		else
			delete[] (struct __vbox__IHost_USCOREgetFloppyDrives*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetUSBDevices:
		if (p->size < 0)
			delete (struct __vbox__IHost_USCOREgetUSBDevices*)p->ptr;
		else
			delete[] (struct __vbox__IHost_USCOREgetUSBDevices*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetUSBDeviceFilters:
		if (p->size < 0)
			delete (struct __vbox__IHost_USCOREgetUSBDeviceFilters*)p->ptr;
		else
			delete[] (struct __vbox__IHost_USCOREgetUSBDeviceFilters*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetNetworkInterfaces:
		if (p->size < 0)
			delete (struct __vbox__IHost_USCOREgetNetworkInterfaces*)p->ptr;
		else
			delete[] (struct __vbox__IHost_USCOREgetNetworkInterfaces*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetProcessorCount:
		if (p->size < 0)
			delete (struct __vbox__IHost_USCOREgetProcessorCount*)p->ptr;
		else
			delete[] (struct __vbox__IHost_USCOREgetProcessorCount*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetProcessorOnlineCount:
		if (p->size < 0)
			delete (struct __vbox__IHost_USCOREgetProcessorOnlineCount*)p->ptr;
		else
			delete[] (struct __vbox__IHost_USCOREgetProcessorOnlineCount*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetMemorySize:
		if (p->size < 0)
			delete (struct __vbox__IHost_USCOREgetMemorySize*)p->ptr;
		else
			delete[] (struct __vbox__IHost_USCOREgetMemorySize*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetMemoryAvailable:
		if (p->size < 0)
			delete (struct __vbox__IHost_USCOREgetMemoryAvailable*)p->ptr;
		else
			delete[] (struct __vbox__IHost_USCOREgetMemoryAvailable*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetOperatingSystem:
		if (p->size < 0)
			delete (struct __vbox__IHost_USCOREgetOperatingSystem*)p->ptr;
		else
			delete[] (struct __vbox__IHost_USCOREgetOperatingSystem*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetOSVersion:
		if (p->size < 0)
			delete (struct __vbox__IHost_USCOREgetOSVersion*)p->ptr;
		else
			delete[] (struct __vbox__IHost_USCOREgetOSVersion*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetUTCTime:
		if (p->size < 0)
			delete (struct __vbox__IHost_USCOREgetUTCTime*)p->ptr;
		else
			delete[] (struct __vbox__IHost_USCOREgetUTCTime*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetAcceleration3DAvailable:
		if (p->size < 0)
			delete (struct __vbox__IHost_USCOREgetAcceleration3DAvailable*)p->ptr;
		else
			delete[] (struct __vbox__IHost_USCOREgetAcceleration3DAvailable*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetProcessorSpeed:
		if (p->size < 0)
			delete (struct __vbox__IHost_USCOREgetProcessorSpeed*)p->ptr;
		else
			delete[] (struct __vbox__IHost_USCOREgetProcessorSpeed*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetProcessorFeature:
		if (p->size < 0)
			delete (struct __vbox__IHost_USCOREgetProcessorFeature*)p->ptr;
		else
			delete[] (struct __vbox__IHost_USCOREgetProcessorFeature*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetProcessorDescription:
		if (p->size < 0)
			delete (struct __vbox__IHost_USCOREgetProcessorDescription*)p->ptr;
		else
			delete[] (struct __vbox__IHost_USCOREgetProcessorDescription*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetProcessorCpuIdLeaf:
		if (p->size < 0)
			delete (struct __vbox__IHost_USCOREgetProcessorCpuIdLeaf*)p->ptr;
		else
			delete[] (struct __vbox__IHost_USCOREgetProcessorCpuIdLeaf*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREcreateHostOnlyNetworkInterface:
		if (p->size < 0)
			delete (struct __vbox__IHost_USCOREcreateHostOnlyNetworkInterface*)p->ptr;
		else
			delete[] (struct __vbox__IHost_USCOREcreateHostOnlyNetworkInterface*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREremoveHostOnlyNetworkInterface:
		if (p->size < 0)
			delete (struct __vbox__IHost_USCOREremoveHostOnlyNetworkInterface*)p->ptr;
		else
			delete[] (struct __vbox__IHost_USCOREremoveHostOnlyNetworkInterface*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREcreateUSBDeviceFilter:
		if (p->size < 0)
			delete (struct __vbox__IHost_USCOREcreateUSBDeviceFilter*)p->ptr;
		else
			delete[] (struct __vbox__IHost_USCOREcreateUSBDeviceFilter*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREinsertUSBDeviceFilter:
		if (p->size < 0)
			delete (struct __vbox__IHost_USCOREinsertUSBDeviceFilter*)p->ptr;
		else
			delete[] (struct __vbox__IHost_USCOREinsertUSBDeviceFilter*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREremoveUSBDeviceFilter:
		if (p->size < 0)
			delete (struct __vbox__IHost_USCOREremoveUSBDeviceFilter*)p->ptr;
		else
			delete[] (struct __vbox__IHost_USCOREremoveUSBDeviceFilter*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREfindHostDVDDrive:
		if (p->size < 0)
			delete (struct __vbox__IHost_USCOREfindHostDVDDrive*)p->ptr;
		else
			delete[] (struct __vbox__IHost_USCOREfindHostDVDDrive*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREfindHostFloppyDrive:
		if (p->size < 0)
			delete (struct __vbox__IHost_USCOREfindHostFloppyDrive*)p->ptr;
		else
			delete[] (struct __vbox__IHost_USCOREfindHostFloppyDrive*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREfindHostNetworkInterfaceByName:
		if (p->size < 0)
			delete (struct __vbox__IHost_USCOREfindHostNetworkInterfaceByName*)p->ptr;
		else
			delete[] (struct __vbox__IHost_USCOREfindHostNetworkInterfaceByName*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREfindHostNetworkInterfaceById:
		if (p->size < 0)
			delete (struct __vbox__IHost_USCOREfindHostNetworkInterfaceById*)p->ptr;
		else
			delete[] (struct __vbox__IHost_USCOREfindHostNetworkInterfaceById*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREfindHostNetworkInterfacesOfType:
		if (p->size < 0)
			delete (struct __vbox__IHost_USCOREfindHostNetworkInterfacesOfType*)p->ptr;
		else
			delete[] (struct __vbox__IHost_USCOREfindHostNetworkInterfacesOfType*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREfindUSBDeviceById:
		if (p->size < 0)
			delete (struct __vbox__IHost_USCOREfindUSBDeviceById*)p->ptr;
		else
			delete[] (struct __vbox__IHost_USCOREfindUSBDeviceById*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREfindUSBDeviceByAddress:
		if (p->size < 0)
			delete (struct __vbox__IHost_USCOREfindUSBDeviceByAddress*)p->ptr;
		else
			delete[] (struct __vbox__IHost_USCOREfindUSBDeviceByAddress*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMinGuestRAM:
		if (p->size < 0)
			delete (struct __vbox__ISystemProperties_USCOREgetMinGuestRAM*)p->ptr;
		else
			delete[] (struct __vbox__ISystemProperties_USCOREgetMinGuestRAM*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMaxGuestRAM:
		if (p->size < 0)
			delete (struct __vbox__ISystemProperties_USCOREgetMaxGuestRAM*)p->ptr;
		else
			delete[] (struct __vbox__ISystemProperties_USCOREgetMaxGuestRAM*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMinGuestVRAM:
		if (p->size < 0)
			delete (struct __vbox__ISystemProperties_USCOREgetMinGuestVRAM*)p->ptr;
		else
			delete[] (struct __vbox__ISystemProperties_USCOREgetMinGuestVRAM*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMaxGuestVRAM:
		if (p->size < 0)
			delete (struct __vbox__ISystemProperties_USCOREgetMaxGuestVRAM*)p->ptr;
		else
			delete[] (struct __vbox__ISystemProperties_USCOREgetMaxGuestVRAM*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMinGuestCPUCount:
		if (p->size < 0)
			delete (struct __vbox__ISystemProperties_USCOREgetMinGuestCPUCount*)p->ptr;
		else
			delete[] (struct __vbox__ISystemProperties_USCOREgetMinGuestCPUCount*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMaxGuestCPUCount:
		if (p->size < 0)
			delete (struct __vbox__ISystemProperties_USCOREgetMaxGuestCPUCount*)p->ptr;
		else
			delete[] (struct __vbox__ISystemProperties_USCOREgetMaxGuestCPUCount*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMaxVDISize:
		if (p->size < 0)
			delete (struct __vbox__ISystemProperties_USCOREgetMaxVDISize*)p->ptr;
		else
			delete[] (struct __vbox__ISystemProperties_USCOREgetMaxVDISize*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetNetworkAdapterCount:
		if (p->size < 0)
			delete (struct __vbox__ISystemProperties_USCOREgetNetworkAdapterCount*)p->ptr;
		else
			delete[] (struct __vbox__ISystemProperties_USCOREgetNetworkAdapterCount*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetSerialPortCount:
		if (p->size < 0)
			delete (struct __vbox__ISystemProperties_USCOREgetSerialPortCount*)p->ptr;
		else
			delete[] (struct __vbox__ISystemProperties_USCOREgetSerialPortCount*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetParallelPortCount:
		if (p->size < 0)
			delete (struct __vbox__ISystemProperties_USCOREgetParallelPortCount*)p->ptr;
		else
			delete[] (struct __vbox__ISystemProperties_USCOREgetParallelPortCount*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMaxBootPosition:
		if (p->size < 0)
			delete (struct __vbox__ISystemProperties_USCOREgetMaxBootPosition*)p->ptr;
		else
			delete[] (struct __vbox__ISystemProperties_USCOREgetMaxBootPosition*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetDefaultMachineFolder:
		if (p->size < 0)
			delete (struct __vbox__ISystemProperties_USCOREgetDefaultMachineFolder*)p->ptr;
		else
			delete[] (struct __vbox__ISystemProperties_USCOREgetDefaultMachineFolder*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREsetDefaultMachineFolder:
		if (p->size < 0)
			delete (struct __vbox__ISystemProperties_USCOREsetDefaultMachineFolder*)p->ptr;
		else
			delete[] (struct __vbox__ISystemProperties_USCOREsetDefaultMachineFolder*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetDefaultHardDiskFolder:
		if (p->size < 0)
			delete (struct __vbox__ISystemProperties_USCOREgetDefaultHardDiskFolder*)p->ptr;
		else
			delete[] (struct __vbox__ISystemProperties_USCOREgetDefaultHardDiskFolder*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREsetDefaultHardDiskFolder:
		if (p->size < 0)
			delete (struct __vbox__ISystemProperties_USCOREsetDefaultHardDiskFolder*)p->ptr;
		else
			delete[] (struct __vbox__ISystemProperties_USCOREsetDefaultHardDiskFolder*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMediumFormats:
		if (p->size < 0)
			delete (struct __vbox__ISystemProperties_USCOREgetMediumFormats*)p->ptr;
		else
			delete[] (struct __vbox__ISystemProperties_USCOREgetMediumFormats*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetDefaultHardDiskFormat:
		if (p->size < 0)
			delete (struct __vbox__ISystemProperties_USCOREgetDefaultHardDiskFormat*)p->ptr;
		else
			delete[] (struct __vbox__ISystemProperties_USCOREgetDefaultHardDiskFormat*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREsetDefaultHardDiskFormat:
		if (p->size < 0)
			delete (struct __vbox__ISystemProperties_USCOREsetDefaultHardDiskFormat*)p->ptr;
		else
			delete[] (struct __vbox__ISystemProperties_USCOREsetDefaultHardDiskFormat*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetRemoteDisplayAuthLibrary:
		if (p->size < 0)
			delete (struct __vbox__ISystemProperties_USCOREgetRemoteDisplayAuthLibrary*)p->ptr;
		else
			delete[] (struct __vbox__ISystemProperties_USCOREgetRemoteDisplayAuthLibrary*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREsetRemoteDisplayAuthLibrary:
		if (p->size < 0)
			delete (struct __vbox__ISystemProperties_USCOREsetRemoteDisplayAuthLibrary*)p->ptr;
		else
			delete[] (struct __vbox__ISystemProperties_USCOREsetRemoteDisplayAuthLibrary*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetWebServiceAuthLibrary:
		if (p->size < 0)
			delete (struct __vbox__ISystemProperties_USCOREgetWebServiceAuthLibrary*)p->ptr;
		else
			delete[] (struct __vbox__ISystemProperties_USCOREgetWebServiceAuthLibrary*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREsetWebServiceAuthLibrary:
		if (p->size < 0)
			delete (struct __vbox__ISystemProperties_USCOREsetWebServiceAuthLibrary*)p->ptr;
		else
			delete[] (struct __vbox__ISystemProperties_USCOREsetWebServiceAuthLibrary*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetLogHistoryCount:
		if (p->size < 0)
			delete (struct __vbox__ISystemProperties_USCOREgetLogHistoryCount*)p->ptr;
		else
			delete[] (struct __vbox__ISystemProperties_USCOREgetLogHistoryCount*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREsetLogHistoryCount:
		if (p->size < 0)
			delete (struct __vbox__ISystemProperties_USCOREsetLogHistoryCount*)p->ptr;
		else
			delete[] (struct __vbox__ISystemProperties_USCOREsetLogHistoryCount*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetDefaultAudioDriver:
		if (p->size < 0)
			delete (struct __vbox__ISystemProperties_USCOREgetDefaultAudioDriver*)p->ptr;
		else
			delete[] (struct __vbox__ISystemProperties_USCOREgetDefaultAudioDriver*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMaxDevicesPerPortForStorageBus:
		if (p->size < 0)
			delete (struct __vbox__ISystemProperties_USCOREgetMaxDevicesPerPortForStorageBus*)p->ptr;
		else
			delete[] (struct __vbox__ISystemProperties_USCOREgetMaxDevicesPerPortForStorageBus*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMinPortCountForStorageBus:
		if (p->size < 0)
			delete (struct __vbox__ISystemProperties_USCOREgetMinPortCountForStorageBus*)p->ptr;
		else
			delete[] (struct __vbox__ISystemProperties_USCOREgetMinPortCountForStorageBus*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMaxPortCountForStorageBus:
		if (p->size < 0)
			delete (struct __vbox__ISystemProperties_USCOREgetMaxPortCountForStorageBus*)p->ptr;
		else
			delete[] (struct __vbox__ISystemProperties_USCOREgetMaxPortCountForStorageBus*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMaxInstancesOfStorageBus:
		if (p->size < 0)
			delete (struct __vbox__ISystemProperties_USCOREgetMaxInstancesOfStorageBus*)p->ptr;
		else
			delete[] (struct __vbox__ISystemProperties_USCOREgetMaxInstancesOfStorageBus*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetDeviceTypesForStorageBus:
		if (p->size < 0)
			delete (struct __vbox__ISystemProperties_USCOREgetDeviceTypesForStorageBus*)p->ptr;
		else
			delete[] (struct __vbox__ISystemProperties_USCOREgetDeviceTypesForStorageBus*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IGuest_USCOREgetOSTypeId:
		if (p->size < 0)
			delete (struct __vbox__IGuest_USCOREgetOSTypeId*)p->ptr;
		else
			delete[] (struct __vbox__IGuest_USCOREgetOSTypeId*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IGuest_USCOREgetAdditionsActive:
		if (p->size < 0)
			delete (struct __vbox__IGuest_USCOREgetAdditionsActive*)p->ptr;
		else
			delete[] (struct __vbox__IGuest_USCOREgetAdditionsActive*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IGuest_USCOREgetAdditionsVersion:
		if (p->size < 0)
			delete (struct __vbox__IGuest_USCOREgetAdditionsVersion*)p->ptr;
		else
			delete[] (struct __vbox__IGuest_USCOREgetAdditionsVersion*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IGuest_USCOREgetSupportsSeamless:
		if (p->size < 0)
			delete (struct __vbox__IGuest_USCOREgetSupportsSeamless*)p->ptr;
		else
			delete[] (struct __vbox__IGuest_USCOREgetSupportsSeamless*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IGuest_USCOREgetSupportsGraphics:
		if (p->size < 0)
			delete (struct __vbox__IGuest_USCOREgetSupportsGraphics*)p->ptr;
		else
			delete[] (struct __vbox__IGuest_USCOREgetSupportsGraphics*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IGuest_USCOREgetMemoryBalloonSize:
		if (p->size < 0)
			delete (struct __vbox__IGuest_USCOREgetMemoryBalloonSize*)p->ptr;
		else
			delete[] (struct __vbox__IGuest_USCOREgetMemoryBalloonSize*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IGuest_USCOREsetMemoryBalloonSize:
		if (p->size < 0)
			delete (struct __vbox__IGuest_USCOREsetMemoryBalloonSize*)p->ptr;
		else
			delete[] (struct __vbox__IGuest_USCOREsetMemoryBalloonSize*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IGuest_USCOREgetStatisticsUpdateInterval:
		if (p->size < 0)
			delete (struct __vbox__IGuest_USCOREgetStatisticsUpdateInterval*)p->ptr;
		else
			delete[] (struct __vbox__IGuest_USCOREgetStatisticsUpdateInterval*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IGuest_USCOREsetStatisticsUpdateInterval:
		if (p->size < 0)
			delete (struct __vbox__IGuest_USCOREsetStatisticsUpdateInterval*)p->ptr;
		else
			delete[] (struct __vbox__IGuest_USCOREsetStatisticsUpdateInterval*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IGuest_USCOREsetCredentials:
		if (p->size < 0)
			delete (struct __vbox__IGuest_USCOREsetCredentials*)p->ptr;
		else
			delete[] (struct __vbox__IGuest_USCOREsetCredentials*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IGuest_USCOREgetStatistic:
		if (p->size < 0)
			delete (struct __vbox__IGuest_USCOREgetStatistic*)p->ptr;
		else
			delete[] (struct __vbox__IGuest_USCOREgetStatistic*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREgetId:
		if (p->size < 0)
			delete (struct __vbox__IProgress_USCOREgetId*)p->ptr;
		else
			delete[] (struct __vbox__IProgress_USCOREgetId*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREgetDescription:
		if (p->size < 0)
			delete (struct __vbox__IProgress_USCOREgetDescription*)p->ptr;
		else
			delete[] (struct __vbox__IProgress_USCOREgetDescription*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREgetInitiator:
		if (p->size < 0)
			delete (struct __vbox__IProgress_USCOREgetInitiator*)p->ptr;
		else
			delete[] (struct __vbox__IProgress_USCOREgetInitiator*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREgetCancelable:
		if (p->size < 0)
			delete (struct __vbox__IProgress_USCOREgetCancelable*)p->ptr;
		else
			delete[] (struct __vbox__IProgress_USCOREgetCancelable*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREgetPercent:
		if (p->size < 0)
			delete (struct __vbox__IProgress_USCOREgetPercent*)p->ptr;
		else
			delete[] (struct __vbox__IProgress_USCOREgetPercent*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREgetTimeRemaining:
		if (p->size < 0)
			delete (struct __vbox__IProgress_USCOREgetTimeRemaining*)p->ptr;
		else
			delete[] (struct __vbox__IProgress_USCOREgetTimeRemaining*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREgetCompleted:
		if (p->size < 0)
			delete (struct __vbox__IProgress_USCOREgetCompleted*)p->ptr;
		else
			delete[] (struct __vbox__IProgress_USCOREgetCompleted*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREgetCanceled:
		if (p->size < 0)
			delete (struct __vbox__IProgress_USCOREgetCanceled*)p->ptr;
		else
			delete[] (struct __vbox__IProgress_USCOREgetCanceled*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREgetResultCode:
		if (p->size < 0)
			delete (struct __vbox__IProgress_USCOREgetResultCode*)p->ptr;
		else
			delete[] (struct __vbox__IProgress_USCOREgetResultCode*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREgetErrorInfo:
		if (p->size < 0)
			delete (struct __vbox__IProgress_USCOREgetErrorInfo*)p->ptr;
		else
			delete[] (struct __vbox__IProgress_USCOREgetErrorInfo*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREgetOperationCount:
		if (p->size < 0)
			delete (struct __vbox__IProgress_USCOREgetOperationCount*)p->ptr;
		else
			delete[] (struct __vbox__IProgress_USCOREgetOperationCount*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREgetOperation:
		if (p->size < 0)
			delete (struct __vbox__IProgress_USCOREgetOperation*)p->ptr;
		else
			delete[] (struct __vbox__IProgress_USCOREgetOperation*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREgetOperationDescription:
		if (p->size < 0)
			delete (struct __vbox__IProgress_USCOREgetOperationDescription*)p->ptr;
		else
			delete[] (struct __vbox__IProgress_USCOREgetOperationDescription*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREgetOperationPercent:
		if (p->size < 0)
			delete (struct __vbox__IProgress_USCOREgetOperationPercent*)p->ptr;
		else
			delete[] (struct __vbox__IProgress_USCOREgetOperationPercent*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREgetTimeout:
		if (p->size < 0)
			delete (struct __vbox__IProgress_USCOREgetTimeout*)p->ptr;
		else
			delete[] (struct __vbox__IProgress_USCOREgetTimeout*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREsetTimeout:
		if (p->size < 0)
			delete (struct __vbox__IProgress_USCOREsetTimeout*)p->ptr;
		else
			delete[] (struct __vbox__IProgress_USCOREsetTimeout*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREsetCurrentOperationProgress:
		if (p->size < 0)
			delete (struct __vbox__IProgress_USCOREsetCurrentOperationProgress*)p->ptr;
		else
			delete[] (struct __vbox__IProgress_USCOREsetCurrentOperationProgress*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREsetNextOperation:
		if (p->size < 0)
			delete (struct __vbox__IProgress_USCOREsetNextOperation*)p->ptr;
		else
			delete[] (struct __vbox__IProgress_USCOREsetNextOperation*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREwaitForCompletion:
		if (p->size < 0)
			delete (struct __vbox__IProgress_USCOREwaitForCompletion*)p->ptr;
		else
			delete[] (struct __vbox__IProgress_USCOREwaitForCompletion*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREwaitForOperationCompletion:
		if (p->size < 0)
			delete (struct __vbox__IProgress_USCOREwaitForOperationCompletion*)p->ptr;
		else
			delete[] (struct __vbox__IProgress_USCOREwaitForOperationCompletion*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREcancel:
		if (p->size < 0)
			delete (struct __vbox__IProgress_USCOREcancel*)p->ptr;
		else
			delete[] (struct __vbox__IProgress_USCOREcancel*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISnapshot_USCOREgetId:
		if (p->size < 0)
			delete (struct __vbox__ISnapshot_USCOREgetId*)p->ptr;
		else
			delete[] (struct __vbox__ISnapshot_USCOREgetId*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISnapshot_USCOREgetName:
		if (p->size < 0)
			delete (struct __vbox__ISnapshot_USCOREgetName*)p->ptr;
		else
			delete[] (struct __vbox__ISnapshot_USCOREgetName*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISnapshot_USCOREsetName:
		if (p->size < 0)
			delete (struct __vbox__ISnapshot_USCOREsetName*)p->ptr;
		else
			delete[] (struct __vbox__ISnapshot_USCOREsetName*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISnapshot_USCOREgetDescription:
		if (p->size < 0)
			delete (struct __vbox__ISnapshot_USCOREgetDescription*)p->ptr;
		else
			delete[] (struct __vbox__ISnapshot_USCOREgetDescription*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISnapshot_USCOREsetDescription:
		if (p->size < 0)
			delete (struct __vbox__ISnapshot_USCOREsetDescription*)p->ptr;
		else
			delete[] (struct __vbox__ISnapshot_USCOREsetDescription*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISnapshot_USCOREgetTimeStamp:
		if (p->size < 0)
			delete (struct __vbox__ISnapshot_USCOREgetTimeStamp*)p->ptr;
		else
			delete[] (struct __vbox__ISnapshot_USCOREgetTimeStamp*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISnapshot_USCOREgetOnline:
		if (p->size < 0)
			delete (struct __vbox__ISnapshot_USCOREgetOnline*)p->ptr;
		else
			delete[] (struct __vbox__ISnapshot_USCOREgetOnline*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISnapshot_USCOREgetMachine:
		if (p->size < 0)
			delete (struct __vbox__ISnapshot_USCOREgetMachine*)p->ptr;
		else
			delete[] (struct __vbox__ISnapshot_USCOREgetMachine*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISnapshot_USCOREgetParent:
		if (p->size < 0)
			delete (struct __vbox__ISnapshot_USCOREgetParent*)p->ptr;
		else
			delete[] (struct __vbox__ISnapshot_USCOREgetParent*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISnapshot_USCOREgetChildren:
		if (p->size < 0)
			delete (struct __vbox__ISnapshot_USCOREgetChildren*)p->ptr;
		else
			delete[] (struct __vbox__ISnapshot_USCOREgetChildren*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetId:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREgetId*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREgetId*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetDescription:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREgetDescription*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREgetDescription*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREsetDescription:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREsetDescription*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREsetDescription*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetState:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREgetState*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREgetState*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetLocation:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREgetLocation*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREgetLocation*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREsetLocation:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREsetLocation*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREsetLocation*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetName:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREgetName*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREgetName*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetDeviceType:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREgetDeviceType*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREgetDeviceType*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetHostDrive:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREgetHostDrive*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREgetHostDrive*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetSize:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREgetSize*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREgetSize*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetFormat:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREgetFormat*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREgetFormat*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetType:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREgetType*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREgetType*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREsetType:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREsetType*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREsetType*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetParent:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREgetParent*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREgetParent*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetChildren:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREgetChildren*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREgetChildren*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetBase:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREgetBase*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREgetBase*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetReadOnly:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREgetReadOnly*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREgetReadOnly*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetLogicalSize:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREgetLogicalSize*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREgetLogicalSize*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetAutoReset:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREgetAutoReset*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREgetAutoReset*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREsetAutoReset:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREsetAutoReset*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREsetAutoReset*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetLastAccessError:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREgetLastAccessError*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREgetLastAccessError*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetMachineIds:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREgetMachineIds*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREgetMachineIds*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCORErefreshState:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCORErefreshState*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCORErefreshState*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetSnapshotIds:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREgetSnapshotIds*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREgetSnapshotIds*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCORElockRead:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCORElockRead*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCORElockRead*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREunlockRead:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREunlockRead*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREunlockRead*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCORElockWrite:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCORElockWrite*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCORElockWrite*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREunlockWrite:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREunlockWrite*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREunlockWrite*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREclose:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREclose*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREclose*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetProperty:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREgetProperty*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREgetProperty*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREsetProperty:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREsetProperty*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREsetProperty*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetProperties:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREgetProperties*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREgetProperties*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREsetProperties:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREsetProperties*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREsetProperties*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREcreateBaseStorage:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREcreateBaseStorage*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREcreateBaseStorage*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREdeleteStorage:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREdeleteStorage*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREdeleteStorage*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREcreateDiffStorage:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREcreateDiffStorage*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREcreateDiffStorage*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREmergeTo:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREmergeTo*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREmergeTo*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREcloneTo:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREcloneTo*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREcloneTo*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREcompact:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREcompact*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREcompact*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREresize:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREresize*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREresize*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREreset:
		if (p->size < 0)
			delete (struct __vbox__IMedium_USCOREreset*)p->ptr;
		else
			delete[] (struct __vbox__IMedium_USCOREreset*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMediumFormat_USCOREgetId:
		if (p->size < 0)
			delete (struct __vbox__IMediumFormat_USCOREgetId*)p->ptr;
		else
			delete[] (struct __vbox__IMediumFormat_USCOREgetId*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMediumFormat_USCOREgetName:
		if (p->size < 0)
			delete (struct __vbox__IMediumFormat_USCOREgetName*)p->ptr;
		else
			delete[] (struct __vbox__IMediumFormat_USCOREgetName*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMediumFormat_USCOREgetFileExtensions:
		if (p->size < 0)
			delete (struct __vbox__IMediumFormat_USCOREgetFileExtensions*)p->ptr;
		else
			delete[] (struct __vbox__IMediumFormat_USCOREgetFileExtensions*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMediumFormat_USCOREgetCapabilities:
		if (p->size < 0)
			delete (struct __vbox__IMediumFormat_USCOREgetCapabilities*)p->ptr;
		else
			delete[] (struct __vbox__IMediumFormat_USCOREgetCapabilities*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMediumFormat_USCOREdescribeProperties:
		if (p->size < 0)
			delete (struct __vbox__IMediumFormat_USCOREdescribeProperties*)p->ptr;
		else
			delete[] (struct __vbox__IMediumFormat_USCOREdescribeProperties*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IKeyboard_USCOREputScancode:
		if (p->size < 0)
			delete (struct __vbox__IKeyboard_USCOREputScancode*)p->ptr;
		else
			delete[] (struct __vbox__IKeyboard_USCOREputScancode*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IKeyboard_USCOREputScancodes:
		if (p->size < 0)
			delete (struct __vbox__IKeyboard_USCOREputScancodes*)p->ptr;
		else
			delete[] (struct __vbox__IKeyboard_USCOREputScancodes*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IKeyboard_USCOREputCAD:
		if (p->size < 0)
			delete (struct __vbox__IKeyboard_USCOREputCAD*)p->ptr;
		else
			delete[] (struct __vbox__IKeyboard_USCOREputCAD*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMouse_USCOREgetAbsoluteSupported:
		if (p->size < 0)
			delete (struct __vbox__IMouse_USCOREgetAbsoluteSupported*)p->ptr;
		else
			delete[] (struct __vbox__IMouse_USCOREgetAbsoluteSupported*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMouse_USCOREputMouseEvent:
		if (p->size < 0)
			delete (struct __vbox__IMouse_USCOREputMouseEvent*)p->ptr;
		else
			delete[] (struct __vbox__IMouse_USCOREputMouseEvent*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IMouse_USCOREputMouseEventAbsolute:
		if (p->size < 0)
			delete (struct __vbox__IMouse_USCOREputMouseEventAbsolute*)p->ptr;
		else
			delete[] (struct __vbox__IMouse_USCOREputMouseEventAbsolute*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IDisplay_USCOREgetWidth:
		if (p->size < 0)
			delete (struct __vbox__IDisplay_USCOREgetWidth*)p->ptr;
		else
			delete[] (struct __vbox__IDisplay_USCOREgetWidth*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IDisplay_USCOREgetHeight:
		if (p->size < 0)
			delete (struct __vbox__IDisplay_USCOREgetHeight*)p->ptr;
		else
			delete[] (struct __vbox__IDisplay_USCOREgetHeight*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IDisplay_USCOREgetBitsPerPixel:
		if (p->size < 0)
			delete (struct __vbox__IDisplay_USCOREgetBitsPerPixel*)p->ptr;
		else
			delete[] (struct __vbox__IDisplay_USCOREgetBitsPerPixel*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IDisplay_USCOREsetVideoModeHint:
		if (p->size < 0)
			delete (struct __vbox__IDisplay_USCOREsetVideoModeHint*)p->ptr;
		else
			delete[] (struct __vbox__IDisplay_USCOREsetVideoModeHint*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IDisplay_USCOREsetSeamlessMode:
		if (p->size < 0)
			delete (struct __vbox__IDisplay_USCOREsetSeamlessMode*)p->ptr;
		else
			delete[] (struct __vbox__IDisplay_USCOREsetSeamlessMode*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IDisplay_USCOREtakeScreenShotSlow:
		if (p->size < 0)
			delete (struct __vbox__IDisplay_USCOREtakeScreenShotSlow*)p->ptr;
		else
			delete[] (struct __vbox__IDisplay_USCOREtakeScreenShotSlow*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IDisplay_USCOREinvalidateAndUpdate:
		if (p->size < 0)
			delete (struct __vbox__IDisplay_USCOREinvalidateAndUpdate*)p->ptr;
		else
			delete[] (struct __vbox__IDisplay_USCOREinvalidateAndUpdate*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IDisplay_USCOREresizeCompleted:
		if (p->size < 0)
			delete (struct __vbox__IDisplay_USCOREresizeCompleted*)p->ptr;
		else
			delete[] (struct __vbox__IDisplay_USCOREresizeCompleted*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IDisplay_USCOREupdateCompleted:
		if (p->size < 0)
			delete (struct __vbox__IDisplay_USCOREupdateCompleted*)p->ptr;
		else
			delete[] (struct __vbox__IDisplay_USCOREupdateCompleted*)p->ptr;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetAdapterType:
		if (p->size < 0)
			delete (struct __vbox__INetworkAdapter_USCOREgetAdapterType*)p->ptr;
		else
			delete[] (struct __vbox__INetworkAdapter_USCOREgetAdapterType*)p->ptr;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetAdapterType:
		if (p->size < 0)
			delete (struct __vbox__INetworkAdapter_USCOREsetAdapterType*)p->ptr;
		else
			delete[] (struct __vbox__INetworkAdapter_USCOREsetAdapterType*)p->ptr;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetSlot:
		if (p->size < 0)
			delete (struct __vbox__INetworkAdapter_USCOREgetSlot*)p->ptr;
		else
			delete[] (struct __vbox__INetworkAdapter_USCOREgetSlot*)p->ptr;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetEnabled:
		if (p->size < 0)
			delete (struct __vbox__INetworkAdapter_USCOREgetEnabled*)p->ptr;
		else
			delete[] (struct __vbox__INetworkAdapter_USCOREgetEnabled*)p->ptr;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetEnabled:
		if (p->size < 0)
			delete (struct __vbox__INetworkAdapter_USCOREsetEnabled*)p->ptr;
		else
			delete[] (struct __vbox__INetworkAdapter_USCOREsetEnabled*)p->ptr;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetMACAddress:
		if (p->size < 0)
			delete (struct __vbox__INetworkAdapter_USCOREgetMACAddress*)p->ptr;
		else
			delete[] (struct __vbox__INetworkAdapter_USCOREgetMACAddress*)p->ptr;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetMACAddress:
		if (p->size < 0)
			delete (struct __vbox__INetworkAdapter_USCOREsetMACAddress*)p->ptr;
		else
			delete[] (struct __vbox__INetworkAdapter_USCOREsetMACAddress*)p->ptr;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetAttachmentType:
		if (p->size < 0)
			delete (struct __vbox__INetworkAdapter_USCOREgetAttachmentType*)p->ptr;
		else
			delete[] (struct __vbox__INetworkAdapter_USCOREgetAttachmentType*)p->ptr;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetHostInterface:
		if (p->size < 0)
			delete (struct __vbox__INetworkAdapter_USCOREgetHostInterface*)p->ptr;
		else
			delete[] (struct __vbox__INetworkAdapter_USCOREgetHostInterface*)p->ptr;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetHostInterface:
		if (p->size < 0)
			delete (struct __vbox__INetworkAdapter_USCOREsetHostInterface*)p->ptr;
		else
			delete[] (struct __vbox__INetworkAdapter_USCOREsetHostInterface*)p->ptr;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetInternalNetwork:
		if (p->size < 0)
			delete (struct __vbox__INetworkAdapter_USCOREgetInternalNetwork*)p->ptr;
		else
			delete[] (struct __vbox__INetworkAdapter_USCOREgetInternalNetwork*)p->ptr;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetInternalNetwork:
		if (p->size < 0)
			delete (struct __vbox__INetworkAdapter_USCOREsetInternalNetwork*)p->ptr;
		else
			delete[] (struct __vbox__INetworkAdapter_USCOREsetInternalNetwork*)p->ptr;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetNATNetwork:
		if (p->size < 0)
			delete (struct __vbox__INetworkAdapter_USCOREgetNATNetwork*)p->ptr;
		else
			delete[] (struct __vbox__INetworkAdapter_USCOREgetNATNetwork*)p->ptr;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetNATNetwork:
		if (p->size < 0)
			delete (struct __vbox__INetworkAdapter_USCOREsetNATNetwork*)p->ptr;
		else
			delete[] (struct __vbox__INetworkAdapter_USCOREsetNATNetwork*)p->ptr;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetCableConnected:
		if (p->size < 0)
			delete (struct __vbox__INetworkAdapter_USCOREgetCableConnected*)p->ptr;
		else
			delete[] (struct __vbox__INetworkAdapter_USCOREgetCableConnected*)p->ptr;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetCableConnected:
		if (p->size < 0)
			delete (struct __vbox__INetworkAdapter_USCOREsetCableConnected*)p->ptr;
		else
			delete[] (struct __vbox__INetworkAdapter_USCOREsetCableConnected*)p->ptr;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetLineSpeed:
		if (p->size < 0)
			delete (struct __vbox__INetworkAdapter_USCOREgetLineSpeed*)p->ptr;
		else
			delete[] (struct __vbox__INetworkAdapter_USCOREgetLineSpeed*)p->ptr;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetLineSpeed:
		if (p->size < 0)
			delete (struct __vbox__INetworkAdapter_USCOREsetLineSpeed*)p->ptr;
		else
			delete[] (struct __vbox__INetworkAdapter_USCOREsetLineSpeed*)p->ptr;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetTraceEnabled:
		if (p->size < 0)
			delete (struct __vbox__INetworkAdapter_USCOREgetTraceEnabled*)p->ptr;
		else
			delete[] (struct __vbox__INetworkAdapter_USCOREgetTraceEnabled*)p->ptr;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetTraceEnabled:
		if (p->size < 0)
			delete (struct __vbox__INetworkAdapter_USCOREsetTraceEnabled*)p->ptr;
		else
			delete[] (struct __vbox__INetworkAdapter_USCOREsetTraceEnabled*)p->ptr;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetTraceFile:
		if (p->size < 0)
			delete (struct __vbox__INetworkAdapter_USCOREgetTraceFile*)p->ptr;
		else
			delete[] (struct __vbox__INetworkAdapter_USCOREgetTraceFile*)p->ptr;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetTraceFile:
		if (p->size < 0)
			delete (struct __vbox__INetworkAdapter_USCOREsetTraceFile*)p->ptr;
		else
			delete[] (struct __vbox__INetworkAdapter_USCOREsetTraceFile*)p->ptr;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREattachToNAT:
		if (p->size < 0)
			delete (struct __vbox__INetworkAdapter_USCOREattachToNAT*)p->ptr;
		else
			delete[] (struct __vbox__INetworkAdapter_USCOREattachToNAT*)p->ptr;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREattachToBridgedInterface:
		if (p->size < 0)
			delete (struct __vbox__INetworkAdapter_USCOREattachToBridgedInterface*)p->ptr;
		else
			delete[] (struct __vbox__INetworkAdapter_USCOREattachToBridgedInterface*)p->ptr;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREattachToInternalNetwork:
		if (p->size < 0)
			delete (struct __vbox__INetworkAdapter_USCOREattachToInternalNetwork*)p->ptr;
		else
			delete[] (struct __vbox__INetworkAdapter_USCOREattachToInternalNetwork*)p->ptr;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREattachToHostOnlyInterface:
		if (p->size < 0)
			delete (struct __vbox__INetworkAdapter_USCOREattachToHostOnlyInterface*)p->ptr;
		else
			delete[] (struct __vbox__INetworkAdapter_USCOREattachToHostOnlyInterface*)p->ptr;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREdetach:
		if (p->size < 0)
			delete (struct __vbox__INetworkAdapter_USCOREdetach*)p->ptr;
		else
			delete[] (struct __vbox__INetworkAdapter_USCOREdetach*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISerialPort_USCOREgetSlot:
		if (p->size < 0)
			delete (struct __vbox__ISerialPort_USCOREgetSlot*)p->ptr;
		else
			delete[] (struct __vbox__ISerialPort_USCOREgetSlot*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISerialPort_USCOREgetEnabled:
		if (p->size < 0)
			delete (struct __vbox__ISerialPort_USCOREgetEnabled*)p->ptr;
		else
			delete[] (struct __vbox__ISerialPort_USCOREgetEnabled*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISerialPort_USCOREsetEnabled:
		if (p->size < 0)
			delete (struct __vbox__ISerialPort_USCOREsetEnabled*)p->ptr;
		else
			delete[] (struct __vbox__ISerialPort_USCOREsetEnabled*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISerialPort_USCOREgetIOBase:
		if (p->size < 0)
			delete (struct __vbox__ISerialPort_USCOREgetIOBase*)p->ptr;
		else
			delete[] (struct __vbox__ISerialPort_USCOREgetIOBase*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISerialPort_USCOREsetIOBase:
		if (p->size < 0)
			delete (struct __vbox__ISerialPort_USCOREsetIOBase*)p->ptr;
		else
			delete[] (struct __vbox__ISerialPort_USCOREsetIOBase*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISerialPort_USCOREgetIRQ:
		if (p->size < 0)
			delete (struct __vbox__ISerialPort_USCOREgetIRQ*)p->ptr;
		else
			delete[] (struct __vbox__ISerialPort_USCOREgetIRQ*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISerialPort_USCOREsetIRQ:
		if (p->size < 0)
			delete (struct __vbox__ISerialPort_USCOREsetIRQ*)p->ptr;
		else
			delete[] (struct __vbox__ISerialPort_USCOREsetIRQ*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISerialPort_USCOREgetHostMode:
		if (p->size < 0)
			delete (struct __vbox__ISerialPort_USCOREgetHostMode*)p->ptr;
		else
			delete[] (struct __vbox__ISerialPort_USCOREgetHostMode*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISerialPort_USCOREsetHostMode:
		if (p->size < 0)
			delete (struct __vbox__ISerialPort_USCOREsetHostMode*)p->ptr;
		else
			delete[] (struct __vbox__ISerialPort_USCOREsetHostMode*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISerialPort_USCOREgetServer:
		if (p->size < 0)
			delete (struct __vbox__ISerialPort_USCOREgetServer*)p->ptr;
		else
			delete[] (struct __vbox__ISerialPort_USCOREgetServer*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISerialPort_USCOREsetServer:
		if (p->size < 0)
			delete (struct __vbox__ISerialPort_USCOREsetServer*)p->ptr;
		else
			delete[] (struct __vbox__ISerialPort_USCOREsetServer*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISerialPort_USCOREgetPath:
		if (p->size < 0)
			delete (struct __vbox__ISerialPort_USCOREgetPath*)p->ptr;
		else
			delete[] (struct __vbox__ISerialPort_USCOREgetPath*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISerialPort_USCOREsetPath:
		if (p->size < 0)
			delete (struct __vbox__ISerialPort_USCOREsetPath*)p->ptr;
		else
			delete[] (struct __vbox__ISerialPort_USCOREsetPath*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IParallelPort_USCOREgetSlot:
		if (p->size < 0)
			delete (struct __vbox__IParallelPort_USCOREgetSlot*)p->ptr;
		else
			delete[] (struct __vbox__IParallelPort_USCOREgetSlot*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IParallelPort_USCOREgetEnabled:
		if (p->size < 0)
			delete (struct __vbox__IParallelPort_USCOREgetEnabled*)p->ptr;
		else
			delete[] (struct __vbox__IParallelPort_USCOREgetEnabled*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IParallelPort_USCOREsetEnabled:
		if (p->size < 0)
			delete (struct __vbox__IParallelPort_USCOREsetEnabled*)p->ptr;
		else
			delete[] (struct __vbox__IParallelPort_USCOREsetEnabled*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IParallelPort_USCOREgetIOBase:
		if (p->size < 0)
			delete (struct __vbox__IParallelPort_USCOREgetIOBase*)p->ptr;
		else
			delete[] (struct __vbox__IParallelPort_USCOREgetIOBase*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IParallelPort_USCOREsetIOBase:
		if (p->size < 0)
			delete (struct __vbox__IParallelPort_USCOREsetIOBase*)p->ptr;
		else
			delete[] (struct __vbox__IParallelPort_USCOREsetIOBase*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IParallelPort_USCOREgetIRQ:
		if (p->size < 0)
			delete (struct __vbox__IParallelPort_USCOREgetIRQ*)p->ptr;
		else
			delete[] (struct __vbox__IParallelPort_USCOREgetIRQ*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IParallelPort_USCOREsetIRQ:
		if (p->size < 0)
			delete (struct __vbox__IParallelPort_USCOREsetIRQ*)p->ptr;
		else
			delete[] (struct __vbox__IParallelPort_USCOREsetIRQ*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IParallelPort_USCOREgetPath:
		if (p->size < 0)
			delete (struct __vbox__IParallelPort_USCOREgetPath*)p->ptr;
		else
			delete[] (struct __vbox__IParallelPort_USCOREgetPath*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IParallelPort_USCOREsetPath:
		if (p->size < 0)
			delete (struct __vbox__IParallelPort_USCOREsetPath*)p->ptr;
		else
			delete[] (struct __vbox__IParallelPort_USCOREsetPath*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBController_USCOREgetEnabled:
		if (p->size < 0)
			delete (struct __vbox__IUSBController_USCOREgetEnabled*)p->ptr;
		else
			delete[] (struct __vbox__IUSBController_USCOREgetEnabled*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBController_USCOREsetEnabled:
		if (p->size < 0)
			delete (struct __vbox__IUSBController_USCOREsetEnabled*)p->ptr;
		else
			delete[] (struct __vbox__IUSBController_USCOREsetEnabled*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBController_USCOREgetEnabledEhci:
		if (p->size < 0)
			delete (struct __vbox__IUSBController_USCOREgetEnabledEhci*)p->ptr;
		else
			delete[] (struct __vbox__IUSBController_USCOREgetEnabledEhci*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBController_USCOREsetEnabledEhci:
		if (p->size < 0)
			delete (struct __vbox__IUSBController_USCOREsetEnabledEhci*)p->ptr;
		else
			delete[] (struct __vbox__IUSBController_USCOREsetEnabledEhci*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBController_USCOREgetUSBStandard:
		if (p->size < 0)
			delete (struct __vbox__IUSBController_USCOREgetUSBStandard*)p->ptr;
		else
			delete[] (struct __vbox__IUSBController_USCOREgetUSBStandard*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBController_USCOREgetDeviceFilters:
		if (p->size < 0)
			delete (struct __vbox__IUSBController_USCOREgetDeviceFilters*)p->ptr;
		else
			delete[] (struct __vbox__IUSBController_USCOREgetDeviceFilters*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBController_USCOREcreateDeviceFilter:
		if (p->size < 0)
			delete (struct __vbox__IUSBController_USCOREcreateDeviceFilter*)p->ptr;
		else
			delete[] (struct __vbox__IUSBController_USCOREcreateDeviceFilter*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBController_USCOREinsertDeviceFilter:
		if (p->size < 0)
			delete (struct __vbox__IUSBController_USCOREinsertDeviceFilter*)p->ptr;
		else
			delete[] (struct __vbox__IUSBController_USCOREinsertDeviceFilter*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBController_USCOREremoveDeviceFilter:
		if (p->size < 0)
			delete (struct __vbox__IUSBController_USCOREremoveDeviceFilter*)p->ptr;
		else
			delete[] (struct __vbox__IUSBController_USCOREremoveDeviceFilter*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetId:
		if (p->size < 0)
			delete (struct __vbox__IUSBDevice_USCOREgetId*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDevice_USCOREgetId*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetVendorId:
		if (p->size < 0)
			delete (struct __vbox__IUSBDevice_USCOREgetVendorId*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDevice_USCOREgetVendorId*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetProductId:
		if (p->size < 0)
			delete (struct __vbox__IUSBDevice_USCOREgetProductId*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDevice_USCOREgetProductId*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetRevision:
		if (p->size < 0)
			delete (struct __vbox__IUSBDevice_USCOREgetRevision*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDevice_USCOREgetRevision*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetManufacturer:
		if (p->size < 0)
			delete (struct __vbox__IUSBDevice_USCOREgetManufacturer*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDevice_USCOREgetManufacturer*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetProduct:
		if (p->size < 0)
			delete (struct __vbox__IUSBDevice_USCOREgetProduct*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDevice_USCOREgetProduct*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetSerialNumber:
		if (p->size < 0)
			delete (struct __vbox__IUSBDevice_USCOREgetSerialNumber*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDevice_USCOREgetSerialNumber*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetAddress:
		if (p->size < 0)
			delete (struct __vbox__IUSBDevice_USCOREgetAddress*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDevice_USCOREgetAddress*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetPort:
		if (p->size < 0)
			delete (struct __vbox__IUSBDevice_USCOREgetPort*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDevice_USCOREgetPort*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetVersion:
		if (p->size < 0)
			delete (struct __vbox__IUSBDevice_USCOREgetVersion*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDevice_USCOREgetVersion*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetPortVersion:
		if (p->size < 0)
			delete (struct __vbox__IUSBDevice_USCOREgetPortVersion*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDevice_USCOREgetPortVersion*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetRemote:
		if (p->size < 0)
			delete (struct __vbox__IUSBDevice_USCOREgetRemote*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDevice_USCOREgetRemote*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREgetName:
		if (p->size < 0)
			delete (struct __vbox__IUSBDeviceFilter_USCOREgetName*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDeviceFilter_USCOREgetName*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREsetName:
		if (p->size < 0)
			delete (struct __vbox__IUSBDeviceFilter_USCOREsetName*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDeviceFilter_USCOREsetName*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREgetActive:
		if (p->size < 0)
			delete (struct __vbox__IUSBDeviceFilter_USCOREgetActive*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDeviceFilter_USCOREgetActive*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREsetActive:
		if (p->size < 0)
			delete (struct __vbox__IUSBDeviceFilter_USCOREsetActive*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDeviceFilter_USCOREsetActive*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREgetVendorId:
		if (p->size < 0)
			delete (struct __vbox__IUSBDeviceFilter_USCOREgetVendorId*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDeviceFilter_USCOREgetVendorId*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREsetVendorId:
		if (p->size < 0)
			delete (struct __vbox__IUSBDeviceFilter_USCOREsetVendorId*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDeviceFilter_USCOREsetVendorId*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREgetProductId:
		if (p->size < 0)
			delete (struct __vbox__IUSBDeviceFilter_USCOREgetProductId*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDeviceFilter_USCOREgetProductId*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREsetProductId:
		if (p->size < 0)
			delete (struct __vbox__IUSBDeviceFilter_USCOREsetProductId*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDeviceFilter_USCOREsetProductId*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREgetRevision:
		if (p->size < 0)
			delete (struct __vbox__IUSBDeviceFilter_USCOREgetRevision*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDeviceFilter_USCOREgetRevision*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREsetRevision:
		if (p->size < 0)
			delete (struct __vbox__IUSBDeviceFilter_USCOREsetRevision*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDeviceFilter_USCOREsetRevision*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREgetManufacturer:
		if (p->size < 0)
			delete (struct __vbox__IUSBDeviceFilter_USCOREgetManufacturer*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDeviceFilter_USCOREgetManufacturer*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREsetManufacturer:
		if (p->size < 0)
			delete (struct __vbox__IUSBDeviceFilter_USCOREsetManufacturer*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDeviceFilter_USCOREsetManufacturer*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREgetProduct:
		if (p->size < 0)
			delete (struct __vbox__IUSBDeviceFilter_USCOREgetProduct*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDeviceFilter_USCOREgetProduct*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREsetProduct:
		if (p->size < 0)
			delete (struct __vbox__IUSBDeviceFilter_USCOREsetProduct*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDeviceFilter_USCOREsetProduct*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREgetSerialNumber:
		if (p->size < 0)
			delete (struct __vbox__IUSBDeviceFilter_USCOREgetSerialNumber*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDeviceFilter_USCOREgetSerialNumber*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREsetSerialNumber:
		if (p->size < 0)
			delete (struct __vbox__IUSBDeviceFilter_USCOREsetSerialNumber*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDeviceFilter_USCOREsetSerialNumber*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREgetPort:
		if (p->size < 0)
			delete (struct __vbox__IUSBDeviceFilter_USCOREgetPort*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDeviceFilter_USCOREgetPort*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREsetPort:
		if (p->size < 0)
			delete (struct __vbox__IUSBDeviceFilter_USCOREsetPort*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDeviceFilter_USCOREsetPort*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREgetRemote:
		if (p->size < 0)
			delete (struct __vbox__IUSBDeviceFilter_USCOREgetRemote*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDeviceFilter_USCOREgetRemote*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREsetRemote:
		if (p->size < 0)
			delete (struct __vbox__IUSBDeviceFilter_USCOREsetRemote*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDeviceFilter_USCOREsetRemote*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREgetMaskedInterfaces:
		if (p->size < 0)
			delete (struct __vbox__IUSBDeviceFilter_USCOREgetMaskedInterfaces*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDeviceFilter_USCOREgetMaskedInterfaces*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREsetMaskedInterfaces:
		if (p->size < 0)
			delete (struct __vbox__IUSBDeviceFilter_USCOREsetMaskedInterfaces*)p->ptr;
		else
			delete[] (struct __vbox__IUSBDeviceFilter_USCOREsetMaskedInterfaces*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHostUSBDevice_USCOREgetState:
		if (p->size < 0)
			delete (struct __vbox__IHostUSBDevice_USCOREgetState*)p->ptr;
		else
			delete[] (struct __vbox__IHostUSBDevice_USCOREgetState*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHostUSBDeviceFilter_USCOREgetAction:
		if (p->size < 0)
			delete (struct __vbox__IHostUSBDeviceFilter_USCOREgetAction*)p->ptr;
		else
			delete[] (struct __vbox__IHostUSBDeviceFilter_USCOREgetAction*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IHostUSBDeviceFilter_USCOREsetAction:
		if (p->size < 0)
			delete (struct __vbox__IHostUSBDeviceFilter_USCOREsetAction*)p->ptr;
		else
			delete[] (struct __vbox__IHostUSBDeviceFilter_USCOREsetAction*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IAudioAdapter_USCOREgetEnabled:
		if (p->size < 0)
			delete (struct __vbox__IAudioAdapter_USCOREgetEnabled*)p->ptr;
		else
			delete[] (struct __vbox__IAudioAdapter_USCOREgetEnabled*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IAudioAdapter_USCOREsetEnabled:
		if (p->size < 0)
			delete (struct __vbox__IAudioAdapter_USCOREsetEnabled*)p->ptr;
		else
			delete[] (struct __vbox__IAudioAdapter_USCOREsetEnabled*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IAudioAdapter_USCOREgetAudioController:
		if (p->size < 0)
			delete (struct __vbox__IAudioAdapter_USCOREgetAudioController*)p->ptr;
		else
			delete[] (struct __vbox__IAudioAdapter_USCOREgetAudioController*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IAudioAdapter_USCOREsetAudioController:
		if (p->size < 0)
			delete (struct __vbox__IAudioAdapter_USCOREsetAudioController*)p->ptr;
		else
			delete[] (struct __vbox__IAudioAdapter_USCOREsetAudioController*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IAudioAdapter_USCOREgetAudioDriver:
		if (p->size < 0)
			delete (struct __vbox__IAudioAdapter_USCOREgetAudioDriver*)p->ptr;
		else
			delete[] (struct __vbox__IAudioAdapter_USCOREgetAudioDriver*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IAudioAdapter_USCOREsetAudioDriver:
		if (p->size < 0)
			delete (struct __vbox__IAudioAdapter_USCOREsetAudioDriver*)p->ptr;
		else
			delete[] (struct __vbox__IAudioAdapter_USCOREsetAudioDriver*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVRDPServer_USCOREgetEnabled:
		if (p->size < 0)
			delete (struct __vbox__IVRDPServer_USCOREgetEnabled*)p->ptr;
		else
			delete[] (struct __vbox__IVRDPServer_USCOREgetEnabled*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVRDPServer_USCOREsetEnabled:
		if (p->size < 0)
			delete (struct __vbox__IVRDPServer_USCOREsetEnabled*)p->ptr;
		else
			delete[] (struct __vbox__IVRDPServer_USCOREsetEnabled*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVRDPServer_USCOREgetPorts:
		if (p->size < 0)
			delete (struct __vbox__IVRDPServer_USCOREgetPorts*)p->ptr;
		else
			delete[] (struct __vbox__IVRDPServer_USCOREgetPorts*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVRDPServer_USCOREsetPorts:
		if (p->size < 0)
			delete (struct __vbox__IVRDPServer_USCOREsetPorts*)p->ptr;
		else
			delete[] (struct __vbox__IVRDPServer_USCOREsetPorts*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVRDPServer_USCOREgetNetAddress:
		if (p->size < 0)
			delete (struct __vbox__IVRDPServer_USCOREgetNetAddress*)p->ptr;
		else
			delete[] (struct __vbox__IVRDPServer_USCOREgetNetAddress*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVRDPServer_USCOREsetNetAddress:
		if (p->size < 0)
			delete (struct __vbox__IVRDPServer_USCOREsetNetAddress*)p->ptr;
		else
			delete[] (struct __vbox__IVRDPServer_USCOREsetNetAddress*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVRDPServer_USCOREgetAuthType:
		if (p->size < 0)
			delete (struct __vbox__IVRDPServer_USCOREgetAuthType*)p->ptr;
		else
			delete[] (struct __vbox__IVRDPServer_USCOREgetAuthType*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVRDPServer_USCOREsetAuthType:
		if (p->size < 0)
			delete (struct __vbox__IVRDPServer_USCOREsetAuthType*)p->ptr;
		else
			delete[] (struct __vbox__IVRDPServer_USCOREsetAuthType*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVRDPServer_USCOREgetAuthTimeout:
		if (p->size < 0)
			delete (struct __vbox__IVRDPServer_USCOREgetAuthTimeout*)p->ptr;
		else
			delete[] (struct __vbox__IVRDPServer_USCOREgetAuthTimeout*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVRDPServer_USCOREsetAuthTimeout:
		if (p->size < 0)
			delete (struct __vbox__IVRDPServer_USCOREsetAuthTimeout*)p->ptr;
		else
			delete[] (struct __vbox__IVRDPServer_USCOREsetAuthTimeout*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVRDPServer_USCOREgetAllowMultiConnection:
		if (p->size < 0)
			delete (struct __vbox__IVRDPServer_USCOREgetAllowMultiConnection*)p->ptr;
		else
			delete[] (struct __vbox__IVRDPServer_USCOREgetAllowMultiConnection*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVRDPServer_USCOREsetAllowMultiConnection:
		if (p->size < 0)
			delete (struct __vbox__IVRDPServer_USCOREsetAllowMultiConnection*)p->ptr;
		else
			delete[] (struct __vbox__IVRDPServer_USCOREsetAllowMultiConnection*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVRDPServer_USCOREgetReuseSingleConnection:
		if (p->size < 0)
			delete (struct __vbox__IVRDPServer_USCOREgetReuseSingleConnection*)p->ptr;
		else
			delete[] (struct __vbox__IVRDPServer_USCOREgetReuseSingleConnection*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IVRDPServer_USCOREsetReuseSingleConnection:
		if (p->size < 0)
			delete (struct __vbox__IVRDPServer_USCOREsetReuseSingleConnection*)p->ptr;
		else
			delete[] (struct __vbox__IVRDPServer_USCOREsetReuseSingleConnection*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISession_USCOREgetState:
		if (p->size < 0)
			delete (struct __vbox__ISession_USCOREgetState*)p->ptr;
		else
			delete[] (struct __vbox__ISession_USCOREgetState*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISession_USCOREgetType:
		if (p->size < 0)
			delete (struct __vbox__ISession_USCOREgetType*)p->ptr;
		else
			delete[] (struct __vbox__ISession_USCOREgetType*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISession_USCOREgetMachine:
		if (p->size < 0)
			delete (struct __vbox__ISession_USCOREgetMachine*)p->ptr;
		else
			delete[] (struct __vbox__ISession_USCOREgetMachine*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISession_USCOREgetConsole:
		if (p->size < 0)
			delete (struct __vbox__ISession_USCOREgetConsole*)p->ptr;
		else
			delete[] (struct __vbox__ISession_USCOREgetConsole*)p->ptr;
		break;
	case SOAP_TYPE___vbox__ISession_USCOREclose:
		if (p->size < 0)
			delete (struct __vbox__ISession_USCOREclose*)p->ptr;
		else
			delete[] (struct __vbox__ISession_USCOREclose*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IStorageController_USCOREgetName:
		if (p->size < 0)
			delete (struct __vbox__IStorageController_USCOREgetName*)p->ptr;
		else
			delete[] (struct __vbox__IStorageController_USCOREgetName*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IStorageController_USCOREgetMaxDevicesPerPortCount:
		if (p->size < 0)
			delete (struct __vbox__IStorageController_USCOREgetMaxDevicesPerPortCount*)p->ptr;
		else
			delete[] (struct __vbox__IStorageController_USCOREgetMaxDevicesPerPortCount*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IStorageController_USCOREgetMinPortCount:
		if (p->size < 0)
			delete (struct __vbox__IStorageController_USCOREgetMinPortCount*)p->ptr;
		else
			delete[] (struct __vbox__IStorageController_USCOREgetMinPortCount*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IStorageController_USCOREgetMaxPortCount:
		if (p->size < 0)
			delete (struct __vbox__IStorageController_USCOREgetMaxPortCount*)p->ptr;
		else
			delete[] (struct __vbox__IStorageController_USCOREgetMaxPortCount*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IStorageController_USCOREgetInstance:
		if (p->size < 0)
			delete (struct __vbox__IStorageController_USCOREgetInstance*)p->ptr;
		else
			delete[] (struct __vbox__IStorageController_USCOREgetInstance*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IStorageController_USCOREsetInstance:
		if (p->size < 0)
			delete (struct __vbox__IStorageController_USCOREsetInstance*)p->ptr;
		else
			delete[] (struct __vbox__IStorageController_USCOREsetInstance*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IStorageController_USCOREgetPortCount:
		if (p->size < 0)
			delete (struct __vbox__IStorageController_USCOREgetPortCount*)p->ptr;
		else
			delete[] (struct __vbox__IStorageController_USCOREgetPortCount*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IStorageController_USCOREsetPortCount:
		if (p->size < 0)
			delete (struct __vbox__IStorageController_USCOREsetPortCount*)p->ptr;
		else
			delete[] (struct __vbox__IStorageController_USCOREsetPortCount*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IStorageController_USCOREgetBus:
		if (p->size < 0)
			delete (struct __vbox__IStorageController_USCOREgetBus*)p->ptr;
		else
			delete[] (struct __vbox__IStorageController_USCOREgetBus*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IStorageController_USCOREgetControllerType:
		if (p->size < 0)
			delete (struct __vbox__IStorageController_USCOREgetControllerType*)p->ptr;
		else
			delete[] (struct __vbox__IStorageController_USCOREgetControllerType*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IStorageController_USCOREsetControllerType:
		if (p->size < 0)
			delete (struct __vbox__IStorageController_USCOREsetControllerType*)p->ptr;
		else
			delete[] (struct __vbox__IStorageController_USCOREsetControllerType*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IStorageController_USCOREGetIDEEmulationPort:
		if (p->size < 0)
			delete (struct __vbox__IStorageController_USCOREGetIDEEmulationPort*)p->ptr;
		else
			delete[] (struct __vbox__IStorageController_USCOREGetIDEEmulationPort*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IStorageController_USCORESetIDEEmulationPort:
		if (p->size < 0)
			delete (struct __vbox__IStorageController_USCORESetIDEEmulationPort*)p->ptr;
		else
			delete[] (struct __vbox__IStorageController_USCORESetIDEEmulationPort*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IManagedObjectRef_USCOREgetInterfaceName:
		if (p->size < 0)
			delete (struct __vbox__IManagedObjectRef_USCOREgetInterfaceName*)p->ptr;
		else
			delete[] (struct __vbox__IManagedObjectRef_USCOREgetInterfaceName*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IManagedObjectRef_USCORErelease:
		if (p->size < 0)
			delete (struct __vbox__IManagedObjectRef_USCORErelease*)p->ptr;
		else
			delete[] (struct __vbox__IManagedObjectRef_USCORErelease*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IWebsessionManager_USCORElogon:
		if (p->size < 0)
			delete (struct __vbox__IWebsessionManager_USCORElogon*)p->ptr;
		else
			delete[] (struct __vbox__IWebsessionManager_USCORElogon*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IWebsessionManager_USCOREgetSessionObject:
		if (p->size < 0)
			delete (struct __vbox__IWebsessionManager_USCOREgetSessionObject*)p->ptr;
		else
			delete[] (struct __vbox__IWebsessionManager_USCOREgetSessionObject*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IWebsessionManager_USCORElogoff:
		if (p->size < 0)
			delete (struct __vbox__IWebsessionManager_USCORElogoff*)p->ptr;
		else
			delete[] (struct __vbox__IWebsessionManager_USCORElogoff*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IPerformanceMetric_USCOREgetMetricName:
		if (p->size < 0)
			delete (struct __vbox__IPerformanceMetric_USCOREgetMetricName*)p->ptr;
		else
			delete[] (struct __vbox__IPerformanceMetric_USCOREgetMetricName*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IPerformanceMetric_USCOREgetObject:
		if (p->size < 0)
			delete (struct __vbox__IPerformanceMetric_USCOREgetObject*)p->ptr;
		else
			delete[] (struct __vbox__IPerformanceMetric_USCOREgetObject*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IPerformanceMetric_USCOREgetDescription:
		if (p->size < 0)
			delete (struct __vbox__IPerformanceMetric_USCOREgetDescription*)p->ptr;
		else
			delete[] (struct __vbox__IPerformanceMetric_USCOREgetDescription*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IPerformanceMetric_USCOREgetPeriod:
		if (p->size < 0)
			delete (struct __vbox__IPerformanceMetric_USCOREgetPeriod*)p->ptr;
		else
			delete[] (struct __vbox__IPerformanceMetric_USCOREgetPeriod*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IPerformanceMetric_USCOREgetCount:
		if (p->size < 0)
			delete (struct __vbox__IPerformanceMetric_USCOREgetCount*)p->ptr;
		else
			delete[] (struct __vbox__IPerformanceMetric_USCOREgetCount*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IPerformanceMetric_USCOREgetUnit:
		if (p->size < 0)
			delete (struct __vbox__IPerformanceMetric_USCOREgetUnit*)p->ptr;
		else
			delete[] (struct __vbox__IPerformanceMetric_USCOREgetUnit*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IPerformanceMetric_USCOREgetMinimumValue:
		if (p->size < 0)
			delete (struct __vbox__IPerformanceMetric_USCOREgetMinimumValue*)p->ptr;
		else
			delete[] (struct __vbox__IPerformanceMetric_USCOREgetMinimumValue*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IPerformanceMetric_USCOREgetMaximumValue:
		if (p->size < 0)
			delete (struct __vbox__IPerformanceMetric_USCOREgetMaximumValue*)p->ptr;
		else
			delete[] (struct __vbox__IPerformanceMetric_USCOREgetMaximumValue*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IPerformanceCollector_USCOREgetMetricNames:
		if (p->size < 0)
			delete (struct __vbox__IPerformanceCollector_USCOREgetMetricNames*)p->ptr;
		else
			delete[] (struct __vbox__IPerformanceCollector_USCOREgetMetricNames*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IPerformanceCollector_USCOREgetMetrics:
		if (p->size < 0)
			delete (struct __vbox__IPerformanceCollector_USCOREgetMetrics*)p->ptr;
		else
			delete[] (struct __vbox__IPerformanceCollector_USCOREgetMetrics*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IPerformanceCollector_USCOREsetupMetrics:
		if (p->size < 0)
			delete (struct __vbox__IPerformanceCollector_USCOREsetupMetrics*)p->ptr;
		else
			delete[] (struct __vbox__IPerformanceCollector_USCOREsetupMetrics*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IPerformanceCollector_USCOREenableMetrics:
		if (p->size < 0)
			delete (struct __vbox__IPerformanceCollector_USCOREenableMetrics*)p->ptr;
		else
			delete[] (struct __vbox__IPerformanceCollector_USCOREenableMetrics*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IPerformanceCollector_USCOREdisableMetrics:
		if (p->size < 0)
			delete (struct __vbox__IPerformanceCollector_USCOREdisableMetrics*)p->ptr;
		else
			delete[] (struct __vbox__IPerformanceCollector_USCOREdisableMetrics*)p->ptr;
		break;
	case SOAP_TYPE___vbox__IPerformanceCollector_USCOREqueryMetricsData:
		if (p->size < 0)
			delete (struct __vbox__IPerformanceCollector_USCOREqueryMetricsData*)p->ptr;
		else
			delete[] (struct __vbox__IPerformanceCollector_USCOREqueryMetricsData*)p->ptr;
		break;
	case SOAP_TYPE_SOAP_ENV__Header:
		if (p->size < 0)
			delete (struct SOAP_ENV__Header*)p->ptr;
		else
			delete[] (struct SOAP_ENV__Header*)p->ptr;
		break;
	case SOAP_TYPE_SOAP_ENV__Code:
		if (p->size < 0)
			delete (struct SOAP_ENV__Code*)p->ptr;
		else
			delete[] (struct SOAP_ENV__Code*)p->ptr;
		break;
	case SOAP_TYPE_SOAP_ENV__Reason:
		if (p->size < 0)
			delete (struct SOAP_ENV__Reason*)p->ptr;
		else
			delete[] (struct SOAP_ENV__Reason*)p->ptr;
		break;
	case SOAP_TYPE_SOAP_ENV__Fault:
		if (p->size < 0)
			delete (struct SOAP_ENV__Fault*)p->ptr;
		else
			delete[] (struct SOAP_ENV__Fault*)p->ptr;
		break;
	case SOAP_TYPE_std__vectorTemplateOfint:
		if (p->size < 0)
			delete (std::vector<int >*)p->ptr;
		else
			delete[] (std::vector<int >*)p->ptr;
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__DataType:
		if (p->size < 0)
			delete (std::vector<enum vbox__DataType >*)p->ptr;
		else
			delete[] (std::vector<enum vbox__DataType >*)p->ptr;
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__DeviceType:
		if (p->size < 0)
			delete (std::vector<enum vbox__DeviceType >*)p->ptr;
		else
			delete[] (std::vector<enum vbox__DeviceType >*)p->ptr;
		break;
	case SOAP_TYPE_std__vectorTemplateOfunsignedByte:
		if (p->size < 0)
			delete (std::vector<unsigned char >*)p->ptr;
		else
			delete[] (std::vector<unsigned char >*)p->ptr;
		break;
	case SOAP_TYPE_std__vectorTemplateOfunsignedLONG64:
		if (p->size < 0)
			delete (std::vector<ULONG64 >*)p->ptr;
		else
			delete[] (std::vector<ULONG64 >*)p->ptr;
		break;
	case SOAP_TYPE_std__vectorTemplateOfPointerTovbox__IMediumAttachment:
		if (p->size < 0)
			delete (std::vector<vbox__IMediumAttachment * >*)p->ptr;
		else
			delete[] (std::vector<vbox__IMediumAttachment * >*)p->ptr;
		break;
	case SOAP_TYPE_std__vectorTemplateOfbool:
		if (p->size < 0)
			delete (std::vector<bool >*)p->ptr;
		else
			delete[] (std::vector<bool >*)p->ptr;
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__VirtualSystemDescriptionType:
		if (p->size < 0)
			delete (std::vector<enum vbox__VirtualSystemDescriptionType >*)p->ptr;
		else
			delete[] (std::vector<enum vbox__VirtualSystemDescriptionType >*)p->ptr;
		break;
	case SOAP_TYPE_std__vectorTemplateOfunsignedInt:
		if (p->size < 0)
			delete (std::vector<unsigned int >*)p->ptr;
		else
			delete[] (std::vector<unsigned int >*)p->ptr;
		break;
	case SOAP_TYPE_std__vectorTemplateOfPointerTovbox__ISharedFolder:
		if (p->size < 0)
			delete (std::vector<vbox__ISharedFolder * >*)p->ptr;
		else
			delete[] (std::vector<vbox__ISharedFolder * >*)p->ptr;
		break;
	case SOAP_TYPE_std__vectorTemplateOfPointerTovbox__IGuestOSType:
		if (p->size < 0)
			delete (std::vector<vbox__IGuestOSType * >*)p->ptr;
		else
			delete[] (std::vector<vbox__IGuestOSType * >*)p->ptr;
		break;
	case SOAP_TYPE_std__vectorTemplateOfstd__string:
		if (p->size < 0)
			delete (std::vector<std::string >*)p->ptr;
		else
			delete[] (std::vector<std::string >*)p->ptr;
		break;
	default:	return SOAP_ERR;
	}
	return SOAP_OK;
}

SOAP_FMAC3 void* SOAP_FMAC4 soap_class_id_enter(struct soap *soap, const char *id, void *p, int t, size_t n, const char *type, const char *arrayType)
{	return soap_id_enter(soap, id, p, t, n, 0, type, arrayType, soap_instantiate);
}

SOAP_FMAC3 void* SOAP_FMAC4 soap_container_id_forward(struct soap *soap, const char *href, void *p, size_t len, int st, int tt, size_t n, unsigned int k)
{	return soap_id_forward(soap, href, p, len, st, tt, n, k, soap_container_insert);
}

SOAP_FMAC3 void SOAP_FMAC4 soap_container_insert(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
#ifdef WIN32
#pragma warning(push)
#pragma warning(disable:4065)
#endif
{	switch (tt)
	{
	case SOAP_TYPE_std__vectorTemplateOfint:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container insert type=%d in %d location=%p object=%p len=%lu\n", st, tt, p, q, (unsigned long)len));
		(*(std::vector<int >*)p)[len] = *(int *)q;
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__DataType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container insert type=%d in %d location=%p object=%p len=%lu\n", st, tt, p, q, (unsigned long)len));
		(*(std::vector<enum vbox__DataType >*)p)[len] = *(enum vbox__DataType *)q;
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__DeviceType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container insert type=%d in %d location=%p object=%p len=%lu\n", st, tt, p, q, (unsigned long)len));
		(*(std::vector<enum vbox__DeviceType >*)p)[len] = *(enum vbox__DeviceType *)q;
		break;
	case SOAP_TYPE_std__vectorTemplateOfunsignedByte:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container insert type=%d in %d location=%p object=%p len=%lu\n", st, tt, p, q, (unsigned long)len));
		(*(std::vector<unsigned char >*)p)[len] = *(unsigned char *)q;
		break;
	case SOAP_TYPE_std__vectorTemplateOfunsignedLONG64:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container insert type=%d in %d location=%p object=%p len=%lu\n", st, tt, p, q, (unsigned long)len));
		(*(std::vector<ULONG64 >*)p)[len] = *(ULONG64 *)q;
		break;
	case SOAP_TYPE_std__vectorTemplateOfPointerTovbox__IMediumAttachment:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container insert type=%d in %d location=%p object=%p len=%lu\n", st, tt, p, q, (unsigned long)len));
		(*(std::vector<vbox__IMediumAttachment * >*)p)[len] = *(vbox__IMediumAttachment **)q;
		break;
	case SOAP_TYPE_std__vectorTemplateOfbool:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container insert type=%d in %d location=%p object=%p len=%lu\n", st, tt, p, q, (unsigned long)len));
		(*(std::vector<bool >*)p)[len] = *(bool *)q;
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__VirtualSystemDescriptionType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container insert type=%d in %d location=%p object=%p len=%lu\n", st, tt, p, q, (unsigned long)len));
		(*(std::vector<enum vbox__VirtualSystemDescriptionType >*)p)[len] = *(enum vbox__VirtualSystemDescriptionType *)q;
		break;
	case SOAP_TYPE_std__vectorTemplateOfunsignedInt:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container insert type=%d in %d location=%p object=%p len=%lu\n", st, tt, p, q, (unsigned long)len));
		(*(std::vector<unsigned int >*)p)[len] = *(unsigned int *)q;
		break;
	case SOAP_TYPE_std__vectorTemplateOfPointerTovbox__ISharedFolder:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container insert type=%d in %d location=%p object=%p len=%lu\n", st, tt, p, q, (unsigned long)len));
		(*(std::vector<vbox__ISharedFolder * >*)p)[len] = *(vbox__ISharedFolder **)q;
		break;
	case SOAP_TYPE_std__vectorTemplateOfPointerTovbox__IGuestOSType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container insert type=%d in %d location=%p object=%p len=%lu\n", st, tt, p, q, (unsigned long)len));
		(*(std::vector<vbox__IGuestOSType * >*)p)[len] = *(vbox__IGuestOSType **)q;
		break;
	case SOAP_TYPE_std__vectorTemplateOfstd__string:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container insert type=%d in %d location=%p object=%p len=%lu\n", st, tt, p, q, (unsigned long)len));
		(*(std::vector<std::string >*)p)[len] = *(std::string *)q;
		break;
	default:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Could not insert type=%d in %d\n", st, tt));
	}
#ifdef WIN32
#pragma warning(pop)
#endif
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_byte(struct soap *soap, char *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_byte
	*a = SOAP_DEFAULT_byte;
#else
	*a = (char)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_byte(struct soap *soap, const char *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_byte);
	if (soap_out_byte(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_byte(struct soap *soap, const char *tag, int id, const char *a, const char *type)
{
	return soap_outbyte(soap, tag, id, a, type, SOAP_TYPE_byte);
}

SOAP_FMAC3 char * SOAP_FMAC4 soap_get_byte(struct soap *soap, char *p, const char *tag, const char *type)
{
	if ((p = soap_in_byte(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 char * SOAP_FMAC4 soap_in_byte(struct soap *soap, const char *tag, char *a, const char *type)
{	char *p;
	p = soap_inbyte(soap, tag, a, type, SOAP_TYPE_byte);
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_short(struct soap *soap, short *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_short
	*a = SOAP_DEFAULT_short;
#else
	*a = (short)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_short(struct soap *soap, const short *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_short);
	if (soap_out_short(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_short(struct soap *soap, const char *tag, int id, const short *a, const char *type)
{
	return soap_outshort(soap, tag, id, a, type, SOAP_TYPE_short);
}

SOAP_FMAC3 short * SOAP_FMAC4 soap_get_short(struct soap *soap, short *p, const char *tag, const char *type)
{
	if ((p = soap_in_short(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 short * SOAP_FMAC4 soap_in_short(struct soap *soap, const char *tag, short *a, const char *type)
{	short *p;
	p = soap_inshort(soap, tag, a, type, SOAP_TYPE_short);
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_int(struct soap *soap, int *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_int
	*a = SOAP_DEFAULT_int;
#else
	*a = (int)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_int(struct soap *soap, const int *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_int);
	if (soap_out_int(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_int(struct soap *soap, const char *tag, int id, const int *a, const char *type)
{
	return soap_outint(soap, tag, id, a, type, SOAP_TYPE_int);
}

SOAP_FMAC3 int * SOAP_FMAC4 soap_get_int(struct soap *soap, int *p, const char *tag, const char *type)
{
	if ((p = soap_in_int(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 int * SOAP_FMAC4 soap_in_int(struct soap *soap, const char *tag, int *a, const char *type)
{	int *p;
	p = soap_inint(soap, tag, a, type, SOAP_TYPE_int);
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_LONG64(struct soap *soap, LONG64 *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_LONG64
	*a = SOAP_DEFAULT_LONG64;
#else
	*a = (LONG64)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_LONG64(struct soap *soap, const LONG64 *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_LONG64);
	if (soap_out_LONG64(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_LONG64(struct soap *soap, const char *tag, int id, const LONG64 *a, const char *type)
{
	return soap_outLONG64(soap, tag, id, a, type, SOAP_TYPE_LONG64);
}

SOAP_FMAC3 LONG64 * SOAP_FMAC4 soap_get_LONG64(struct soap *soap, LONG64 *p, const char *tag, const char *type)
{
	if ((p = soap_in_LONG64(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 LONG64 * SOAP_FMAC4 soap_in_LONG64(struct soap *soap, const char *tag, LONG64 *a, const char *type)
{	LONG64 *p;
	p = soap_inLONG64(soap, tag, a, type, SOAP_TYPE_LONG64);
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_unsignedByte(struct soap *soap, unsigned char *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_unsignedByte
	*a = SOAP_DEFAULT_unsignedByte;
#else
	*a = (unsigned char)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_unsignedByte(struct soap *soap, const unsigned char *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_unsignedByte);
	if (soap_out_unsignedByte(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_unsignedByte(struct soap *soap, const char *tag, int id, const unsigned char *a, const char *type)
{
	return soap_outunsignedByte(soap, tag, id, a, type, SOAP_TYPE_unsignedByte);
}

SOAP_FMAC3 unsigned char * SOAP_FMAC4 soap_get_unsignedByte(struct soap *soap, unsigned char *p, const char *tag, const char *type)
{
	if ((p = soap_in_unsignedByte(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 unsigned char * SOAP_FMAC4 soap_in_unsignedByte(struct soap *soap, const char *tag, unsigned char *a, const char *type)
{	unsigned char *p;
	p = soap_inunsignedByte(soap, tag, a, type, SOAP_TYPE_unsignedByte);
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_unsignedShort(struct soap *soap, unsigned short *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_unsignedShort
	*a = SOAP_DEFAULT_unsignedShort;
#else
	*a = (unsigned short)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_unsignedShort(struct soap *soap, const unsigned short *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_unsignedShort);
	if (soap_out_unsignedShort(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_unsignedShort(struct soap *soap, const char *tag, int id, const unsigned short *a, const char *type)
{
	return soap_outunsignedShort(soap, tag, id, a, type, SOAP_TYPE_unsignedShort);
}

SOAP_FMAC3 unsigned short * SOAP_FMAC4 soap_get_unsignedShort(struct soap *soap, unsigned short *p, const char *tag, const char *type)
{
	if ((p = soap_in_unsignedShort(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 unsigned short * SOAP_FMAC4 soap_in_unsignedShort(struct soap *soap, const char *tag, unsigned short *a, const char *type)
{	unsigned short *p;
	p = soap_inunsignedShort(soap, tag, a, type, SOAP_TYPE_unsignedShort);
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_unsignedInt(struct soap *soap, unsigned int *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_unsignedInt
	*a = SOAP_DEFAULT_unsignedInt;
#else
	*a = (unsigned int)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_unsignedInt(struct soap *soap, const unsigned int *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_unsignedInt);
	if (soap_out_unsignedInt(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_unsignedInt(struct soap *soap, const char *tag, int id, const unsigned int *a, const char *type)
{
	return soap_outunsignedInt(soap, tag, id, a, type, SOAP_TYPE_unsignedInt);
}

SOAP_FMAC3 unsigned int * SOAP_FMAC4 soap_get_unsignedInt(struct soap *soap, unsigned int *p, const char *tag, const char *type)
{
	if ((p = soap_in_unsignedInt(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 unsigned int * SOAP_FMAC4 soap_in_unsignedInt(struct soap *soap, const char *tag, unsigned int *a, const char *type)
{	unsigned int *p;
	p = soap_inunsignedInt(soap, tag, a, type, SOAP_TYPE_unsignedInt);
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_unsignedLONG64(struct soap *soap, ULONG64 *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_unsignedLONG64
	*a = SOAP_DEFAULT_unsignedLONG64;
#else
	*a = (ULONG64)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_unsignedLONG64(struct soap *soap, const ULONG64 *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_unsignedLONG64);
	if (soap_out_unsignedLONG64(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_unsignedLONG64(struct soap *soap, const char *tag, int id, const ULONG64 *a, const char *type)
{
	return soap_outULONG64(soap, tag, id, a, type, SOAP_TYPE_unsignedLONG64);
}

SOAP_FMAC3 ULONG64 * SOAP_FMAC4 soap_get_unsignedLONG64(struct soap *soap, ULONG64 *p, const char *tag, const char *type)
{
	if ((p = soap_in_unsignedLONG64(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 ULONG64 * SOAP_FMAC4 soap_in_unsignedLONG64(struct soap *soap, const char *tag, ULONG64 *a, const char *type)
{	ULONG64 *p;
	p = soap_inULONG64(soap, tag, a, type, SOAP_TYPE_unsignedLONG64);
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_bool(struct soap *soap, bool *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_bool
	*a = SOAP_DEFAULT_bool;
#else
	*a = (bool)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_bool(struct soap *soap, const bool *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_bool);
	if (soap_out_bool(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_bool[] =
{	{ (long)false, "false" },
	{ (long)true, "true" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_bool2s(struct soap *soap, bool n)
{	(void)soap; /* appease -Wall -Werror */
	return soap_code_str(soap_codes_bool, n!=0);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_bool(struct soap *soap, const char *tag, int id, const bool *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_bool), type) || soap_send(soap, soap_bool2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 bool * SOAP_FMAC4 soap_get_bool(struct soap *soap, bool *p, const char *tag, const char *type)
{
	if ((p = soap_in_bool(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2bool(struct soap *soap, const char *s, bool *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_bool, s);
	if (map)
		*a = (bool)(map->code != 0);
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || n < 0 || n > 1)
			return soap->error = SOAP_TYPE;
		*a = (bool)(n != 0);
	}
	return SOAP_OK;
}

SOAP_FMAC3 bool * SOAP_FMAC4 soap_in_bool(struct soap *soap, const char *tag, bool *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	if (*soap->type && soap_match_tag(soap, soap->type, type) && soap_match_tag(soap, soap->type, ":boolean"))
	{	soap->error = SOAP_TYPE;
		return NULL;
	}
	a = (bool *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_bool, sizeof(bool), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2bool(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (bool *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_bool, 0, sizeof(bool), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__StorageControllerType(struct soap *soap, enum vbox__StorageControllerType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__StorageControllerType
	*a = SOAP_DEFAULT_vbox__StorageControllerType;
#else
	*a = (enum vbox__StorageControllerType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__StorageControllerType(struct soap *soap, const enum vbox__StorageControllerType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__StorageControllerType);
	if (soap_out_vbox__StorageControllerType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__StorageControllerType[] =
{	{ (long)vbox__StorageControllerType__Null, "Null" },
	{ (long)vbox__StorageControllerType__LsiLogic, "LsiLogic" },
	{ (long)vbox__StorageControllerType__BusLogic, "BusLogic" },
	{ (long)vbox__StorageControllerType__IntelAhci, "IntelAhci" },
	{ (long)vbox__StorageControllerType__PIIX3, "PIIX3" },
	{ (long)vbox__StorageControllerType__PIIX4, "PIIX4" },
	{ (long)vbox__StorageControllerType__ICH6, "ICH6" },
	{ (long)vbox__StorageControllerType__I82078, "I82078" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__StorageControllerType2s(struct soap *soap, enum vbox__StorageControllerType n)
{	const char *s = soap_code_str(soap_codes_vbox__StorageControllerType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__StorageControllerType(struct soap *soap, const char *tag, int id, const enum vbox__StorageControllerType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__StorageControllerType), type) || soap_send(soap, soap_vbox__StorageControllerType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__StorageControllerType * SOAP_FMAC4 soap_get_vbox__StorageControllerType(struct soap *soap, enum vbox__StorageControllerType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__StorageControllerType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__StorageControllerType(struct soap *soap, const char *s, enum vbox__StorageControllerType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__StorageControllerType, s);
	if (map)
		*a = (enum vbox__StorageControllerType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 7)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__StorageControllerType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__StorageControllerType * SOAP_FMAC4 soap_in_vbox__StorageControllerType(struct soap *soap, const char *tag, enum vbox__StorageControllerType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__StorageControllerType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__StorageControllerType, sizeof(enum vbox__StorageControllerType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__StorageControllerType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__StorageControllerType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__StorageControllerType, 0, sizeof(enum vbox__StorageControllerType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__StorageBus(struct soap *soap, enum vbox__StorageBus *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__StorageBus
	*a = SOAP_DEFAULT_vbox__StorageBus;
#else
	*a = (enum vbox__StorageBus)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__StorageBus(struct soap *soap, const enum vbox__StorageBus *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__StorageBus);
	if (soap_out_vbox__StorageBus(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__StorageBus[] =
{	{ (long)vbox__StorageBus__Null, "Null" },
	{ (long)vbox__StorageBus__IDE, "IDE" },
	{ (long)vbox__StorageBus__SATA, "SATA" },
	{ (long)vbox__StorageBus__SCSI, "SCSI" },
	{ (long)vbox__StorageBus__Floppy, "Floppy" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__StorageBus2s(struct soap *soap, enum vbox__StorageBus n)
{	const char *s = soap_code_str(soap_codes_vbox__StorageBus, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__StorageBus(struct soap *soap, const char *tag, int id, const enum vbox__StorageBus *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__StorageBus), type) || soap_send(soap, soap_vbox__StorageBus2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__StorageBus * SOAP_FMAC4 soap_get_vbox__StorageBus(struct soap *soap, enum vbox__StorageBus *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__StorageBus(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__StorageBus(struct soap *soap, const char *s, enum vbox__StorageBus *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__StorageBus, s);
	if (map)
		*a = (enum vbox__StorageBus)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 4)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__StorageBus)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__StorageBus * SOAP_FMAC4 soap_in_vbox__StorageBus(struct soap *soap, const char *tag, enum vbox__StorageBus *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__StorageBus *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__StorageBus, sizeof(enum vbox__StorageBus), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__StorageBus(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__StorageBus *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__StorageBus, 0, sizeof(enum vbox__StorageBus), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__VRDPAuthType(struct soap *soap, enum vbox__VRDPAuthType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__VRDPAuthType
	*a = SOAP_DEFAULT_vbox__VRDPAuthType;
#else
	*a = (enum vbox__VRDPAuthType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__VRDPAuthType(struct soap *soap, const enum vbox__VRDPAuthType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__VRDPAuthType);
	if (soap_out_vbox__VRDPAuthType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__VRDPAuthType[] =
{	{ (long)vbox__VRDPAuthType__Null, "Null" },
	{ (long)vbox__VRDPAuthType__External, "External" },
	{ (long)vbox__VRDPAuthType__Guest, "Guest" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__VRDPAuthType2s(struct soap *soap, enum vbox__VRDPAuthType n)
{	const char *s = soap_code_str(soap_codes_vbox__VRDPAuthType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__VRDPAuthType(struct soap *soap, const char *tag, int id, const enum vbox__VRDPAuthType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__VRDPAuthType), type) || soap_send(soap, soap_vbox__VRDPAuthType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__VRDPAuthType * SOAP_FMAC4 soap_get_vbox__VRDPAuthType(struct soap *soap, enum vbox__VRDPAuthType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__VRDPAuthType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__VRDPAuthType(struct soap *soap, const char *s, enum vbox__VRDPAuthType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__VRDPAuthType, s);
	if (map)
		*a = (enum vbox__VRDPAuthType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__VRDPAuthType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__VRDPAuthType * SOAP_FMAC4 soap_in_vbox__VRDPAuthType(struct soap *soap, const char *tag, enum vbox__VRDPAuthType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__VRDPAuthType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__VRDPAuthType, sizeof(enum vbox__VRDPAuthType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__VRDPAuthType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__VRDPAuthType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__VRDPAuthType, 0, sizeof(enum vbox__VRDPAuthType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__AudioControllerType(struct soap *soap, enum vbox__AudioControllerType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__AudioControllerType
	*a = SOAP_DEFAULT_vbox__AudioControllerType;
#else
	*a = (enum vbox__AudioControllerType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__AudioControllerType(struct soap *soap, const enum vbox__AudioControllerType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__AudioControllerType);
	if (soap_out_vbox__AudioControllerType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__AudioControllerType[] =
{	{ (long)vbox__AudioControllerType__AC97, "AC97" },
	{ (long)vbox__AudioControllerType__SB16, "SB16" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__AudioControllerType2s(struct soap *soap, enum vbox__AudioControllerType n)
{	const char *s = soap_code_str(soap_codes_vbox__AudioControllerType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__AudioControllerType(struct soap *soap, const char *tag, int id, const enum vbox__AudioControllerType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__AudioControllerType), type) || soap_send(soap, soap_vbox__AudioControllerType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__AudioControllerType * SOAP_FMAC4 soap_get_vbox__AudioControllerType(struct soap *soap, enum vbox__AudioControllerType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__AudioControllerType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__AudioControllerType(struct soap *soap, const char *s, enum vbox__AudioControllerType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__AudioControllerType, s);
	if (map)
		*a = (enum vbox__AudioControllerType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 1)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__AudioControllerType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__AudioControllerType * SOAP_FMAC4 soap_in_vbox__AudioControllerType(struct soap *soap, const char *tag, enum vbox__AudioControllerType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__AudioControllerType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__AudioControllerType, sizeof(enum vbox__AudioControllerType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__AudioControllerType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__AudioControllerType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__AudioControllerType, 0, sizeof(enum vbox__AudioControllerType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__AudioDriverType(struct soap *soap, enum vbox__AudioDriverType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__AudioDriverType
	*a = SOAP_DEFAULT_vbox__AudioDriverType;
#else
	*a = (enum vbox__AudioDriverType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__AudioDriverType(struct soap *soap, const enum vbox__AudioDriverType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__AudioDriverType);
	if (soap_out_vbox__AudioDriverType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__AudioDriverType[] =
{	{ (long)vbox__AudioDriverType__Null, "Null" },
	{ (long)vbox__AudioDriverType__WinMM, "WinMM" },
	{ (long)vbox__AudioDriverType__OSS, "OSS" },
	{ (long)vbox__AudioDriverType__ALSA, "ALSA" },
	{ (long)vbox__AudioDriverType__DirectSound, "DirectSound" },
	{ (long)vbox__AudioDriverType__CoreAudio, "CoreAudio" },
	{ (long)vbox__AudioDriverType__MMPM, "MMPM" },
	{ (long)vbox__AudioDriverType__Pulse, "Pulse" },
	{ (long)vbox__AudioDriverType__SolAudio, "SolAudio" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__AudioDriverType2s(struct soap *soap, enum vbox__AudioDriverType n)
{	const char *s = soap_code_str(soap_codes_vbox__AudioDriverType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__AudioDriverType(struct soap *soap, const char *tag, int id, const enum vbox__AudioDriverType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__AudioDriverType), type) || soap_send(soap, soap_vbox__AudioDriverType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__AudioDriverType * SOAP_FMAC4 soap_get_vbox__AudioDriverType(struct soap *soap, enum vbox__AudioDriverType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__AudioDriverType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__AudioDriverType(struct soap *soap, const char *s, enum vbox__AudioDriverType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__AudioDriverType, s);
	if (map)
		*a = (enum vbox__AudioDriverType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 8)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__AudioDriverType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__AudioDriverType * SOAP_FMAC4 soap_in_vbox__AudioDriverType(struct soap *soap, const char *tag, enum vbox__AudioDriverType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__AudioDriverType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__AudioDriverType, sizeof(enum vbox__AudioDriverType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__AudioDriverType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__AudioDriverType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__AudioDriverType, 0, sizeof(enum vbox__AudioDriverType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__USBDeviceFilterAction(struct soap *soap, enum vbox__USBDeviceFilterAction *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__USBDeviceFilterAction
	*a = SOAP_DEFAULT_vbox__USBDeviceFilterAction;
#else
	*a = (enum vbox__USBDeviceFilterAction)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__USBDeviceFilterAction(struct soap *soap, const enum vbox__USBDeviceFilterAction *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__USBDeviceFilterAction);
	if (soap_out_vbox__USBDeviceFilterAction(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__USBDeviceFilterAction[] =
{	{ (long)vbox__USBDeviceFilterAction__Null, "Null" },
	{ (long)vbox__USBDeviceFilterAction__Ignore, "Ignore" },
	{ (long)vbox__USBDeviceFilterAction__Hold, "Hold" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__USBDeviceFilterAction2s(struct soap *soap, enum vbox__USBDeviceFilterAction n)
{	const char *s = soap_code_str(soap_codes_vbox__USBDeviceFilterAction, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__USBDeviceFilterAction(struct soap *soap, const char *tag, int id, const enum vbox__USBDeviceFilterAction *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__USBDeviceFilterAction), type) || soap_send(soap, soap_vbox__USBDeviceFilterAction2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__USBDeviceFilterAction * SOAP_FMAC4 soap_get_vbox__USBDeviceFilterAction(struct soap *soap, enum vbox__USBDeviceFilterAction *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__USBDeviceFilterAction(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__USBDeviceFilterAction(struct soap *soap, const char *s, enum vbox__USBDeviceFilterAction *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__USBDeviceFilterAction, s);
	if (map)
		*a = (enum vbox__USBDeviceFilterAction)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__USBDeviceFilterAction)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__USBDeviceFilterAction * SOAP_FMAC4 soap_in_vbox__USBDeviceFilterAction(struct soap *soap, const char *tag, enum vbox__USBDeviceFilterAction *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__USBDeviceFilterAction *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__USBDeviceFilterAction, sizeof(enum vbox__USBDeviceFilterAction), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__USBDeviceFilterAction(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__USBDeviceFilterAction *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__USBDeviceFilterAction, 0, sizeof(enum vbox__USBDeviceFilterAction), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__USBDeviceState(struct soap *soap, enum vbox__USBDeviceState *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__USBDeviceState
	*a = SOAP_DEFAULT_vbox__USBDeviceState;
#else
	*a = (enum vbox__USBDeviceState)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__USBDeviceState(struct soap *soap, const enum vbox__USBDeviceState *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__USBDeviceState);
	if (soap_out_vbox__USBDeviceState(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__USBDeviceState[] =
{	{ (long)vbox__USBDeviceState__NotSupported, "NotSupported" },
	{ (long)vbox__USBDeviceState__Unavailable, "Unavailable" },
	{ (long)vbox__USBDeviceState__Busy, "Busy" },
	{ (long)vbox__USBDeviceState__Available, "Available" },
	{ (long)vbox__USBDeviceState__Held, "Held" },
	{ (long)vbox__USBDeviceState__Captured, "Captured" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__USBDeviceState2s(struct soap *soap, enum vbox__USBDeviceState n)
{	const char *s = soap_code_str(soap_codes_vbox__USBDeviceState, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__USBDeviceState(struct soap *soap, const char *tag, int id, const enum vbox__USBDeviceState *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__USBDeviceState), type) || soap_send(soap, soap_vbox__USBDeviceState2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__USBDeviceState * SOAP_FMAC4 soap_get_vbox__USBDeviceState(struct soap *soap, enum vbox__USBDeviceState *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__USBDeviceState(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__USBDeviceState(struct soap *soap, const char *s, enum vbox__USBDeviceState *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__USBDeviceState, s);
	if (map)
		*a = (enum vbox__USBDeviceState)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 5)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__USBDeviceState)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__USBDeviceState * SOAP_FMAC4 soap_in_vbox__USBDeviceState(struct soap *soap, const char *tag, enum vbox__USBDeviceState *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__USBDeviceState *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__USBDeviceState, sizeof(enum vbox__USBDeviceState), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__USBDeviceState(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__USBDeviceState *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__USBDeviceState, 0, sizeof(enum vbox__USBDeviceState), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__PortMode(struct soap *soap, enum vbox__PortMode *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__PortMode
	*a = SOAP_DEFAULT_vbox__PortMode;
#else
	*a = (enum vbox__PortMode)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__PortMode(struct soap *soap, const enum vbox__PortMode *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__PortMode);
	if (soap_out_vbox__PortMode(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__PortMode[] =
{	{ (long)vbox__PortMode__Disconnected, "Disconnected" },
	{ (long)vbox__PortMode__HostPipe, "HostPipe" },
	{ (long)vbox__PortMode__HostDevice, "HostDevice" },
	{ (long)vbox__PortMode__RawFile, "RawFile" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__PortMode2s(struct soap *soap, enum vbox__PortMode n)
{	const char *s = soap_code_str(soap_codes_vbox__PortMode, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__PortMode(struct soap *soap, const char *tag, int id, const enum vbox__PortMode *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__PortMode), type) || soap_send(soap, soap_vbox__PortMode2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__PortMode * SOAP_FMAC4 soap_get_vbox__PortMode(struct soap *soap, enum vbox__PortMode *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__PortMode(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__PortMode(struct soap *soap, const char *s, enum vbox__PortMode *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__PortMode, s);
	if (map)
		*a = (enum vbox__PortMode)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__PortMode)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__PortMode * SOAP_FMAC4 soap_in_vbox__PortMode(struct soap *soap, const char *tag, enum vbox__PortMode *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__PortMode *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__PortMode, sizeof(enum vbox__PortMode), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__PortMode(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__PortMode *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__PortMode, 0, sizeof(enum vbox__PortMode), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__NetworkAdapterType(struct soap *soap, enum vbox__NetworkAdapterType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__NetworkAdapterType
	*a = SOAP_DEFAULT_vbox__NetworkAdapterType;
#else
	*a = (enum vbox__NetworkAdapterType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__NetworkAdapterType(struct soap *soap, const enum vbox__NetworkAdapterType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__NetworkAdapterType);
	if (soap_out_vbox__NetworkAdapterType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__NetworkAdapterType[] =
{	{ (long)vbox__NetworkAdapterType__Null, "Null" },
	{ (long)vbox__NetworkAdapterType__Am79C970A, "Am79C970A" },
	{ (long)vbox__NetworkAdapterType__Am79C973, "Am79C973" },
	{ (long)vbox__NetworkAdapterType__I82540EM, "I82540EM" },
	{ (long)vbox__NetworkAdapterType__I82543GC, "I82543GC" },
	{ (long)vbox__NetworkAdapterType__I82545EM, "I82545EM" },
	{ (long)vbox__NetworkAdapterType__Virtio, "Virtio" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__NetworkAdapterType2s(struct soap *soap, enum vbox__NetworkAdapterType n)
{	const char *s = soap_code_str(soap_codes_vbox__NetworkAdapterType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__NetworkAdapterType(struct soap *soap, const char *tag, int id, const enum vbox__NetworkAdapterType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__NetworkAdapterType), type) || soap_send(soap, soap_vbox__NetworkAdapterType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__NetworkAdapterType * SOAP_FMAC4 soap_get_vbox__NetworkAdapterType(struct soap *soap, enum vbox__NetworkAdapterType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__NetworkAdapterType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__NetworkAdapterType(struct soap *soap, const char *s, enum vbox__NetworkAdapterType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__NetworkAdapterType, s);
	if (map)
		*a = (enum vbox__NetworkAdapterType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 6)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__NetworkAdapterType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__NetworkAdapterType * SOAP_FMAC4 soap_in_vbox__NetworkAdapterType(struct soap *soap, const char *tag, enum vbox__NetworkAdapterType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__NetworkAdapterType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__NetworkAdapterType, sizeof(enum vbox__NetworkAdapterType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__NetworkAdapterType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__NetworkAdapterType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__NetworkAdapterType, 0, sizeof(enum vbox__NetworkAdapterType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__NetworkAttachmentType(struct soap *soap, enum vbox__NetworkAttachmentType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__NetworkAttachmentType
	*a = SOAP_DEFAULT_vbox__NetworkAttachmentType;
#else
	*a = (enum vbox__NetworkAttachmentType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__NetworkAttachmentType(struct soap *soap, const enum vbox__NetworkAttachmentType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__NetworkAttachmentType);
	if (soap_out_vbox__NetworkAttachmentType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__NetworkAttachmentType[] =
{	{ (long)vbox__NetworkAttachmentType__Null, "Null" },
	{ (long)vbox__NetworkAttachmentType__NAT, "NAT" },
	{ (long)vbox__NetworkAttachmentType__Bridged, "Bridged" },
	{ (long)vbox__NetworkAttachmentType__Internal, "Internal" },
	{ (long)vbox__NetworkAttachmentType__HostOnly, "HostOnly" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__NetworkAttachmentType2s(struct soap *soap, enum vbox__NetworkAttachmentType n)
{	const char *s = soap_code_str(soap_codes_vbox__NetworkAttachmentType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__NetworkAttachmentType(struct soap *soap, const char *tag, int id, const enum vbox__NetworkAttachmentType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__NetworkAttachmentType), type) || soap_send(soap, soap_vbox__NetworkAttachmentType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__NetworkAttachmentType * SOAP_FMAC4 soap_get_vbox__NetworkAttachmentType(struct soap *soap, enum vbox__NetworkAttachmentType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__NetworkAttachmentType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__NetworkAttachmentType(struct soap *soap, const char *s, enum vbox__NetworkAttachmentType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__NetworkAttachmentType, s);
	if (map)
		*a = (enum vbox__NetworkAttachmentType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 4)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__NetworkAttachmentType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__NetworkAttachmentType * SOAP_FMAC4 soap_in_vbox__NetworkAttachmentType(struct soap *soap, const char *tag, enum vbox__NetworkAttachmentType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__NetworkAttachmentType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__NetworkAttachmentType, sizeof(enum vbox__NetworkAttachmentType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__NetworkAttachmentType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__NetworkAttachmentType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__NetworkAttachmentType, 0, sizeof(enum vbox__NetworkAttachmentType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__FramebufferPixelFormat(struct soap *soap, enum vbox__FramebufferPixelFormat *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__FramebufferPixelFormat
	*a = SOAP_DEFAULT_vbox__FramebufferPixelFormat;
#else
	*a = (enum vbox__FramebufferPixelFormat)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__FramebufferPixelFormat(struct soap *soap, const enum vbox__FramebufferPixelFormat *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__FramebufferPixelFormat);
	if (soap_out_vbox__FramebufferPixelFormat(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__FramebufferPixelFormat[] =
{	{ (long)vbox__FramebufferPixelFormat__Opaque, "Opaque" },
	{ (long)vbox__FramebufferPixelFormat__FOURCC_USCORERGB, "FOURCC_RGB" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__FramebufferPixelFormat2s(struct soap *soap, enum vbox__FramebufferPixelFormat n)
{	const char *s = soap_code_str(soap_codes_vbox__FramebufferPixelFormat, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__FramebufferPixelFormat(struct soap *soap, const char *tag, int id, const enum vbox__FramebufferPixelFormat *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__FramebufferPixelFormat), type) || soap_send(soap, soap_vbox__FramebufferPixelFormat2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__FramebufferPixelFormat * SOAP_FMAC4 soap_get_vbox__FramebufferPixelFormat(struct soap *soap, enum vbox__FramebufferPixelFormat *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__FramebufferPixelFormat(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__FramebufferPixelFormat(struct soap *soap, const char *s, enum vbox__FramebufferPixelFormat *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__FramebufferPixelFormat, s);
	if (map)
		*a = (enum vbox__FramebufferPixelFormat)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 1)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__FramebufferPixelFormat)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__FramebufferPixelFormat * SOAP_FMAC4 soap_in_vbox__FramebufferPixelFormat(struct soap *soap, const char *tag, enum vbox__FramebufferPixelFormat *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__FramebufferPixelFormat *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__FramebufferPixelFormat, sizeof(enum vbox__FramebufferPixelFormat), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__FramebufferPixelFormat(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__FramebufferPixelFormat *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__FramebufferPixelFormat, 0, sizeof(enum vbox__FramebufferPixelFormat), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__MouseButtonState(struct soap *soap, enum vbox__MouseButtonState *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__MouseButtonState
	*a = SOAP_DEFAULT_vbox__MouseButtonState;
#else
	*a = (enum vbox__MouseButtonState)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__MouseButtonState(struct soap *soap, const enum vbox__MouseButtonState *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__MouseButtonState);
	if (soap_out_vbox__MouseButtonState(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__MouseButtonState[] =
{	{ (long)vbox__MouseButtonState__LeftButton, "LeftButton" },
	{ (long)vbox__MouseButtonState__RightButton, "RightButton" },
	{ (long)vbox__MouseButtonState__MiddleButton, "MiddleButton" },
	{ (long)vbox__MouseButtonState__WheelUp, "WheelUp" },
	{ (long)vbox__MouseButtonState__WheelDown, "WheelDown" },
	{ (long)vbox__MouseButtonState__XButton1, "XButton1" },
	{ (long)vbox__MouseButtonState__XButton2, "XButton2" },
	{ (long)vbox__MouseButtonState__MouseStateMask, "MouseStateMask" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__MouseButtonState2s(struct soap *soap, enum vbox__MouseButtonState n)
{	const char *s = soap_code_str(soap_codes_vbox__MouseButtonState, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__MouseButtonState(struct soap *soap, const char *tag, int id, const enum vbox__MouseButtonState *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__MouseButtonState), type) || soap_send(soap, soap_vbox__MouseButtonState2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__MouseButtonState * SOAP_FMAC4 soap_get_vbox__MouseButtonState(struct soap *soap, enum vbox__MouseButtonState *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__MouseButtonState(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__MouseButtonState(struct soap *soap, const char *s, enum vbox__MouseButtonState *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__MouseButtonState, s);
	if (map)
		*a = (enum vbox__MouseButtonState)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 7)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__MouseButtonState)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__MouseButtonState * SOAP_FMAC4 soap_in_vbox__MouseButtonState(struct soap *soap, const char *tag, enum vbox__MouseButtonState *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__MouseButtonState *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__MouseButtonState, sizeof(enum vbox__MouseButtonState), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__MouseButtonState(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__MouseButtonState *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__MouseButtonState, 0, sizeof(enum vbox__MouseButtonState), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__MediumFormatCapabilities(struct soap *soap, enum vbox__MediumFormatCapabilities *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__MediumFormatCapabilities
	*a = SOAP_DEFAULT_vbox__MediumFormatCapabilities;
#else
	*a = (enum vbox__MediumFormatCapabilities)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__MediumFormatCapabilities(struct soap *soap, const enum vbox__MediumFormatCapabilities *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__MediumFormatCapabilities);
	if (soap_out_vbox__MediumFormatCapabilities(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__MediumFormatCapabilities[] =
{	{ (long)vbox__MediumFormatCapabilities__Uuid, "Uuid" },
	{ (long)vbox__MediumFormatCapabilities__CreateFixed, "CreateFixed" },
	{ (long)vbox__MediumFormatCapabilities__CreateDynamic, "CreateDynamic" },
	{ (long)vbox__MediumFormatCapabilities__CreateSplit2G, "CreateSplit2G" },
	{ (long)vbox__MediumFormatCapabilities__Differencing, "Differencing" },
	{ (long)vbox__MediumFormatCapabilities__Asynchronous, "Asynchronous" },
	{ (long)vbox__MediumFormatCapabilities__File, "File" },
	{ (long)vbox__MediumFormatCapabilities__Properties, "Properties" },
	{ (long)vbox__MediumFormatCapabilities__CapabilityMask, "CapabilityMask" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__MediumFormatCapabilities2s(struct soap *soap, enum vbox__MediumFormatCapabilities n)
{	const char *s = soap_code_str(soap_codes_vbox__MediumFormatCapabilities, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__MediumFormatCapabilities(struct soap *soap, const char *tag, int id, const enum vbox__MediumFormatCapabilities *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__MediumFormatCapabilities), type) || soap_send(soap, soap_vbox__MediumFormatCapabilities2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__MediumFormatCapabilities * SOAP_FMAC4 soap_get_vbox__MediumFormatCapabilities(struct soap *soap, enum vbox__MediumFormatCapabilities *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__MediumFormatCapabilities(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__MediumFormatCapabilities(struct soap *soap, const char *s, enum vbox__MediumFormatCapabilities *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__MediumFormatCapabilities, s);
	if (map)
		*a = (enum vbox__MediumFormatCapabilities)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 8)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__MediumFormatCapabilities)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__MediumFormatCapabilities * SOAP_FMAC4 soap_in_vbox__MediumFormatCapabilities(struct soap *soap, const char *tag, enum vbox__MediumFormatCapabilities *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__MediumFormatCapabilities *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__MediumFormatCapabilities, sizeof(enum vbox__MediumFormatCapabilities), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__MediumFormatCapabilities(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__MediumFormatCapabilities *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__MediumFormatCapabilities, 0, sizeof(enum vbox__MediumFormatCapabilities), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__DataFlags(struct soap *soap, enum vbox__DataFlags *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DataFlags
	*a = SOAP_DEFAULT_vbox__DataFlags;
#else
	*a = (enum vbox__DataFlags)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__DataFlags(struct soap *soap, const enum vbox__DataFlags *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__DataFlags);
	if (soap_out_vbox__DataFlags(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__DataFlags[] =
{	{ (long)vbox__DataFlags__None, "None" },
	{ (long)vbox__DataFlags__Mandatory, "Mandatory" },
	{ (long)vbox__DataFlags__Expert, "Expert" },
	{ (long)vbox__DataFlags__Array, "Array" },
	{ (long)vbox__DataFlags__FlagMask, "FlagMask" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__DataFlags2s(struct soap *soap, enum vbox__DataFlags n)
{	const char *s = soap_code_str(soap_codes_vbox__DataFlags, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__DataFlags(struct soap *soap, const char *tag, int id, const enum vbox__DataFlags *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__DataFlags), type) || soap_send(soap, soap_vbox__DataFlags2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__DataFlags * SOAP_FMAC4 soap_get_vbox__DataFlags(struct soap *soap, enum vbox__DataFlags *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__DataFlags(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__DataFlags(struct soap *soap, const char *s, enum vbox__DataFlags *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__DataFlags, s);
	if (map)
		*a = (enum vbox__DataFlags)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 4)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__DataFlags)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__DataFlags * SOAP_FMAC4 soap_in_vbox__DataFlags(struct soap *soap, const char *tag, enum vbox__DataFlags *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__DataFlags *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__DataFlags, sizeof(enum vbox__DataFlags), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__DataFlags(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__DataFlags *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__DataFlags, 0, sizeof(enum vbox__DataFlags), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__DataType(struct soap *soap, enum vbox__DataType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DataType
	*a = SOAP_DEFAULT_vbox__DataType;
#else
	*a = (enum vbox__DataType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__DataType(struct soap *soap, const enum vbox__DataType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__DataType);
	if (soap_out_vbox__DataType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__DataType[] =
{	{ (long)vbox__DataType__Int32, "Int32" },
	{ (long)vbox__DataType__Int8, "Int8" },
	{ (long)vbox__DataType__String, "String" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__DataType2s(struct soap *soap, enum vbox__DataType n)
{	const char *s = soap_code_str(soap_codes_vbox__DataType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__DataType(struct soap *soap, const char *tag, int id, const enum vbox__DataType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__DataType), type) || soap_send(soap, soap_vbox__DataType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__DataType * SOAP_FMAC4 soap_get_vbox__DataType(struct soap *soap, enum vbox__DataType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__DataType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__DataType(struct soap *soap, const char *s, enum vbox__DataType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__DataType, s);
	if (map)
		*a = (enum vbox__DataType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__DataType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__DataType * SOAP_FMAC4 soap_in_vbox__DataType(struct soap *soap, const char *tag, enum vbox__DataType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__DataType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__DataType, sizeof(enum vbox__DataType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__DataType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__DataType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__DataType, 0, sizeof(enum vbox__DataType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__MediumVariant(struct soap *soap, enum vbox__MediumVariant *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__MediumVariant
	*a = SOAP_DEFAULT_vbox__MediumVariant;
#else
	*a = (enum vbox__MediumVariant)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__MediumVariant(struct soap *soap, const enum vbox__MediumVariant *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__MediumVariant);
	if (soap_out_vbox__MediumVariant(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__MediumVariant[] =
{	{ (long)vbox__MediumVariant__Standard, "Standard" },
	{ (long)vbox__MediumVariant__VmdkSplit2G, "VmdkSplit2G" },
	{ (long)vbox__MediumVariant__VmdkStreamOptimized, "VmdkStreamOptimized" },
	{ (long)vbox__MediumVariant__VmdkESX, "VmdkESX" },
	{ (long)vbox__MediumVariant__Fixed, "Fixed" },
	{ (long)vbox__MediumVariant__Diff, "Diff" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__MediumVariant2s(struct soap *soap, enum vbox__MediumVariant n)
{	const char *s = soap_code_str(soap_codes_vbox__MediumVariant, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__MediumVariant(struct soap *soap, const char *tag, int id, const enum vbox__MediumVariant *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__MediumVariant), type) || soap_send(soap, soap_vbox__MediumVariant2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__MediumVariant * SOAP_FMAC4 soap_get_vbox__MediumVariant(struct soap *soap, enum vbox__MediumVariant *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__MediumVariant(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__MediumVariant(struct soap *soap, const char *s, enum vbox__MediumVariant *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__MediumVariant, s);
	if (map)
		*a = (enum vbox__MediumVariant)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 5)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__MediumVariant)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__MediumVariant * SOAP_FMAC4 soap_in_vbox__MediumVariant(struct soap *soap, const char *tag, enum vbox__MediumVariant *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__MediumVariant *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__MediumVariant, sizeof(enum vbox__MediumVariant), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__MediumVariant(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__MediumVariant *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__MediumVariant, 0, sizeof(enum vbox__MediumVariant), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__MediumType(struct soap *soap, enum vbox__MediumType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__MediumType
	*a = SOAP_DEFAULT_vbox__MediumType;
#else
	*a = (enum vbox__MediumType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__MediumType(struct soap *soap, const enum vbox__MediumType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__MediumType);
	if (soap_out_vbox__MediumType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__MediumType[] =
{	{ (long)vbox__MediumType__Normal, "Normal" },
	{ (long)vbox__MediumType__Immutable, "Immutable" },
	{ (long)vbox__MediumType__Writethrough, "Writethrough" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__MediumType2s(struct soap *soap, enum vbox__MediumType n)
{	const char *s = soap_code_str(soap_codes_vbox__MediumType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__MediumType(struct soap *soap, const char *tag, int id, const enum vbox__MediumType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__MediumType), type) || soap_send(soap, soap_vbox__MediumType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__MediumType * SOAP_FMAC4 soap_get_vbox__MediumType(struct soap *soap, enum vbox__MediumType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__MediumType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__MediumType(struct soap *soap, const char *s, enum vbox__MediumType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__MediumType, s);
	if (map)
		*a = (enum vbox__MediumType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__MediumType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__MediumType * SOAP_FMAC4 soap_in_vbox__MediumType(struct soap *soap, const char *tag, enum vbox__MediumType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__MediumType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__MediumType, sizeof(enum vbox__MediumType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__MediumType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__MediumType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__MediumType, 0, sizeof(enum vbox__MediumType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__MediumState(struct soap *soap, enum vbox__MediumState *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__MediumState
	*a = SOAP_DEFAULT_vbox__MediumState;
#else
	*a = (enum vbox__MediumState)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__MediumState(struct soap *soap, const enum vbox__MediumState *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__MediumState);
	if (soap_out_vbox__MediumState(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__MediumState[] =
{	{ (long)vbox__MediumState__NotCreated, "NotCreated" },
	{ (long)vbox__MediumState__Created, "Created" },
	{ (long)vbox__MediumState__LockedRead, "LockedRead" },
	{ (long)vbox__MediumState__LockedWrite, "LockedWrite" },
	{ (long)vbox__MediumState__Inaccessible, "Inaccessible" },
	{ (long)vbox__MediumState__Creating, "Creating" },
	{ (long)vbox__MediumState__Deleting, "Deleting" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__MediumState2s(struct soap *soap, enum vbox__MediumState n)
{	const char *s = soap_code_str(soap_codes_vbox__MediumState, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__MediumState(struct soap *soap, const char *tag, int id, const enum vbox__MediumState *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__MediumState), type) || soap_send(soap, soap_vbox__MediumState2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__MediumState * SOAP_FMAC4 soap_get_vbox__MediumState(struct soap *soap, enum vbox__MediumState *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__MediumState(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__MediumState(struct soap *soap, const char *s, enum vbox__MediumState *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__MediumState, s);
	if (map)
		*a = (enum vbox__MediumState)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 6)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__MediumState)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__MediumState * SOAP_FMAC4 soap_in_vbox__MediumState(struct soap *soap, const char *tag, enum vbox__MediumState *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__MediumState *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__MediumState, sizeof(enum vbox__MediumState), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__MediumState(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__MediumState *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__MediumState, 0, sizeof(enum vbox__MediumState), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__HostNetworkInterfaceType(struct soap *soap, enum vbox__HostNetworkInterfaceType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__HostNetworkInterfaceType
	*a = SOAP_DEFAULT_vbox__HostNetworkInterfaceType;
#else
	*a = (enum vbox__HostNetworkInterfaceType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__HostNetworkInterfaceType(struct soap *soap, const enum vbox__HostNetworkInterfaceType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__HostNetworkInterfaceType);
	if (soap_out_vbox__HostNetworkInterfaceType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__HostNetworkInterfaceType[] =
{	{ (long)vbox__HostNetworkInterfaceType__Bridged, "Bridged" },
	{ (long)vbox__HostNetworkInterfaceType__HostOnly, "HostOnly" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__HostNetworkInterfaceType2s(struct soap *soap, enum vbox__HostNetworkInterfaceType n)
{	const char *s = soap_code_str(soap_codes_vbox__HostNetworkInterfaceType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__HostNetworkInterfaceType(struct soap *soap, const char *tag, int id, const enum vbox__HostNetworkInterfaceType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__HostNetworkInterfaceType), type) || soap_send(soap, soap_vbox__HostNetworkInterfaceType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__HostNetworkInterfaceType * SOAP_FMAC4 soap_get_vbox__HostNetworkInterfaceType(struct soap *soap, enum vbox__HostNetworkInterfaceType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__HostNetworkInterfaceType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__HostNetworkInterfaceType(struct soap *soap, const char *s, enum vbox__HostNetworkInterfaceType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__HostNetworkInterfaceType, s);
	if (map)
		*a = (enum vbox__HostNetworkInterfaceType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 1)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__HostNetworkInterfaceType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__HostNetworkInterfaceType * SOAP_FMAC4 soap_in_vbox__HostNetworkInterfaceType(struct soap *soap, const char *tag, enum vbox__HostNetworkInterfaceType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__HostNetworkInterfaceType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__HostNetworkInterfaceType, sizeof(enum vbox__HostNetworkInterfaceType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__HostNetworkInterfaceType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__HostNetworkInterfaceType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__HostNetworkInterfaceType, 0, sizeof(enum vbox__HostNetworkInterfaceType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__HostNetworkInterfaceStatus(struct soap *soap, enum vbox__HostNetworkInterfaceStatus *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__HostNetworkInterfaceStatus
	*a = SOAP_DEFAULT_vbox__HostNetworkInterfaceStatus;
#else
	*a = (enum vbox__HostNetworkInterfaceStatus)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__HostNetworkInterfaceStatus(struct soap *soap, const enum vbox__HostNetworkInterfaceStatus *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__HostNetworkInterfaceStatus);
	if (soap_out_vbox__HostNetworkInterfaceStatus(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__HostNetworkInterfaceStatus[] =
{	{ (long)vbox__HostNetworkInterfaceStatus__Unknown, "Unknown" },
	{ (long)vbox__HostNetworkInterfaceStatus__Up, "Up" },
	{ (long)vbox__HostNetworkInterfaceStatus__Down, "Down" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__HostNetworkInterfaceStatus2s(struct soap *soap, enum vbox__HostNetworkInterfaceStatus n)
{	const char *s = soap_code_str(soap_codes_vbox__HostNetworkInterfaceStatus, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__HostNetworkInterfaceStatus(struct soap *soap, const char *tag, int id, const enum vbox__HostNetworkInterfaceStatus *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__HostNetworkInterfaceStatus), type) || soap_send(soap, soap_vbox__HostNetworkInterfaceStatus2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__HostNetworkInterfaceStatus * SOAP_FMAC4 soap_get_vbox__HostNetworkInterfaceStatus(struct soap *soap, enum vbox__HostNetworkInterfaceStatus *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__HostNetworkInterfaceStatus(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__HostNetworkInterfaceStatus(struct soap *soap, const char *s, enum vbox__HostNetworkInterfaceStatus *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__HostNetworkInterfaceStatus, s);
	if (map)
		*a = (enum vbox__HostNetworkInterfaceStatus)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__HostNetworkInterfaceStatus)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__HostNetworkInterfaceStatus * SOAP_FMAC4 soap_in_vbox__HostNetworkInterfaceStatus(struct soap *soap, const char *tag, enum vbox__HostNetworkInterfaceStatus *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__HostNetworkInterfaceStatus *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__HostNetworkInterfaceStatus, sizeof(enum vbox__HostNetworkInterfaceStatus), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__HostNetworkInterfaceStatus(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__HostNetworkInterfaceStatus *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__HostNetworkInterfaceStatus, 0, sizeof(enum vbox__HostNetworkInterfaceStatus), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__HostNetworkInterfaceMediumType(struct soap *soap, enum vbox__HostNetworkInterfaceMediumType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__HostNetworkInterfaceMediumType
	*a = SOAP_DEFAULT_vbox__HostNetworkInterfaceMediumType;
#else
	*a = (enum vbox__HostNetworkInterfaceMediumType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__HostNetworkInterfaceMediumType(struct soap *soap, const enum vbox__HostNetworkInterfaceMediumType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__HostNetworkInterfaceMediumType);
	if (soap_out_vbox__HostNetworkInterfaceMediumType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__HostNetworkInterfaceMediumType[] =
{	{ (long)vbox__HostNetworkInterfaceMediumType__Unknown, "Unknown" },
	{ (long)vbox__HostNetworkInterfaceMediumType__Ethernet, "Ethernet" },
	{ (long)vbox__HostNetworkInterfaceMediumType__PPP, "PPP" },
	{ (long)vbox__HostNetworkInterfaceMediumType__SLIP, "SLIP" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__HostNetworkInterfaceMediumType2s(struct soap *soap, enum vbox__HostNetworkInterfaceMediumType n)
{	const char *s = soap_code_str(soap_codes_vbox__HostNetworkInterfaceMediumType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__HostNetworkInterfaceMediumType(struct soap *soap, const char *tag, int id, const enum vbox__HostNetworkInterfaceMediumType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__HostNetworkInterfaceMediumType), type) || soap_send(soap, soap_vbox__HostNetworkInterfaceMediumType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__HostNetworkInterfaceMediumType * SOAP_FMAC4 soap_get_vbox__HostNetworkInterfaceMediumType(struct soap *soap, enum vbox__HostNetworkInterfaceMediumType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__HostNetworkInterfaceMediumType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__HostNetworkInterfaceMediumType(struct soap *soap, const char *s, enum vbox__HostNetworkInterfaceMediumType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__HostNetworkInterfaceMediumType, s);
	if (map)
		*a = (enum vbox__HostNetworkInterfaceMediumType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__HostNetworkInterfaceMediumType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__HostNetworkInterfaceMediumType * SOAP_FMAC4 soap_in_vbox__HostNetworkInterfaceMediumType(struct soap *soap, const char *tag, enum vbox__HostNetworkInterfaceMediumType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__HostNetworkInterfaceMediumType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__HostNetworkInterfaceMediumType, sizeof(enum vbox__HostNetworkInterfaceMediumType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__HostNetworkInterfaceMediumType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__HostNetworkInterfaceMediumType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__HostNetworkInterfaceMediumType, 0, sizeof(enum vbox__HostNetworkInterfaceMediumType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__VirtualSystemDescriptionValueType(struct soap *soap, enum vbox__VirtualSystemDescriptionValueType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__VirtualSystemDescriptionValueType
	*a = SOAP_DEFAULT_vbox__VirtualSystemDescriptionValueType;
#else
	*a = (enum vbox__VirtualSystemDescriptionValueType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__VirtualSystemDescriptionValueType(struct soap *soap, const enum vbox__VirtualSystemDescriptionValueType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__VirtualSystemDescriptionValueType);
	if (soap_out_vbox__VirtualSystemDescriptionValueType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__VirtualSystemDescriptionValueType[] =
{	{ (long)vbox__VirtualSystemDescriptionValueType__Reference, "Reference" },
	{ (long)vbox__VirtualSystemDescriptionValueType__Original, "Original" },
	{ (long)vbox__VirtualSystemDescriptionValueType__Auto, "Auto" },
	{ (long)vbox__VirtualSystemDescriptionValueType__ExtraConfig, "ExtraConfig" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__VirtualSystemDescriptionValueType2s(struct soap *soap, enum vbox__VirtualSystemDescriptionValueType n)
{	const char *s = soap_code_str(soap_codes_vbox__VirtualSystemDescriptionValueType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__VirtualSystemDescriptionValueType(struct soap *soap, const char *tag, int id, const enum vbox__VirtualSystemDescriptionValueType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__VirtualSystemDescriptionValueType), type) || soap_send(soap, soap_vbox__VirtualSystemDescriptionValueType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__VirtualSystemDescriptionValueType * SOAP_FMAC4 soap_get_vbox__VirtualSystemDescriptionValueType(struct soap *soap, enum vbox__VirtualSystemDescriptionValueType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__VirtualSystemDescriptionValueType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__VirtualSystemDescriptionValueType(struct soap *soap, const char *s, enum vbox__VirtualSystemDescriptionValueType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__VirtualSystemDescriptionValueType, s);
	if (map)
		*a = (enum vbox__VirtualSystemDescriptionValueType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__VirtualSystemDescriptionValueType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__VirtualSystemDescriptionValueType * SOAP_FMAC4 soap_in_vbox__VirtualSystemDescriptionValueType(struct soap *soap, const char *tag, enum vbox__VirtualSystemDescriptionValueType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__VirtualSystemDescriptionValueType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__VirtualSystemDescriptionValueType, sizeof(enum vbox__VirtualSystemDescriptionValueType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__VirtualSystemDescriptionValueType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__VirtualSystemDescriptionValueType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__VirtualSystemDescriptionValueType, 0, sizeof(enum vbox__VirtualSystemDescriptionValueType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__VirtualSystemDescriptionType(struct soap *soap, enum vbox__VirtualSystemDescriptionType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__VirtualSystemDescriptionType
	*a = SOAP_DEFAULT_vbox__VirtualSystemDescriptionType;
#else
	*a = (enum vbox__VirtualSystemDescriptionType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__VirtualSystemDescriptionType(struct soap *soap, const enum vbox__VirtualSystemDescriptionType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__VirtualSystemDescriptionType);
	if (soap_out_vbox__VirtualSystemDescriptionType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__VirtualSystemDescriptionType[] =
{	{ (long)vbox__VirtualSystemDescriptionType__Ignore, "Ignore" },
	{ (long)vbox__VirtualSystemDescriptionType__OS, "OS" },
	{ (long)vbox__VirtualSystemDescriptionType__Name, "Name" },
	{ (long)vbox__VirtualSystemDescriptionType__Product, "Product" },
	{ (long)vbox__VirtualSystemDescriptionType__Vendor, "Vendor" },
	{ (long)vbox__VirtualSystemDescriptionType__Version, "Version" },
	{ (long)vbox__VirtualSystemDescriptionType__ProductUrl, "ProductUrl" },
	{ (long)vbox__VirtualSystemDescriptionType__VendorUrl, "VendorUrl" },
	{ (long)vbox__VirtualSystemDescriptionType__Description, "Description" },
	{ (long)vbox__VirtualSystemDescriptionType__License, "License" },
	{ (long)vbox__VirtualSystemDescriptionType__Miscellaneous, "Miscellaneous" },
	{ (long)vbox__VirtualSystemDescriptionType__CPU, "CPU" },
	{ (long)vbox__VirtualSystemDescriptionType__Memory, "Memory" },
	{ (long)vbox__VirtualSystemDescriptionType__HardDiskControllerIDE, "HardDiskControllerIDE" },
	{ (long)vbox__VirtualSystemDescriptionType__HardDiskControllerSATA, "HardDiskControllerSATA" },
	{ (long)vbox__VirtualSystemDescriptionType__HardDiskControllerSCSI, "HardDiskControllerSCSI" },
	{ (long)vbox__VirtualSystemDescriptionType__HardDiskImage, "HardDiskImage" },
	{ (long)vbox__VirtualSystemDescriptionType__Floppy, "Floppy" },
	{ (long)vbox__VirtualSystemDescriptionType__CDROM, "CDROM" },
	{ (long)vbox__VirtualSystemDescriptionType__NetworkAdapter, "NetworkAdapter" },
	{ (long)vbox__VirtualSystemDescriptionType__USBController, "USBController" },
	{ (long)vbox__VirtualSystemDescriptionType__SoundCard, "SoundCard" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__VirtualSystemDescriptionType2s(struct soap *soap, enum vbox__VirtualSystemDescriptionType n)
{	const char *s = soap_code_str(soap_codes_vbox__VirtualSystemDescriptionType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__VirtualSystemDescriptionType(struct soap *soap, const char *tag, int id, const enum vbox__VirtualSystemDescriptionType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__VirtualSystemDescriptionType), type) || soap_send(soap, soap_vbox__VirtualSystemDescriptionType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__VirtualSystemDescriptionType * SOAP_FMAC4 soap_get_vbox__VirtualSystemDescriptionType(struct soap *soap, enum vbox__VirtualSystemDescriptionType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__VirtualSystemDescriptionType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__VirtualSystemDescriptionType(struct soap *soap, const char *s, enum vbox__VirtualSystemDescriptionType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__VirtualSystemDescriptionType, s);
	if (map)
		*a = (enum vbox__VirtualSystemDescriptionType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 21)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__VirtualSystemDescriptionType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__VirtualSystemDescriptionType * SOAP_FMAC4 soap_in_vbox__VirtualSystemDescriptionType(struct soap *soap, const char *tag, enum vbox__VirtualSystemDescriptionType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__VirtualSystemDescriptionType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__VirtualSystemDescriptionType, sizeof(enum vbox__VirtualSystemDescriptionType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__VirtualSystemDescriptionType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__VirtualSystemDescriptionType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__VirtualSystemDescriptionType, 0, sizeof(enum vbox__VirtualSystemDescriptionType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__VFSFileType(struct soap *soap, enum vbox__VFSFileType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__VFSFileType
	*a = SOAP_DEFAULT_vbox__VFSFileType;
#else
	*a = (enum vbox__VFSFileType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__VFSFileType(struct soap *soap, const enum vbox__VFSFileType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__VFSFileType);
	if (soap_out_vbox__VFSFileType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__VFSFileType[] =
{	{ (long)vbox__VFSFileType__Unknown, "Unknown" },
	{ (long)vbox__VFSFileType__Fifo, "Fifo" },
	{ (long)vbox__VFSFileType__DevChar, "DevChar" },
	{ (long)vbox__VFSFileType__Directory, "Directory" },
	{ (long)vbox__VFSFileType__DevBlock, "DevBlock" },
	{ (long)vbox__VFSFileType__File, "File" },
	{ (long)vbox__VFSFileType__SymLink, "SymLink" },
	{ (long)vbox__VFSFileType__Socket, "Socket" },
	{ (long)vbox__VFSFileType__WhiteOut, "WhiteOut" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__VFSFileType2s(struct soap *soap, enum vbox__VFSFileType n)
{	const char *s = soap_code_str(soap_codes_vbox__VFSFileType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__VFSFileType(struct soap *soap, const char *tag, int id, const enum vbox__VFSFileType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__VFSFileType), type) || soap_send(soap, soap_vbox__VFSFileType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__VFSFileType * SOAP_FMAC4 soap_get_vbox__VFSFileType(struct soap *soap, enum vbox__VFSFileType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__VFSFileType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__VFSFileType(struct soap *soap, const char *s, enum vbox__VFSFileType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__VFSFileType, s);
	if (map)
		*a = (enum vbox__VFSFileType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 8)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__VFSFileType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__VFSFileType * SOAP_FMAC4 soap_in_vbox__VFSFileType(struct soap *soap, const char *tag, enum vbox__VFSFileType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__VFSFileType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__VFSFileType, sizeof(enum vbox__VFSFileType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__VFSFileType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__VFSFileType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__VFSFileType, 0, sizeof(enum vbox__VFSFileType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__VFSType(struct soap *soap, enum vbox__VFSType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__VFSType
	*a = SOAP_DEFAULT_vbox__VFSType;
#else
	*a = (enum vbox__VFSType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__VFSType(struct soap *soap, const enum vbox__VFSType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__VFSType);
	if (soap_out_vbox__VFSType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__VFSType[] =
{	{ (long)vbox__VFSType__File, "File" },
	{ (long)vbox__VFSType__Cloud, "Cloud" },
	{ (long)vbox__VFSType__S3, "S3" },
	{ (long)vbox__VFSType__WebDav, "WebDav" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__VFSType2s(struct soap *soap, enum vbox__VFSType n)
{	const char *s = soap_code_str(soap_codes_vbox__VFSType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__VFSType(struct soap *soap, const char *tag, int id, const enum vbox__VFSType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__VFSType), type) || soap_send(soap, soap_vbox__VFSType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__VFSType * SOAP_FMAC4 soap_get_vbox__VFSType(struct soap *soap, enum vbox__VFSType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__VFSType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__VFSType(struct soap *soap, const char *s, enum vbox__VFSType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__VFSType, s);
	if (map)
		*a = (enum vbox__VFSType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__VFSType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__VFSType * SOAP_FMAC4 soap_in_vbox__VFSType(struct soap *soap, const char *tag, enum vbox__VFSType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__VFSType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__VFSType, sizeof(enum vbox__VFSType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__VFSType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__VFSType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__VFSType, 0, sizeof(enum vbox__VFSType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__FirmwareType(struct soap *soap, enum vbox__FirmwareType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__FirmwareType
	*a = SOAP_DEFAULT_vbox__FirmwareType;
#else
	*a = (enum vbox__FirmwareType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__FirmwareType(struct soap *soap, const enum vbox__FirmwareType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__FirmwareType);
	if (soap_out_vbox__FirmwareType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__FirmwareType[] =
{	{ (long)vbox__FirmwareType__BIOS, "BIOS" },
	{ (long)vbox__FirmwareType__EFI, "EFI" },
	{ (long)vbox__FirmwareType__EFI32, "EFI32" },
	{ (long)vbox__FirmwareType__EFI64, "EFI64" },
	{ (long)vbox__FirmwareType__EFIDUAL, "EFIDUAL" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__FirmwareType2s(struct soap *soap, enum vbox__FirmwareType n)
{	const char *s = soap_code_str(soap_codes_vbox__FirmwareType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__FirmwareType(struct soap *soap, const char *tag, int id, const enum vbox__FirmwareType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__FirmwareType), type) || soap_send(soap, soap_vbox__FirmwareType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__FirmwareType * SOAP_FMAC4 soap_get_vbox__FirmwareType(struct soap *soap, enum vbox__FirmwareType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__FirmwareType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__FirmwareType(struct soap *soap, const char *s, enum vbox__FirmwareType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__FirmwareType, s);
	if (map)
		*a = (enum vbox__FirmwareType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 4)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__FirmwareType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__FirmwareType * SOAP_FMAC4 soap_in_vbox__FirmwareType(struct soap *soap, const char *tag, enum vbox__FirmwareType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__FirmwareType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__FirmwareType, sizeof(enum vbox__FirmwareType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__FirmwareType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__FirmwareType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__FirmwareType, 0, sizeof(enum vbox__FirmwareType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__ProcessorFeature(struct soap *soap, enum vbox__ProcessorFeature *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ProcessorFeature
	*a = SOAP_DEFAULT_vbox__ProcessorFeature;
#else
	*a = (enum vbox__ProcessorFeature)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__ProcessorFeature(struct soap *soap, const enum vbox__ProcessorFeature *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__ProcessorFeature);
	if (soap_out_vbox__ProcessorFeature(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__ProcessorFeature[] =
{	{ (long)vbox__ProcessorFeature__HWVirtEx, "HWVirtEx" },
	{ (long)vbox__ProcessorFeature__PAE, "PAE" },
	{ (long)vbox__ProcessorFeature__LongMode, "LongMode" },
	{ (long)vbox__ProcessorFeature__NestedPaging, "NestedPaging" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__ProcessorFeature2s(struct soap *soap, enum vbox__ProcessorFeature n)
{	const char *s = soap_code_str(soap_codes_vbox__ProcessorFeature, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__ProcessorFeature(struct soap *soap, const char *tag, int id, const enum vbox__ProcessorFeature *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__ProcessorFeature), type) || soap_send(soap, soap_vbox__ProcessorFeature2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__ProcessorFeature * SOAP_FMAC4 soap_get_vbox__ProcessorFeature(struct soap *soap, enum vbox__ProcessorFeature *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__ProcessorFeature(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__ProcessorFeature(struct soap *soap, const char *s, enum vbox__ProcessorFeature *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__ProcessorFeature, s);
	if (map)
		*a = (enum vbox__ProcessorFeature)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__ProcessorFeature)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__ProcessorFeature * SOAP_FMAC4 soap_in_vbox__ProcessorFeature(struct soap *soap, const char *tag, enum vbox__ProcessorFeature *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__ProcessorFeature *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__ProcessorFeature, sizeof(enum vbox__ProcessorFeature), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__ProcessorFeature(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__ProcessorFeature *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__ProcessorFeature, 0, sizeof(enum vbox__ProcessorFeature), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__BIOSBootMenuMode(struct soap *soap, enum vbox__BIOSBootMenuMode *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__BIOSBootMenuMode
	*a = SOAP_DEFAULT_vbox__BIOSBootMenuMode;
#else
	*a = (enum vbox__BIOSBootMenuMode)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__BIOSBootMenuMode(struct soap *soap, const enum vbox__BIOSBootMenuMode *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__BIOSBootMenuMode);
	if (soap_out_vbox__BIOSBootMenuMode(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__BIOSBootMenuMode[] =
{	{ (long)vbox__BIOSBootMenuMode__Disabled, "Disabled" },
	{ (long)vbox__BIOSBootMenuMode__MenuOnly, "MenuOnly" },
	{ (long)vbox__BIOSBootMenuMode__MessageAndMenu, "MessageAndMenu" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__BIOSBootMenuMode2s(struct soap *soap, enum vbox__BIOSBootMenuMode n)
{	const char *s = soap_code_str(soap_codes_vbox__BIOSBootMenuMode, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__BIOSBootMenuMode(struct soap *soap, const char *tag, int id, const enum vbox__BIOSBootMenuMode *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__BIOSBootMenuMode), type) || soap_send(soap, soap_vbox__BIOSBootMenuMode2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__BIOSBootMenuMode * SOAP_FMAC4 soap_get_vbox__BIOSBootMenuMode(struct soap *soap, enum vbox__BIOSBootMenuMode *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__BIOSBootMenuMode(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__BIOSBootMenuMode(struct soap *soap, const char *s, enum vbox__BIOSBootMenuMode *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__BIOSBootMenuMode, s);
	if (map)
		*a = (enum vbox__BIOSBootMenuMode)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__BIOSBootMenuMode)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__BIOSBootMenuMode * SOAP_FMAC4 soap_in_vbox__BIOSBootMenuMode(struct soap *soap, const char *tag, enum vbox__BIOSBootMenuMode *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__BIOSBootMenuMode *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__BIOSBootMenuMode, sizeof(enum vbox__BIOSBootMenuMode), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__BIOSBootMenuMode(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__BIOSBootMenuMode *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__BIOSBootMenuMode, 0, sizeof(enum vbox__BIOSBootMenuMode), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__GuestStatisticType(struct soap *soap, enum vbox__GuestStatisticType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__GuestStatisticType
	*a = SOAP_DEFAULT_vbox__GuestStatisticType;
#else
	*a = (enum vbox__GuestStatisticType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__GuestStatisticType(struct soap *soap, const enum vbox__GuestStatisticType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__GuestStatisticType);
	if (soap_out_vbox__GuestStatisticType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__GuestStatisticType[] =
{	{ (long)vbox__GuestStatisticType__CPULoad_USCOREIdle, "CPULoad_Idle" },
	{ (long)vbox__GuestStatisticType__CPULoad_USCOREKernel, "CPULoad_Kernel" },
	{ (long)vbox__GuestStatisticType__CPULoad_USCOREUser, "CPULoad_User" },
	{ (long)vbox__GuestStatisticType__Threads, "Threads" },
	{ (long)vbox__GuestStatisticType__Processes, "Processes" },
	{ (long)vbox__GuestStatisticType__Handles, "Handles" },
	{ (long)vbox__GuestStatisticType__MemoryLoad, "MemoryLoad" },
	{ (long)vbox__GuestStatisticType__PhysMemTotal, "PhysMemTotal" },
	{ (long)vbox__GuestStatisticType__PhysMemAvailable, "PhysMemAvailable" },
	{ (long)vbox__GuestStatisticType__PhysMemBalloon, "PhysMemBalloon" },
	{ (long)vbox__GuestStatisticType__MemCommitTotal, "MemCommitTotal" },
	{ (long)vbox__GuestStatisticType__MemKernelTotal, "MemKernelTotal" },
	{ (long)vbox__GuestStatisticType__MemKernelPaged, "MemKernelPaged" },
	{ (long)vbox__GuestStatisticType__MemKernelNonpaged, "MemKernelNonpaged" },
	{ (long)vbox__GuestStatisticType__MemSystemCache, "MemSystemCache" },
	{ (long)vbox__GuestStatisticType__PageFileSize, "PageFileSize" },
	{ (long)vbox__GuestStatisticType__SampleNumber, "SampleNumber" },
	{ (long)vbox__GuestStatisticType__MaxVal, "MaxVal" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__GuestStatisticType2s(struct soap *soap, enum vbox__GuestStatisticType n)
{	const char *s = soap_code_str(soap_codes_vbox__GuestStatisticType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__GuestStatisticType(struct soap *soap, const char *tag, int id, const enum vbox__GuestStatisticType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__GuestStatisticType), type) || soap_send(soap, soap_vbox__GuestStatisticType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__GuestStatisticType * SOAP_FMAC4 soap_get_vbox__GuestStatisticType(struct soap *soap, enum vbox__GuestStatisticType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__GuestStatisticType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__GuestStatisticType(struct soap *soap, const char *s, enum vbox__GuestStatisticType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__GuestStatisticType, s);
	if (map)
		*a = (enum vbox__GuestStatisticType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 17)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__GuestStatisticType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__GuestStatisticType * SOAP_FMAC4 soap_in_vbox__GuestStatisticType(struct soap *soap, const char *tag, enum vbox__GuestStatisticType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__GuestStatisticType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__GuestStatisticType, sizeof(enum vbox__GuestStatisticType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__GuestStatisticType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__GuestStatisticType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__GuestStatisticType, 0, sizeof(enum vbox__GuestStatisticType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__Scope(struct soap *soap, enum vbox__Scope *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__Scope
	*a = SOAP_DEFAULT_vbox__Scope;
#else
	*a = (enum vbox__Scope)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__Scope(struct soap *soap, const enum vbox__Scope *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__Scope);
	if (soap_out_vbox__Scope(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__Scope[] =
{	{ (long)vbox__Scope__Global, "Global" },
	{ (long)vbox__Scope__Machine, "Machine" },
	{ (long)vbox__Scope__Session, "Session" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__Scope2s(struct soap *soap, enum vbox__Scope n)
{	const char *s = soap_code_str(soap_codes_vbox__Scope, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__Scope(struct soap *soap, const char *tag, int id, const enum vbox__Scope *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__Scope), type) || soap_send(soap, soap_vbox__Scope2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__Scope * SOAP_FMAC4 soap_get_vbox__Scope(struct soap *soap, enum vbox__Scope *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__Scope(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__Scope(struct soap *soap, const char *s, enum vbox__Scope *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__Scope, s);
	if (map)
		*a = (enum vbox__Scope)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__Scope)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__Scope * SOAP_FMAC4 soap_in_vbox__Scope(struct soap *soap, const char *tag, enum vbox__Scope *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__Scope *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__Scope, sizeof(enum vbox__Scope), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__Scope(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__Scope *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__Scope, 0, sizeof(enum vbox__Scope), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__ClipboardMode(struct soap *soap, enum vbox__ClipboardMode *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ClipboardMode
	*a = SOAP_DEFAULT_vbox__ClipboardMode;
#else
	*a = (enum vbox__ClipboardMode)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__ClipboardMode(struct soap *soap, const enum vbox__ClipboardMode *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__ClipboardMode);
	if (soap_out_vbox__ClipboardMode(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__ClipboardMode[] =
{	{ (long)vbox__ClipboardMode__Disabled, "Disabled" },
	{ (long)vbox__ClipboardMode__HostToGuest, "HostToGuest" },
	{ (long)vbox__ClipboardMode__GuestToHost, "GuestToHost" },
	{ (long)vbox__ClipboardMode__Bidirectional, "Bidirectional" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__ClipboardMode2s(struct soap *soap, enum vbox__ClipboardMode n)
{	const char *s = soap_code_str(soap_codes_vbox__ClipboardMode, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__ClipboardMode(struct soap *soap, const char *tag, int id, const enum vbox__ClipboardMode *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__ClipboardMode), type) || soap_send(soap, soap_vbox__ClipboardMode2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__ClipboardMode * SOAP_FMAC4 soap_get_vbox__ClipboardMode(struct soap *soap, enum vbox__ClipboardMode *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__ClipboardMode(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__ClipboardMode(struct soap *soap, const char *s, enum vbox__ClipboardMode *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__ClipboardMode, s);
	if (map)
		*a = (enum vbox__ClipboardMode)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__ClipboardMode)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__ClipboardMode * SOAP_FMAC4 soap_in_vbox__ClipboardMode(struct soap *soap, const char *tag, enum vbox__ClipboardMode *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__ClipboardMode *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__ClipboardMode, sizeof(enum vbox__ClipboardMode), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__ClipboardMode(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__ClipboardMode *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__ClipboardMode, 0, sizeof(enum vbox__ClipboardMode), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__DeviceActivity(struct soap *soap, enum vbox__DeviceActivity *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DeviceActivity
	*a = SOAP_DEFAULT_vbox__DeviceActivity;
#else
	*a = (enum vbox__DeviceActivity)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__DeviceActivity(struct soap *soap, const enum vbox__DeviceActivity *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__DeviceActivity);
	if (soap_out_vbox__DeviceActivity(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__DeviceActivity[] =
{	{ (long)vbox__DeviceActivity__Null, "Null" },
	{ (long)vbox__DeviceActivity__Idle, "Idle" },
	{ (long)vbox__DeviceActivity__Reading, "Reading" },
	{ (long)vbox__DeviceActivity__Writing, "Writing" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__DeviceActivity2s(struct soap *soap, enum vbox__DeviceActivity n)
{	const char *s = soap_code_str(soap_codes_vbox__DeviceActivity, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__DeviceActivity(struct soap *soap, const char *tag, int id, const enum vbox__DeviceActivity *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__DeviceActivity), type) || soap_send(soap, soap_vbox__DeviceActivity2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__DeviceActivity * SOAP_FMAC4 soap_get_vbox__DeviceActivity(struct soap *soap, enum vbox__DeviceActivity *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__DeviceActivity(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__DeviceActivity(struct soap *soap, const char *s, enum vbox__DeviceActivity *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__DeviceActivity, s);
	if (map)
		*a = (enum vbox__DeviceActivity)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__DeviceActivity)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__DeviceActivity * SOAP_FMAC4 soap_in_vbox__DeviceActivity(struct soap *soap, const char *tag, enum vbox__DeviceActivity *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__DeviceActivity *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__DeviceActivity, sizeof(enum vbox__DeviceActivity), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__DeviceActivity(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__DeviceActivity *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__DeviceActivity, 0, sizeof(enum vbox__DeviceActivity), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__DeviceType(struct soap *soap, enum vbox__DeviceType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DeviceType
	*a = SOAP_DEFAULT_vbox__DeviceType;
#else
	*a = (enum vbox__DeviceType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__DeviceType(struct soap *soap, const enum vbox__DeviceType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__DeviceType);
	if (soap_out_vbox__DeviceType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__DeviceType[] =
{	{ (long)vbox__DeviceType__Null, "Null" },
	{ (long)vbox__DeviceType__Floppy, "Floppy" },
	{ (long)vbox__DeviceType__DVD, "DVD" },
	{ (long)vbox__DeviceType__HardDisk, "HardDisk" },
	{ (long)vbox__DeviceType__Network, "Network" },
	{ (long)vbox__DeviceType__USB, "USB" },
	{ (long)vbox__DeviceType__SharedFolder, "SharedFolder" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__DeviceType2s(struct soap *soap, enum vbox__DeviceType n)
{	const char *s = soap_code_str(soap_codes_vbox__DeviceType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__DeviceType(struct soap *soap, const char *tag, int id, const enum vbox__DeviceType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__DeviceType), type) || soap_send(soap, soap_vbox__DeviceType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__DeviceType * SOAP_FMAC4 soap_get_vbox__DeviceType(struct soap *soap, enum vbox__DeviceType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__DeviceType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__DeviceType(struct soap *soap, const char *s, enum vbox__DeviceType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__DeviceType, s);
	if (map)
		*a = (enum vbox__DeviceType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 6)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__DeviceType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__DeviceType * SOAP_FMAC4 soap_in_vbox__DeviceType(struct soap *soap, const char *tag, enum vbox__DeviceType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__DeviceType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__DeviceType, sizeof(enum vbox__DeviceType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__DeviceType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__DeviceType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__DeviceType, 0, sizeof(enum vbox__DeviceType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__SessionType(struct soap *soap, enum vbox__SessionType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__SessionType
	*a = SOAP_DEFAULT_vbox__SessionType;
#else
	*a = (enum vbox__SessionType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__SessionType(struct soap *soap, const enum vbox__SessionType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__SessionType);
	if (soap_out_vbox__SessionType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__SessionType[] =
{	{ (long)vbox__SessionType__Null, "Null" },
	{ (long)vbox__SessionType__Direct, "Direct" },
	{ (long)vbox__SessionType__Remote, "Remote" },
	{ (long)vbox__SessionType__Existing, "Existing" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__SessionType2s(struct soap *soap, enum vbox__SessionType n)
{	const char *s = soap_code_str(soap_codes_vbox__SessionType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__SessionType(struct soap *soap, const char *tag, int id, const enum vbox__SessionType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__SessionType), type) || soap_send(soap, soap_vbox__SessionType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__SessionType * SOAP_FMAC4 soap_get_vbox__SessionType(struct soap *soap, enum vbox__SessionType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__SessionType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__SessionType(struct soap *soap, const char *s, enum vbox__SessionType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__SessionType, s);
	if (map)
		*a = (enum vbox__SessionType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__SessionType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__SessionType * SOAP_FMAC4 soap_in_vbox__SessionType(struct soap *soap, const char *tag, enum vbox__SessionType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__SessionType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__SessionType, sizeof(enum vbox__SessionType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__SessionType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__SessionType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__SessionType, 0, sizeof(enum vbox__SessionType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__HWVirtExPropertyType(struct soap *soap, enum vbox__HWVirtExPropertyType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__HWVirtExPropertyType
	*a = SOAP_DEFAULT_vbox__HWVirtExPropertyType;
#else
	*a = (enum vbox__HWVirtExPropertyType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__HWVirtExPropertyType(struct soap *soap, const enum vbox__HWVirtExPropertyType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__HWVirtExPropertyType);
	if (soap_out_vbox__HWVirtExPropertyType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__HWVirtExPropertyType[] =
{	{ (long)vbox__HWVirtExPropertyType__Null, "Null" },
	{ (long)vbox__HWVirtExPropertyType__Enabled, "Enabled" },
	{ (long)vbox__HWVirtExPropertyType__Exclusive, "Exclusive" },
	{ (long)vbox__HWVirtExPropertyType__VPID, "VPID" },
	{ (long)vbox__HWVirtExPropertyType__NestedPaging, "NestedPaging" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__HWVirtExPropertyType2s(struct soap *soap, enum vbox__HWVirtExPropertyType n)
{	const char *s = soap_code_str(soap_codes_vbox__HWVirtExPropertyType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__HWVirtExPropertyType(struct soap *soap, const char *tag, int id, const enum vbox__HWVirtExPropertyType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__HWVirtExPropertyType), type) || soap_send(soap, soap_vbox__HWVirtExPropertyType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__HWVirtExPropertyType * SOAP_FMAC4 soap_get_vbox__HWVirtExPropertyType(struct soap *soap, enum vbox__HWVirtExPropertyType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__HWVirtExPropertyType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__HWVirtExPropertyType(struct soap *soap, const char *s, enum vbox__HWVirtExPropertyType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__HWVirtExPropertyType, s);
	if (map)
		*a = (enum vbox__HWVirtExPropertyType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 4)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__HWVirtExPropertyType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__HWVirtExPropertyType * SOAP_FMAC4 soap_in_vbox__HWVirtExPropertyType(struct soap *soap, const char *tag, enum vbox__HWVirtExPropertyType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__HWVirtExPropertyType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__HWVirtExPropertyType, sizeof(enum vbox__HWVirtExPropertyType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__HWVirtExPropertyType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__HWVirtExPropertyType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__HWVirtExPropertyType, 0, sizeof(enum vbox__HWVirtExPropertyType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__CpuPropertyType(struct soap *soap, enum vbox__CpuPropertyType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__CpuPropertyType
	*a = SOAP_DEFAULT_vbox__CpuPropertyType;
#else
	*a = (enum vbox__CpuPropertyType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__CpuPropertyType(struct soap *soap, const enum vbox__CpuPropertyType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__CpuPropertyType);
	if (soap_out_vbox__CpuPropertyType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__CpuPropertyType[] =
{	{ (long)vbox__CpuPropertyType__Null, "Null" },
	{ (long)vbox__CpuPropertyType__PAE, "PAE" },
	{ (long)vbox__CpuPropertyType__Synthetic, "Synthetic" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__CpuPropertyType2s(struct soap *soap, enum vbox__CpuPropertyType n)
{	const char *s = soap_code_str(soap_codes_vbox__CpuPropertyType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__CpuPropertyType(struct soap *soap, const char *tag, int id, const enum vbox__CpuPropertyType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__CpuPropertyType), type) || soap_send(soap, soap_vbox__CpuPropertyType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__CpuPropertyType * SOAP_FMAC4 soap_get_vbox__CpuPropertyType(struct soap *soap, enum vbox__CpuPropertyType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__CpuPropertyType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__CpuPropertyType(struct soap *soap, const char *s, enum vbox__CpuPropertyType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__CpuPropertyType, s);
	if (map)
		*a = (enum vbox__CpuPropertyType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__CpuPropertyType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__CpuPropertyType * SOAP_FMAC4 soap_in_vbox__CpuPropertyType(struct soap *soap, const char *tag, enum vbox__CpuPropertyType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__CpuPropertyType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__CpuPropertyType, sizeof(enum vbox__CpuPropertyType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__CpuPropertyType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__CpuPropertyType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__CpuPropertyType, 0, sizeof(enum vbox__CpuPropertyType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__SessionState(struct soap *soap, enum vbox__SessionState *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__SessionState
	*a = SOAP_DEFAULT_vbox__SessionState;
#else
	*a = (enum vbox__SessionState)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__SessionState(struct soap *soap, const enum vbox__SessionState *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__SessionState);
	if (soap_out_vbox__SessionState(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__SessionState[] =
{	{ (long)vbox__SessionState__Null, "Null" },
	{ (long)vbox__SessionState__Closed, "Closed" },
	{ (long)vbox__SessionState__Open, "Open" },
	{ (long)vbox__SessionState__Spawning, "Spawning" },
	{ (long)vbox__SessionState__Closing, "Closing" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__SessionState2s(struct soap *soap, enum vbox__SessionState n)
{	const char *s = soap_code_str(soap_codes_vbox__SessionState, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__SessionState(struct soap *soap, const char *tag, int id, const enum vbox__SessionState *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__SessionState), type) || soap_send(soap, soap_vbox__SessionState2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__SessionState * SOAP_FMAC4 soap_get_vbox__SessionState(struct soap *soap, enum vbox__SessionState *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__SessionState(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__SessionState(struct soap *soap, const char *s, enum vbox__SessionState *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__SessionState, s);
	if (map)
		*a = (enum vbox__SessionState)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 4)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__SessionState)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__SessionState * SOAP_FMAC4 soap_in_vbox__SessionState(struct soap *soap, const char *tag, enum vbox__SessionState *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__SessionState *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__SessionState, sizeof(enum vbox__SessionState), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__SessionState(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__SessionState *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__SessionState, 0, sizeof(enum vbox__SessionState), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__MachineState(struct soap *soap, enum vbox__MachineState *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__MachineState
	*a = SOAP_DEFAULT_vbox__MachineState;
#else
	*a = (enum vbox__MachineState)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__MachineState(struct soap *soap, const enum vbox__MachineState *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__MachineState);
	if (soap_out_vbox__MachineState(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__MachineState[] =
{	{ (long)vbox__MachineState__Null, "Null" },
	{ (long)vbox__MachineState__PoweredOff, "PoweredOff" },
	{ (long)vbox__MachineState__Saved, "Saved" },
	{ (long)vbox__MachineState__Teleported, "Teleported" },
	{ (long)vbox__MachineState__Aborted, "Aborted" },
	{ (long)vbox__MachineState__Running, "Running" },
	{ (long)vbox__MachineState__Paused, "Paused" },
	{ (long)vbox__MachineState__Stuck, "Stuck" },
	{ (long)vbox__MachineState__Teleporting, "Teleporting" },
	{ (long)vbox__MachineState__LiveSnapshotting, "LiveSnapshotting" },
	{ (long)vbox__MachineState__Starting, "Starting" },
	{ (long)vbox__MachineState__Stopping, "Stopping" },
	{ (long)vbox__MachineState__Saving, "Saving" },
	{ (long)vbox__MachineState__Restoring, "Restoring" },
	{ (long)vbox__MachineState__TeleportingPausedVM, "TeleportingPausedVM" },
	{ (long)vbox__MachineState__TeleportingIn, "TeleportingIn" },
	{ (long)vbox__MachineState__RestoringSnapshot, "RestoringSnapshot" },
	{ (long)vbox__MachineState__DeletingSnapshot, "DeletingSnapshot" },
	{ (long)vbox__MachineState__SettingUp, "SettingUp" },
	{ (long)vbox__MachineState__FirstOnline, "FirstOnline" },
	{ (long)vbox__MachineState__LastOnline, "LastOnline" },
	{ (long)vbox__MachineState__FirstTransient, "FirstTransient" },
	{ (long)vbox__MachineState__LastTransient, "LastTransient" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__MachineState2s(struct soap *soap, enum vbox__MachineState n)
{	const char *s = soap_code_str(soap_codes_vbox__MachineState, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__MachineState(struct soap *soap, const char *tag, int id, const enum vbox__MachineState *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__MachineState), type) || soap_send(soap, soap_vbox__MachineState2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__MachineState * SOAP_FMAC4 soap_get_vbox__MachineState(struct soap *soap, enum vbox__MachineState *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__MachineState(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__MachineState(struct soap *soap, const char *s, enum vbox__MachineState *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__MachineState, s);
	if (map)
		*a = (enum vbox__MachineState)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 22)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__MachineState)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__MachineState * SOAP_FMAC4 soap_in_vbox__MachineState(struct soap *soap, const char *tag, enum vbox__MachineState *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__MachineState *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__MachineState, sizeof(enum vbox__MachineState), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__MachineState(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__MachineState *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__MachineState, 0, sizeof(enum vbox__MachineState), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__AccessMode(struct soap *soap, enum vbox__AccessMode *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__AccessMode
	*a = SOAP_DEFAULT_vbox__AccessMode;
#else
	*a = (enum vbox__AccessMode)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__AccessMode(struct soap *soap, const enum vbox__AccessMode *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__AccessMode);
	if (soap_out_vbox__AccessMode(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__AccessMode[] =
{	{ (long)vbox__AccessMode__ReadOnly, "ReadOnly" },
	{ (long)vbox__AccessMode__ReadWrite, "ReadWrite" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__AccessMode2s(struct soap *soap, enum vbox__AccessMode n)
{	const char *s = soap_code_str(soap_codes_vbox__AccessMode, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__AccessMode(struct soap *soap, const char *tag, int id, const enum vbox__AccessMode *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__AccessMode), type) || soap_send(soap, soap_vbox__AccessMode2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__AccessMode * SOAP_FMAC4 soap_get_vbox__AccessMode(struct soap *soap, enum vbox__AccessMode *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__AccessMode(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__AccessMode(struct soap *soap, const char *s, enum vbox__AccessMode *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__AccessMode, s);
	if (map)
		*a = (enum vbox__AccessMode)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 1)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__AccessMode)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__AccessMode * SOAP_FMAC4 soap_in_vbox__AccessMode(struct soap *soap, const char *tag, enum vbox__AccessMode *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__AccessMode *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__AccessMode, sizeof(enum vbox__AccessMode), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__AccessMode(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__AccessMode *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__AccessMode, 0, sizeof(enum vbox__AccessMode), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__SettingsVersion(struct soap *soap, enum vbox__SettingsVersion *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__SettingsVersion
	*a = SOAP_DEFAULT_vbox__SettingsVersion;
#else
	*a = (enum vbox__SettingsVersion)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__SettingsVersion(struct soap *soap, const enum vbox__SettingsVersion *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__SettingsVersion);
	if (soap_out_vbox__SettingsVersion(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__SettingsVersion[] =
{	{ (long)vbox__SettingsVersion__Null, "Null" },
	{ (long)vbox__SettingsVersion__v1_USCORE0, "v1_0" },
	{ (long)vbox__SettingsVersion__v1_USCORE1, "v1_1" },
	{ (long)vbox__SettingsVersion__v1_USCORE2, "v1_2" },
	{ (long)vbox__SettingsVersion__v1_USCORE3pre, "v1_3pre" },
	{ (long)vbox__SettingsVersion__v1_USCORE3, "v1_3" },
	{ (long)vbox__SettingsVersion__v1_USCORE4, "v1_4" },
	{ (long)vbox__SettingsVersion__v1_USCORE5, "v1_5" },
	{ (long)vbox__SettingsVersion__v1_USCORE6, "v1_6" },
	{ (long)vbox__SettingsVersion__v1_USCORE7, "v1_7" },
	{ (long)vbox__SettingsVersion__v1_USCORE8, "v1_8" },
	{ (long)vbox__SettingsVersion__v1_USCORE9, "v1_9" },
	{ (long)vbox__SettingsVersion__Future, "Future" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__SettingsVersion2s(struct soap *soap, enum vbox__SettingsVersion n)
{	const char *s = soap_code_str(soap_codes_vbox__SettingsVersion, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__SettingsVersion(struct soap *soap, const char *tag, int id, const enum vbox__SettingsVersion *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__SettingsVersion), type) || soap_send(soap, soap_vbox__SettingsVersion2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__SettingsVersion * SOAP_FMAC4 soap_get_vbox__SettingsVersion(struct soap *soap, enum vbox__SettingsVersion *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__SettingsVersion(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__SettingsVersion(struct soap *soap, const char *s, enum vbox__SettingsVersion *a)
{
	const struct soap_code_map *map;
	if (!s)
		return SOAP_OK;
	map = soap_code(soap_codes_vbox__SettingsVersion, s);
	if (map)
		*a = (enum vbox__SettingsVersion)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 12)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__SettingsVersion)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__SettingsVersion * SOAP_FMAC4 soap_in_vbox__SettingsVersion(struct soap *soap, const char *tag, enum vbox__SettingsVersion *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__SettingsVersion *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__SettingsVersion, sizeof(enum vbox__SettingsVersion), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__SettingsVersion(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__SettingsVersion *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__SettingsVersion, 0, sizeof(enum vbox__SettingsVersion), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

void _vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnMetricNames);
	soap_default_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnObjects);
	soap_default_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnUnits);
	soap_default_std__vectorTemplateOfunsignedInt(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnScales);
	soap_default_std__vectorTemplateOfunsignedInt(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnSequenceNumbers);
	soap_default_std__vectorTemplateOfunsignedInt(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnDataIndices);
	soap_default_std__vectorTemplateOfunsignedInt(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnDataLengths);
	soap_default_std__vectorTemplateOfint(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnMetricNames);
	soap_serialize_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnObjects);
	soap_serialize_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnUnits);
	soap_serialize_std__vectorTemplateOfunsignedInt(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnScales);
	soap_serialize_std__vectorTemplateOfunsignedInt(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnSequenceNumbers);
	soap_serialize_std__vectorTemplateOfunsignedInt(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnDataIndices);
	soap_serialize_std__vectorTemplateOfunsignedInt(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnDataLengths);
	soap_serialize_std__vectorTemplateOfint(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnval);
	/* transient soap skipped */
}

int _vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse(struct soap *soap, const char *tag, int id, const _vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse), type))
		return soap->error;
	if (soap_out_std__vectorTemplateOfstd__string(soap, "returnMetricNames", -1, &(a->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnMetricNames), ""))
		return soap->error;
	if (soap_out_std__vectorTemplateOfstd__string(soap, "returnObjects", -1, &(a->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnObjects), ""))
		return soap->error;
	if (soap_out_std__vectorTemplateOfstd__string(soap, "returnUnits", -1, &(a->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnUnits), ""))
		return soap->error;
	if (soap_out_std__vectorTemplateOfunsignedInt(soap, "returnScales", -1, &(a->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnScales), ""))
		return soap->error;
	if (soap_out_std__vectorTemplateOfunsignedInt(soap, "returnSequenceNumbers", -1, &(a->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnSequenceNumbers), ""))
		return soap->error;
	if (soap_out_std__vectorTemplateOfunsignedInt(soap, "returnDataIndices", -1, &(a->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnDataIndices), ""))
		return soap->error;
	if (soap_out_std__vectorTemplateOfunsignedInt(soap, "returnDataLengths", -1, &(a->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnDataLengths), ""))
		return soap->error;
	if (soap_out_std__vectorTemplateOfint(soap, "returnval", -1, &(a->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse * SOAP_FMAC4 soap_get__vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse(struct soap *soap, _vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse(soap, tag, this, type);
}
